/* original parser id follows */
/* yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93" */
/* (use YYMAJOR/YYMINOR for ifdefs dependent on parser version) */

#define YYBYACC 1
#define YYMAJOR 2
#define YYMINOR 0
#define YYPATCH 20210109

#define YYEMPTY        (-1)
#define yyclearin      (yychar = YYEMPTY)
#define yyerrok        (yyerrflag = 0)
#define YYRECOVERING() (yyerrflag != 0)
#define YYENOMEM       (-2)
#define YYEOF          0
#define YYPREFIX "yy"

#define YYPURE 1

#line 121 "language.yacc"
/* This is the grammar definition of Pike. */

#include "global.h"
#ifdef HAVE_MEMORY_H
#include <memory.h>
#endif

#include "interpret.h"
#include "array.h"
#include "object.h"
#include "mapping.h"
#include "stralloc.h"
#include "las.h"
#include "interpret.h"
#include "program.h"
#include "pike_types.h"
#include "constants.h"
#include "pike_macros.h"
#include "pike_error.h"
#include "docode.h"
#include "pike_embed.h"
#include "opcodes.h"
#include "operators.h"
#include "bignum.h"

#define YYMAXDEPTH	1000

#ifdef PIKE_DEBUG
#ifndef YYDEBUG
/* May also be defined by machine.h */
#define YYDEBUG 1
#endif /* YYDEBUG */
#endif

/* Get verbose parse error reporting. */
#define YYERROR_VERBOSE	1

/* #define LAMBDA_DEBUG	1 */

static void yyerror_reserved(const char *keyword);
static struct pike_string *get_new_name(struct pike_string *prefix);
int add_local_name(struct pike_string *, struct pike_type *, node *);
int low_add_local_name(struct compiler_frame *,
		       struct pike_string *, struct pike_type *, node *);
static void mark_lvalues_as_used(node *n);
static node *lexical_islocal(struct pike_string *);
static node *safe_inc_enum(node *n);
static node *find_versioned_identifier(struct pike_string *identifier,
				       int major, int minor);
static int call_handle_import(struct pike_string *s);

static int inherit_depth;
static struct program_state *inherit_state = NULL;

/*
 * Kludge for Bison not using prototypes.
 */
#ifndef __GNUC__
#ifndef __cplusplus
static void __yy_memcpy(char *to, const char *from,
			unsigned int count);
#endif /* !__cplusplus */
#endif /* !__GNUC__ */

#ifdef YYSTYPE
#undef  YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
#endif
#ifndef YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
#line 187 "language.yacc"
typedef union
{
  int number;
  FLOAT_TYPE fnum;
  struct node_s *n;
  char *str;
  void *ptr;
} YYSTYPE;
#endif /* !YYSTYPE_IS_DECLARED */
#line 197 "language.yacc"
/* Need to be included after YYSTYPE is defined. */
#define INCLUDED_FROM_LANGUAGE_YACC
#include "lex.h"
#include "pike_compiler.h"
#line 204 "language.yacc"
/* Include <stdio.h> our selves, so that we can do our magic
 * without being disturbed... */
#include <stdio.h>
int yylex(YYSTYPE *yylval);
/* Bison is stupid, and tries to optimize for space... */
#ifdef YYBISON
#define short int
#endif /* YYBISON */

#line 117 "y.tab.c"

/* compatibility with bison */
#ifdef YYPARSE_PARAM
/* compatibility with FreeBSD */
# ifdef YYPARSE_PARAM_TYPE
#  define YYPARSE_DECL() yyparse(YYPARSE_PARAM_TYPE YYPARSE_PARAM)
# else
#  define YYPARSE_DECL() yyparse(void *YYPARSE_PARAM)
# endif
#else
# define YYPARSE_DECL() yyparse(void)
#endif

/* Parameters sent to lex. */
#ifdef YYLEX_PARAM
# ifdef YYLEX_PARAM_TYPE
#  define YYLEX_DECL() yylex(YYSTYPE *yylval, YYLEX_PARAM_TYPE YYLEX_PARAM)
# else
#  define YYLEX_DECL() yylex(YYSTYPE *yylval, void * YYLEX_PARAM)
# endif
# define YYLEX yylex(&yylval, YYLEX_PARAM)
#else
# define YYLEX_DECL() yylex(YYSTYPE *yylval)
# define YYLEX yylex(&yylval)
#endif

/* Parameters sent to yyerror. */
#ifndef YYERROR_DECL
#define YYERROR_DECL() yyerror(const char *s)
#endif
#ifndef YYERROR_CALL
#define YYERROR_CALL(msg) yyerror(msg)
#endif

extern int YYPARSE_DECL();

#define TOK_ARROW 257
#define TOK_CONSTANT 258
#define TOK_FLOAT 259
#define TOK_STRING 260
#define TOK_NUMBER 261
#define TOK_INC 262
#define TOK_DEC 263
#define TOK_RETURN 264
#define TOK_EQ 265
#define TOK_GE 266
#define TOK_LE 267
#define TOK_NE 268
#define TOK_NOT 269
#define TOK_LSH 270
#define TOK_RSH 271
#define TOK_LAND 272
#define TOK_LOR 273
#define TOK_SWITCH 274
#define TOK_SSCANF 275
#define TOK_CATCH 276
#define TOK_FOREACH 277
#define TOK_LEX_EOF 278
#define TOK_ADD_EQ 279
#define TOK_AND_EQ 280
#define TOK_ARRAY_ID 281
#define TOK_ATTRIBUTE_ID 282
#define TOK_BREAK 283
#define TOK_CASE 284
#define TOK_CLASS 285
#define TOK_COLON_COLON 286
#define TOK_CONTINUE 287
#define TOK_DEFAULT 288
#define TOK_DEPRECATED_ID 289
#define TOK_DIV_EQ 290
#define TOK_DO 291
#define TOK_DOT_DOT 292
#define TOK_DOT_DOT_DOT 293
#define TOK_ELSE 294
#define TOK_ENUM 295
#define TOK_EXTERN 296
#define TOK_FLOAT_ID 297
#define TOK_FOR 298
#define TOK_FUNCTION_ID 299
#define TOK_GAUGE 300
#define TOK_GLOBAL 301
#define TOK_IDENTIFIER 302
#define TOK_RESERVED 303
#define TOK_IF 304
#define TOK_IMPORT 305
#define TOK_INHERIT 306
#define TOK_INLINE 307
#define TOK_LOCAL_ID 308
#define TOK_FINAL_ID 309
#define TOK_FUNCTION_NAME 310
#define TOK_INT_ID 311
#define TOK_LAMBDA 312
#define TOK_MULTISET_ID 313
#define TOK_MULTISET_END 314
#define TOK_MULTISET_START 315
#define TOK_LSH_EQ 316
#define TOK_MAPPING_ID 317
#define TOK_MIXED_ID 318
#define TOK_MOD_EQ 319
#define TOK_MULT_EQ 320
#define TOK_NO_MASK 321
#define TOK_OBJECT_ID 322
#define TOK_OR_EQ 323
#define TOK_PRIVATE 324
#define TOK_PROGRAM_ID 325
#define TOK_PROTECTED 326
#define TOK_PREDEF 327
#define TOK_PUBLIC 328
#define TOK_RSH_EQ 329
#define TOK_STATIC 330
#define TOK_STRING_ID 331
#define TOK_SUB_EQ 332
#define TOK_TYPEDEF 333
#define TOK_TYPEOF 334
#define TOK_VARIANT 335
#define TOK_VERSION 336
#define TOK_VOID_ID 337
#define TOK_WHILE 338
#define TOK_XOR_EQ 339
#define TOK_OPTIONAL 340
#define TOK_SAFE_INDEX 341
#define TOK_SAFE_START_INDEX 342
#define TOK_BITS 343
#define YYERRCODE 256
typedef short YYINT;
static const YYINT yylhs[] = {                           -1,
    0,    0,  121,  121,  121,   32,   32,   37,   37,   37,
   37,  111,  111,  124,  125,  112,  126,  126,  126,  126,
  126,  126,  126,  127,  127,  127,  127,  127,  128,  128,
  128,  129,  129,  130,  130,  130,  130,   49,   49,   49,
   49,  131,   46,   47,   47,  132,  132,  133,  133,   48,
  134,  134,  119,   17,   17,  136,  137,  122,  122,  138,
  122,  122,  122,  122,  122,  122,  122,  122,  122,  122,
  122,  141,  122,   15,   15,   15,   38,   38,   38,  142,
    3,    1,    1,    2,    2,    2,    8,    8,    8,    8,
    8,    8,    8,    8,    8,    8,    8,   21,   21,   21,
   21,   21,   21,   21,   21,   21,   21,   21,   22,   22,
   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,
   22,   22,   22,   22,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   20,   20,   20,
  115,  115,  115,   10,    9,    9,   40,   40,   40,  135,
  135,   19,   26,   27,  145,  145,   28,   29,   30,  143,
  143,  144,  144,  147,  147,  148,  148,  148,  148,  148,
  148,  148,  148,  148,  148,  148,  148,  148,  148,  148,
  148,  146,   25,   25,   25,   24,   24,   24,  156,  156,
  150,  150,  150,  150,  149,  153,  157,  153,  154,  154,
  154,  158,  159,  152,  152,   13,   13,   14,  160,   14,
  155,  155,  161,  162,  163,  151,  151,  139,  139,  164,
  164,  165,  164,  164,  164,  164,   93,   93,   93,   93,
   93,   93,   94,   94,   94,   94,   42,  166,  167,  168,
   43,  169,  169,   45,   45,   45,   99,   84,   84,   85,
   85,  170,  170,  170,  171,  171,  172,  172,  172,  172,
  103,  103,  104,   95,   95,   95,   95,   95,   95,   95,
   95,   95,   95,   95,   95,  102,  102,  102,  102,  102,
  102,  102,  102,  102,  174,   82,   97,   97,   50,   63,
   63,   62,  120,   39,  175,  176,   83,   83,  177,  113,
  113,  178,  114,  114,    6,    6,    6,    5,    5,    5,
    4,    4,   18,   18,  180,  179,  179,  179,  181,  182,
   54,  116,  116,   56,   56,  183,  183,   98,  184,  184,
  184,  185,  186,  187,   55,  140,  188,  189,   61,  190,
  190,  190,   96,   96,   87,   87,   65,   65,   65,  118,
  118,  117,  117,  191,  192,   78,   64,   64,   64,  173,
  173,  193,  194,   76,  195,  196,  109,   77,   77,  197,
  198,  105,   51,   51,   51,  199,  199,  199,  199,  100,
  100,  107,  107,  108,  110,  110,   57,   57,   58,   58,
   58,   58,   58,   59,   59,   66,   66,   71,   71,   71,
   71,   71,   71,   71,   71,   71,   71,   67,   67,    7,
    7,    7,    7,    7,    7,    7,    7,    7,    7,   16,
   16,   74,   74,   75,   75,   91,   91,   92,   92,   92,
   41,   41,   68,   68,   68,   68,   68,   68,   68,   68,
   68,   68,   68,   68,   68,   68,   68,   68,   68,   68,
   68,   68,   68,   68,   68,   68,   68,   68,   68,   68,
   68,   68,   68,   68,   68,   68,   68,   68,   68,   69,
   69,   69,   69,   69,   69,   69,   69,   70,   70,   70,
   44,  201,   44,   72,   72,   72,   72,   72,   11,   73,
   73,   73,   73,   73,   73,   73,   73,   73,   73,   73,
   73,   73,   73,   73,   73,   73,   73,   73,   73,   73,
   73,   73,   73,   73,   73,   73,   73,   73,   73,   73,
   73,   73,   73,   73,   73,   73,   73,   73,   73,   81,
   81,   81,   80,   80,   80,   80,   34,   34,   12,   12,
   12,   12,   86,   86,   86,   86,   86,   86,   86,   86,
   86,   86,   86,   86,   86,   60,   60,   60,   60,   60,
   79,  106,  106,  106,  106,  106,   53,   53,   53,   53,
   53,   53,   53,  202,   52,  101,  101,  101,  101,  101,
  101,  101,  101,  101,  101,  101,  101,  101,   88,   88,
   88,   88,   90,   89,   89,   35,   35,   36,   36,   33,
   33,   31,   31,   31,  123,  123,  123,  123,  123,  123,
  123,  123,  123,  123,  123,  123,  123,  123,  123,  123,
  123,  123,  123,  200,  200,  200,  200,  200,  200,  200,
  200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
  200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
  200,  200,  200,
};
static const YYINT yylen[] = {                            2,
    1,    2,    2,    2,    0,    1,    1,    2,    2,    2,
    0,    1,    1,    1,    0,    2,    5,    5,    5,    5,
    4,    4,    4,    3,    3,    3,    3,    3,    3,    3,
    3,    1,    3,    4,    4,    4,    4,    1,    1,    1,
    1,    1,    1,    1,    0,    1,    0,    1,    1,    1,
    1,    0,    0,    0,    1,    0,    0,   13,    8,    0,
   11,    6,    1,    1,    1,    2,    2,    1,    2,    2,
    2,    0,    5,    1,    1,    0,    1,    1,    0,    3,
    3,    1,    2,    1,    3,    3,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    0,    2,    5,    3,    1,    0,
    2,    0,    3,    3,    1,    1,    1,    1,    1,    3,
    1,    3,    1,    1,    1,    1,    1,    1,    2,    2,
    2,    2,    2,    2,    2,    2,    6,    5,    2,    4,
    4,    1,    0,    1,    2,    0,    1,    2,    1,    1,
    0,    3,    5,    3,    1,    0,    0,    4,    0,    3,
    3,    0,    0,    8,    0,    1,    2,    1,    0,    4,
    3,    0,    0,    0,    0,    8,    0,    1,    3,    2,
    2,    0,    5,    4,    4,    4,    2,    2,    4,    4,
    4,    4,    1,    1,    3,    3,    0,    0,    0,    0,
    7,    1,    1,    1,    1,    1,    0,    1,    4,    1,
    4,    3,    3,    3,    1,    3,    3,    3,    3,    3,
    0,    2,    2,    1,    1,    1,    1,    1,    1,    2,
    2,    2,    2,    2,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    0,    4,    1,    0,    2,    2,
    1,    2,    0,    0,    0,    0,    8,    5,    0,    5,
    3,    0,    6,    4,    5,    5,    4,    1,    3,    3,
    1,    2,    0,    3,    0,    4,    1,    1,    0,    0,
    7,    1,    1,    0,    2,    0,    2,    0,    1,    4,
    1,    0,    0,    0,    8,    5,    0,    0,    9,    1,
    1,    1,    0,    2,    1,    1,    1,    1,    1,    0,
    1,    2,    4,    0,    0,    9,    8,    5,    4,    1,
    1,    0,    0,   12,    0,    0,    8,    0,    1,    0,
    0,    8,    3,    5,    4,    1,    1,    1,    1,    2,
    3,    0,    1,    1,    0,    1,    1,    1,    1,    2,
    2,    2,    2,    1,    3,    1,    2,    1,    3,    3,
    3,    5,    3,    3,    3,    5,    4,    1,    5,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    0,
    1,    0,    2,    1,    3,    0,    2,    1,    3,    3,
    3,    3,    1,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    1,
    2,    2,    2,    2,    2,    2,    2,    1,    2,    2,
    0,    0,    6,    5,    5,    4,    4,    4,    0,    1,
    1,    1,    1,    1,    1,    1,    1,    2,    2,    1,
    1,    4,    4,    6,    5,    7,    4,    4,    4,    4,
    4,    3,    5,    5,    4,    4,    3,    3,    3,    3,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    1,
    3,    3,    1,    3,    3,    3,    1,    1,    2,    2,
    3,    3,    1,    2,    3,    1,    3,    3,    3,    3,
    2,    2,    2,    2,    2,    0,    1,    2,    1,    2,
    2,    4,    4,    4,    4,    4,    3,    3,    3,    3,
    3,    1,    1,    0,    3,    7,    7,    7,    7,    7,
    5,    5,    5,    5,    4,    4,    4,    4,    1,    3,
    2,    1,    2,    0,    3,    1,    1,    1,    2,    1,
    3,    1,    2,    3,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,
};
static const YYINT yydefred[] = {                         5,
    0,    0,    0,    2,    0,    4,    0,    0,    3,   63,
   64,   65,   68,   69,   70,   71,    0,  606,    0,    0,
    0,  556,  607,    0,    0,    0,    0,    0,  608,    0,
    0,  543,   90,   96,   93,   88,   87,   92,   95,   94,
   89,   97,   91,  156,    0,  247,  342,    0,    0,   72,
   66,   67,    0,   27,   26,   28,  648,  655,  654,  651,
  662,  616,  617,  657,  658,  618,  659,  660,  619,  646,
  647,  620,  644,  621,  661,  622,  652,  564,  633,  663,
  649,  650,  634,  635,  645,  623,  624,  653,  627,  625,
  626,  636,  628,  638,  629,  639,  637,  640,  643,  630,
  631,  656,  642,  632,  641,  565,  615,  550,    0,    0,
    0,  554,  563,    0,    0,  549,   25,  609,   24,    0,
    0,    0,    0,   32,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  176,    0,    0,    0,    0,  178,    0,
    0,    0,  177,    0,    0,    0,  175,  171,  174,    5,
    0,    0,   42,  161,    0,    0,  555,  557,  558,  559,
  560,  551,  552,  546,  544,  545,   36,    0,   35,   37,
    0,    0,   34,    0,   77,  329,   78,    0,   22,   21,
   23,    0,    0,    0,    0,    0,    0,   16,    0,  185,
  189,    0,    0,  212,  182,    0,  180,  186,  223,  181,
  183,    0,    0,  184,  179,  205,  332,    0,    0,  333,
    0,    0,    0,   55,  162,  359,  502,  501,    0,    0,
    0,    0,    0,  358,    0,    0,    0,  247,    0,    0,
    0,    0,   43,   50,    0,    0,    0,    0,    0,    0,
  503,   31,  408,    0,  443,  480,  357,  511,    0,  504,
    0,  510,  507,  506,  505,    0,   29,   30,    0,   33,
  330,  343,   19,   18,   20,   10,  612,    6,    0,    8,
    9,   17,    0,    0,    0,    0,    0,    0,    0,    0,
  197,    0,    0,    0,    0,    0,    0,    0,  170,  346,
   49,   48,   73,    0,  158,    0,    0,  228,    0,  584,
    0,    0,  247,    0,    0,    0,    0,    0,  485,    0,
    0,    0,  583,    0,  248,  582,  571,    0,  304,    0,
    0,  487,  486,  508,  509,  481,  482,    0,    0,    0,
    0,  404,    0,  173,    0,    0,    0,    0,    0,    0,
    0,  166,  602,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  247,  489,  490,  425,  420,  429,  423,  428,
  427,  421,  424,  426,  422,  247,  247,    0,  247,    0,
    0,    0,    0,    0,    0,    0,  613,    0,    0,  221,
    0,    0,  191,  190,  431,    0,    0,  216,    0,  204,
  202,  198,  199,  200,    0,    0,   14,    0,  211,  210,
    0,    0,    0,    0,   62,  162,    0,    0,    0,  585,
    0,  162,    0,    0,    0,    0,  169,  247,  541,  542,
  303,    0,    0,  434,  406,    0,    0,    0,    0,  528,
  529,  530,  527,    0,  438,    0,    0,    0,    0,    0,
    0,    0,  522,    0,  163,    0,    0,    0,  603,    0,
  164,  601,  467,    0,  470,    0,  472,    0,  468,    0,
  473,    0,  474,    0,  463,    0,  462,    0,    0,  464,
    0,  465,    0,  466,    0,  469,    0,  471,    0,  475,
    0,  476,    0,  477,  459,  478,  460,  479,  461,    0,
    0,    0,  410,  409,    0,  414,  413,    0,    0,    0,
  569,    0,    0,  567,    0,    0,  411,  415,    0,    0,
  341,    0,  339,    0,  614,  188,    0,   75,   74,    0,
    0,  217,  194,    0,    0,  224,  208,  157,    0,    0,
    0,    0,    0,  229,  596,  598,  597,  595,    0,    0,
  579,  581,  580,  578,    0,    0,  258,  403,    0,    0,
  260,  402,    0,  577,  249,    0,  533,  531,  534,  535,
  532,  407,  525,  526,    0,  433,  575,  576,  574,  573,
  572,   46,    0,    0,  389,  387,  386,  388,    0,   51,
    0,    0,  437,  405,  172,  600,    0,  417,    0,    0,
    0,  539,  136,  143,  145,  144,  131,  130,  111,  112,
  134,  135,  133,  137,  138,  113,  126,  129,  123,  101,
  121,  127,  117,  132,  147,  151,  152,  125,  139,  140,
  106,  103,   99,  118,  122,  141,  115,  114,  110,   98,
  116,  102,  119,  105,  142,  104,  100,  120,  124,  146,
  108,  109,  128,  107,  153,  148,  149,  150,  536,  537,
    0,    0,  538,  496,  497,  498,    0,    0,  518,  519,
  520,  521,  517,  570,  568,  512,    0,  513,    0,    0,
  318,    0,  321,  327,  328,    5,  331,    0,  337,  338,
    0,  187,  213,    0,  195,  203,    0,  234,  235,    0,
   59,   56,  236,    0,    0,    0,  592,  594,  593,  591,
    0,    0,    0,  257,    0,    0,  257,    0,  250,  308,
    0,  435,  523,    0,  442,  441,  524,  440,  439,  605,
  412,  416,  419,    0,  515,  247,  495,  494,    0,   44,
  324,  155,    0,  322,  162,    0,  335,    0,  253,  252,
  345,    0,    0,    0,  233,    0,    0,    0,   82,   84,
    0,    0,    0,    0,    0,    0,  162,  245,  311,    0,
  309,  162,  246,  271,  306,    0,  303,  514,  320,  319,
    0,    0,  340,    0,    0,    0,    0,    0,    0,   83,
    0,  588,  590,  589,  587,  586,  241,  242,  239,  314,
  312,  240,    0,  259,    0,    0,  261,    0,    0,  516,
  492,    0,  326,  214,  226,   57,   41,   40,   39,   38,
   61,   86,   85,   80,    0,    0,   81,  255,  256,  254,
  310,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  375,  285,  279,    0,  292,
  394,  276,    0,  293,  288,  289,  290,  294,  286,  277,
  272,  274,  291,    0,  287,  275,  251,  278,  307,  271,
  315,  316,    0,  313,  283,  282,  284,    0,    0,    0,
  265,    0,  398,  371,  370,    0,  397,  390,  247,  247,
  297,  299,    0,    0,  302,  300,    0,  247,    0,  247,
  247,  280,  281,  273,    0,   58,  269,    0,  268,  270,
    0,    0,  267,    0,  391,  381,  365,    0,  383,    0,
    0,  373,    0,  348,  376,  493,  264,  262,  263,    0,
  266,    0,    0,  396,    0,  385,  369,    0,    0,  296,
    0,    0,    0,    0,  384,  368,    0,    0,    0,    0,
    0,    0,    0,  393,    0,    0,    0,  352,  351,  350,
    0,    0,    0,    0,    0,    0,    0,    0,  382,  356,
  361,  355,    0,  362,    0,  367,  379,    0,    0,  377,
    0,  366,    0,    0,  349,  363,    0,  354,    0,  374,
};
static const YYINT yydgoto[] = {                          1,
  757,  758,  771,  679,  680,  681,  380,   44,    7,    8,
  235,   27,  396,  397,  530,  759,  215,  520,  803,  655,
  656,  657,  658,  284,  535,  236,  237,  153,  422,  423,
  269,  270,  185,   28,   29,  238,  184,  176,  431,  154,
  445,  319,  848,  737,  831,  239,  741,  240,  821,  849,
  850,  241,  317,   51,   52,  689,  954,  887,  425,  515,
  852,  853,  854,  855,  242,  434,  243,  244,  245,  246,
  332,  248,  249,  436,  437,  856,  978,  857,  250,  251,
  252,  858,  253,  556,  560,   32,  971,  338,  459,  339,
  449,  450,  557,  561,  859,  985,  892,  748,  767,  860,
  254,  861,  808,  862,  863,  255,  955,  864,  865,  935,
  188,  129,  562,  558,  659,  522,  964,  973,  540,  566,
    2,    9,  177,  408,  130,   10,  866,  124,  125,   12,
  155,  583,  293,  591,   53,  756,  873,  542,  297,   13,
  150,  760,  761,  426,  341,  427,  148,  334,  205,  197,
  200,  195,  201,  204,  190,  405,  202,  279,  752,  694,
  285,  697,  785,  298,  700,  428,  719,  774,  751,  881,
  882,  868,  888,  899,  721,  809,  806,  825,  687,  782,
  261,  385,  523,  524,  127,  386,  691,  900,  941,  961,
  890,  933,  898,  939,  901,  942,  889,  932,  589,  256,
  870,  312,
};
static const YYINT yysindex[] = {                         0,
    0,   93,  381,    0,    1,    0, 1624,  690,    0,    0,
    0,    0,    0,    0,    0,    0,  504,    0,10838,   15,
    0,    0,    0,  -89,   95, -237,10290,  175,    0,  -43,
  477,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,10370,    0,    0,   56, 4085,    0,
    0,    0, 8767,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  -66,10906,
10974,    0,    0,  201,  214,    0,    0,    0,    0,10450,
  602,  272,  343,    0,   19,11042,11042,  590,  -16,  536,
  442,   32,  492,    0,  524,  540,  442,  545,    0,    0,
  565,  540,    0, -109,  527,10047,    0,    0,    0,    0,
  128,  581,    0,    0,  340,  506,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 4698,    0,    0,
 4698, 4698,    0,10530,    0,    0,    0,  516,    0,    0,
    0,  691,10210,  583,  640, -109,  527,    0, 4085,    0,
    0, -109, 3091,    0,    0,  -11,    0,    0,    0,    0,
    0,  622, 7247,    0,    0,    0,    0, 4085,  631,    0,
   -8, -109, 2640,    0,    0,    0,    0,    0, 3042, 3042,
 8723,  669,    0,    0,   -4,  426,    0,    0,  -89,  674,
 8723, 8723,    0,    0,  246, 8723, 8723, -109, 3621, 4594,
    0,    0,    0,10037,    0,    0,    0,    0,  185,    0,
  527,    0,    0,    0,    0, 2065,    0,    0,  655,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   88,    0,
    0,    0, -109,    5,  478, -109,  681,   12, 1576,  704,
    0,  728,  510,  247, 4085,  536,  735,   26,    0,    0,
    0,    0,    0,  611,    0,11110,  452,    0,  669,    0,
   -4,  426,    0,  674, 4817,  -23,  -23, 2701,    0,    9,
 5297,   -4,    0, 3846,    0,    0,    0,11178,    0, 4904,
 5390,    0,    0,    0,    0,    0,    0,   17, 5522, 4393,
  450,    0,   40,    0, 4594,  -23,  527,  749,  686,  -34,
  499,    0,    0, 7495, 7552, 7609, 7732, 7801, 7858, 7915,
 7984, 8723, 8054, 8111, 8174, 8237, 8337, 8355, 8424, 8481,
 8543, 8661,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 5615,    0, 5709,
 5004, 3293, 6001, 6001,  768,10610,    0,  550, -109,    0,
  778, 4085,    0,    0,    0,  317,  777,    0,  506,    0,
    0,    0,    0,    0,  130,   -1,    0,  784,    0,    0,
 4085,  793,  781,  787,    0,    0,  -34,  117,  -15,    0,
  335,    0,11246,  808,  811,  732,    0,    0,    0,    0,
    0,  -20, 6001,    0,    0,  -21,  816,  342,  828,    0,
    0,    0,    0,  727,    0, 4594,  588,  185,  786,  838,
 2065, 6001,    0, 4085,    0,  790,  732, 4594,    0, 2190,
    0,    0,    0, 2304,    0,  865,    0,  865,    0, 2304,
    0, 1063,    0, 1063,    0,10049,    0, 4790,  829,    0,
 7212,    0, 1178,    0, 1345,    0,  865,    0,  865,    0,
  456,    0,  456,    0,    0,    0,    0,    0,    0,10127,
  592, 3706,    0,    0,  593,    0,    0,  387,  849,  118,
    0, 3931,  818,    0,  247,  832,    0,    0,  884,  -50,
    0,  848,    0,  886,    0,    0,   42,    0,    0,  881,
    0,    0,    0,  692,  914,    0,    0,    0, -172,  141,
 6001,  919,11314,    0,    0,    0,    0,    0,  454, 6001,
    0,    0,    0,    0,11382,  920,    0,    0,  906,  927,
    0,    0,  912,    0,    0,  721,    0,    0,    0,    0,
    0,    0,    0,    0, 5522,    0,    0,    0,    0,    0,
    0,    0,  939,  889,    0,    0,    0,    0, 5814,    0,
  942, 5908,    0,    0,    0,    0,  749,    0, 6001, 6001,
 8723,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  247,  898,    0,    0,    0,    0,  877,  877,    0,    0,
    0,    0,    0,    0,    0,    0, 3706,    0,  962,   33,
    0, 4085,    0,    0,    0,    0,    0, 4698,    0,    0,
  -85,    0,    0, 4085,    0,    0, 4085,    0,    0, 6001,
    0,    0,    0, 1576,  781,  787,    0,    0,    0,    0,
  104,  944,  947,    0, 4698,  143,    0, 4698,    0,    0,
  967,    0,    0, 2190,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 3706,    0,    0,    0,    0,  916,    0,
    0,    0,    0,    0,    0,   59,    0,11450,    0,    0,
    0, 4085,  506,  506,    0, 1576,  971,  171,    0,    0,
  558,  474,  973, 5091,  159, 6001,    0,    0,    0, 1576,
    0,    0,    0,    0,    0,  922,    0,    0,    0,    0,
  317,  -85,    0,   47,  979,  962,  348, 4085, 4085,    0,
11042,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,11518,    0,  962,  447,    0, 2934,  447,    0,
    0,11586,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  447,  944,    0,    0,    0,    0,
    0,  703,10690, 3396,    0,    0,  719, 3518,  719,  966,
    0,    0,    0,    0,    1,    0,    0,    0,   36,    0,
    0,    0,   36,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   36,    0,    0,    0,    0,    0,    0,
    0,    0,  348,    0,    0,    0,    0,  619,  985,  986,
    0,  543,    0,    0,    0,   36,    0,    0,    0,    0,
    0,    0,  196, 4013,    0,    0, 3208,    0,  990,    0,
    0,    0,    0,    0, 2934,    0,    0, 4698,    0,    0,
 4698, 4698,    0,10770,    0,    0,    0, 4013,    0,  588,
 -203,    0, 3208,    0,    0,    0,    0,    0,    0,  988,
    0, 1013, 1015,    0,  588,    0,    0,  -14, 1022,    0,
 1023, 1024, 4013, 6001,    0,    0, 4013, 4013, 4013, 4013,
   30,  629,   30,    0,   36,   30,   30,    0,    0,    0,
 3208, 4475, 4475,   30,   36, 4013, 3208, 3208,    0,    0,
    0,    0, 1008,    0, 3208,    0,    0,   36,  774,    0,
 4475,    0, 4013, 3208,    0,    0,   30,    0, 3208,    0,
};
static const YYINT yyrindex[] = {                         0,
    0,  946,    0,    0,    0,    0, 6110, 8826,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1033,    0,    0,    0,    0,    0,    0,    0,    0,  798,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  801,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1395, 1484,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   97,  949,    0, 1026,    0,
 6274,    0,    0,    0, 6359, 6495, 6274, 6580,    0, 4311,
 6716, 6495,    0,  798, 6801,    0,    0,    0,    0,    0,
    0, 8885,    0,    0,11654, 6894,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  333,    0,    0,
  333,  333,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  525,  137,  533,    0,    0,    0,
    0,    0,    0,    0,    0,  505,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 6191,    0,    0,    0,    0,    0,    0,    0,  333,  333,
  333, 2373, 6146,    0, 7391, 7405, 1144,    0, 7413, 7460,
  333,  333,    0,    0,    0,  333,  333, 2185,  333,  333,
    0,    0,    0, 2198,    0,    0,    0,    0, 9182,    0,
 2368,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1027,    0,
    0,    0,    0,    0,    0,  800,    0,    0,  121,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1048,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  333, 9211, 9250,    0,    0, 9182,
  333,    0,    0,  333,    0,    0,    0,    0,    0,   25,
  333,    0,    0,    0,    0,    0,    0,    0,   28,   39,
    0,    0,    0,    0,  333,  682, 1790, 1004,    0,  796,
    0,    0,    0,  333,  333,  333,  333,  333,  333,  333,
  333,  333,  333,  333,  333,  333,  333,  333,  333,  333,
  333,  333,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  333,    0,  333,
   62,  702,  333,  333,  803,  242,    0,    0,  893,    0,
    0,    0,    0,    0,    0, 1041,  121,    0,   66,    0,
    0,    0,    0,    0, 1066,    0,    0,    0,    0,    0,
 1068,    0,  579,  385,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1119,11722,    0,    0,    0,    0,
    0,    0,  333,    0,    0,    0,  -29,    0,    0,    0,
    0,    0,    0, 1071,    0,  333,    0,10010, 1073,   45,
  129,  333,    0,    0,    0,    0,  796,  333,    0,    0,
    0,    0,    0, 9729,    0, 9593,    0, 9632,    0, 9911,
    0, 9347,    0, 9564,    0, 6656,    0,  531,    0,    0,
 9965,    0, 9940,    0, 9075,    0, 9661,    0, 9700,    0,
 9279,    0, 9318,    0,    0,    0,    0,    0,    0,    0,
    0,  702,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  333,    0,    0,    0,    6,    0,    0, 1697,    0,
    0,  318,    0,  -69,    0,    0,    0,    0,    0,    0,
 2753,    0,    0,    0,    0,    0,    0,    0, 5203,    0,
  333,    0,    0,    0,    0,    0,    0,    0,    0,  333,
    0,    0,    0,    0,    0, 4977,    0,    0,  958, 5192,
    0,    0,  393,    0,    0, 1077,    0,    0,    0,    0,
    0,    0,    0,    0,   21,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  333,    0,
    0,   41,    0,    0,    0,    0,   46,    0,  333,  333,
  333,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    6,    0,    0,    0,    0, 2274, 2274,    0,    0,
    0,    0,    0,    0,    0,    0,  646,    0,  804,  347,
    0,    0,    0,    0,    0,    0,    0,  333,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  333,
    0,    0,    0, 1048,  632,  635,    0,    0,    0,    0,
 1079, 3356,  733,    0,  333,    0,    0,  333,    0,    0,
    0,    0,    0,  373,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  646,    0,    0,    0,    0,    0,    0,
    0,    0, 4170,    0,    0, 8579,    0,  242,    0,    0,
    0,    0,   86, 1089,    0,  146,    0,  146,    0,    0,
 7014,    0,    0,  333,    0,  333,    0,    0,    0,  347,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 7103,    0,    0,    0,    0,  396,    0,    0,  315,    0,
  643,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  804,    0,    0,  333,    0,    0,
    0,  221,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  847,    0,    0,    0,    0,
    0,    0,    0, 1310,  321,  441,  417, 1974, 1233, 2457,
 2546,  863, 1879, 1308, 2279,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  333,    0,    0,  333,    0,    0,    0,
    0,    0,    0,    0,  333,    0,    0,  333,    0,    0,
  333,  333,    0,    0,    0,    0,    0,  131,    0,    0,
    0,    0,  333,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  333,  333,    0,    0,  333,  433,  333,  333,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  333,   57,  333,    0,    0,  517,  333,  333,    0,    0,
    0,    0,    0,    0,  333,    0,    0,    0, 2847,    0,
   -3,    0,   60,  333,    0,    0,    0,    0,  333,    0,
};
static const YYINT yygindex[] = {                         0,
 -297,    0, -547,    0,    0, -108, -241,    0,    0, -165,
    0,    0,    0,    0, -687, -190,    0,    0, -178,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   20,    0,  -17,  177,    0, -116,    0,    0,
  526,  -36, -192,  464, -623, -195, -614,  683,  260,    0,
    0,    0,  822,  909,  910,    0,  172,  -91, -160, -461,
    0,    0,    0,    0, -153,  571, -324, 2931,  248,    0,
  286,    0,  199, -221,    0,    0,    0,    0,    0,   -5,
    0,    0,    0,    0,    0,    0,  184, -453, -562, -283,
    0,    0, -340,    0,    0,    0,  309,    0,  434,    0,
    0,  507,  280,    0,    0,    0,  169,    0,    0,    0,
  868,    0,    0,    0,    0, 1009,    0,  183,    0, -196,
 -148,    0,  -18,    0,    0,    0,    2,  991,    0,    0,
  484,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   29,   11, -209,    0,  -46, -186,  419,    0, 1025,
    0,    0,    0,    0, 1031, -507,    0,    0,    0,    0,
    0,    0,    0,  753,    0,    0,    0,    0,   49,  256,
    0,    0,  310,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  424,    0,    0,    0,    0,    0,    0,  101,
    0,    0,    0,    0,    0,    0,    0,    0, -850,  -13,
    0,    0,
};
#define YYTABLESIZE 12062
static const YYINT yytable[] = {                         31,
  106,  211,  147,   11,  597,  107,  147,  677,  115,  126,
  178,  430,  118,  107,  384,  117,  233,  257,  258,  574,
  571,  289,  379,  305,  305,  947,  123,  479,  550,  333,
  340,  107,  316,  283,  730,  314,  296,  360,  569,  750,
  661,  183,  919,  145,  305,  390,   26,  145,  233,  404,
    6,  456,  394,  381,  379,  344,  536,  443,  461,  146,
  109,  431,  174,  156,  112,  432,  410,  234,  432,  936,
  960,  192,  686,  791,  937,  441,  743,  173,  331,  436,
  455,  431,  692,  698,  945,  430,  604,  814,  398,  454,
  742,  159,  161,  812,  885,  430,  107,  107,  417,  234,
  392,  166,  432,  412,  570,  699,  107,  444,  316,  218,
  381,  381,  107,  107,  381,  360,  292,    6,  315,  316,
  340,  360,  208,  218,  187,  457,  118,  210,  208,  220,
  388,  436,  107,  431,  938,  208,   79,  430,  604,  305,
  381,  442,  147,  220,  331,  431,  147,  458,  763,  208,
   18,    6,  432,  734,  959,  123,  147,  548,  672,  509,
  107,  147,  584,  454,  271,  208,  147,  212,  118,  107,
  208,  816,  602,  775,  534,  546,  670,  610,  430,  610,
  702,   30,  770,  145,  392,  869,  430,  145,  395,  395,
  827,  320,  749,  342,  610,  610,  110,  145,  770,  274,
   23,  874,  145,  278,  430,  684,  532,  145,  344,  384,
  673,  275,   11,  288,  789,  739,   18,  801,  600,   79,
  118,  602,  424,  278,  233,  144,  343,  685,  788,  144,
  379,  294,  147,  363,  337,  157,  340,  543,  147,  182,
  549,  547,  671,  555,  280,  378,  576,    3,  457,  281,
  305,  313,  381,  587,  586,  395,   17,  567,  118,  593,
   18,  317,  305,  946,  317,  363,   23,  595,  430,  291,
  364,  365,  776,  145,  360,  234,  733,  414,  317,  145,
  187,  499,  107,  342,  430,  336,   19,  191,  342,  399,
  514,  499,  573,  568,  440,  406,    5,  404,  404,  430,
  108,   20,   21,   22,  107,  499,  186,  958,  337,  499,
   23,  128,  499,  884,    3,  499,  451,  376,  377,  499,
  588,  343,  499,  499,  337,  499,  500,   24,  683,  337,
  894,  282,  171,  499,  431,  499,   25,  392,  432,  501,
  502,  499,  505,  317,  499,  147,  499,  387,    3,  376,
  377,  499,   79,  682,  499,  431,  499,  218,  218,  762,
  380,  334,  716,    5,  147,  144,  336,  210,  276,  144,
    4,  118,  107,  431,   79,  554,  337,  220,  220,  144,
  111,  655,  580,  191,  144,  918,  145,  430,  276,  144,
  533,  565,  610,  552,  545,  669,  701,    5,  769,  342,
  578,  430,  527,  172,  563,  145,  819,  147,  395,  107,
  514,  342,  430,  430,  800,  499,  600,  306,  307,  310,
  675,  527,  548,  430,   60,  499,  804,  667,  231,  310,
  310,  807,  343,  244,  310,  310,  244,  431,  336,   15,
  337,  363,  334,  231,  343,  665,  364,  365,  145,  389,
  244,  244,  337,  247,   45,  144,  247,  247,  786,  553,
  116,  144,  186,  366,  367,  600,  579,  149,  309,  430,
  315,  149,  805,  585,  368,  298,  317,  657,  322,  323,
  364,  189,  600,  326,  327,  244,  162,  403,  404,  744,
  453,  392,  361,  452,  710,  416,  337,  360,  317,  163,
  369,  662,  362,  370,  371,   16,  337,  372,  972,  972,
  415,  666,  708,  373,  795,  765,  374,  244,   45,  336,
  273,  392,  120,  375,  706,  376,  377,  972,  448,  107,
   46,  193,  793,  336,  747,  119,  713,  746,  403,  404,
   47,  107,  310,  310,  310,  310,  310,  310,  310,  310,
  310,  310,  310,  310,  310,  310,  310,  310,  310,  310,
  310,  768,   55,  194,  773,   12,  781,  790,  144,  315,
  431,  444,  120,   13,  444,  378,  682,  682,  709,  196,
  811,   26,   12,   12,  199,  514,  914,  144,  444,  444,
   13,   13,  431,  444,  820,  334,  419,  214,  794,  655,
  655,  913,  430,  817,  203,  435,  439,  149,  528,  529,
  655,  149,  551,  830,  435,  447,  830,  499,   53,  577,
  213,  149,  230,  444,  430,  818,  149,  499,   56,  208,
  144,  149,  830,  779,  780,  147,  655,  230,  262,  655,
  655,  272,  514,  655,  336,  587,  586,  147,  180,  655,
  147,   45,  655,  273,  411,  444,  336,  147,   14,  655,
  169,  286,  168,  504,  664,  507,  435,  516,  517,  518,
  244,  337,  963,   45,  824,  230,  145,  909,  231,  908,
  820,  208,  273,   79,  244,  244,   79,  962,  145,  290,
  230,  145,  156,  231,  298,  657,  657,  149,  145,  777,
   79,   79,  828,  149,  753,  147,  657,  754,  311,  147,
  392,  318,  588,  321,  181,  168,  851,  499,  572,  662,
  662,  393,  599,  147,  829,  599,  170,  499,  337,  210,
  662,  707,  657,  391,  107,  657,  657,  594,  566,  657,
  599,  147,  147,  910,  400,  657,  145,   11,  657,  264,
  145,  792,  457,  457,  927,  657,  662,  928,  929,  662,
  662,  876,  784,  662,  145,   79,  305,  305,  401,  662,
  402,  457,  662,  238,  599,  409,  238,  107,  460,  662,
   12,   54,  145,  145,  713,  305,  444,  662,   13,  107,
  238,  238,  458,  872,  378,   18,  196,  196,  107,  310,
  462,  499,  337,  444,  897,  851,  599,  519,  444,  525,
  149,  499,   50,  851,  880,  265,  822,  823,  526,  107,
  531,   19,  444,  444,  537,  238,  703,  877,  337,  149,
  813,  851,  337,  538,   53,  711,   20,   21,   22,   31,
  610,  539,  610,  610,  444,   23,   15,  541,  564,  528,
  529,  582,  916,  917,  452,  454,  867,  238,  144,  575,
  435,  922,   24,  924,  925,  585,  391,  179,  581,  851,
  144,   25,  149,  144,  726,  851,  851,  447,  590,  167,
  144,  592,  596,  851,  731,  732,  601,  237,  337,  668,
  237,  337,  851,  660,  663,  880,  907,  851,   79,  337,
  107,  361,  372,  308,  237,  237,  360,  358,  688,  359,
  676,  362,  337,  308,  308,  342,  342,  337,  308,  308,
   79,  330,  335,  661,  678,  323,   45,  395,  144,  690,
  499,  382,  144,  611,  342,  611,  611,  337,  693,  237,
  499,  337,  337,  337,  337,    1,  144,   45,  343,  343,
  611,  611,  695,  926,  696,  337,  337,  337,  704,  599,
  337,  337,  337,  714,  144,  144,  715,  343,  263,  337,
  717,  237,  718,  247,   46,  337,  720,  337,  337,  723,
  875,  724,  727,  337,   47,  755,  499,  330,  382,  382,
  735,  155,  382,  566,  566,   48,  499,  303,  243,  736,
  247,  243,  740,  247,  764,  886,  770,  766,  778,  893,
  238,  787,  446,  796,  810,  243,  243,  335,  382,  815,
  891,   30,   49,  896,  238,  238,  308,  308,  308,  308,
  308,  308,  308,  308,  308,  308,  308,  308,  308,  308,
  308,  308,  308,  308,  308,  911,  912,  923,  908,  799,
  243,  802,  943,  965,  944,  610,  967,  968,  323,   45,
   15,  948,  949,  950,  975,  920,  981,  984,  155,  553,
  553,   79,  553,  553,  553,  553,  553,  553,  553,  553,
  323,   45,  243,  548,   11,    7,   15,  989,  430,  934,
  553,  553,  553,  553,  553,  553,  604,  165,   76,  361,
  149,   15,   15,   15,  360,  358,  193,  359,  431,  362,
   15,   47,  149,   52,  951,  149,  305,  729,  953,  604,
  956,  957,  149,  553,  237,  553,  553,   15,  335,  225,
  382,  738,  906,  420,  348,  349,   15,  977,  237,  237,
  335,  661,  661,  324,  325,  722,  974,  895,  611,  905,
  772,  987,  661,  407,  209,  553,  553,  553,  902,  399,
  336,  336,  903,  986,  260,  745,  206,  198,  544,  931,
  149,  783,    0,  904,  149,    0,  399,  399,  661,  336,
    0,  661,  661,  247,  653,  661,    0,  653,  149,    0,
    0,  661,    0,  247,  661,  915,  247,  247,    0,    0,
    0,  661,  653,  155,  653,  155,  149,  149,    0,    0,
    0,  399,    0,  303,  361,  355,    0,    0,    0,  360,
  358,    0,  359,    0,  362,    0,  155,  155,    0,  952,
  155,  155,    0,    0,  155,  243,  653,  357,    0,  356,
  155,  155,  155,  399,  155,    0,  155,  155,  155,  243,
  243,  155,  155,  155,  155,  155,  155,    0,  155,    0,
    0,    0,  155,  155,  966,    0,  155,  155,  653,  155,
  155,  155,  155,  155,  976,  155,  155,    0,  155,    0,
  155,  155,  155,  308,    0,  155,    0,  983,  553,  553,
  553,  298,    0,  659,  553,  553,  553,  553,  553,  553,
  553,    0,  553,  553,  553,  553,  553,  553,  553,  553,
  553,  553,  553,  553,  553,  553,  553,  553,  547,  553,
  553,  553,  553,  553,  553,  553,  553,  553,  553,  553,
  553,  553,  553,    0,  553,  553,  553,  553,  553,  553,
  553,  553,  553,  553,  553,  553,  553,  347,  553,  553,
  553,  553,  553,  553,  553,  553,  553,  553,  553,  553,
  553,  553,  553,  553,  553,  553,  553,  553,  663,  553,
  648,  553,  553,  553,  553,    0,    0,    0,    0,    0,
    0,  361,    0,    0,    0,    0,  360,  358,    0,  359,
    0,  362,    0,    0,    0,    0,  399,    0,    0,  247,
    0,    0,    0,  921,  357,    0,  356,    0,    0,    0,
  399,  399,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  653,  653,  653,    0,    0,    0,    0,    0,  940,
    0,  561,  561,  653,  561,  561,  561,  561,  561,  561,
  561,  561,  344,  345,  346,  347,    0,  348,  349,    0,
    0,    0,  561,  561,  561,  561,  561,  561,    0,  653,
    0,    0,  653,  653,    0,    0,  653,  969,    0,    0,
    0,    0,  653,  979,  980,  653,    0,    0,    0,    0,
    0,  982,  653,    0,    0,  561,    0,  561,  561,    0,
  988,    0,    0,    0,    0,  990,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  298,  659,  659,    0,    0,    0,    0,  561,  561,  561,
  562,  562,  659,  562,  562,  562,  562,  562,  562,  562,
  562,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  562,  562,  562,  562,  562,  562,    0,  659,    0,
    0,  659,  659,    0,    0,  659,    0,    0,    0,    0,
    0,  659,    0,    0,  659,    0,    0,    0,    0,    0,
    0,  659,    0,    0,  562,    0,  562,  562,    0,    0,
    0,    0,    0,    0,    0,    0,  663,  663,  648,  648,
    0,    0,    0,    0,  499,    0,    0,  663,    0,  648,
    0,    0,    0,    0,  499,    0,  562,  562,  562,  344,
  345,  346,  347,    0,  348,  349,    0,    0,    0,  395,
    0,   26,    0,  663,    0,  648,  663,  663,  648,  648,
  663,    0,  648,    0,    0,    0,  663,    0,  648,  663,
    0,  648,    0,    0,  335,  335,  663,    0,  648,    0,
  561,  561,  561,    0,    0,    0,  561,  561,  561,  561,
  561,  561,  561,  335,  561,  561,  561,  561,  561,  561,
  561,  561,  561,  561,  561,  561,  561,  561,  561,  561,
    0,  561,  561,  561,  561,  561,  561,  561,  561,  561,
  561,  561,  561,  561,  561,    0,  561,  561,  561,  561,
  561,  561,  561,  561,  561,  561,  561,  561,  561,    0,
  561,  561,  561,  561,  561,  561,  561,  561,  561,  561,
  561,  561,  561,  561,  561,  561,  561,  561,  561,  561,
    0,  561,    0,  561,  561,  561,  561,  430,    0,  562,
  562,  562,  155,    0,    0,  562,  562,  562,  562,  562,
  562,  562,    0,  562,  562,  562,  562,  562,  562,  562,
  562,  562,  562,  562,  562,  562,  562,  562,  562,    0,
  562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
  562,  562,  562,  562,    0,  562,  562,  562,  562,  562,
  562,  562,  562,  562,  562,  562,  562,  562,    0,  562,
  562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
  562,  562,  562,  562,  562,  562,  562,  562,  562,  430,
  562,    0,  562,  562,  562,  562,  540,  540,    0,  540,
  540,  540,  540,  540,  540,   18,  540,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  540,  540,  540,
  540,  540,  540,    0,    0,    0,  131,  132,    0,    0,
    0,   19,    0,    0,  133,    0,    0,    0,    0,    0,
    0,    0,  134,    0,  135,    0,   20,   21,   22,    0,
  540,    0,  540,  540,    0,   23,  136,    0,  137,    0,
    0,    0,  138,  139,    0,    0,    0,  140,    0,    0,
  141,    0,   24,    0,    0,    0,  142,    0,    0,    0,
    0,   25,  143,  540,  540,  553,  553,    0,  553,   33,
  553,  553,  553,  553,  553,  553,    0,    0,    0,    0,
   34,   35,   36,    0,    0,    0,  295,  553,  553,  553,
  553,  553,    0,    0,   37,    0,    0,   38,    0,   39,
    0,   40,  430,   41,    0,    0,  155,    0,   42,    0,
    0,    0,    0,   43,    0,    0,    0,    0,    0,  553,
    0,    0,  553,    0,  430,    0,    0,  155,  155,    0,
    0,    0,  155,    0,    0,  155,    0,    0,    0,    0,
    0,    0,  155,  155,    0,  155,    0,  155,  155,  155,
    0,    0,  553,  155,  155,  155,  155,  155,    0,  155,
    0,    0,    0,  155,  155,    0,    0,  155,  155,    0,
  155,  155,  155,  155,  155,    0,  155,  155,    0,    0,
    0,  155,  155,  155,  658,    0,  155,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  540,    0,    0,    0,
    0,  540,  540,  192,  540,  540,  540,  540,    0,  540,
  540,  540,  540,  192,  192,  192,  192,  540,  540,  540,
  192,  192,  192,  192,  192,    0,  192,  192,  192,  540,
  192,  540,  540,  192,  192,  192,  192,  192,  192,  192,
    0,  192,  192,  192,  192,  192,  192,  192,  192,  192,
  192,  192,  192,    0,    0,  540,  192,  192,  540,  540,
  192,  192,  540,  192,  192,  192,  192,  192,  540,  192,
  192,  540,  192,  192,  192,  383,  192,    0,  540,  192,
  540,  540,    0,    0,    0,  553,    0,    0,    0,    0,
  553,  553,  553,  553,  553,  553,  553,    0,  553,  553,
  553,  553,  553,  553,  553,  553,  553,  553,  553,  553,
  553,  553,  553,  553,  547,  553,  553,  553,  553,  553,
    0,    0,  553,  553,  553,  553,  553,  553,  553,    0,
  553,  553,  553,  553,  553,  553,  553,  553,  553,  553,
  553,  553,    0,    0,  553,  553,  553,  553,  553,  553,
  553,  553,  553,  553,  553,  553,  553,  553,  553,  553,
  553,  553,  553,  553,    0,  553,    0,  553,  553,  553,
  553,  500,  500,    0,  500,  500,  500,  500,  500,  500,
  500,  500,    0,    0,    0,    0,    0,    0,  418,    0,
    0,  418,  500,  500,  500,  500,  500,  500,    0,    0,
  599,    0,  658,  658,    0,  418,  418,    0,  499,    0,
    0,    0,    0,  658,    0,    0,    0,    0,  499,    0,
    0,    0,    0,    0,    0,  500,    0,  500,  500,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  658,
  418,    0,  658,  658,    0,    0,  658,    0,    0,    0,
    0,    0,  658,    0,    0,  658,    0,    0,  500,  500,
  491,  491,  658,  491,  491,  491,  491,  491,  491,  491,
  491,    0,  418,    0,    0,    0,    0,    0,    0,    0,
    0,  491,  491,  491,  491,  491,  491,    0,    0,  649,
  361,    0,    0,  366,  367,  360,  358,    0,  359,    0,
  362,    0,    0,    0,  368,    0,    0,    0,    0,    0,
    0,    0,    0,  357,  491,  356,  491,  491,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  369,    0,    0,  370,  371,    0,    0,  372,    0,    0,
    0,    0,    0,  373,    0,    0,  374,  491,  491,    0,
    0,    0,    0,  375,  540,  540,    0,  540,  540,  540,
  540,  540,  540,  654,  540,    0,  654,    0,    0,    0,
    0,    0,    0,    0,    0,  540,  540,  540,  540,  540,
  540,  654,    0,  654,    0,    0,    0,    0,    0,    0,
  500,  500,    0,    0,    0,  598,  500,  500,    0,  500,
  500,  500,  500,  418,  500,  500,  500,  500,  540,    0,
  540,  540,  500,  500,  500,  654,    0,    0,  366,  367,
  548,    0,    0,    0,  500,  418,  500,  500,    0,  368,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  418,
  418,  540,  540,    0,    0,    0,  301,  654,  500,    0,
  500,  301,  301,  500,  500,  369,    0,  500,  370,  371,
    0,  418,  372,  500,    0,  301,  500,  660,  373,    0,
    0,  374,    0,  500,    0,  500,  500,    0,  375,  491,
  491,    0,    0,    0,    0,  491,  491,    0,  491,  491,
  491,  491,    0,  491,  491,  491,  491,  301,    0,    0,
    0,  491,  491,  491,    0,    0,    0,  649,  649,    0,
    0,    0,    0,  491,    0,  491,  491,    0,  649,  345,
  346,    0,    0,  348,  349,    0,    0,    0,    0,  301,
    0,  301,  301,    0,    0,  247,    0,  491,    0,  491,
  247,  247,  491,  491,  649,    0,  491,  649,  649,    0,
    0,  649,  491,    0,  247,  491,  646,  649,    0,    0,
  649,    0,  491,    0,  491,  491,    0,  649,    0,    0,
    0,    0,    0,  540,  540,    0,    0,    0,    0,  540,
  540,    0,  540,  540,  540,  540,  247,  540,  540,  540,
  540,    0,    0,    0,    0,  540,  540,  540,    0,    0,
  654,  654,  654,    0,    0,    0,    0,  540,    0,  540,
  540,    0,  654,    0,    0,    0,    0,    0,  247,    0,
    0,  247,    0,    0,    0,    0,    0,    0,    0,    0,
  295,  540,    0,  540,    0,   26,  540,  540,  654,    0,
  540,  654,  654,    0,    0,  654,  540,    0,    0,  540,
    0,  654,    0,    0,  654,    0,  540,    0,  540,  540,
    0,  654,  301,    0,  301,  301,  301,  301,  301,  301,
  301,    0,    0,    0,    0,  301,    0,    0,    0,    0,
  301,  301,  301,  301,  301,  660,  660,  301,  301,  301,
  301,  301,  301,  301,  301,  301,  660,  301,    0,    0,
  301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
  301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
    0,  301,  660,  301,  301,  660,  660,  301,  301,  660,
  301,  301,  301,  301,  301,  660,  301,  301,  660,    0,
  301,  301,  301,  301,  301,  660,  301,    0,  219,    0,
    0,  247,    0,  247,  247,  247,  247,  247,  247,  247,
  431,    0,    0,    0,  247,    0,    0,    0,    0,  247,
  247,  247,  247,    0,  646,  646,  247,  247,  247,  247,
  247,  247,  247,  247,  247,  646,  247,    0,    0,  247,
  247,  247,  247,  247,  247,  247,  247,  247,  247,  247,
  247,  247,  247,  247,  247,  247,  247,  247,  247,    0,
  247,  646,  247,  247,  646,  646,  247,  247,  646,  247,
  247,  247,  247,  247,  646,  247,  247,  646,    0,  247,
  247,  247,  247,  247,  646,  247,  353,    0,    0,    0,
    0,  353,  353,    0,    0,  277,    0,    0,    0,   18,
    0,    0,    0,    0,    0,  353,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  131,  132,    0,    0,    0,   19,    0,    0,  133,    0,
    0,    0,    0,    0,    0,    0,  134,  353,  135,    0,
   20,   21,   22,    0,    0,    0,    0,    0,    0,   23,
  136,    0,  137,    0,    0,    0,  138,  139,    0,    0,
    0,  140,    0,    0,  141,    0,   24,    0,    0,  353,
  142,  353,  353,  233,    0,   25,  143,    0,  231,   26,
    0,  131,  132,    0,    0,    0,    0,    0,    0,  133,
    0,    0,  847,    0,    0,    0,    0,  134,    0,  135,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  136,  219,  137,    0,    0,    0,  138,  139,    0,
    0,    0,  140,    0,  234,  141,    0,    0,    0,    0,
    0,  142,    0,  219,  219,    0,    0,  143,  219,    0,
    0,  219,    0,    0,  431,  431,    0,    0,    0,  219,
    0,  219,    0,  219,  219,  219,  315,    0,  750,  232,
    0,    0,  219,  219,    0,  219,    0,    0,    0,  219,
  219,    0,    0,    0,  219,    0,    0,  219,    0,  219,
    0,  233,    0,  219,    0,    0,    0,   26,  219,  219,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  353,    0,  353,  353,  353,  353,  353,  353,
  353,    0,    0,    0,    0,  353,    0,    0,    0,    0,
  353,  353,  353,  353,  353,    0,    0,  353,  353,  353,
  353,  353,  353,  353,  353,  353,   26,  353,    0,    0,
    0,  353,  353,  353,  353,  353,  353,  353,  353,  353,
  353,  353,  353,  353,  353,  353,  353,  353,  353,  353,
    0,  353,    0,  353,  353,    0,    0,  353,  353,    0,
  353,  353,  353,  353,  353,    0,  353,  353,    0,    0,
  353,  353,  353,  353,  353,    0,  353,    0,    0,  832,
    0,  833,  217,   18,  218,  219,  220,  834,    0,    0,
    0,    0,  221,    0,    0,    0,    0,  835,  222,  223,
  836,  749,    0,    0,  131,  132,  837,  838,    0,   19,
  839,  840,  133,    0,  841,    0,    0,   71,    0,   73,
  134,  842,  135,  225,   20,  843,   22,  844,  845,   82,
   83,  226,   85,   23,  136,  227,  137,  233,  228,    0,
  138,  139,  231,   26,   92,  140,    0,   94,  141,   96,
  229,   98,    0,   99,  142,    0,  847,  230,  103,   25,
  143,  846,    0,  105,  464,  466,  468,  470,  472,  474,
  476,  478,    0,  481,  483,  485,  487,  489,  491,  493,
  495,  497,  499,    0,    0,    0,    0,    0,  234,    0,
  217,   18,  218,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  299,  300,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   19,    0,    0,
  315,    0,  233,  232,  513,    0,    0,  231,   26,    0,
    0,  301,   20,   21,   22,    0,  277,    0,    0,  302,
   18,   23,  512,  303,    0,    0,  228,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   24,    0,
    0,  131,  132,    0,    0,  304,   19,   25,    0,  133,
    0,    0,    0,  234,    0,    0,    0,  134,    0,  135,
    0,   20,   21,   22,    0,  303,  237,    0,    0,  237,
   23,  136,    0,  137,    0,    0,    0,  138,  139,    0,
    0,    0,  140,  237,  237,  141,    0,   24,  232,    0,
    0,  142,    0,    0,    0,    0,   25,  143,    0,    0,
    0,    0,    0,    0,    0,  233,    0,    0,    0,    0,
  231,   26,    0,    0,    0,    0,    0,    0,  237,    0,
    0,    0,    0,    0,  885,    0,    0,    0,    0,    0,
    0,    0,    0,  832,    0,  833,  217,   18,  218,  219,
  220,  834,    0,    0,    0,    0,  221,    0,    0,    0,
  237,  835,  222,  223,  836,    0,  234,    0,  131,  132,
  837,  838,    0,   19,  839,  840,  133,    0,  841,    0,
    0,   71,    0,   73,  134,  842,  135,  225,   20,  843,
   22,  844,  845,   82,   83,  226,   85,   23,  136,  227,
  137,  232,  228,    0,  138,  139,    0,    0,   92,  140,
    0,   94,  141,   96,  229,   98,    0,   99,  142,    0,
    0,  230,  103,   25,  143,  846,    0,  105,  510,    0,
    0,  217,   18,  218,  219,  220,   57,  233,    0,    0,
    0,  221,  231,   26,    0,    0,   58,  222,  223,   61,
  511,    0,    0,  131,  132,   64,   65,    0,   19,   67,
   68,  133,    0,   70,    0,    0,   71,    0,   73,  134,
   75,  135,  225,   20,   21,   22,   80,   81,   82,   83,
  226,   85,   23,  136,  227,  137,    0,  228,  234,  138,
  139,  303,    0,   92,  140,    0,   94,  141,   96,  229,
   98,    0,   99,  142,    0,    0,  230,  103,   25,  143,
    0,    0,  105,  237,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  232,    0,    0,    0,  237,  237,    0,
    0,  883,    0,    0,  217,   18,  218,  219,  220,   57,
  233,    0,    0,    0,  221,  231,   26,    0,    0,   58,
  222,  223,   61,  884,    0,    0,  131,  132,   64,   65,
    0,   19,   67,   68,  133,    0,   70,    0,    0,   71,
    0,   73,  134,   75,  135,  225,   20,   21,   22,   80,
   81,   82,   83,  226,   85,   23,  136,  227,  137,    0,
  228,  234,  138,  139,    0,    0,   92,  140,    0,   94,
  141,   96,  229,   98,    0,   99,  142,    0,    0,  230,
  103,   25,  143,    0,    0,  105,    0,    0,    0,    0,
    0,    0,    0,  329,    0,  233,  232,    0,    0,    0,
  231,   26,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  512,    0,    0,    0,    0,
    0,    0,    0,  883,    0,    0,  217,   18,  218,  219,
  220,   57,    0,    0,    0,    0,  221,    0,    0,    0,
    0,   58,  222,  223,   61,    0,  234,    0,  131,  132,
   64,   65,    0,   19,   67,   68,  133,    0,   70,  403,
  404,   71,    0,   73,  134,   75,  135,  225,   20,   21,
   22,   80,   81,   82,   83,  226,   85,   23,  136,  227,
  137,  232,  228,    0,  138,  139,    0,    0,   92,  140,
    0,   94,  141,   96,  229,   98,    0,   99,  142,    0,
    0,  230,  103,   25,  143,    0,    0,  105,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  328,    0,    0,  217,
   18,  218,  219,  220,   57,  233,    0,    0,    0,  221,
  231,   26,    0,    0,   58,  222,  223,   61,    0,    0,
    0,  131,  132,   64,   65,    0,   19,   67,   68,  133,
    0,   70,    0,    0,   71,    0,   73,  134,   75,  135,
  225,   20,   21,   22,   80,   81,   82,   83,  226,   85,
   23,  136,  227,  137,    0,  228,  234,  138,  139,    0,
    0,   92,  140,    0,   94,  141,   96,  229,   98,    0,
   99,  142,    0,    0,  230,  103,   25,  143,    0,    0,
  105,    0,    0,    0,  217,   18,  218,  219,  220,   57,
  233,  232,    0,    0,  221,  231,   26,    0,    0,   58,
  222,  223,   61,  511,    0,    0,  131,  132,   64,   65,
    0,   19,   67,   68,  133,    0,   70,    0,    0,   71,
    0,   73,  134,   75,  135,  225,   20,   21,   22,   80,
   81,   82,   83,  226,   85,   23,  136,  227,  137,    0,
  228,  234,  138,  139,    0,    0,   92,  140,    0,   94,
  141,   96,  229,   98,    0,   99,  142,    0,    0,  230,
  103,   25,  143,    0,    0,  105,    0,    0,    0,    0,
    0,    0,  233,    0,    0,    0,  232,  231,   26,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  421,    0,  234,  217,   18,  218,  219,  220,   57,
    0,    0,    0,    0,  221,    0,    0,    0,    0,   58,
  222,  223,   61,    0,    0,    0,  131,  132,   64,   65,
   26,   19,   67,   68,  133,    0,   70,    0,  232,   71,
    0,   73,  134,   75,  135,  225,   20,   21,   22,   80,
   81,   82,   83,  226,   85,   23,  136,  227,  137,    0,
  228,    0,  138,  139,    0,    0,   92,  140,    0,   94,
  141,   96,  229,   98,    0,   99,  142,    0,    0,  230,
  103,   25,  143,    0,    0,  105,    0,    0,    0,  217,
   18,  218,  219,  220,   57,    0,    0,    0,    0,  221,
    0,    0,    0,    0,   58,  222,  223,   61,  674,    0,
  431,  131,  132,   64,   65,  155,   19,   67,   68,  133,
    0,   70,    0,    0,   71,    0,   73,  134,   75,  135,
  225,   20,   21,   22,   80,   81,   82,   83,  226,   85,
   23,  136,  227,  137,    0,  228,    0,  138,  139,    0,
    0,   92,  140,    0,   94,  141,   96,  229,   98,    0,
   99,  142,    0,    0,  230,  103,   25,  143,  883,    0,
  105,  217,   18,  218,  219,  220,   57,    0,    0,    0,
    0,  221,    0,    0,    0,    0,   58,  222,  223,   61,
    0,    0,  431,  131,  132,   64,   65,    0,   19,   67,
   68,  133,    0,   70,    0,    0,   71,    0,   73,  134,
   75,  135,  225,   20,   21,   22,   80,   81,   82,   83,
  226,   85,   23,  136,  227,  137,    0,  228,    0,  138,
  139,    0,    0,   92,  140,    0,   94,  141,   96,  229,
   98,    0,   99,  142,   18,    0,  230,  103,   25,  143,
  207,  206,  105,    0,  206,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  131,  132,    0,  206,  206,
   19,    0,    0,  133,    0,    0,    0,    0,    0,    0,
    0,  134,    0,  135,    0,   20,   21,   22,    0,    0,
    0,    0,    0,    0,   23,  136,    0,  137,    0,    0,
    0,  138,  139,  206,    0,    0,  140,    0,    0,  141,
    0,   24,    0,    0,    0,  142,    0,    0,    0,    0,
   25,  143,    0,    0,    0,  431,    0,    0,    0,  155,
    0,    0,  233,  206,  206,    0,    0,  231,   26,    0,
    0,    0,    0,    0,    0,    0,    0,  431,    0,    0,
  155,  155,    0,    0,    0,  155,    0,    0,  155,    0,
    0,    0,    0,    0,    0,  155,  155,    0,  155,    0,
  155,  155,  155,    0,    0,    0,  155,  155,  155,  155,
  155,    0,  155,  234,    0,    0,  155,  155,    0,    0,
  155,  155,    0,  155,  155,  155,  155,  155,    0,  155,
  155,    0,    0,    0,  155,  155,  155,    0,    0,  155,
    0,    0,    0,    0,  233,    0,    0,    0,  232,    0,
   26,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  234,  206,    0,  206,    0,
    0,    0,    0,    0,  206,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  206,  206,  206,  206,  206,    0,
    0,  206,  206,  206,  206,  206,    0,  206,  206,  206,
    0,  206,  206,  206,  206,  206,  206,  206,  206,  206,
  206,    0,  206,  206,  206,  206,  206,  206,  206,  206,
  206,  206,  206,  206,    0,    0,    0,  206,  206,    0,
    0,  206,  206,  233,  206,  206,  206,  206,  206,   26,
  206,  206,    0,  206,  206,  206,    0,  206,    0,    0,
  206,  217,   18,  218,  219,  220,   57,    0,    0,    0,
    0,  221,    0,    0,    0,    0,   58,  222,  223,   61,
    0,    0,    0,  131,  132,   64,   65,    0,   19,   67,
   68,  133,    0,   70,  234,    0,   71,    0,   73,  134,
   75,  135,  225,   20,   21,   22,   80,   81,   82,   83,
  226,   85,   23,  136,  227,  137,    0,  228,    0,  138,
  139,    0,    0,   92,  140,    0,   94,  141,   96,  229,
   98,    0,   99,  142,    0,    0,  230,  103,   25,  143,
  970,    0,  105,  217,   18,  218,    0,  233,   57,    0,
    0,    0,  231,   26,    0,    0,    0,    0,   58,  222,
  223,   61,    0,    0,    0,  131,  132,   64,   65,    0,
   19,   67,   68,  133,    0,   70,    0,    0,   71,    0,
   73,  134,   75,  135,  225,   20,   21,   22,   80,   81,
   82,   83,  226,   85,   23,  136,  227,  137,  234,  228,
    0,  138,  139,    0,    0,   92,  140,    0,   94,  141,
   96,  229,   98,    0,   99,  142,    0,    0,  230,  103,
   25,  143,    0,    0,  105,    0,    0,    0,    0,    0,
    0,    0,    0,  232,    0,    0,  361,  355,    0,    0,
    0,  360,  358,    0,  359,    0,  362,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  357,
    0,  356,  217,   18,  218,    0,  233,   57,    0,    0,
    0,  231,   26,    0,    0,    0,    0,   58,  222,  223,
   61,    0,    0,    0,  131,  132,   64,   65,    0,   19,
   67,   68,  133,  354,   70,    0,    0,   71,    0,   73,
  134,   75,  135,  225,   20,   21,   22,   80,   81,   82,
   83,  226,   85,   23,  136,  227,  137,  234,  228,    0,
  138,  139,    0,  353,   92,  140,    0,   94,  141,   96,
  229,   98,    0,   99,  142,    0,    0,  230,  103,   25,
  143,    0,    0,  105,    0,    0,    0,    0,    0,  329,
    0,    0,  232,  233,    0,    0,    0,    0,  231,   26,
    0,    0,    0,  216,    0,    0,  217,   18,  218,  219,
  220,   57,    0,    0,    0,    0,  221,  433,    0,    0,
    0,   58,  222,  223,   61,  224,    0,    0,    0,    0,
   64,   65,    0,   19,   67,   68,    0,    0,   70,    0,
    0,   71,    0,   73,  234,   75,    0,  225,   20,   21,
   22,   80,   81,   82,   83,  226,   85,   23,    0,  227,
    0,    0,  228,    0,    0,    0,    0,  400,   92,    0,
    0,   94,    0,   96,  229,   98,    0,   99,    0,  232,
    0,  230,  103,   25,  400,  400,    0,  105,    0,    0,
    0,    0,    0,  233,    0,    0,    0,    0,  231,   26,
    0,    0,    0,    0,  344,  345,  346,  347,    0,  348,
  349,  350,    0,    0,    0,    0,    0,  433,    0,  400,
    0,    0,  328,    0,    0,  217,   18,  218,  219,  220,
   57,    0,    0,    0,    0,  221,    0,    0,    0,    0,
   58,  222,  223,   61,  234,    0,    0,    0,    0,   64,
   65,  400,   19,   67,   68,    0,    0,   70,    0,    0,
   71,    0,   73,    0,   75,    0,  225,   20,   21,   22,
   80,   81,   82,   83,  226,   85,   23,    0,  227,  232,
  233,  228,    0,    0,    0,  231,   26,   92,    0,    0,
   94,    0,   96,  229,   98,    0,   99,    0,    0,    0,
  230,  103,   25,    0,    0,    0,  105,    0,    0,  432,
    0,    0,  217,   18,  218,  219,  220,   57,    0,    0,
    0,    0,  221,    0,    0,    0,    0,   58,  222,  223,
   61,  234,    0,    0,    0,    0,   64,   65,    0,   19,
   67,   68,    0,    0,   70,    0,    0,   71,    0,   73,
    0,   75,    0,  225,   20,   21,   22,   80,   81,   82,
   83,  226,   85,   23,    0,  227,  232,    0,  228,    0,
    0,    0,    0,    0,   92,    0,    0,   94,    0,   96,
  229,   98,  401,   99,    0,    0,    0,  230,  103,   25,
    0,    0,  232,  105,    0,    0,    0,  232,  232,  401,
  401,    0,    0,    0,  400,    0,    0,    0,    0,  508,
    0,    0,  217,   18,  218,  219,  220,   57,  400,  400,
    0,    0,  221,    0,    0,    0,    0,   58,  222,  223,
   61,    0,    0,    0,  401,    0,   64,   65,    0,   19,
   67,   68,    0,  232,   70,    0,    0,   71,    0,   73,
    0,   75,    0,  225,   20,   21,   22,   80,   81,   82,
   83,  226,   85,   23,    0,  227,  401,    0,  228,    0,
    0,    0,    0,    0,   92,    0,    0,   94,  232,   96,
  229,   98,    0,   99,    0,    0,  233,  230,  103,   25,
    0,  231,   26,  105,    0,    0,  797,    0,    0,  217,
   18,  218,  219,  220,   57,    0,    0,    0,    0,  221,
    0,    0,    0,    0,   58,  222,  223,   61,  798,    0,
    0,    0,    0,   64,   65,    0,   19,   67,   68,    0,
    0,   70,    0,    0,   71,    0,   73,  234,   75,    0,
  225,   20,   21,   22,   80,   81,   82,   83,  226,   85,
   23,    0,  227,    0,    0,  228,    0,    0,    0,    0,
    0,   92,    0,    0,   94,    0,   96,  229,   98,    0,
   99,    0,  232,    0,  230,  103,   25,    0,    0,  233,
  105,    0,    0,    0,  231,   26,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  232,  232,  232,  232,  232,  232,    0,    0,  401,
    0,  232,    0,    0,    0,    0,  232,  232,  232,  232,
  234,    0,    0,  401,  401,  232,  232,  232,  232,  232,
  232,    0,    0,  232,    0,    0,  232,  232,  232,    0,
  232,    0,  232,  232,  232,  232,  232,  232,  232,  232,
  232,  232,  232,    0,  232,  232,    0,  232,    0,    0,
    0,    0,    0,  232,    0,    0,  232,    0,  232,  232,
  232,    0,  232,    0,    0,    0,  232,  232,  232,    0,
    0,    0,  232,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  418,    0,    0,  217,   18,  218,  219,  220,
   57,  233,    0,    0,    0,  221,  231,   26,    0,    0,
   58,  222,  223,   61,    0,    0,    0,    0,    0,   64,
   65,    0,   19,   67,   68,  433,    0,   70,    0,    0,
   71,    0,   73,    0,   75,    0,  225,   20,   21,   22,
   80,   81,   82,   83,  226,   85,   23,    0,  227,    0,
    0,  228,  234,    0,    0,    0,    0,   92,    0,    0,
   94,    0,   96,  229,   98,    0,   99,    0,    0,    0,
  230,  103,   25,    0,    0,    0,  105,    0,    0,    0,
    0,    0,    0,    0,    0,  438,    0,  232,  217,   18,
  218,  219,  220,   57,  233,    0,    0,    0,  221,  231,
   26,    0,    0,   58,  222,  223,   61,    0,    0,    0,
    0,    0,   64,   65,    0,   19,   67,   68,    0,    0,
   70,    0,    0,   71,    0,   73,    0,   75,    0,  225,
   20,   21,   22,   80,   81,   82,   83,  226,   85,   23,
    0,  227,    0,    0,  228,  234,    0,    0,    0,    0,
   92,    0,    0,   94,    0,   96,  229,   98,    0,   99,
    0,    0,    0,  230,  103,   25,    0,    0,    0,  105,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  232,    0,    0,    0,    0,    0,    0,    0,  233,    0,
    0,    0,    0,  231,   26,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  217,   18,  218,  219,  220,   57,    0,    0,    0,    0,
  221,    0,    0,    0,    0,   58,  222,  223,   61,  234,
    0,    0,    0,    0,   64,   65,    0,   19,   67,   68,
    0,    0,   70,    0,    0,   71,    0,   73,    0,   75,
    0,  225,   20,   21,   22,   80,   81,   82,   83,  226,
   85,   23,    0,  227,  232,    0,  228,    0,    0,    0,
    0,    0,   92,    0,    0,   94,    0,   96,  229,   98,
    0,   99,    0,  233,    0,  230,  103,   25,  231,   26,
    0,  105,    0,    0,    0,    0,    0,    0,    0,    0,
  503,    0,    0,  217,   18,  218,  219,  220,   57,    0,
    0,    0,    0,  221,    0,    0,    0,    0,   58,  222,
  223,   61,    0,    0,    0,    0,    0,   64,   65,    0,
   19,   67,   68,    0,  234,   70,    0,    0,   71,    0,
   73,    0,   75,    0,  225,   20,   21,   22,   80,   81,
   82,   83,  226,   85,   23,    0,  227,    0,    0,  228,
    0,    0,    0,    0,    0,   92,    0,    0,   94,  232,
   96,  229,   98,    0,   99,    0,    0,  233,  230,  103,
   25,    0,  231,   26,  105,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  506,    0,    0,  217,   18,  218,
  219,  220,   57,    0,    0,    0,    0,  221,    0,    0,
    0,    0,   58,  222,  223,   61,    0,    0,    0,    0,
    0,   64,   65,    0,   19,   67,   68,    0,  234,   70,
    0,    0,   71,    0,   73,    0,   75,    0,  225,   20,
   21,   22,   80,   81,   82,   83,  226,   85,   23,    0,
  227,    0,    0,  228,    0,    0,    0,    0,    0,   92,
    0,    0,   94,  232,   96,  229,   98,    0,   99,    0,
  233,    0,  230,  103,   25,  231,   26,    0,  105,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  725,
    0,    0,  217,   18,  218,  219,  220,   57,    0,    0,
    0,    0,  221,    0,    0,    0,    0,   58,  222,  223,
   61,  234,    0,    0,    0,    0,   64,   65,    0,   19,
   67,   68,    0,    0,   70,    0,    0,   71,    0,   73,
    0,   75,    0,  225,   20,   21,   22,   80,   81,   82,
   83,  226,   85,   23,    0,  227,  232,    0,  228,    0,
    0,    0,    0,    0,   92,    0,    0,   94,    0,   96,
  229,   98,    0,   99,    0,    0,    0,  230,  103,   25,
    0,    0,    0,  105,    0,  154,    0,    0,    0,    0,
    0,    0,    0,  728,    0,    0,  217,   18,  218,  219,
  220,   57,    0,    0,    0,    0,  221,    0,    0,    0,
    0,   58,  222,  223,   61,  584,  651,    0,    0,  651,
   64,   65,    0,   19,   67,   68,    0,    0,   70,    0,
    0,   71,    0,   73,  651,   75,  651,  225,   20,   21,
   22,   80,   81,   82,   83,  226,   85,   23,    0,  227,
    0,    0,  228,    0,    0,    0,    0,    0,   92,    0,
    0,   94,  154,   96,  229,   98,  155,   99,  651,    0,
    0,  230,  103,   25,    0,    0,    0,  105,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  217,
   18,  218,  219,  220,   57,    0,    0,    0,  584,  221,
  651,    0,    0,    0,   58,  222,  223,   61,    0,    0,
    0,    0,    0,   64,   65,    0,   19,   67,   68,    0,
    0,   70,    0,    0,   71,    0,   73,    0,   75,    0,
  225,   20,   21,   22,   80,   81,   82,   83,  226,   85,
   23,    0,  227,  155,  222,  228,    0,  222,    0,    0,
    0,   92,    0,    0,   94,    0,   96,  229,   98,    0,
   99,  222,  222,    0,  230,  103,   25,    0,    0,    0,
  105,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  222,  154,    0,  154,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  154,  154,    0,    0,  154,  154,  222,  222,  154,  215,
    0,  584,  215,    0,  154,    0,  154,    0,  154,    0,
  154,  154,  154,    0,    0,  154,  215,  215,    0,  154,
  154,    0,  154,  651,  651,  651,  154,  154,    0,    0,
    0,  154,    0,    0,  154,  651,  154,    0,    0,    0,
  154,    0,  154,    0,    0,  154,  154,    0,  155,    0,
  155,  215,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  651,    0,    0,  651,  651,    0,    0,  651,    0,
    0,  155,  155,    0,  651,  155,  155,  651,    0,  155,
    0,  215,  215,    0,  651,  155,  155,  155,    0,  155,
    0,  155,  155,  155,    0,    0,  155,  155,  155,  155,
  155,  155,    0,  155,    0,    0,    0,  155,  155,    0,
    0,  155,  155,    0,  155,  155,  155,  155,  155,    0,
  155,  155,    0,  155,    0,  155,  155,  155,    0,  222,
  155,  222,    0,    0,    0,  201,    0,  222,  201,    0,
    0,    0,    0,    0,    0,    0,    0,  222,  222,  222,
  222,  222,  201,  201,  222,  222,  222,  222,  222,    0,
  222,  222,  222,    0,  222,  222,  222,  222,  222,  222,
  222,  222,  222,  222,    0,  222,  222,  222,  222,  222,
  222,  222,  222,  222,  222,  222,  222,  201,    0,    0,
  222,  222,    0,    0,  222,  222,    0,  222,  222,  222,
  222,  222,    0,  222,  222,    0,  222,  222,  222,    0,
  222,    0,    0,  222,  215,    0,  215,  201,  201,    0,
  227,    0,  215,  227,    0,    0,    0,    0,    0,    0,
    0,    0,  215,  215,  215,  215,  215,  227,  227,  215,
  215,  215,  215,  215,    0,  215,  215,  215,    0,  215,
  215,  215,  215,  215,  215,  215,  215,  215,  215,    0,
  215,  215,  215,  215,  215,  215,  215,  215,  215,  215,
  215,  215,  227,    0,    0,  215,  215,    0,    0,  215,
  215,    0,  215,  215,  215,  215,  215,    0,  215,  215,
    0,  215,  215,  215,    0,  215,  445,    0,  215,  445,
    0,    0,  227,  227,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  445,  445,    0,    0,    0,  445,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  445,    0,
  201,    0,  201,    0,    0,    0,  209,    0,  201,  209,
    0,    0,    0,    0,    0,    0,    0,    0,  201,  201,
  201,  201,  201,  209,  209,  201,  201,  201,  201,  201,
  445,  201,  201,  201,    0,  201,  201,  201,  201,  201,
  201,  201,  201,  201,  201,    0,  201,  201,  201,  201,
  201,  201,  201,  201,  201,  201,  201,  201,  209,    0,
    0,  201,  201,    0,    0,  201,  201,    0,  201,  201,
  201,  201,  201,    0,  201,  201,    0,  201,  201,  201,
    0,  201,    0,    0,  201,  227,    0,  227,  209,  209,
    0,  192,    0,  227,  192,    0,    0,    0,    0,    0,
    0,    0,    0,  227,  227,  227,  227,  227,  192,  192,
  227,  227,  227,  227,  227,    0,  227,  227,  227,    0,
  227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
    0,  227,  227,  227,  227,  227,  227,  227,  227,  227,
  227,  227,  227,  192,    0,    0,  227,  227,    0,    0,
  227,  227,    0,  227,  227,  227,  227,  227,    0,  227,
  227,  445,  227,  227,  227,    0,  227,    0,    0,  227,
    0,    0,    0,  192,  192,    0,    0,  445,  445,    0,
    0,    0,    0,  445,  167,    0,    0,  167,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  445,  445,    0,
    0,  167,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  445,
    0,  209,    0,  209,    0,    0,    0,    0,    0,  209,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  209,
  209,  209,  209,  209,    0,    0,  209,  209,  209,  209,
  209,    0,  209,  209,  209,    0,  209,  209,  209,  209,
  209,  209,  209,  209,  209,  209,  167,  209,  209,  209,
  209,  209,  209,  209,  209,  209,  209,  209,  209,    0,
    0,    0,  209,  209,    0,    0,  209,  209,    0,  209,
  209,  209,  209,  209,    0,  209,  209,    0,  209,  209,
  209,    0,  209,    0,   76,  209,  192,   76,  192,    0,
    0,    0,    0,    0,  192,    0,    0,    0,    0,    0,
    0,   76,   76,    0,  192,  192,  192,  192,  192,    0,
    0,  192,  192,  192,  192,  192,    0,  192,  192,  192,
    0,  192,  192,  192,  192,  192,  192,  192,  192,  192,
  192,    0,  192,  192,  192,  192,  192,  192,  192,  192,
  192,  192,  192,  192,    0,    0,    0,  192,  192,    0,
    0,  192,  192,    0,  192,  192,  192,  192,  192,    0,
  192,  192,    0,  192,  192,  192,   76,  192,    0,    0,
  192,    0,    0,   76,    0,    0,   76,    0,    0,  167,
    0,  167,    0,    0,    0,    0,    0,  167,    0,    0,
   76,    0,    0,    0,    0,    0,    0,  167,  167,  167,
  167,  167,    0,    0,  167,  167,  167,  167,  167,    0,
  167,  167,  167,    0,  167,  167,  167,  167,  167,  167,
  167,  167,  167,  167,    0,  167,  167,  167,  167,  167,
  167,  167,  167,  167,  167,  167,  167,    0,    0,    0,
  167,  167,    0,    0,  167,  167,    0,  167,  167,  167,
  167,  167,    0,  167,  167,   76,  167,  167,  167,    0,
  167,    0,    0,  167,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  361,  355,
    0,    0,    0,  360,  358,    0,  359,    0,  362,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   76,
    0,  357,    0,  356,    0,    0,    0,   76,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   76,   76,   76,
   76,   76,   26,    0,   76,   76,   76,   76,   76,    0,
   76,   76,   76,    0,   76,  354,    0,   76,   76,   76,
   76,   76,   76,   76,    0,   76,   76,   76,   76,   76,
   76,   76,   76,   76,   76,   76,   76,    0,    0,    0,
   76,   76,    0,    0,   76,   76,    0,   76,   76,   76,
   76,   76,    0,   76,   76,    0,   76,   76,   76,    0,
   76,    0,    0,   76,    0,    0,    0,    0,   76,    0,
    0,    0,    0,    0,    0,    0,   76,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   76,   76,   76,   76,
   76,    0,    0,   76,   76,   76,   76,   76,    0,   76,
   76,   76,    0,   76,    0,    0,   76,   76,   76,   76,
   76,   76,   76,    0,   76,   76,   76,   76,   76,   76,
   76,   76,   76,   76,   76,   76,    0,    0,    0,   76,
   76,    0,    0,   76,   76,    0,   76,   76,   76,   76,
   76,  652,   76,   76,  652,   76,   76,   76,    0,   76,
    0,    0,   76,    0,    0,  635,    0,    0,  635,  652,
    0,  652,    0,  637,    0,    0,  637,    0,    0,    0,
    0,    0,    0,  635,    0,  635,    0,    0,    0,    0,
    0,  637,    0,  637,    0,    0,  344,  345,  346,  347,
    0,  348,  349,  652,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  635,    0,    0,
  656,    0,  287,  656,    0,  637,   18,    0,    0,    0,
    0,    0,    0,    0,    0,  652,    0,    0,  656,    0,
  656,    0,    0,    0,    0,    0,    0,  131,  132,  635,
    0,    0,   19,    0,  233,  133,    0,  637,    0,  231,
   26,    0,    0,  134,    0,  135,    0,   20,   21,   22,
    0,    0,  656,    0,    0,    0,   23,  136,    0,  137,
    0,    0,    0,  138,  139,    0,    0,    0,  140,    0,
    0,  141,    0,   24,    0,    0,    0,  142,    0,    0,
    0,    0,   25,  143,  656,  234,    0,    0,    0,    0,
    0,  233,    0,    0,    0,    0,  231,   26,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  232,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  234,    0,    0,    0,    0,    0,  233,    0,
    0,    0,    0,  231,   26,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  652,  652,
  652,    0,    0,    0,    0,    0,    0,  232,    0,    0,
  652,    0,  635,  635,  635,    0,    0,    0,    0,    0,
  637,  637,  637,    0,  635,    0,    0,    0,    0,  234,
    0,    0,  637,    0,    0,    0,  652,    0,    0,  652,
  652,    0,    0,  652,    0,    0,    0,    0,    0,  652,
  635,    0,  652,  635,  635,    0,    0,  635,  637,  652,
    0,  637,  637,  635,  232,  637,  635,  656,  656,  656,
    0,  637,    0,  635,  637,    0,    0,    0,    0,  656,
  463,  637,    0,  217,   18,  218,  219,  220,    0,    0,
    0,    0,    0,  221,    0,    0,    0,    0,    0,  299,
  300,  233,    0,    0,    0,  656,  231,   26,  656,  656,
   19,    0,  656,    0,    0,    0,    0,    0,  656,    0,
    0,  656,    0,    0,  301,   20,   21,   22,  656,    0,
    0,    0,  302,    0,   23,    0,  303,  465,    0,  228,
  217,   18,  218,  219,  220,    0,    0,    0,    0,    0,
  221,   24,  234,    0,    0,    0,  299,  300,  304,    0,
   25,    0,    0,    0,    0,    0,    0,   19,    0,    0,
  233,    0,    0,    0,    0,  231,   26,    0,    0,    0,
    0,  301,   20,   21,   22,    0,    0,  232,    0,  302,
    0,   23,    0,  303,  467,    0,  228,  217,   18,  218,
  219,  220,    0,    0,    0,    0,    0,  221,   24,    0,
    0,    0,    0,  299,  300,  304,    0,   25,    0,    0,
    0,  234,    0,    0,   19,    0,    0,  233,    0,    0,
    0,    0,  231,   26,    0,    0,    0,    0,  301,   20,
   21,   22,    0,    0,    0,    0,  302,    0,   23,    0,
  303,    0,    0,  228,    0,    0,  232,    0,    0,    0,
    0,    0,    0,    0,    0,   24,    0,    0,    0,    0,
    0,    0,  304,    0,   25,    0,    0,    0,  234,    0,
    0,    0,    0,    0,  233,    0,    0,    0,    0,  231,
   26,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  232,    0,    0,    0,  469,    0,    0,
  217,   18,  218,  219,  220,    0,    0,    0,    0,    0,
  221,    0,    0,    0,    0,  234,  299,  300,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   19,    0,    0,
    0,    0,    0,  233,    0,    0,    0,    0,  231,   26,
    0,  301,   20,   21,   22,    0,    0,    0,    0,  302,
  232,   23,    0,  303,    0,    0,  228,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  471,    0,   24,  217,
   18,  218,  219,  220,    0,  304,    0,   25,    0,  221,
    0,    0,    0,    0,  234,  299,  300,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   19,    0,    0,    0,
    0,    0,    0,  233,    0,    0,    0,    0,  231,   26,
  301,   20,   21,   22,    0,    0,    0,    0,  302,  232,
   23,    0,  303,  473,    0,  228,  217,   18,  218,  219,
  220,    0,    0,    0,    0,    0,  221,   24,    0,    0,
    0,    0,  299,  300,  304,    0,   25,    0,    0,    0,
    0,    0,    0,   19,  234,    0,    0,    0,    0,    0,
  233,    0,    0,    0,    0,  231,   26,  301,   20,   21,
   22,    0,    0,    0,    0,  302,    0,   23,    0,  303,
  475,    0,  228,  217,   18,  218,  219,  220,    0,  232,
    0,    0,    0,  221,   24,    0,    0,    0,    0,  299,
  300,  304,    0,   25,    0,    0,    0,    0,    0,    0,
   19,  234,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  233,  301,   20,   21,   22,  231,   26,
    0,    0,  302,    0,   23,    0,  303,    0,    0,  228,
    0,    0,    0,    0,    0,    0,  232,    0,    0,  477,
    0,   24,  217,   18,  218,  219,  220,    0,  304,    0,
   25,    0,  221,    0,    0,    0,    0,    0,  299,  300,
    0,    0,    0,    0,  234,    0,    0,    0,    0,   19,
    0,    0,    0,    0,    0,    0,  233,    0,    0,    0,
    0,  231,   26,  301,   20,   21,   22,    0,    0,    0,
    0,  302,    0,   23,    0,  303,    0,    0,  228,  232,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  480,
   24,    0,  217,   18,  218,  219,  220,  304,    0,   25,
    0,    0,  221,    0,    0,    0,    0,  234,  299,  300,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   19,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  301,   20,   21,   22,    0,    0,    0,
    0,  302,  232,   23,    0,  303,  482,    0,  228,  217,
   18,  218,  219,  220,    0,    0,  233,    0,    0,  221,
   24,  231,   26,    0,    0,  299,  300,  304,    0,   25,
    0,    0,    0,    0,  233,    0,   19,    0,    0,  231,
   26,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  301,   20,   21,   22,    0,    0,    0,    0,  302,    0,
   23,    0,  303,    0,    0,  228,    0,  234,    0,  484,
    0,    0,  217,   18,  218,  219,  220,   24,    0,    0,
    0,    0,  221,    0,  304,  234,   25,    0,  299,  300,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   19,
    0,    0,  232,  233,    0,    0,    0,    0,  231,   26,
    0,    0,    0,  301,   20,   21,   22,    0,    0,    0,
  232,  302,    0,   23,    0,  303,    0,    0,  228,    0,
    0,    0,  486,    0,    0,  217,   18,  218,  219,  220,
   24,    0,    0,    0,    0,  221,    0,  304,    0,   25,
    0,  299,  300,    0,  234,    0,    0,    0,    0,    0,
  233,    0,   19,    0,    0,  231,   26,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  301,   20,   21,   22,
    0,    0,    0,    0,  302,    0,   23,    0,  303,  232,
    0,  228,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   24,    0,    0,    0,    0,    0,    0,
  304,  234,   25,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  233,    0,    0,    0,    0,  231,   26,    0,
    0,    0,  488,    0,    0,  217,   18,  218,  219,  220,
    0,    0,    0,    0,    0,  221,  232,    0,    0,    0,
  490,  299,  300,  217,   18,  218,  219,  220,    0,    0,
    0,    0,   19,  221,  155,    0,    0,    0,    0,  299,
  300,    0,    0,  234,    0,    0,  301,   20,   21,   22,
   19,    0,    0,    0,  302,    0,   23,    0,  303,    0,
    0,  228,    0,    0,  301,   20,   21,   22,    0,    0,
    0,    0,  302,   24,   23,    0,  303,    0,  232,  228,
  304,    0,   25,    0,    0,    0,    0,    0,    0,  492,
    0,   24,  217,   18,  218,  219,  220,    0,  304,    0,
   25,    0,  221,    0,    0,    0,    0,    0,  299,  300,
  233,  155,    0,  325,    0,  231,   26,    0,    0,   19,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  301,   20,   21,   22,    0,    0,    0,
    0,  302,    0,   23,    0,  303,  494,    0,  228,  217,
   18,  218,  219,  220,    0,    0,    0,    0,    0,  221,
   24,  234,    0,    0,    0,  299,  300,  304,    0,   25,
    0,    0,  233,    0,    0,    0,   19,  231,   26,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  301,   20,   21,   22,    0,    0,  232,    0,  302,    0,
   23,    0,  303,    0,    0,  228,    0,    0,  496,    0,
    0,  217,   18,  218,  219,  220,    0,   24,    0,    0,
    0,  221,   26,  234,  304,    0,   25,  299,  300,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   19,    0,
    0,    0,    0,    0,    0,    0,  155,    0,  155,    0,
    0,    0,  301,   20,   21,   22,    0,    0,  232,    0,
  302,    0,   23,    0,  303,    0,  325,  228,    0,  155,
  155,    0,    0,  155,  155,    0,    0,  155,    0,   24,
    0,  160,    0,  155,  155,  155,  304,  155,   25,  155,
  155,  155,    0,    0,  155,  155,  155,  155,  155,  155,
    0,  155,    0,    0,    0,  155,  155,    0,    0,  155,
  155,    0,  155,  155,  155,  155,  155,    0,  155,  155,
    0,  155,    0,  155,  155,  155,  498,    0,  155,  217,
   18,  218,  219,  220,    0,    0,    0,    0,    0,  221,
  159,    0,    0,    0,    0,  299,  300,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   19,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  301,   20,   21,   22,    0,    0,    0,    0,  302,    0,
   23,    0,  303,    0,    0,  228,    0,    0,    0,    0,
    0,  217,   18,  218,  219,  220,    0,   24,    0,    0,
    0,  221,    0,    0,  304,    0,   25,  299,  300,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   19,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  301,   20,   21,   22,   18,    0,    0,    0,
  302,    0,   23,    0,  303,    0,    0,  228,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  131,  151,   24,
    0,    0,   19,    0,    0,  152,  304,    0,   25,    0,
    0,    0,    0,  134,    0,  135,    0,   20,   21,   22,
    0,    0,    0,    0,    0,    0,   23,  136,    0,  137,
    0,    0,    0,  138,  139,  160,    0,    0,  140,    0,
    0,  141,    0,   24,    0,    0,    0,  142,    0,    0,
    0,    0,   25,  143,    0,    0,  160,  160,    0,    0,
    0,  160,  448,    0,  160,  448,    0,    0,  448,    0,
    0,    0,  160,    0,  160,    0,  160,  160,  160,    0,
    0,    0,  448,  448,    0,  160,  160,  448,  160,    0,
    0,    0,  160,  160,  159,    0,    0,  160,    0,    0,
  160,    0,  160,    0,    0,    0,  160,    0,    0,    0,
    0,  160,  160,    0,    0,  159,  159,  448,  448,    0,
  159,    0,    0,  159,    0,    0,    0,    0,    0,    0,
    0,  159,    0,  159,    0,  159,  159,  159,    0,    0,
    0,    0,    0,    0,  159,  159,    0,  159,  448,  448,
    0,  159,  159,    0,    0,    0,  159,    0,    0,  159,
    0,  159,    0,    0,    0,  159,    0,    0,  488,  488,
  159,  159,  488,  488,  488,  488,  488,    0,  488,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  488,
  488,  488,    0,  488,  488,    0,    0,  483,  483,    0,
    0,  483,  483,  483,  483,  483,    0,  483,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  483,  483,
  483,    0,  483,  483,  488,  488,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  484,  484,    0,    0,
  484,  484,  484,  484,  484,    0,  484,    0,    0,    0,
    0,    0,    0,  483,  483,  488,  488,  484,  484,  484,
    0,  484,  484,    0,    0,    0,  457,    0,    0,  457,
    0,  457,  457,  457,    0,    0,    0,    0,    0,    0,
  448,    0,    0,    0,  483,  483,  457,  457,  457,    0,
  457,  457,  484,  484,    0,    0,  448,  448,    0,    0,
    0,    0,  448,    0,    0,  458,    0,    0,  458,    0,
  458,  458,  458,    0,    0,    0,  448,  448,    0,    0,
    0,  457,  457,  484,  484,  458,  458,  458,    0,  458,
  458,    0,    0,    0,  455,    0,    0,  455,  448,    0,
  455,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  457,  457,  455,  455,  455,    0,  455,  455,
  458,  458,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  488,    0,  455,
  455,  458,  458,    0,    0,    0,  488,  488,  488,  488,
    0,  488,  488,  488,  488,    0,    0,    0,    0,  488,
    0,    0,    0,    0,    0,    0,  483,    0,    0,    0,
  455,  455,    0,  488,  488,  483,  483,  483,  483,    0,
  483,  483,  483,  483,    0,    0,    0,    0,  483,    0,
    0,    0,    0,    0,    0,  488,    0,    0,    0,    0,
    0,    0,  483,  483,    0,  484,    0,    0,    0,    0,
    0,    0,    0,    0,  484,  484,  484,  484,    0,  484,
  484,  484,  484,    0,  483,    0,    0,  484,    0,    0,
    0,    0,    0,    0,  457,    0,    0,    0,    0,    0,
    0,  484,  484,  457,  457,  457,  457,    0,  457,  457,
  457,  457,    0,    0,    0,    0,  457,    0,    0,    0,
    0,    0,    0,  484,    0,    0,    0,    0,    0,    0,
  457,  457,    0,  458,    0,    0,    0,    0,    0,    0,
    0,    0,  458,  458,  458,  458,    0,  458,  458,  458,
  458,    0,  457,    0,    0,  458,    0,    0,    0,    0,
    0,  456,  455,    0,  456,    0,    0,  456,    0,  458,
  458,  455,  455,  455,  455,    0,  455,  455,  455,  455,
    0,  456,  456,  456,  455,  456,  456,    0,    0,    0,
  452,  458,    0,  452,    0,    0,  452,    0,  455,  455,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  452,  452,  452,    0,  452,  452,  456,  456,    0,    0,
  455,    0,    0,    0,    0,    0,    0,    0,    0,  454,
    0,    0,  454,    0,    0,  454,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  452,  452,  456,  456,  454,
  454,  454,    0,  454,  454,    0,    0,    0,  451,    0,
    0,  451,    0,    0,  451,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  452,  452,  451,  451,
  451,    0,  451,  451,  454,  454,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  453,    0,    0,
  453,    0,    0,  453,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  451,  451,  454,  454,  453,  453,  453,
    0,  453,  453,    0,    0,    0,  449,    0,    0,  449,
    0,    0,  449,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  451,  451,  449,  449,    0,    0,
    0,  449,  453,  453,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  456,
    0,  449,  449,  453,  453,    0,    0,    0,  456,  456,
  456,  456,    0,  456,  456,  456,  456,    0,    0,    0,
    0,  456,    0,    0,    0,    0,    0,    0,  452,    0,
    0,    0,  449,  449,    0,  456,  456,  452,  452,  452,
  452,    0,    0,    0,  452,  452,    0,    0,    0,    0,
  452,    0,    0,    0,    0,    0,    0,  456,    0,    0,
    0,    0,    0,    0,  452,  452,    0,  454,    0,    0,
    0,    0,    0,    0,    0,    0,  454,  454,  454,  454,
    0,    0,    0,  454,  454,    0,  452,    0,    0,  454,
    0,    0,    0,    0,    0,    0,  451,    0,    0,    0,
    0,    0,    0,  454,  454,  451,  451,  451,  451,    0,
    0,    0,  451,  451,    0,    0,    0,    0,  451,    0,
    0,    0,    0,    0,    0,  454,    0,    0,  450,    0,
    0,  450,  451,  451,  450,  453,    0,    0,    0,    0,
    0,    0,    0,    0,  453,  453,  453,  453,  450,  450,
    0,  453,  453,  450,  451,    0,    0,  453,    0,    0,
  447,    0,    0,  447,  449,    0,    0,    0,    0,    0,
    0,  453,  453,  449,    0,    0,  449,  447,  447,    0,
  449,  449,  447,  450,  450,  446,  449,    0,  446,    0,
    0,    0,    0,  453,    0,    0,    0,    0,    0,    0,
  449,  449,  446,  446,    0,    0,    0,  446,    0,    0,
    0,    0,  447,  447,  450,  450,    0,    0,    0,    0,
    0,    0,  449,    0,    0,    0,  488,  488,    0,    0,
    0,  488,  488,  599,  488,    0,  488,  446,    0,    0,
    0,    0,    0,  447,  447,    0,    0,  488,  488,  488,
    0,  488,  488,  361,  355,    0,    0,    0,  360,  358,
    0,  359,    0,  362,    0,  361,  355,    0,  446,  446,
  360,  358,    0,  359,    0,  362,  357,    0,  356,  352,
    0,    0,  599,  488,    0,    0,    0,    0,  357,    0,
  356,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  354,    0,    0,  488,  488,    0,    0,    0,    0,    0,
    0,    0,  354,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  353,    0,    0,    0,    0,    0,  450,    0,    0,    0,
  208,    0,  353,    0,    0,  450,    0,    0,  450,    0,
    0,    0,  450,  450,    0,    0,    0,    0,  450,    0,
    0,    0,    0,    0,    0,  447,    0,    0,    0,    0,
    0,    0,  450,  450,    0,    0,    0,    0,    0,    0,
    0,  447,  447,    0,    0,    0,    0,  447,    0,    0,
  446,    0,    0,    0,  450,    0,    0,    0,    0,    0,
    0,  447,  447,    0,    0,    0,  446,  446,    0,    0,
    0,    0,  446,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  447,    0,    0,  446,  446,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  488,  488,  488,  488,  446,  488,
  488,  488,  488,    0,    0,    0,    0,  488,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  344,  345,  346,  347,    0,  348,  349,  350,  351,
   57,    0,    0,  344,  345,  346,  347,    0,  348,  349,
   58,   59,   60,   61,    0,    0,    0,   62,   63,   64,
   65,   66,    0,   67,   68,   69,    0,   70,    0,    0,
   71,   72,   73,   74,   75,   76,   77,    0,  207,   79,
   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,
    0,    0,    0,   90,   91,    0,    0,   92,   93,    0,
   94,   95,   96,   97,   98,    0,   99,  100,    0,  101,
  102,  103,  602,  104,  603,    0,  105,    0,    0,    0,
  604,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  605,  606,  607,  608,    0,    0,    0,  609,  610,  611,
  612,  613,    0,  614,  615,  616,    0,  617,    0,    0,
  618,  619,  620,  621,  622,  623,  624,  625,  626,  627,
  628,  629,  630,  631,  632,  633,  634,  635,  636,  637,
    0,    0,    0,  638,  639,    0,    0,  640,  641,    0,
  642,  643,  644,  645,  646,    0,  647,  648,    0,  649,
  650,  651,    0,  652,  653,  266,  654,    0,    0,  267,
    0,    0,    0,   57,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   58,   59,   60,   61,    0,    0,    0,
   62,   63,   64,   65,   66,    0,   67,   68,   69,    0,
   70,    0,    0,   71,   72,   73,   74,   75,   76,   77,
    0,  268,   79,   80,   81,   82,   83,   84,   85,   86,
   87,   88,   89,    0,    0,    0,   90,   91,    0,    0,
   92,   93,    0,   94,   95,   96,   97,   98,    0,   99,
  100,    0,  101,  102,  103,  113,  104,    0,    0,  105,
    0,    0,    0,   57,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   58,   59,   60,   61,    0,    0,    0,
   62,   63,   64,   65,   66,    0,   67,   68,   69,    0,
   70,    0,    0,   71,   72,   73,   74,   75,   76,   77,
    0,  114,   79,   80,   81,   82,   83,   84,   85,   86,
   87,   88,   89,    0,    0,    0,   90,   91,    0,    0,
   92,   93,    0,   94,   95,   96,   97,   98,    0,   99,
  100,    0,  101,  102,  103,  121,  104,    0,    0,  105,
    0,    0,    0,   57,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   58,   59,   60,   61,    0,    0,    0,
   62,   63,   64,   65,   66,    0,   67,   68,   69,    0,
   70,    0,    0,   71,   72,   73,   74,   75,   76,   77,
    0,  122,   79,   80,   81,   82,   83,   84,   85,   86,
   87,   88,   89,    0,    0,    0,   90,   91,    0,    0,
   92,   93,    0,   94,   95,   96,   97,   98,    0,   99,
  100,    0,  101,  102,  103,  164,  104,    0,    0,  105,
    0,    0,    0,   57,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   58,   59,   60,   61,    0,    0,    0,
   62,   63,   64,   65,   66,    0,   67,   68,   69,    0,
   70,    0,    0,   71,   72,   73,   74,   75,   76,   77,
    0,  165,   79,   80,   81,   82,   83,   84,   85,   86,
   87,   88,   89,    0,    0,    0,   90,   91,    0,    0,
   92,   93,    0,   94,   95,   96,   97,   98,    0,   99,
  100,    0,  101,  102,  103,  259,  104,    0,    0,  105,
    0,    0,    0,   57,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   58,   59,   60,   61,    0,    0,    0,
   62,   63,   64,   65,   66,    0,   67,   68,   69,    0,
   70,    0,    0,   71,   72,   73,   74,   75,   76,   77,
    0,  122,   79,   80,   81,   82,   83,   84,   85,   86,
   87,   88,   89,    0,    0,    0,   90,   91,    0,    0,
   92,   93,    0,   94,   95,   96,   97,   98,    0,   99,
  100,    0,  101,  102,  103,  521,  104,    0,    0,  105,
    0,    0,    0,   57,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   58,   59,   60,   61,    0,    0,    0,
   62,   63,   64,   65,   66,    0,   67,   68,   69,    0,
   70,    0,    0,   71,   72,   73,   74,   75,   76,   77,
    0,  207,   79,   80,   81,   82,   83,   84,   85,   86,
   87,   88,   89,    0,    0,    0,   90,   91,    0,    0,
   92,   93,    0,   94,   95,   96,   97,   98,    0,   99,
  100,    0,  101,  102,  103,  878,  104,    0,    0,  105,
    0,    0,    0,   57,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   58,   59,   60,   61,    0,    0,    0,
   62,   63,   64,   65,   66,    0,   67,   68,   69,    0,
   70,    0,    0,   71,   72,   73,   74,   75,   76,   77,
    0,  879,   79,   80,   81,   82,   83,   84,   85,   86,
   87,   88,   89,    0,    0,    0,   90,   91,    0,    0,
   92,   93,    0,   94,   95,   96,   97,   98,    0,   99,
  100,    0,  101,  102,  103,  930,  104,    0,    0,  105,
    0,    0,    0,   57,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   58,   59,   60,   61,    0,    0,    0,
   62,   63,   64,   65,   66,    0,   67,   68,   69,    0,
   70,    0,    0,   71,   72,   73,   74,   75,   76,   77,
    0,  879,   79,   80,   81,   82,   83,   84,   85,   86,
   87,   88,   89,    0,    0,    0,   90,   91,    0,    0,
   92,   93,    0,   94,   95,   96,   97,   98,    0,   99,
  100,   57,  101,  102,  103,    0,  104,    0,    0,  105,
    0,   58,   59,   60,   61,    0,    0,    0,   62,   63,
   64,   65,   66,    0,   67,   68,   69,    0,   70,    0,
    0,   71,   72,   73,   74,   75,   76,   77,    0,   78,
   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,
   89,    0,    0,    0,   90,   91,    0,    0,   92,   93,
    0,   94,   95,   96,   97,   98,    0,   99,  100,   57,
  101,  102,  103,    0,  104,    0,    0,  105,    0,   58,
   59,   60,   61,    0,    0,    0,   62,   63,   64,   65,
   66,    0,   67,   68,   69,    0,   70,    0,    0,   71,
   72,   73,   74,   75,   76,   77,    0,  158,   79,   80,
   81,   82,   83,   84,   85,   86,   87,   88,   89,    0,
    0,    0,   90,   91,    0,    0,   92,   93,    0,   94,
   95,   96,   97,   98,    0,   99,  100,   57,  101,  102,
  103,    0,  104,    0,    0,  105,    0,   58,   59,   60,
   61,    0,    0,    0,   62,   63,   64,   65,   66,    0,
   67,   68,   69,    0,   70,    0,    0,   71,   72,   73,
   74,   75,   76,   77,    0,  160,   79,   80,   81,   82,
   83,   84,   85,   86,   87,   88,   89,    0,    0,    0,
   90,   91,    0,    0,   92,   93,    0,   94,   95,   96,
   97,   98,    0,   99,  100,   57,  101,  102,  103,    0,
  104,    0,    0,  105,    0,   58,   59,   60,   61,    0,
    0,    0,   62,   63,   64,   65,   66,    0,   67,   68,
   69,    0,   70,    0,    0,   71,   72,   73,   74,   75,
   76,   77,    0,  175,   79,   80,   81,   82,   83,   84,
   85,   86,   87,   88,   89,    0,    0,    0,   90,   91,
    0,    0,   92,   93,    0,   94,   95,   96,   97,   98,
    0,   99,  100,   57,  101,  102,  103,    0,  104,    0,
    0,  105,    0,   58,   59,   60,   61,    0,    0,    0,
   62,   63,   64,   65,   66,    0,   67,   68,   69,    0,
   70,    0,    0,   71,   72,   73,   74,   75,   76,   77,
    0,  413,   79,   80,   81,   82,   83,   84,   85,   86,
   87,   88,   89,    0,    0,    0,   90,   91,    0,    0,
   92,   93,    0,   94,   95,   96,   97,   98,    0,   99,
  100,   57,  101,  102,  103,    0,  104,    0,    0,  105,
    0,   58,   59,   60,   61,    0,    0,    0,   62,   63,
   64,   65,   66,    0,   67,   68,   69,    0,   70,    0,
    0,   71,   72,   73,   74,   75,   76,   77,    0,  429,
   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,
   89,    0,    0,    0,   90,   91,    0,    0,   92,   93,
    0,   94,   95,   96,   97,   98,    0,   99,  100,   57,
  101,  102,  103,    0,  104,    0,    0,  105,    0,   58,
   59,   60,   61,    0,    0,    0,   62,   63,   64,   65,
   66,    0,   67,   68,   69,    0,   70,    0,    0,   71,
   72,   73,   74,   75,   76,   77,    0,  559,   79,   80,
   81,   82,   83,   84,   85,   86,   87,   88,   89,    0,
    0,    0,   90,   91,    0,    0,   92,   93,    0,   94,
   95,   96,   97,   98,    0,   99,  100,   57,  101,  102,
  103,    0,  104,    0,    0,  105,    0,   58,   59,   60,
   61,    0,    0,    0,   62,   63,   64,   65,   66,    0,
   67,   68,   69,    0,   70,    0,    0,   71,   72,   73,
   74,   75,   76,   77,    0,  705,   79,   80,   81,   82,
   83,   84,   85,   86,   87,   88,   89,    0,    0,    0,
   90,   91,    0,    0,   92,   93,    0,   94,   95,   96,
   97,   98,    0,   99,  100,   57,  101,  102,  103,    0,
  104,    0,    0,  105,    0,   58,   59,   60,   61,    0,
    0,    0,   62,   63,   64,   65,   66,    0,   67,   68,
   69,    0,   70,    0,    0,   71,   72,   73,   74,   75,
   76,   77,    0,  712,   79,   80,   81,   82,   83,   84,
   85,   86,   87,   88,   89,    0,    0,    0,   90,   91,
    0,    0,   92,   93,    0,   94,   95,   96,   97,   98,
    0,   99,  100,   57,  101,  102,  103,    0,  104,    0,
    0,  105,    0,   58,   59,   60,   61,    0,    0,    0,
   62,   63,   64,   65,   66,    0,   67,   68,   69,    0,
   70,    0,    0,   71,   72,   73,   74,   75,   76,   77,
    0,  207,   79,   80,   81,   82,   83,   84,   85,   86,
   87,   88,   89,    0,    0,    0,   90,   91,    0,    0,
   92,   93,    0,   94,   95,   96,   97,   98,    0,   99,
  100,   57,  101,  102,  103,    0,  104,    0,    0,  105,
    0,   58,   59,   60,   61,    0,    0,    0,   62,   63,
   64,   65,   66,    0,   67,   68,   69,    0,   70,    0,
    0,   71,   72,   73,   74,   75,   76,   77,    0,  826,
   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,
   89,    0,    0,    0,   90,   91,    0,    0,   92,   93,
    0,   94,   95,   96,   97,   98,    0,   99,  100,   57,
  101,  102,  103,    0,  104,    0,    0,  105,    0,   58,
   59,   60,   61,    0,    0,    0,   62,   63,   64,   65,
   66,    0,   67,   68,   69,    0,   70,    0,    0,   71,
   72,   73,   74,   75,   76,   77,    0,  871,   79,   80,
   81,   82,   83,   84,   85,   86,   87,   88,   89,    0,
    0,    0,   90,   91,    0,    0,   92,   93,    0,   94,
   95,   96,   97,   98,    0,   99,  100,   54,  101,  102,
  103,    0,  104,    0,    0,  105,    0,   54,   54,   54,
   54,    0,    0,    0,   54,   54,   54,   54,   54,    0,
   54,   54,   54,    0,   54,    0,    0,   54,   54,   54,
   54,   54,   54,   54,    0,   54,   54,   54,   54,   54,
   54,   54,   54,   54,   54,   54,   54,    0,    0,    0,
   54,   54,    0,    0,   54,   54,    0,   54,   54,   54,
   54,   54,    0,   54,   54,  168,   54,   54,   54,    0,
   54,    0,    0,   54,    0,  168,  168,  168,  168,    0,
    0,    0,  168,  168,  168,  168,  168,    0,  168,  168,
  168,    0,  168,    0,    0,  168,  168,  168,  168,  168,
  168,  168,    0,  168,  168,  168,  168,  168,  168,  168,
  168,  168,  168,  168,  168,    0,    0,    0,  168,  168,
    0,    0,  168,  168,    0,  168,  168,  168,  168,  168,
    0,  168,  168,    0,  168,  168,  168,    0,  168,    0,
    0,  168,
};
static const YYINT yycheck[] = {                          5,
   19,  150,   49,    2,  458,   19,   53,  515,   27,   46,
  127,   41,   30,   27,  256,   59,   40,  171,  172,   41,
   41,  208,   46,  219,  220,   40,   45,  352,   44,  239,
  240,   45,  225,   45,  597,   40,  215,   41,   59,  125,
  502,   58,  893,   49,  240,   41,   46,   53,   40,   44,
   59,  335,   41,  249,   46,  125,   58,   41,   93,   49,
   46,   41,   44,   53,  302,   41,   41,   91,   41,  920,
   41,   40,  123,  761,  278,   59,   44,   59,  239,   41,
   41,   41,   41,  256,  935,   41,   41,   41,  279,  124,
   58,  110,  111,  781,   59,  125,  110,  111,  308,   91,
   41,  120,   41,  294,  125,  278,  120,  329,  301,   44,
  306,  307,  126,  127,  310,   59,  125,   59,  123,  312,
  330,  125,  124,   58,  130,  335,  144,  146,  124,   44,
   43,   93,  146,   93,  338,  124,   40,   93,   93,  335,
  336,  125,  189,   58,  305,  125,  193,   44,  711,  124,
  260,   59,  125,  661,  125,  174,  203,   41,   41,  381,
  174,  208,  446,  124,  183,  124,  213,   40,  186,  183,
  124,  786,   44,  721,   45,   59,   59,   41,   58,   43,
   40,    5,   40,  189,  125,  809,   41,  193,   58,   59,
  805,  228,  278,  240,   58,   59,  286,  203,   40,  189,
  310,  825,  208,  193,   59,  256,  397,  213,  278,  451,
   93,  192,  211,  203,   44,  677,  260,  765,  460,  123,
  238,   93,  314,  213,   40,   49,  240,  278,   58,   53,
   46,  212,  279,  257,  240,  302,  446,  416,  285,  256,
  256,  125,  125,  422,  256,   61,  437,  256,  458,  261,
  446,  256,  448,   58,   59,  125,  256,  278,  276,  450,
  260,   41,  458,  278,   44,  257,  310,  454,  123,  278,
  262,  263,  734,  279,  278,   91,  601,  296,   58,  285,
  286,  285,  296,  330,  314,   44,  286,  256,  335,  279,
  382,  295,  314,  314,  278,  285,  305,  292,  293,  318,
  286,  301,  302,  303,  318,  285,  130,  278,  314,  285,
  310,  256,  285,  278,  256,  295,  330,  341,  342,  295,
  125,  335,  295,  285,  330,  285,  363,  327,  519,  335,
  838,  343,   61,  295,  314,  295,  336,  278,  314,  376,
  377,  285,  379,  123,  285,  392,  285,  260,  256,  341,
  342,  295,  256,  519,  295,   41,  295,  292,  293,  256,
   40,   44,  559,  305,  411,  189,  125,  386,  192,  193,
  278,  389,  386,   59,  278,   41,  382,  292,  293,  203,
  286,   61,   41,  256,  208,  893,  392,   41,  212,  213,
  261,  428,  256,   59,  278,  278,  256,  305,  256,  446,
   59,  256,  392,   61,  423,  411,   59,  454,  278,  423,
  502,  458,  292,  293,  256,  285,   44,  219,  220,  221,
  512,  411,  286,  278,   40,  295,  767,   41,   44,  231,
  232,  772,  446,   41,  236,  237,   44,  123,  240,   59,
  446,  257,  125,   59,  458,   59,  262,  263,  454,  273,
   58,   59,  458,  168,   59,  279,  171,  172,  756,  125,
  286,  285,  286,  279,  280,   93,  125,   49,  221,  123,
  123,   53,  770,  278,  290,   59,  256,   61,  231,  232,
   40,   40,  724,  236,  237,   93,  286,  292,  293,  680,
   41,   59,   37,   44,   41,   44,  502,   42,  278,  286,
  316,   61,   47,  319,  320,  125,  512,  323,  962,  963,
   59,  125,   59,  329,   41,  712,  332,  125,  123,  278,
   43,   44,   46,  339,  543,  341,  342,  981,  330,  543,
  285,   40,   59,  335,  688,   59,  555,  686,  292,  293,
  295,  555,  344,  345,  346,  347,  348,  349,  350,  351,
  352,  353,  354,  355,  356,  357,  358,  359,  360,  361,
  362,  715,   59,   40,  718,   41,  745,  758,  392,  123,
  256,   41,   46,   41,   44,   59,  742,  743,  125,   40,
  777,   46,   58,   59,   40,  677,   44,  411,   58,   59,
   58,   59,  278,   63,  787,  278,  311,  258,  125,  279,
  280,   59,  256,  256,   40,  320,  321,  189,  292,  293,
  290,  193,  278,  806,  329,  330,  809,  285,   40,  278,
   40,  203,   44,   93,  278,  278,  208,  295,  125,  124,
  454,  213,  825,  742,  743,  682,  316,   59,  123,  319,
  320,   59,  734,  323,  446,   58,   59,  694,   59,  329,
  697,  256,  332,   43,   44,  125,  458,  704,  278,  339,
   59,   40,   61,  378,  278,  380,  381,  382,  383,  384,
  278,  677,   44,  278,  791,   44,  682,   59,   44,   61,
  873,  124,   43,   41,  292,  293,   44,   59,  694,   59,
   59,  697,  682,   59,  278,  279,  280,  279,  704,  736,
   58,   59,  256,  285,  694,  752,  290,  697,   40,  756,
  278,  286,  125,   40,  125,   61,  808,  285,  433,  279,
  280,   41,   41,  770,  278,   44,  125,  295,  734,  748,
  290,  278,  316,  256,  748,  319,  320,  452,   93,  323,
   59,  788,  789,  125,   41,  329,  752,  746,  332,   59,
  756,  278,  962,  963,  908,  339,  316,  911,  912,  319,
  320,   59,  752,  323,  770,  123,  962,  963,   41,  329,
  261,  981,  332,   41,   93,   41,   44,  791,   93,  339,
  256,  278,  788,  789,  803,  981,  256,  502,  256,  803,
   58,   59,   44,  812,  278,  260,  292,  293,  812,  601,
  302,  285,  808,  273,  841,  897,  125,   40,  278,  260,
  392,  295,  123,  905,  833,  125,  788,  789,   41,  833,
   44,  286,  292,  293,   41,   93,  541,  125,  834,  411,
  782,  923,  838,   41,  256,  550,  301,  302,  303,  845,
   41,   61,   43,   44,  314,  310,   46,   61,   41,  292,
  293,  125,  889,  890,   44,  124,  808,  125,  682,   44,
  575,  898,  327,  900,  901,  278,  256,  278,   41,  961,
  694,  336,  454,  697,  589,  967,  968,  592,   93,  278,
  704,   44,   93,  975,  599,  600,   58,   41,  894,   41,
   44,  897,  984,  302,  302,  914,  278,  989,  256,  905,
  914,   37,   40,  221,   58,   59,   42,   43,   61,   45,
   93,   47,  918,  231,  232,  962,  963,  923,  236,  237,
  278,  239,  240,   61,   93,  123,  123,   44,  752,   44,
  285,  249,  756,   41,  981,   43,   44,  943,   58,   93,
  295,  947,  948,  949,  950,    0,  770,  258,  962,  963,
   58,   59,  261,  905,   41,  961,  962,  963,   40,  278,
  966,  967,  968,   44,  788,  789,   61,  981,  278,  975,
   44,  125,   61,  688,  285,  981,  256,  983,  984,   41,
  278,   93,   41,  989,  295,  700,  285,  305,  306,  307,
   93,   46,  310,  292,  293,  306,  295,   40,   41,  123,
  715,   44,   41,  718,   61,  834,   40,   61,   93,  838,
  278,   41,  330,   41,   93,   58,   59,  335,  336,   41,
  302,  845,  333,   58,  292,  293,  344,  345,  346,  347,
  348,  349,  350,  351,  352,  353,  354,  355,  356,  357,
  358,  359,  360,  361,  362,   61,   61,   58,   61,  764,
   93,  766,   40,  953,   40,  256,  956,  957,  256,  256,
  260,   40,   40,   40,  964,  894,   59,  294,  123,   37,
   38,  123,   40,   41,   42,   43,   44,   45,   46,   47,
  278,  278,  125,  286,   59,   59,  286,  987,   41,  918,
   58,   59,   60,   61,   62,   63,   93,  302,   58,   37,
  682,  301,  302,  303,   42,   43,   41,   45,   41,   47,
  310,   41,  694,   41,  943,  697,   40,  592,  947,   41,
  949,  950,  704,   91,  278,   93,   94,  327,  446,   41,
  448,  668,  873,  312,  270,  271,  336,  966,  292,  293,
  458,  279,  280,  235,  235,  575,  963,  839,  256,  870,
  717,  983,  290,  286,  146,  123,  124,  125,  849,   41,
  962,  963,  853,  981,  174,  682,  142,  137,  416,  914,
  752,  748,   -1,  864,  756,   -1,   58,   59,  316,  981,
   -1,  319,  320,   40,   41,  323,   -1,   44,  770,   -1,
   -1,  329,   -1,  908,  332,  886,  911,  912,   -1,   -1,
   -1,  339,   59,  258,   61,  260,  788,  789,   -1,   -1,
   -1,   93,   -1,  256,   37,   38,   -1,   -1,   -1,   42,
   43,   -1,   45,   -1,   47,   -1,  281,  282,   -1,  944,
  285,  286,   -1,   -1,  289,  278,   93,   60,   -1,   62,
  295,  296,  297,  125,  299,   -1,  301,  302,  303,  292,
  293,  306,  307,  308,  309,  310,  311,   -1,  313,   -1,
   -1,   -1,  317,  318,  955,   -1,  321,  322,  125,  324,
  325,  326,  327,  328,  965,  330,  331,   -1,  333,   -1,
  335,  336,  337,  601,   -1,  340,   -1,  978,  256,  257,
  258,   59,   -1,   61,  262,  263,  264,  265,  266,  267,
  268,   -1,  270,  271,  272,  273,  274,  275,  276,  277,
  278,  279,  280,  281,  282,  283,  284,  285,  286,  287,
  288,  289,  290,  291,  292,  293,  294,  295,  296,  297,
  298,  299,  300,   -1,  302,  303,  304,  305,  306,  307,
  308,  309,  310,  311,  312,  313,  314,   40,  316,  317,
  318,  319,  320,  321,  322,  323,  324,  325,  326,  327,
  328,  329,  330,  331,  332,  333,  334,  335,   61,  337,
   61,  339,  340,  341,  342,   -1,   -1,   -1,   -1,   -1,
   -1,   37,   -1,   -1,   -1,   -1,   42,   43,   -1,   45,
   -1,   47,   -1,   -1,   -1,   -1,  278,   -1,   -1,  256,
   -1,   -1,   -1,  897,   60,   -1,   62,   -1,   -1,   -1,
  292,  293,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  278,  279,  280,   -1,   -1,   -1,   -1,   -1,  923,
   -1,   37,   38,  290,   40,   41,   42,   43,   44,   45,
   46,   47,  265,  266,  267,  268,   -1,  270,  271,   -1,
   -1,   -1,   58,   59,   60,   61,   62,   63,   -1,  316,
   -1,   -1,  319,  320,   -1,   -1,  323,  961,   -1,   -1,
   -1,   -1,  329,  967,  968,  332,   -1,   -1,   -1,   -1,
   -1,  975,  339,   -1,   -1,   91,   -1,   93,   94,   -1,
  984,   -1,   -1,   -1,   -1,  989,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  278,  279,  280,   -1,   -1,   -1,   -1,  123,  124,  125,
   37,   38,  290,   40,   41,   42,   43,   44,   45,   46,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   58,   59,   60,   61,   62,   63,   -1,  316,   -1,
   -1,  319,  320,   -1,   -1,  323,   -1,   -1,   -1,   -1,
   -1,  329,   -1,   -1,  332,   -1,   -1,   -1,   -1,   -1,
   -1,  339,   -1,   -1,   91,   -1,   93,   94,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  279,  280,  279,  280,
   -1,   -1,   -1,   -1,  285,   -1,   -1,  290,   -1,  290,
   -1,   -1,   -1,   -1,  295,   -1,  123,  124,  125,  265,
  266,  267,  268,   -1,  270,  271,   -1,   -1,   -1,   44,
   -1,   46,   -1,  316,   -1,  316,  319,  320,  319,  320,
  323,   -1,  323,   -1,   -1,   -1,  329,   -1,  329,  332,
   -1,  332,   -1,   -1,  962,  963,  339,   -1,  339,   -1,
  256,  257,  258,   -1,   -1,   -1,  262,  263,  264,  265,
  266,  267,  268,  981,  270,  271,  272,  273,  274,  275,
  276,  277,  278,  279,  280,  281,  282,  283,  284,  285,
   -1,  287,  288,  289,  290,  291,  292,  293,  294,  295,
  296,  297,  298,  299,  300,   -1,  302,  303,  304,  305,
  306,  307,  308,  309,  310,  311,  312,  313,  314,   -1,
  316,  317,  318,  319,  320,  321,  322,  323,  324,  325,
  326,  327,  328,  329,  330,  331,  332,  333,  334,  335,
   -1,  337,   -1,  339,  340,  341,  342,   41,   -1,  256,
  257,  258,   46,   -1,   -1,  262,  263,  264,  265,  266,
  267,  268,   -1,  270,  271,  272,  273,  274,  275,  276,
  277,  278,  279,  280,  281,  282,  283,  284,  285,   -1,
  287,  288,  289,  290,  291,  292,  293,  294,  295,  296,
  297,  298,  299,  300,   -1,  302,  303,  304,  305,  306,
  307,  308,  309,  310,  311,  312,  313,  314,   -1,  316,
  317,  318,  319,  320,  321,  322,  323,  324,  325,  326,
  327,  328,  329,  330,  331,  332,  333,  334,  335,  123,
  337,   -1,  339,  340,  341,  342,   37,   38,   -1,   40,
   41,   42,   43,   44,   45,  260,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,
   61,   62,   63,   -1,   -1,   -1,  281,  282,   -1,   -1,
   -1,  286,   -1,   -1,  289,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  297,   -1,  299,   -1,  301,  302,  303,   -1,
   91,   -1,   93,   94,   -1,  310,  311,   -1,  313,   -1,
   -1,   -1,  317,  318,   -1,   -1,   -1,  322,   -1,   -1,
  325,   -1,  327,   -1,   -1,   -1,  331,   -1,   -1,   -1,
   -1,  336,  337,  124,  125,   37,   38,   -1,   40,  296,
   42,   43,   44,   45,   46,   47,   -1,   -1,   -1,   -1,
  307,  308,  309,   -1,   -1,   -1,   58,   59,   60,   61,
   62,   63,   -1,   -1,  321,   -1,   -1,  324,   -1,  326,
   -1,  328,  256,  330,   -1,   -1,  260,   -1,  335,   -1,
   -1,   -1,   -1,  340,   -1,   -1,   -1,   -1,   -1,   91,
   -1,   -1,   94,   -1,  278,   -1,   -1,  281,  282,   -1,
   -1,   -1,  286,   -1,   -1,  289,   -1,   -1,   -1,   -1,
   -1,   -1,  296,  297,   -1,  299,   -1,  301,  302,  303,
   -1,   -1,  124,  307,  308,  309,  310,  311,   -1,  313,
   -1,   -1,   -1,  317,  318,   -1,   -1,  321,  322,   -1,
  324,  325,  326,  327,  328,   -1,  330,  331,   -1,   -1,
   -1,  335,  336,  337,   61,   -1,  340,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,   -1,   -1,
   -1,  262,  263,  264,  265,  266,  267,  268,   -1,  270,
  271,  272,  273,  274,  275,  276,  277,  278,  279,  280,
  281,  282,  283,  284,  285,   -1,  287,  288,  289,  290,
  291,  292,  293,  294,  295,  296,  297,  298,  299,  300,
   -1,  302,  303,  304,  305,  306,  307,  308,  309,  310,
  311,  312,  313,   -1,   -1,  316,  317,  318,  319,  320,
  321,  322,  323,  324,  325,  326,  327,  328,  329,  330,
  331,  332,  333,  334,  335,   61,  337,   -1,  339,  340,
  341,  342,   -1,   -1,   -1,  257,   -1,   -1,   -1,   -1,
  262,  263,  264,  265,  266,  267,  268,   -1,  270,  271,
  272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
  282,  283,  284,  285,  286,  287,  288,  289,  290,  291,
   -1,   -1,  294,  295,  296,  297,  298,  299,  300,   -1,
  302,  303,  304,  305,  306,  307,  308,  309,  310,  311,
  312,  313,   -1,   -1,  316,  317,  318,  319,  320,  321,
  322,  323,  324,  325,  326,  327,  328,  329,  330,  331,
  332,  333,  334,  335,   -1,  337,   -1,  339,  340,  341,
  342,   37,   38,   -1,   40,   41,   42,   43,   44,   45,
   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,   41,   -1,
   -1,   44,   58,   59,   60,   61,   62,   63,   -1,   -1,
   61,   -1,  279,  280,   -1,   58,   59,   -1,  285,   -1,
   -1,   -1,   -1,  290,   -1,   -1,   -1,   -1,  295,   -1,
   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,   94,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  316,
   93,   -1,  319,  320,   -1,   -1,  323,   -1,   -1,   -1,
   -1,   -1,  329,   -1,   -1,  332,   -1,   -1,  124,  125,
   37,   38,  339,   40,   41,   42,   43,   44,   45,   46,
   47,   -1,  125,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   58,   59,   60,   61,   62,   63,   -1,   -1,   61,
   37,   -1,   -1,  279,  280,   42,   43,   -1,   45,   -1,
   47,   -1,   -1,   -1,  290,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   60,   91,   62,   93,   94,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  316,   -1,   -1,  319,  320,   -1,   -1,  323,   -1,   -1,
   -1,   -1,   -1,  329,   -1,   -1,  332,  124,  125,   -1,
   -1,   -1,   -1,  339,   37,   38,   -1,   40,   41,   42,
   43,   44,   45,   41,   47,   -1,   44,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,
   63,   59,   -1,   61,   -1,   -1,   -1,   -1,   -1,   -1,
  256,  257,   -1,   -1,   -1,  256,  262,  263,   -1,  265,
  266,  267,  268,  256,  270,  271,  272,  273,   91,   -1,
   93,   94,  278,  279,  280,   93,   -1,   -1,  279,  280,
  286,   -1,   -1,   -1,  290,  278,  292,  293,   -1,  290,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  292,
  293,  124,  125,   -1,   -1,   -1,   40,  125,  314,   -1,
  316,   45,   46,  319,  320,  316,   -1,  323,  319,  320,
   -1,  314,  323,  329,   -1,   59,  332,   61,  329,   -1,
   -1,  332,   -1,  339,   -1,  341,  342,   -1,  339,  256,
  257,   -1,   -1,   -1,   -1,  262,  263,   -1,  265,  266,
  267,  268,   -1,  270,  271,  272,  273,   91,   -1,   -1,
   -1,  278,  279,  280,   -1,   -1,   -1,  279,  280,   -1,
   -1,   -1,   -1,  290,   -1,  292,  293,   -1,  290,  266,
  267,   -1,   -1,  270,  271,   -1,   -1,   -1,   -1,  123,
   -1,  125,  126,   -1,   -1,   40,   -1,  314,   -1,  316,
   45,   46,  319,  320,  316,   -1,  323,  319,  320,   -1,
   -1,  323,  329,   -1,   59,  332,   61,  329,   -1,   -1,
  332,   -1,  339,   -1,  341,  342,   -1,  339,   -1,   -1,
   -1,   -1,   -1,  256,  257,   -1,   -1,   -1,   -1,  262,
  263,   -1,  265,  266,  267,  268,   91,  270,  271,  272,
  273,   -1,   -1,   -1,   -1,  278,  279,  280,   -1,   -1,
  278,  279,  280,   -1,   -1,   -1,   -1,  290,   -1,  292,
  293,   -1,  290,   -1,   -1,   -1,   -1,   -1,  123,   -1,
   -1,  126,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   41,  314,   -1,  316,   -1,   46,  319,  320,  316,   -1,
  323,  319,  320,   -1,   -1,  323,  329,   -1,   -1,  332,
   -1,  329,   -1,   -1,  332,   -1,  339,   -1,  341,  342,
   -1,  339,  256,   -1,  258,  259,  260,  261,  262,  263,
  264,   -1,   -1,   -1,   -1,  269,   -1,   -1,   -1,   -1,
  274,  275,  276,  277,  278,  279,  280,  281,  282,  283,
  284,  285,  286,  287,  288,  289,  290,  291,   -1,   -1,
  294,  295,  296,  297,  298,  299,  300,  301,  302,  303,
  304,  305,  306,  307,  308,  309,  310,  311,  312,  313,
   -1,  315,  316,  317,  318,  319,  320,  321,  322,  323,
  324,  325,  326,  327,  328,  329,  330,  331,  332,   -1,
  334,  335,  336,  337,  338,  339,  340,   -1,   46,   -1,
   -1,  256,   -1,  258,  259,  260,  261,  262,  263,  264,
   58,   -1,   -1,   -1,  269,   -1,   -1,   -1,   -1,  274,
  275,  276,  277,   -1,  279,  280,  281,  282,  283,  284,
  285,  286,  287,  288,  289,  290,  291,   -1,   -1,  294,
  295,  296,  297,  298,  299,  300,  301,  302,  303,  304,
  305,  306,  307,  308,  309,  310,  311,  312,  313,   -1,
  315,  316,  317,  318,  319,  320,  321,  322,  323,  324,
  325,  326,  327,  328,  329,  330,  331,  332,   -1,  334,
  335,  336,  337,  338,  339,  340,   40,   -1,   -1,   -1,
   -1,   45,   46,   -1,   -1,  256,   -1,   -1,   -1,  260,
   -1,   -1,   -1,   -1,   -1,   59,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  281,  282,   -1,   -1,   -1,  286,   -1,   -1,  289,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  297,   91,  299,   -1,
  301,  302,  303,   -1,   -1,   -1,   -1,   -1,   -1,  310,
  311,   -1,  313,   -1,   -1,   -1,  317,  318,   -1,   -1,
   -1,  322,   -1,   -1,  325,   -1,  327,   -1,   -1,  123,
  331,  125,  126,   40,   -1,  336,  337,   -1,   45,   46,
   -1,  281,  282,   -1,   -1,   -1,   -1,   -1,   -1,  289,
   -1,   -1,   59,   -1,   -1,   -1,   -1,  297,   -1,  299,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  311,  260,  313,   -1,   -1,   -1,  317,  318,   -1,
   -1,   -1,  322,   -1,   91,  325,   -1,   -1,   -1,   -1,
   -1,  331,   -1,  281,  282,   -1,   -1,  337,  286,   -1,
   -1,  289,   -1,   -1,  292,  293,   -1,   -1,   -1,  297,
   -1,  299,   -1,  301,  302,  303,  123,   -1,  125,  126,
   -1,   -1,  310,  311,   -1,  313,   -1,   -1,   -1,  317,
  318,   -1,   -1,   -1,  322,   -1,   -1,  325,   -1,  327,
   -1,   40,   -1,  331,   -1,   -1,   -1,   46,  336,  337,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  256,   -1,  258,  259,  260,  261,  262,  263,
  264,   -1,   -1,   -1,   -1,  269,   -1,   -1,   -1,   -1,
  274,  275,  276,  277,  278,   -1,   -1,  281,  282,  283,
  284,  285,  286,  287,  288,  289,   46,  291,   -1,   -1,
   -1,  295,  296,  297,  298,  299,  300,  301,  302,  303,
  304,  305,  306,  307,  308,  309,  310,  311,  312,  313,
   -1,  315,   -1,  317,  318,   -1,   -1,  321,  322,   -1,
  324,  325,  326,  327,  328,   -1,  330,  331,   -1,   -1,
  334,  335,  336,  337,  338,   -1,  340,   -1,   -1,  256,
   -1,  258,  259,  260,  261,  262,  263,  264,   -1,   -1,
   -1,   -1,  269,   -1,   -1,   -1,   -1,  274,  275,  276,
  277,  278,   -1,   -1,  281,  282,  283,  284,   -1,  286,
  287,  288,  289,   -1,  291,   -1,   -1,  294,   -1,  296,
  297,  298,  299,  300,  301,  302,  303,  304,  305,  306,
  307,  308,  309,  310,  311,  312,  313,   40,  315,   -1,
  317,  318,   45,   46,  321,  322,   -1,  324,  325,  326,
  327,  328,   -1,  330,  331,   -1,   59,  334,  335,  336,
  337,  338,   -1,  340,  344,  345,  346,  347,  348,  349,
  350,  351,   -1,  353,  354,  355,  356,  357,  358,  359,
  360,  361,  362,   -1,   -1,   -1,   -1,   -1,   91,   -1,
  259,  260,  261,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  275,  276,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  286,   -1,   -1,
  123,   -1,   40,  126,   42,   -1,   -1,   45,   46,   -1,
   -1,  300,  301,  302,  303,   -1,  256,   -1,   -1,  308,
  260,  310,   60,  312,   -1,   -1,  315,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  327,   -1,
   -1,  281,  282,   -1,   -1,  334,  286,  336,   -1,  289,
   -1,   -1,   -1,   91,   -1,   -1,   -1,  297,   -1,  299,
   -1,  301,  302,  303,   -1,   40,   41,   -1,   -1,   44,
  310,  311,   -1,  313,   -1,   -1,   -1,  317,  318,   -1,
   -1,   -1,  322,   58,   59,  325,   -1,  327,  126,   -1,
   -1,  331,   -1,   -1,   -1,   -1,  336,  337,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   40,   -1,   -1,   -1,   -1,
   45,   46,   -1,   -1,   -1,   -1,   -1,   -1,   93,   -1,
   -1,   -1,   -1,   -1,   59,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  256,   -1,  258,  259,  260,  261,  262,
  263,  264,   -1,   -1,   -1,   -1,  269,   -1,   -1,   -1,
  125,  274,  275,  276,  277,   -1,   91,   -1,  281,  282,
  283,  284,   -1,  286,  287,  288,  289,   -1,  291,   -1,
   -1,  294,   -1,  296,  297,  298,  299,  300,  301,  302,
  303,  304,  305,  306,  307,  308,  309,  310,  311,  312,
  313,  126,  315,   -1,  317,  318,   -1,   -1,  321,  322,
   -1,  324,  325,  326,  327,  328,   -1,  330,  331,   -1,
   -1,  334,  335,  336,  337,  338,   -1,  340,  256,   -1,
   -1,  259,  260,  261,  262,  263,  264,   40,   -1,   -1,
   -1,  269,   45,   46,   -1,   -1,  274,  275,  276,  277,
  278,   -1,   -1,  281,  282,  283,  284,   -1,  286,  287,
  288,  289,   -1,  291,   -1,   -1,  294,   -1,  296,  297,
  298,  299,  300,  301,  302,  303,  304,  305,  306,  307,
  308,  309,  310,  311,  312,  313,   -1,  315,   91,  317,
  318,  256,   -1,  321,  322,   -1,  324,  325,  326,  327,
  328,   -1,  330,  331,   -1,   -1,  334,  335,  336,  337,
   -1,   -1,  340,  278,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  126,   -1,   -1,   -1,  292,  293,   -1,
   -1,  256,   -1,   -1,  259,  260,  261,  262,  263,  264,
   40,   -1,   -1,   -1,  269,   45,   46,   -1,   -1,  274,
  275,  276,  277,  278,   -1,   -1,  281,  282,  283,  284,
   -1,  286,  287,  288,  289,   -1,  291,   -1,   -1,  294,
   -1,  296,  297,  298,  299,  300,  301,  302,  303,  304,
  305,  306,  307,  308,  309,  310,  311,  312,  313,   -1,
  315,   91,  317,  318,   -1,   -1,  321,  322,   -1,  324,
  325,  326,  327,  328,   -1,  330,  331,   -1,   -1,  334,
  335,  336,  337,   -1,   -1,  340,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  123,   -1,   40,  126,   -1,   -1,   -1,
   45,   46,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   60,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  256,   -1,   -1,  259,  260,  261,  262,
  263,  264,   -1,   -1,   -1,   -1,  269,   -1,   -1,   -1,
   -1,  274,  275,  276,  277,   -1,   91,   -1,  281,  282,
  283,  284,   -1,  286,  287,  288,  289,   -1,  291,  292,
  293,  294,   -1,  296,  297,  298,  299,  300,  301,  302,
  303,  304,  305,  306,  307,  308,  309,  310,  311,  312,
  313,  126,  315,   -1,  317,  318,   -1,   -1,  321,  322,
   -1,  324,  325,  326,  327,  328,   -1,  330,  331,   -1,
   -1,  334,  335,  336,  337,   -1,   -1,  340,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  256,   -1,   -1,  259,
  260,  261,  262,  263,  264,   40,   -1,   -1,   -1,  269,
   45,   46,   -1,   -1,  274,  275,  276,  277,   -1,   -1,
   -1,  281,  282,  283,  284,   -1,  286,  287,  288,  289,
   -1,  291,   -1,   -1,  294,   -1,  296,  297,  298,  299,
  300,  301,  302,  303,  304,  305,  306,  307,  308,  309,
  310,  311,  312,  313,   -1,  315,   91,  317,  318,   -1,
   -1,  321,  322,   -1,  324,  325,  326,  327,  328,   -1,
  330,  331,   -1,   -1,  334,  335,  336,  337,   -1,   -1,
  340,   -1,   -1,   -1,  259,  260,  261,  262,  263,  264,
   40,  126,   -1,   -1,  269,   45,   46,   -1,   -1,  274,
  275,  276,  277,  278,   -1,   -1,  281,  282,  283,  284,
   -1,  286,  287,  288,  289,   -1,  291,   -1,   -1,  294,
   -1,  296,  297,  298,  299,  300,  301,  302,  303,  304,
  305,  306,  307,  308,  309,  310,  311,  312,  313,   -1,
  315,   91,  317,  318,   -1,   -1,  321,  322,   -1,  324,
  325,  326,  327,  328,   -1,  330,  331,   -1,   -1,  334,
  335,  336,  337,   -1,   -1,  340,   -1,   -1,   -1,   -1,
   -1,   -1,   40,   -1,   -1,   -1,  126,   45,   46,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  256,   -1,   91,  259,  260,  261,  262,  263,  264,
   -1,   -1,   -1,   -1,  269,   -1,   -1,   -1,   -1,  274,
  275,  276,  277,   -1,   -1,   -1,  281,  282,  283,  284,
   46,  286,  287,  288,  289,   -1,  291,   -1,  126,  294,
   -1,  296,  297,  298,  299,  300,  301,  302,  303,  304,
  305,  306,  307,  308,  309,  310,  311,  312,  313,   -1,
  315,   -1,  317,  318,   -1,   -1,  321,  322,   -1,  324,
  325,  326,  327,  328,   -1,  330,  331,   -1,   -1,  334,
  335,  336,  337,   -1,   -1,  340,   -1,   -1,   -1,  259,
  260,  261,  262,  263,  264,   -1,   -1,   -1,   -1,  269,
   -1,   -1,   -1,   -1,  274,  275,  276,  277,  278,   -1,
   41,  281,  282,  283,  284,   46,  286,  287,  288,  289,
   -1,  291,   -1,   -1,  294,   -1,  296,  297,  298,  299,
  300,  301,  302,  303,  304,  305,  306,  307,  308,  309,
  310,  311,  312,  313,   -1,  315,   -1,  317,  318,   -1,
   -1,  321,  322,   -1,  324,  325,  326,  327,  328,   -1,
  330,  331,   -1,   -1,  334,  335,  336,  337,  256,   -1,
  340,  259,  260,  261,  262,  263,  264,   -1,   -1,   -1,
   -1,  269,   -1,   -1,   -1,   -1,  274,  275,  276,  277,
   -1,   -1,  123,  281,  282,  283,  284,   -1,  286,  287,
  288,  289,   -1,  291,   -1,   -1,  294,   -1,  296,  297,
  298,  299,  300,  301,  302,  303,  304,  305,  306,  307,
  308,  309,  310,  311,  312,  313,   -1,  315,   -1,  317,
  318,   -1,   -1,  321,  322,   -1,  324,  325,  326,  327,
  328,   -1,  330,  331,  260,   -1,  334,  335,  336,  337,
   40,   41,  340,   -1,   44,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  281,  282,   -1,   58,   59,
  286,   -1,   -1,  289,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  297,   -1,  299,   -1,  301,  302,  303,   -1,   -1,
   -1,   -1,   -1,   -1,  310,  311,   -1,  313,   -1,   -1,
   -1,  317,  318,   93,   -1,   -1,  322,   -1,   -1,  325,
   -1,  327,   -1,   -1,   -1,  331,   -1,   -1,   -1,   -1,
  336,  337,   -1,   -1,   -1,  256,   -1,   -1,   -1,  260,
   -1,   -1,   40,  123,  124,   -1,   -1,   45,   46,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  278,   -1,   -1,
  281,  282,   -1,   -1,   -1,  286,   -1,   -1,  289,   -1,
   -1,   -1,   -1,   -1,   -1,  296,  297,   -1,  299,   -1,
  301,  302,  303,   -1,   -1,   -1,  307,  308,  309,  310,
  311,   -1,  313,   91,   -1,   -1,  317,  318,   -1,   -1,
  321,  322,   -1,  324,  325,  326,  327,  328,   -1,  330,
  331,   -1,   -1,   -1,  335,  336,  337,   -1,   -1,  340,
   -1,   -1,   -1,   -1,   40,   -1,   -1,   -1,  126,   -1,
   46,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   91,  256,   -1,  258,   -1,
   -1,   -1,   -1,   -1,  264,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  274,  275,  276,  277,  278,   -1,
   -1,  281,  282,  283,  284,  285,   -1,  287,  288,  289,
   -1,  291,  292,  293,  294,  295,  296,  297,  298,  299,
  300,   -1,  302,  303,  304,  305,  306,  307,  308,  309,
  310,  311,  312,  313,   -1,   -1,   -1,  317,  318,   -1,
   -1,  321,  322,   40,  324,  325,  326,  327,  328,   46,
  330,  331,   -1,  333,  334,  335,   -1,  337,   -1,   -1,
  340,  259,  260,  261,  262,  263,  264,   -1,   -1,   -1,
   -1,  269,   -1,   -1,   -1,   -1,  274,  275,  276,  277,
   -1,   -1,   -1,  281,  282,  283,  284,   -1,  286,  287,
  288,  289,   -1,  291,   91,   -1,  294,   -1,  296,  297,
  298,  299,  300,  301,  302,  303,  304,  305,  306,  307,
  308,  309,  310,  311,  312,  313,   -1,  315,   -1,  317,
  318,   -1,   -1,  321,  322,   -1,  324,  325,  326,  327,
  328,   -1,  330,  331,   -1,   -1,  334,  335,  336,  337,
  256,   -1,  340,  259,  260,  261,   -1,   40,  264,   -1,
   -1,   -1,   45,   46,   -1,   -1,   -1,   -1,  274,  275,
  276,  277,   -1,   -1,   -1,  281,  282,  283,  284,   -1,
  286,  287,  288,  289,   -1,  291,   -1,   -1,  294,   -1,
  296,  297,  298,  299,  300,  301,  302,  303,  304,  305,
  306,  307,  308,  309,  310,  311,  312,  313,   91,  315,
   -1,  317,  318,   -1,   -1,  321,  322,   -1,  324,  325,
  326,  327,  328,   -1,  330,  331,   -1,   -1,  334,  335,
  336,  337,   -1,   -1,  340,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  126,   -1,   -1,   37,   38,   -1,   -1,
   -1,   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   60,
   -1,   62,  259,  260,  261,   -1,   40,  264,   -1,   -1,
   -1,   45,   46,   -1,   -1,   -1,   -1,  274,  275,  276,
  277,   -1,   -1,   -1,  281,  282,  283,  284,   -1,  286,
  287,  288,  289,   94,  291,   -1,   -1,  294,   -1,  296,
  297,  298,  299,  300,  301,  302,  303,  304,  305,  306,
  307,  308,  309,  310,  311,  312,  313,   91,  315,   -1,
  317,  318,   -1,  124,  321,  322,   -1,  324,  325,  326,
  327,  328,   -1,  330,  331,   -1,   -1,  334,  335,  336,
  337,   -1,   -1,  340,   -1,   -1,   -1,   -1,   -1,  123,
   -1,   -1,  126,   40,   -1,   -1,   -1,   -1,   45,   46,
   -1,   -1,   -1,  256,   -1,   -1,  259,  260,  261,  262,
  263,  264,   -1,   -1,   -1,   -1,  269,   64,   -1,   -1,
   -1,  274,  275,  276,  277,  278,   -1,   -1,   -1,   -1,
  283,  284,   -1,  286,  287,  288,   -1,   -1,  291,   -1,
   -1,  294,   -1,  296,   91,  298,   -1,  300,  301,  302,
  303,  304,  305,  306,  307,  308,  309,  310,   -1,  312,
   -1,   -1,  315,   -1,   -1,   -1,   -1,   41,  321,   -1,
   -1,  324,   -1,  326,  327,  328,   -1,  330,   -1,  126,
   -1,  334,  335,  336,   58,   59,   -1,  340,   -1,   -1,
   -1,   -1,   -1,   40,   -1,   -1,   -1,   -1,   45,   46,
   -1,   -1,   -1,   -1,  265,  266,  267,  268,   -1,  270,
  271,  272,   -1,   -1,   -1,   -1,   -1,   64,   -1,   93,
   -1,   -1,  256,   -1,   -1,  259,  260,  261,  262,  263,
  264,   -1,   -1,   -1,   -1,  269,   -1,   -1,   -1,   -1,
  274,  275,  276,  277,   91,   -1,   -1,   -1,   -1,  283,
  284,  125,  286,  287,  288,   -1,   -1,  291,   -1,   -1,
  294,   -1,  296,   -1,  298,   -1,  300,  301,  302,  303,
  304,  305,  306,  307,  308,  309,  310,   -1,  312,  126,
   40,  315,   -1,   -1,   -1,   45,   46,  321,   -1,   -1,
  324,   -1,  326,  327,  328,   -1,  330,   -1,   -1,   -1,
  334,  335,  336,   -1,   -1,   -1,  340,   -1,   -1,  256,
   -1,   -1,  259,  260,  261,  262,  263,  264,   -1,   -1,
   -1,   -1,  269,   -1,   -1,   -1,   -1,  274,  275,  276,
  277,   91,   -1,   -1,   -1,   -1,  283,  284,   -1,  286,
  287,  288,   -1,   -1,  291,   -1,   -1,  294,   -1,  296,
   -1,  298,   -1,  300,  301,  302,  303,  304,  305,  306,
  307,  308,  309,  310,   -1,  312,  126,   -1,  315,   -1,
   -1,   -1,   -1,   -1,  321,   -1,   -1,  324,   -1,  326,
  327,  328,   41,  330,   -1,   -1,   -1,  334,  335,  336,
   -1,   -1,   40,  340,   -1,   -1,   -1,   45,   46,   58,
   59,   -1,   -1,   -1,  278,   -1,   -1,   -1,   -1,  256,
   -1,   -1,  259,  260,  261,  262,  263,  264,  292,  293,
   -1,   -1,  269,   -1,   -1,   -1,   -1,  274,  275,  276,
  277,   -1,   -1,   -1,   93,   -1,  283,  284,   -1,  286,
  287,  288,   -1,   91,  291,   -1,   -1,  294,   -1,  296,
   -1,  298,   -1,  300,  301,  302,  303,  304,  305,  306,
  307,  308,  309,  310,   -1,  312,  125,   -1,  315,   -1,
   -1,   -1,   -1,   -1,  321,   -1,   -1,  324,  126,  326,
  327,  328,   -1,  330,   -1,   -1,   40,  334,  335,  336,
   -1,   45,   46,  340,   -1,   -1,  256,   -1,   -1,  259,
  260,  261,  262,  263,  264,   -1,   -1,   -1,   -1,  269,
   -1,   -1,   -1,   -1,  274,  275,  276,  277,  278,   -1,
   -1,   -1,   -1,  283,  284,   -1,  286,  287,  288,   -1,
   -1,  291,   -1,   -1,  294,   -1,  296,   91,  298,   -1,
  300,  301,  302,  303,  304,  305,  306,  307,  308,  309,
  310,   -1,  312,   -1,   -1,  315,   -1,   -1,   -1,   -1,
   -1,  321,   -1,   -1,  324,   -1,  326,  327,  328,   -1,
  330,   -1,  126,   -1,  334,  335,  336,   -1,   -1,   40,
  340,   -1,   -1,   -1,   45,   46,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  259,  260,  261,  262,  263,  264,   -1,   -1,  278,
   -1,  269,   -1,   -1,   -1,   -1,  274,  275,  276,  277,
   91,   -1,   -1,  292,  293,  283,  284,  285,  286,  287,
  288,   -1,   -1,  291,   -1,   -1,  294,  295,  296,   -1,
  298,   -1,  300,  301,  302,  303,  304,  305,  306,  307,
  308,  309,  310,   -1,  312,  126,   -1,  315,   -1,   -1,
   -1,   -1,   -1,  321,   -1,   -1,  324,   -1,  326,  327,
  328,   -1,  330,   -1,   -1,   -1,  334,  335,  336,   -1,
   -1,   -1,  340,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  256,   -1,   -1,  259,  260,  261,  262,  263,
  264,   40,   -1,   -1,   -1,  269,   45,   46,   -1,   -1,
  274,  275,  276,  277,   -1,   -1,   -1,   -1,   -1,  283,
  284,   -1,  286,  287,  288,   64,   -1,  291,   -1,   -1,
  294,   -1,  296,   -1,  298,   -1,  300,  301,  302,  303,
  304,  305,  306,  307,  308,  309,  310,   -1,  312,   -1,
   -1,  315,   91,   -1,   -1,   -1,   -1,  321,   -1,   -1,
  324,   -1,  326,  327,  328,   -1,  330,   -1,   -1,   -1,
  334,  335,  336,   -1,   -1,   -1,  340,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  256,   -1,  126,  259,  260,
  261,  262,  263,  264,   40,   -1,   -1,   -1,  269,   45,
   46,   -1,   -1,  274,  275,  276,  277,   -1,   -1,   -1,
   -1,   -1,  283,  284,   -1,  286,  287,  288,   -1,   -1,
  291,   -1,   -1,  294,   -1,  296,   -1,  298,   -1,  300,
  301,  302,  303,  304,  305,  306,  307,  308,  309,  310,
   -1,  312,   -1,   -1,  315,   91,   -1,   -1,   -1,   -1,
  321,   -1,   -1,  324,   -1,  326,  327,  328,   -1,  330,
   -1,   -1,   -1,  334,  335,  336,   -1,   -1,   -1,  340,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  126,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   40,   -1,
   -1,   -1,   -1,   45,   46,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  259,  260,  261,  262,  263,  264,   -1,   -1,   -1,   -1,
  269,   -1,   -1,   -1,   -1,  274,  275,  276,  277,   91,
   -1,   -1,   -1,   -1,  283,  284,   -1,  286,  287,  288,
   -1,   -1,  291,   -1,   -1,  294,   -1,  296,   -1,  298,
   -1,  300,  301,  302,  303,  304,  305,  306,  307,  308,
  309,  310,   -1,  312,  126,   -1,  315,   -1,   -1,   -1,
   -1,   -1,  321,   -1,   -1,  324,   -1,  326,  327,  328,
   -1,  330,   -1,   40,   -1,  334,  335,  336,   45,   46,
   -1,  340,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  256,   -1,   -1,  259,  260,  261,  262,  263,  264,   -1,
   -1,   -1,   -1,  269,   -1,   -1,   -1,   -1,  274,  275,
  276,  277,   -1,   -1,   -1,   -1,   -1,  283,  284,   -1,
  286,  287,  288,   -1,   91,  291,   -1,   -1,  294,   -1,
  296,   -1,  298,   -1,  300,  301,  302,  303,  304,  305,
  306,  307,  308,  309,  310,   -1,  312,   -1,   -1,  315,
   -1,   -1,   -1,   -1,   -1,  321,   -1,   -1,  324,  126,
  326,  327,  328,   -1,  330,   -1,   -1,   40,  334,  335,
  336,   -1,   45,   46,  340,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  256,   -1,   -1,  259,  260,  261,
  262,  263,  264,   -1,   -1,   -1,   -1,  269,   -1,   -1,
   -1,   -1,  274,  275,  276,  277,   -1,   -1,   -1,   -1,
   -1,  283,  284,   -1,  286,  287,  288,   -1,   91,  291,
   -1,   -1,  294,   -1,  296,   -1,  298,   -1,  300,  301,
  302,  303,  304,  305,  306,  307,  308,  309,  310,   -1,
  312,   -1,   -1,  315,   -1,   -1,   -1,   -1,   -1,  321,
   -1,   -1,  324,  126,  326,  327,  328,   -1,  330,   -1,
   40,   -1,  334,  335,  336,   45,   46,   -1,  340,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  256,
   -1,   -1,  259,  260,  261,  262,  263,  264,   -1,   -1,
   -1,   -1,  269,   -1,   -1,   -1,   -1,  274,  275,  276,
  277,   91,   -1,   -1,   -1,   -1,  283,  284,   -1,  286,
  287,  288,   -1,   -1,  291,   -1,   -1,  294,   -1,  296,
   -1,  298,   -1,  300,  301,  302,  303,  304,  305,  306,
  307,  308,  309,  310,   -1,  312,  126,   -1,  315,   -1,
   -1,   -1,   -1,   -1,  321,   -1,   -1,  324,   -1,  326,
  327,  328,   -1,  330,   -1,   -1,   -1,  334,  335,  336,
   -1,   -1,   -1,  340,   -1,   46,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  256,   -1,   -1,  259,  260,  261,  262,
  263,  264,   -1,   -1,   -1,   -1,  269,   -1,   -1,   -1,
   -1,  274,  275,  276,  277,   40,   41,   -1,   -1,   44,
  283,  284,   -1,  286,  287,  288,   -1,   -1,  291,   -1,
   -1,  294,   -1,  296,   59,  298,   61,  300,  301,  302,
  303,  304,  305,  306,  307,  308,  309,  310,   -1,  312,
   -1,   -1,  315,   -1,   -1,   -1,   -1,   -1,  321,   -1,
   -1,  324,  123,  326,  327,  328,   46,  330,   93,   -1,
   -1,  334,  335,  336,   -1,   -1,   -1,  340,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  259,
  260,  261,  262,  263,  264,   -1,   -1,   -1,  123,  269,
  125,   -1,   -1,   -1,  274,  275,  276,  277,   -1,   -1,
   -1,   -1,   -1,  283,  284,   -1,  286,  287,  288,   -1,
   -1,  291,   -1,   -1,  294,   -1,  296,   -1,  298,   -1,
  300,  301,  302,  303,  304,  305,  306,  307,  308,  309,
  310,   -1,  312,  123,   41,  315,   -1,   44,   -1,   -1,
   -1,  321,   -1,   -1,  324,   -1,  326,  327,  328,   -1,
  330,   58,   59,   -1,  334,  335,  336,   -1,   -1,   -1,
  340,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   93,  258,   -1,  260,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  281,  282,   -1,   -1,  285,  286,  123,  124,  289,   41,
   -1,  256,   44,   -1,  295,   -1,  297,   -1,  299,   -1,
  301,  302,  303,   -1,   -1,  306,   58,   59,   -1,  310,
  311,   -1,  313,  278,  279,  280,  317,  318,   -1,   -1,
   -1,  322,   -1,   -1,  325,  290,  327,   -1,   -1,   -1,
  331,   -1,  333,   -1,   -1,  336,  337,   -1,  258,   -1,
  260,   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  316,   -1,   -1,  319,  320,   -1,   -1,  323,   -1,
   -1,  281,  282,   -1,  329,  285,  286,  332,   -1,  289,
   -1,  123,  124,   -1,  339,  295,  296,  297,   -1,  299,
   -1,  301,  302,  303,   -1,   -1,  306,  307,  308,  309,
  310,  311,   -1,  313,   -1,   -1,   -1,  317,  318,   -1,
   -1,  321,  322,   -1,  324,  325,  326,  327,  328,   -1,
  330,  331,   -1,  333,   -1,  335,  336,  337,   -1,  256,
  340,  258,   -1,   -1,   -1,   41,   -1,  264,   44,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  274,  275,  276,
  277,  278,   58,   59,  281,  282,  283,  284,  285,   -1,
  287,  288,  289,   -1,  291,  292,  293,  294,  295,  296,
  297,  298,  299,  300,   -1,  302,  303,  304,  305,  306,
  307,  308,  309,  310,  311,  312,  313,   93,   -1,   -1,
  317,  318,   -1,   -1,  321,  322,   -1,  324,  325,  326,
  327,  328,   -1,  330,  331,   -1,  333,  334,  335,   -1,
  337,   -1,   -1,  340,  256,   -1,  258,  123,  124,   -1,
   41,   -1,  264,   44,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  274,  275,  276,  277,  278,   58,   59,  281,
  282,  283,  284,  285,   -1,  287,  288,  289,   -1,  291,
  292,  293,  294,  295,  296,  297,  298,  299,  300,   -1,
  302,  303,  304,  305,  306,  307,  308,  309,  310,  311,
  312,  313,   93,   -1,   -1,  317,  318,   -1,   -1,  321,
  322,   -1,  324,  325,  326,  327,  328,   -1,  330,  331,
   -1,  333,  334,  335,   -1,  337,   41,   -1,  340,   44,
   -1,   -1,  123,  124,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   58,   59,   -1,   -1,   -1,   63,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   93,   -1,
  256,   -1,  258,   -1,   -1,   -1,   41,   -1,  264,   44,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  274,  275,
  276,  277,  278,   58,   59,  281,  282,  283,  284,  285,
  125,  287,  288,  289,   -1,  291,  292,  293,  294,  295,
  296,  297,  298,  299,  300,   -1,  302,  303,  304,  305,
  306,  307,  308,  309,  310,  311,  312,  313,   93,   -1,
   -1,  317,  318,   -1,   -1,  321,  322,   -1,  324,  325,
  326,  327,  328,   -1,  330,  331,   -1,  333,  334,  335,
   -1,  337,   -1,   -1,  340,  256,   -1,  258,  123,  124,
   -1,   41,   -1,  264,   44,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  274,  275,  276,  277,  278,   58,   59,
  281,  282,  283,  284,  285,   -1,  287,  288,  289,   -1,
  291,  292,  293,  294,  295,  296,  297,  298,  299,  300,
   -1,  302,  303,  304,  305,  306,  307,  308,  309,  310,
  311,  312,  313,   93,   -1,   -1,  317,  318,   -1,   -1,
  321,  322,   -1,  324,  325,  326,  327,  328,   -1,  330,
  331,  256,  333,  334,  335,   -1,  337,   -1,   -1,  340,
   -1,   -1,   -1,  123,  124,   -1,   -1,  272,  273,   -1,
   -1,   -1,   -1,  278,   41,   -1,   -1,   44,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  292,  293,   -1,
   -1,   58,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  314,
   -1,  256,   -1,  258,   -1,   -1,   -1,   -1,   -1,  264,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  274,
  275,  276,  277,  278,   -1,   -1,  281,  282,  283,  284,
  285,   -1,  287,  288,  289,   -1,  291,  292,  293,  294,
  295,  296,  297,  298,  299,  300,  123,  302,  303,  304,
  305,  306,  307,  308,  309,  310,  311,  312,  313,   -1,
   -1,   -1,  317,  318,   -1,   -1,  321,  322,   -1,  324,
  325,  326,  327,  328,   -1,  330,  331,   -1,  333,  334,
  335,   -1,  337,   -1,   41,  340,  256,   44,  258,   -1,
   -1,   -1,   -1,   -1,  264,   -1,   -1,   -1,   -1,   -1,
   -1,   58,   59,   -1,  274,  275,  276,  277,  278,   -1,
   -1,  281,  282,  283,  284,  285,   -1,  287,  288,  289,
   -1,  291,  292,  293,  294,  295,  296,  297,  298,  299,
  300,   -1,  302,  303,  304,  305,  306,  307,  308,  309,
  310,  311,  312,  313,   -1,   -1,   -1,  317,  318,   -1,
   -1,  321,  322,   -1,  324,  325,  326,  327,  328,   -1,
  330,  331,   -1,  333,  334,  335,  123,  337,   -1,   -1,
  340,   -1,   -1,   41,   -1,   -1,   44,   -1,   -1,  256,
   -1,  258,   -1,   -1,   -1,   -1,   -1,  264,   -1,   -1,
   58,   -1,   -1,   -1,   -1,   -1,   -1,  274,  275,  276,
  277,  278,   -1,   -1,  281,  282,  283,  284,  285,   -1,
  287,  288,  289,   -1,  291,  292,  293,  294,  295,  296,
  297,  298,  299,  300,   -1,  302,  303,  304,  305,  306,
  307,  308,  309,  310,  311,  312,  313,   -1,   -1,   -1,
  317,  318,   -1,   -1,  321,  322,   -1,  324,  325,  326,
  327,  328,   -1,  330,  331,  123,  333,  334,  335,   -1,
  337,   -1,   -1,  340,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   37,   38,
   -1,   -1,   -1,   42,   43,   -1,   45,   -1,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  256,
   -1,   60,   -1,   62,   -1,   -1,   -1,  264,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  274,  275,  276,
  277,  278,   46,   -1,  281,  282,  283,  284,  285,   -1,
  287,  288,  289,   -1,  291,   94,   -1,  294,  295,  296,
  297,  298,  299,  300,   -1,  302,  303,  304,  305,  306,
  307,  308,  309,  310,  311,  312,  313,   -1,   -1,   -1,
  317,  318,   -1,   -1,  321,  322,   -1,  324,  325,  326,
  327,  328,   -1,  330,  331,   -1,  333,  334,  335,   -1,
  337,   -1,   -1,  340,   -1,   -1,   -1,   -1,  256,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  264,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  274,  275,  276,  277,
  278,   -1,   -1,  281,  282,  283,  284,  285,   -1,  287,
  288,  289,   -1,  291,   -1,   -1,  294,  295,  296,  297,
  298,  299,  300,   -1,  302,  303,  304,  305,  306,  307,
  308,  309,  310,  311,  312,  313,   -1,   -1,   -1,  317,
  318,   -1,   -1,  321,  322,   -1,  324,  325,  326,  327,
  328,   41,  330,  331,   44,  333,  334,  335,   -1,  337,
   -1,   -1,  340,   -1,   -1,   41,   -1,   -1,   44,   59,
   -1,   61,   -1,   41,   -1,   -1,   44,   -1,   -1,   -1,
   -1,   -1,   -1,   59,   -1,   61,   -1,   -1,   -1,   -1,
   -1,   59,   -1,   61,   -1,   -1,  265,  266,  267,  268,
   -1,  270,  271,   93,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   93,   -1,   -1,
   41,   -1,  256,   44,   -1,   93,  260,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  125,   -1,   -1,   59,   -1,
   61,   -1,   -1,   -1,   -1,   -1,   -1,  281,  282,  125,
   -1,   -1,  286,   -1,   40,  289,   -1,  125,   -1,   45,
   46,   -1,   -1,  297,   -1,  299,   -1,  301,  302,  303,
   -1,   -1,   93,   -1,   -1,   -1,  310,  311,   -1,  313,
   -1,   -1,   -1,  317,  318,   -1,   -1,   -1,  322,   -1,
   -1,  325,   -1,  327,   -1,   -1,   -1,  331,   -1,   -1,
   -1,   -1,  336,  337,  125,   91,   -1,   -1,   -1,   -1,
   -1,   40,   -1,   -1,   -1,   -1,   45,   46,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  126,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   91,   -1,   -1,   -1,   -1,   -1,   40,   -1,
   -1,   -1,   -1,   45,   46,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  278,  279,
  280,   -1,   -1,   -1,   -1,   -1,   -1,  126,   -1,   -1,
  290,   -1,  278,  279,  280,   -1,   -1,   -1,   -1,   -1,
  278,  279,  280,   -1,  290,   -1,   -1,   -1,   -1,   91,
   -1,   -1,  290,   -1,   -1,   -1,  316,   -1,   -1,  319,
  320,   -1,   -1,  323,   -1,   -1,   -1,   -1,   -1,  329,
  316,   -1,  332,  319,  320,   -1,   -1,  323,  316,  339,
   -1,  319,  320,  329,  126,  323,  332,  278,  279,  280,
   -1,  329,   -1,  339,  332,   -1,   -1,   -1,   -1,  290,
  256,  339,   -1,  259,  260,  261,  262,  263,   -1,   -1,
   -1,   -1,   -1,  269,   -1,   -1,   -1,   -1,   -1,  275,
  276,   40,   -1,   -1,   -1,  316,   45,   46,  319,  320,
  286,   -1,  323,   -1,   -1,   -1,   -1,   -1,  329,   -1,
   -1,  332,   -1,   -1,  300,  301,  302,  303,  339,   -1,
   -1,   -1,  308,   -1,  310,   -1,  312,  256,   -1,  315,
  259,  260,  261,  262,  263,   -1,   -1,   -1,   -1,   -1,
  269,  327,   91,   -1,   -1,   -1,  275,  276,  334,   -1,
  336,   -1,   -1,   -1,   -1,   -1,   -1,  286,   -1,   -1,
   40,   -1,   -1,   -1,   -1,   45,   46,   -1,   -1,   -1,
   -1,  300,  301,  302,  303,   -1,   -1,  126,   -1,  308,
   -1,  310,   -1,  312,  256,   -1,  315,  259,  260,  261,
  262,  263,   -1,   -1,   -1,   -1,   -1,  269,  327,   -1,
   -1,   -1,   -1,  275,  276,  334,   -1,  336,   -1,   -1,
   -1,   91,   -1,   -1,  286,   -1,   -1,   40,   -1,   -1,
   -1,   -1,   45,   46,   -1,   -1,   -1,   -1,  300,  301,
  302,  303,   -1,   -1,   -1,   -1,  308,   -1,  310,   -1,
  312,   -1,   -1,  315,   -1,   -1,  126,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  327,   -1,   -1,   -1,   -1,
   -1,   -1,  334,   -1,  336,   -1,   -1,   -1,   91,   -1,
   -1,   -1,   -1,   -1,   40,   -1,   -1,   -1,   -1,   45,
   46,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  126,   -1,   -1,   -1,  256,   -1,   -1,
  259,  260,  261,  262,  263,   -1,   -1,   -1,   -1,   -1,
  269,   -1,   -1,   -1,   -1,   91,  275,  276,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  286,   -1,   -1,
   -1,   -1,   -1,   40,   -1,   -1,   -1,   -1,   45,   46,
   -1,  300,  301,  302,  303,   -1,   -1,   -1,   -1,  308,
  126,  310,   -1,  312,   -1,   -1,  315,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  256,   -1,  327,  259,
  260,  261,  262,  263,   -1,  334,   -1,  336,   -1,  269,
   -1,   -1,   -1,   -1,   91,  275,  276,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  286,   -1,   -1,   -1,
   -1,   -1,   -1,   40,   -1,   -1,   -1,   -1,   45,   46,
  300,  301,  302,  303,   -1,   -1,   -1,   -1,  308,  126,
  310,   -1,  312,  256,   -1,  315,  259,  260,  261,  262,
  263,   -1,   -1,   -1,   -1,   -1,  269,  327,   -1,   -1,
   -1,   -1,  275,  276,  334,   -1,  336,   -1,   -1,   -1,
   -1,   -1,   -1,  286,   91,   -1,   -1,   -1,   -1,   -1,
   40,   -1,   -1,   -1,   -1,   45,   46,  300,  301,  302,
  303,   -1,   -1,   -1,   -1,  308,   -1,  310,   -1,  312,
  256,   -1,  315,  259,  260,  261,  262,  263,   -1,  126,
   -1,   -1,   -1,  269,  327,   -1,   -1,   -1,   -1,  275,
  276,  334,   -1,  336,   -1,   -1,   -1,   -1,   -1,   -1,
  286,   91,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   40,  300,  301,  302,  303,   45,   46,
   -1,   -1,  308,   -1,  310,   -1,  312,   -1,   -1,  315,
   -1,   -1,   -1,   -1,   -1,   -1,  126,   -1,   -1,  256,
   -1,  327,  259,  260,  261,  262,  263,   -1,  334,   -1,
  336,   -1,  269,   -1,   -1,   -1,   -1,   -1,  275,  276,
   -1,   -1,   -1,   -1,   91,   -1,   -1,   -1,   -1,  286,
   -1,   -1,   -1,   -1,   -1,   -1,   40,   -1,   -1,   -1,
   -1,   45,   46,  300,  301,  302,  303,   -1,   -1,   -1,
   -1,  308,   -1,  310,   -1,  312,   -1,   -1,  315,  126,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  256,
  327,   -1,  259,  260,  261,  262,  263,  334,   -1,  336,
   -1,   -1,  269,   -1,   -1,   -1,   -1,   91,  275,  276,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  286,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  300,  301,  302,  303,   -1,   -1,   -1,
   -1,  308,  126,  310,   -1,  312,  256,   -1,  315,  259,
  260,  261,  262,  263,   -1,   -1,   40,   -1,   -1,  269,
  327,   45,   46,   -1,   -1,  275,  276,  334,   -1,  336,
   -1,   -1,   -1,   -1,   40,   -1,  286,   -1,   -1,   45,
   46,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  300,  301,  302,  303,   -1,   -1,   -1,   -1,  308,   -1,
  310,   -1,  312,   -1,   -1,  315,   -1,   91,   -1,  256,
   -1,   -1,  259,  260,  261,  262,  263,  327,   -1,   -1,
   -1,   -1,  269,   -1,  334,   91,  336,   -1,  275,  276,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  286,
   -1,   -1,  126,   40,   -1,   -1,   -1,   -1,   45,   46,
   -1,   -1,   -1,  300,  301,  302,  303,   -1,   -1,   -1,
  126,  308,   -1,  310,   -1,  312,   -1,   -1,  315,   -1,
   -1,   -1,  256,   -1,   -1,  259,  260,  261,  262,  263,
  327,   -1,   -1,   -1,   -1,  269,   -1,  334,   -1,  336,
   -1,  275,  276,   -1,   91,   -1,   -1,   -1,   -1,   -1,
   40,   -1,  286,   -1,   -1,   45,   46,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  300,  301,  302,  303,
   -1,   -1,   -1,   -1,  308,   -1,  310,   -1,  312,  126,
   -1,  315,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  327,   -1,   -1,   -1,   -1,   -1,   -1,
  334,   91,  336,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   40,   -1,   -1,   -1,   -1,   45,   46,   -1,
   -1,   -1,  256,   -1,   -1,  259,  260,  261,  262,  263,
   -1,   -1,   -1,   -1,   -1,  269,  126,   -1,   -1,   -1,
  256,  275,  276,  259,  260,  261,  262,  263,   -1,   -1,
   -1,   -1,  286,  269,   46,   -1,   -1,   -1,   -1,  275,
  276,   -1,   -1,   91,   -1,   -1,  300,  301,  302,  303,
  286,   -1,   -1,   -1,  308,   -1,  310,   -1,  312,   -1,
   -1,  315,   -1,   -1,  300,  301,  302,  303,   -1,   -1,
   -1,   -1,  308,  327,  310,   -1,  312,   -1,  126,  315,
  334,   -1,  336,   -1,   -1,   -1,   -1,   -1,   -1,  256,
   -1,  327,  259,  260,  261,  262,  263,   -1,  334,   -1,
  336,   -1,  269,   -1,   -1,   -1,   -1,   -1,  275,  276,
   40,  123,   -1,  125,   -1,   45,   46,   -1,   -1,  286,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  300,  301,  302,  303,   -1,   -1,   -1,
   -1,  308,   -1,  310,   -1,  312,  256,   -1,  315,  259,
  260,  261,  262,  263,   -1,   -1,   -1,   -1,   -1,  269,
  327,   91,   -1,   -1,   -1,  275,  276,  334,   -1,  336,
   -1,   -1,   40,   -1,   -1,   -1,  286,   45,   46,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  300,  301,  302,  303,   -1,   -1,  126,   -1,  308,   -1,
  310,   -1,  312,   -1,   -1,  315,   -1,   -1,  256,   -1,
   -1,  259,  260,  261,  262,  263,   -1,  327,   -1,   -1,
   -1,  269,   46,   91,  334,   -1,  336,  275,  276,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  286,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  258,   -1,  260,   -1,
   -1,   -1,  300,  301,  302,  303,   -1,   -1,  126,   -1,
  308,   -1,  310,   -1,  312,   -1,  278,  315,   -1,  281,
  282,   -1,   -1,  285,  286,   -1,   -1,  289,   -1,  327,
   -1,   46,   -1,  295,  296,  297,  334,  299,  336,  301,
  302,  303,   -1,   -1,  306,  307,  308,  309,  310,  311,
   -1,  313,   -1,   -1,   -1,  317,  318,   -1,   -1,  321,
  322,   -1,  324,  325,  326,  327,  328,   -1,  330,  331,
   -1,  333,   -1,  335,  336,  337,  256,   -1,  340,  259,
  260,  261,  262,  263,   -1,   -1,   -1,   -1,   -1,  269,
   46,   -1,   -1,   -1,   -1,  275,  276,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  286,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  300,  301,  302,  303,   -1,   -1,   -1,   -1,  308,   -1,
  310,   -1,  312,   -1,   -1,  315,   -1,   -1,   -1,   -1,
   -1,  259,  260,  261,  262,  263,   -1,  327,   -1,   -1,
   -1,  269,   -1,   -1,  334,   -1,  336,  275,  276,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  286,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  300,  301,  302,  303,  260,   -1,   -1,   -1,
  308,   -1,  310,   -1,  312,   -1,   -1,  315,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  281,  282,  327,
   -1,   -1,  286,   -1,   -1,  289,  334,   -1,  336,   -1,
   -1,   -1,   -1,  297,   -1,  299,   -1,  301,  302,  303,
   -1,   -1,   -1,   -1,   -1,   -1,  310,  311,   -1,  313,
   -1,   -1,   -1,  317,  318,  260,   -1,   -1,  322,   -1,
   -1,  325,   -1,  327,   -1,   -1,   -1,  331,   -1,   -1,
   -1,   -1,  336,  337,   -1,   -1,  281,  282,   -1,   -1,
   -1,  286,   38,   -1,  289,   41,   -1,   -1,   44,   -1,
   -1,   -1,  297,   -1,  299,   -1,  301,  302,  303,   -1,
   -1,   -1,   58,   59,   -1,  310,  311,   63,  313,   -1,
   -1,   -1,  317,  318,  260,   -1,   -1,  322,   -1,   -1,
  325,   -1,  327,   -1,   -1,   -1,  331,   -1,   -1,   -1,
   -1,  336,  337,   -1,   -1,  281,  282,   93,   94,   -1,
  286,   -1,   -1,  289,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  297,   -1,  299,   -1,  301,  302,  303,   -1,   -1,
   -1,   -1,   -1,   -1,  310,  311,   -1,  313,  124,  125,
   -1,  317,  318,   -1,   -1,   -1,  322,   -1,   -1,  325,
   -1,  327,   -1,   -1,   -1,  331,   -1,   -1,   37,   38,
  336,  337,   41,   42,   43,   44,   45,   -1,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,
   59,   60,   -1,   62,   63,   -1,   -1,   37,   38,   -1,
   -1,   41,   42,   43,   44,   45,   -1,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,
   60,   -1,   62,   63,   93,   94,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   37,   38,   -1,   -1,
   41,   42,   43,   44,   45,   -1,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   93,   94,  124,  125,   58,   59,   60,
   -1,   62,   63,   -1,   -1,   -1,   38,   -1,   -1,   41,
   -1,   43,   44,   45,   -1,   -1,   -1,   -1,   -1,   -1,
  256,   -1,   -1,   -1,  124,  125,   58,   59,   60,   -1,
   62,   63,   93,   94,   -1,   -1,  272,  273,   -1,   -1,
   -1,   -1,  278,   -1,   -1,   38,   -1,   -1,   41,   -1,
   43,   44,   45,   -1,   -1,   -1,  292,  293,   -1,   -1,
   -1,   93,   94,  124,  125,   58,   59,   60,   -1,   62,
   63,   -1,   -1,   -1,   38,   -1,   -1,   41,  314,   -1,
   44,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  124,  125,   58,   59,   60,   -1,   62,   63,
   93,   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  256,   -1,   93,
   94,  124,  125,   -1,   -1,   -1,  265,  266,  267,  268,
   -1,  270,  271,  272,  273,   -1,   -1,   -1,   -1,  278,
   -1,   -1,   -1,   -1,   -1,   -1,  256,   -1,   -1,   -1,
  124,  125,   -1,  292,  293,  265,  266,  267,  268,   -1,
  270,  271,  272,  273,   -1,   -1,   -1,   -1,  278,   -1,
   -1,   -1,   -1,   -1,   -1,  314,   -1,   -1,   -1,   -1,
   -1,   -1,  292,  293,   -1,  256,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  265,  266,  267,  268,   -1,  270,
  271,  272,  273,   -1,  314,   -1,   -1,  278,   -1,   -1,
   -1,   -1,   -1,   -1,  256,   -1,   -1,   -1,   -1,   -1,
   -1,  292,  293,  265,  266,  267,  268,   -1,  270,  271,
  272,  273,   -1,   -1,   -1,   -1,  278,   -1,   -1,   -1,
   -1,   -1,   -1,  314,   -1,   -1,   -1,   -1,   -1,   -1,
  292,  293,   -1,  256,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  265,  266,  267,  268,   -1,  270,  271,  272,
  273,   -1,  314,   -1,   -1,  278,   -1,   -1,   -1,   -1,
   -1,   38,  256,   -1,   41,   -1,   -1,   44,   -1,  292,
  293,  265,  266,  267,  268,   -1,  270,  271,  272,  273,
   -1,   58,   59,   60,  278,   62,   63,   -1,   -1,   -1,
   38,  314,   -1,   41,   -1,   -1,   44,   -1,  292,  293,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   58,   59,   60,   -1,   62,   63,   93,   94,   -1,   -1,
  314,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   38,
   -1,   -1,   41,   -1,   -1,   44,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   93,   94,  124,  125,   58,
   59,   60,   -1,   62,   63,   -1,   -1,   -1,   38,   -1,
   -1,   41,   -1,   -1,   44,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  124,  125,   58,   59,
   60,   -1,   62,   63,   93,   94,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   38,   -1,   -1,
   41,   -1,   -1,   44,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   93,   94,  124,  125,   58,   59,   60,
   -1,   62,   63,   -1,   -1,   -1,   38,   -1,   -1,   41,
   -1,   -1,   44,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  124,  125,   58,   59,   -1,   -1,
   -1,   63,   93,   94,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  256,
   -1,   93,   94,  124,  125,   -1,   -1,   -1,  265,  266,
  267,  268,   -1,  270,  271,  272,  273,   -1,   -1,   -1,
   -1,  278,   -1,   -1,   -1,   -1,   -1,   -1,  256,   -1,
   -1,   -1,  124,  125,   -1,  292,  293,  265,  266,  267,
  268,   -1,   -1,   -1,  272,  273,   -1,   -1,   -1,   -1,
  278,   -1,   -1,   -1,   -1,   -1,   -1,  314,   -1,   -1,
   -1,   -1,   -1,   -1,  292,  293,   -1,  256,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  265,  266,  267,  268,
   -1,   -1,   -1,  272,  273,   -1,  314,   -1,   -1,  278,
   -1,   -1,   -1,   -1,   -1,   -1,  256,   -1,   -1,   -1,
   -1,   -1,   -1,  292,  293,  265,  266,  267,  268,   -1,
   -1,   -1,  272,  273,   -1,   -1,   -1,   -1,  278,   -1,
   -1,   -1,   -1,   -1,   -1,  314,   -1,   -1,   38,   -1,
   -1,   41,  292,  293,   44,  256,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  265,  266,  267,  268,   58,   59,
   -1,  272,  273,   63,  314,   -1,   -1,  278,   -1,   -1,
   41,   -1,   -1,   44,  256,   -1,   -1,   -1,   -1,   -1,
   -1,  292,  293,  265,   -1,   -1,  268,   58,   59,   -1,
  272,  273,   63,   93,   94,   41,  278,   -1,   44,   -1,
   -1,   -1,   -1,  314,   -1,   -1,   -1,   -1,   -1,   -1,
  292,  293,   58,   59,   -1,   -1,   -1,   63,   -1,   -1,
   -1,   -1,   93,   94,  124,  125,   -1,   -1,   -1,   -1,
   -1,   -1,  314,   -1,   -1,   -1,   37,   38,   -1,   -1,
   -1,   42,   43,   44,   45,   -1,   47,   93,   -1,   -1,
   -1,   -1,   -1,  124,  125,   -1,   -1,   58,   59,   60,
   -1,   62,   63,   37,   38,   -1,   -1,   -1,   42,   43,
   -1,   45,   -1,   47,   -1,   37,   38,   -1,  124,  125,
   42,   43,   -1,   45,   -1,   47,   60,   -1,   62,   63,
   -1,   -1,   93,   94,   -1,   -1,   -1,   -1,   60,   -1,
   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   94,   -1,   -1,  124,  125,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  124,   -1,   -1,   -1,   -1,   -1,  256,   -1,   -1,   -1,
  124,   -1,  124,   -1,   -1,  265,   -1,   -1,  268,   -1,
   -1,   -1,  272,  273,   -1,   -1,   -1,   -1,  278,   -1,
   -1,   -1,   -1,   -1,   -1,  256,   -1,   -1,   -1,   -1,
   -1,   -1,  292,  293,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  272,  273,   -1,   -1,   -1,   -1,  278,   -1,   -1,
  256,   -1,   -1,   -1,  314,   -1,   -1,   -1,   -1,   -1,
   -1,  292,  293,   -1,   -1,   -1,  272,  273,   -1,   -1,
   -1,   -1,  278,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  314,   -1,   -1,  292,  293,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  265,  266,  267,  268,  314,  270,
  271,  272,  273,   -1,   -1,   -1,   -1,  278,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  265,  266,  267,  268,   -1,  270,  271,  272,  273,
  264,   -1,   -1,  265,  266,  267,  268,   -1,  270,  271,
  274,  275,  276,  277,   -1,   -1,   -1,  281,  282,  283,
  284,  285,   -1,  287,  288,  289,   -1,  291,   -1,   -1,
  294,  295,  296,  297,  298,  299,  300,   -1,  302,  303,
  304,  305,  306,  307,  308,  309,  310,  311,  312,  313,
   -1,   -1,   -1,  317,  318,   -1,   -1,  321,  322,   -1,
  324,  325,  326,  327,  328,   -1,  330,  331,   -1,  333,
  334,  335,  256,  337,  258,   -1,  340,   -1,   -1,   -1,
  264,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  274,  275,  276,  277,   -1,   -1,   -1,  281,  282,  283,
  284,  285,   -1,  287,  288,  289,   -1,  291,   -1,   -1,
  294,  295,  296,  297,  298,  299,  300,  301,  302,  303,
  304,  305,  306,  307,  308,  309,  310,  311,  312,  313,
   -1,   -1,   -1,  317,  318,   -1,   -1,  321,  322,   -1,
  324,  325,  326,  327,  328,   -1,  330,  331,   -1,  333,
  334,  335,   -1,  337,  338,  256,  340,   -1,   -1,  260,
   -1,   -1,   -1,  264,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  274,  275,  276,  277,   -1,   -1,   -1,
  281,  282,  283,  284,  285,   -1,  287,  288,  289,   -1,
  291,   -1,   -1,  294,  295,  296,  297,  298,  299,  300,
   -1,  302,  303,  304,  305,  306,  307,  308,  309,  310,
  311,  312,  313,   -1,   -1,   -1,  317,  318,   -1,   -1,
  321,  322,   -1,  324,  325,  326,  327,  328,   -1,  330,
  331,   -1,  333,  334,  335,  256,  337,   -1,   -1,  340,
   -1,   -1,   -1,  264,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  274,  275,  276,  277,   -1,   -1,   -1,
  281,  282,  283,  284,  285,   -1,  287,  288,  289,   -1,
  291,   -1,   -1,  294,  295,  296,  297,  298,  299,  300,
   -1,  302,  303,  304,  305,  306,  307,  308,  309,  310,
  311,  312,  313,   -1,   -1,   -1,  317,  318,   -1,   -1,
  321,  322,   -1,  324,  325,  326,  327,  328,   -1,  330,
  331,   -1,  333,  334,  335,  256,  337,   -1,   -1,  340,
   -1,   -1,   -1,  264,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  274,  275,  276,  277,   -1,   -1,   -1,
  281,  282,  283,  284,  285,   -1,  287,  288,  289,   -1,
  291,   -1,   -1,  294,  295,  296,  297,  298,  299,  300,
   -1,  302,  303,  304,  305,  306,  307,  308,  309,  310,
  311,  312,  313,   -1,   -1,   -1,  317,  318,   -1,   -1,
  321,  322,   -1,  324,  325,  326,  327,  328,   -1,  330,
  331,   -1,  333,  334,  335,  256,  337,   -1,   -1,  340,
   -1,   -1,   -1,  264,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  274,  275,  276,  277,   -1,   -1,   -1,
  281,  282,  283,  284,  285,   -1,  287,  288,  289,   -1,
  291,   -1,   -1,  294,  295,  296,  297,  298,  299,  300,
   -1,  302,  303,  304,  305,  306,  307,  308,  309,  310,
  311,  312,  313,   -1,   -1,   -1,  317,  318,   -1,   -1,
  321,  322,   -1,  324,  325,  326,  327,  328,   -1,  330,
  331,   -1,  333,  334,  335,  256,  337,   -1,   -1,  340,
   -1,   -1,   -1,  264,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  274,  275,  276,  277,   -1,   -1,   -1,
  281,  282,  283,  284,  285,   -1,  287,  288,  289,   -1,
  291,   -1,   -1,  294,  295,  296,  297,  298,  299,  300,
   -1,  302,  303,  304,  305,  306,  307,  308,  309,  310,
  311,  312,  313,   -1,   -1,   -1,  317,  318,   -1,   -1,
  321,  322,   -1,  324,  325,  326,  327,  328,   -1,  330,
  331,   -1,  333,  334,  335,  256,  337,   -1,   -1,  340,
   -1,   -1,   -1,  264,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  274,  275,  276,  277,   -1,   -1,   -1,
  281,  282,  283,  284,  285,   -1,  287,  288,  289,   -1,
  291,   -1,   -1,  294,  295,  296,  297,  298,  299,  300,
   -1,  302,  303,  304,  305,  306,  307,  308,  309,  310,
  311,  312,  313,   -1,   -1,   -1,  317,  318,   -1,   -1,
  321,  322,   -1,  324,  325,  326,  327,  328,   -1,  330,
  331,   -1,  333,  334,  335,  256,  337,   -1,   -1,  340,
   -1,   -1,   -1,  264,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  274,  275,  276,  277,   -1,   -1,   -1,
  281,  282,  283,  284,  285,   -1,  287,  288,  289,   -1,
  291,   -1,   -1,  294,  295,  296,  297,  298,  299,  300,
   -1,  302,  303,  304,  305,  306,  307,  308,  309,  310,
  311,  312,  313,   -1,   -1,   -1,  317,  318,   -1,   -1,
  321,  322,   -1,  324,  325,  326,  327,  328,   -1,  330,
  331,   -1,  333,  334,  335,  256,  337,   -1,   -1,  340,
   -1,   -1,   -1,  264,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  274,  275,  276,  277,   -1,   -1,   -1,
  281,  282,  283,  284,  285,   -1,  287,  288,  289,   -1,
  291,   -1,   -1,  294,  295,  296,  297,  298,  299,  300,
   -1,  302,  303,  304,  305,  306,  307,  308,  309,  310,
  311,  312,  313,   -1,   -1,   -1,  317,  318,   -1,   -1,
  321,  322,   -1,  324,  325,  326,  327,  328,   -1,  330,
  331,  264,  333,  334,  335,   -1,  337,   -1,   -1,  340,
   -1,  274,  275,  276,  277,   -1,   -1,   -1,  281,  282,
  283,  284,  285,   -1,  287,  288,  289,   -1,  291,   -1,
   -1,  294,  295,  296,  297,  298,  299,  300,   -1,  302,
  303,  304,  305,  306,  307,  308,  309,  310,  311,  312,
  313,   -1,   -1,   -1,  317,  318,   -1,   -1,  321,  322,
   -1,  324,  325,  326,  327,  328,   -1,  330,  331,  264,
  333,  334,  335,   -1,  337,   -1,   -1,  340,   -1,  274,
  275,  276,  277,   -1,   -1,   -1,  281,  282,  283,  284,
  285,   -1,  287,  288,  289,   -1,  291,   -1,   -1,  294,
  295,  296,  297,  298,  299,  300,   -1,  302,  303,  304,
  305,  306,  307,  308,  309,  310,  311,  312,  313,   -1,
   -1,   -1,  317,  318,   -1,   -1,  321,  322,   -1,  324,
  325,  326,  327,  328,   -1,  330,  331,  264,  333,  334,
  335,   -1,  337,   -1,   -1,  340,   -1,  274,  275,  276,
  277,   -1,   -1,   -1,  281,  282,  283,  284,  285,   -1,
  287,  288,  289,   -1,  291,   -1,   -1,  294,  295,  296,
  297,  298,  299,  300,   -1,  302,  303,  304,  305,  306,
  307,  308,  309,  310,  311,  312,  313,   -1,   -1,   -1,
  317,  318,   -1,   -1,  321,  322,   -1,  324,  325,  326,
  327,  328,   -1,  330,  331,  264,  333,  334,  335,   -1,
  337,   -1,   -1,  340,   -1,  274,  275,  276,  277,   -1,
   -1,   -1,  281,  282,  283,  284,  285,   -1,  287,  288,
  289,   -1,  291,   -1,   -1,  294,  295,  296,  297,  298,
  299,  300,   -1,  302,  303,  304,  305,  306,  307,  308,
  309,  310,  311,  312,  313,   -1,   -1,   -1,  317,  318,
   -1,   -1,  321,  322,   -1,  324,  325,  326,  327,  328,
   -1,  330,  331,  264,  333,  334,  335,   -1,  337,   -1,
   -1,  340,   -1,  274,  275,  276,  277,   -1,   -1,   -1,
  281,  282,  283,  284,  285,   -1,  287,  288,  289,   -1,
  291,   -1,   -1,  294,  295,  296,  297,  298,  299,  300,
   -1,  302,  303,  304,  305,  306,  307,  308,  309,  310,
  311,  312,  313,   -1,   -1,   -1,  317,  318,   -1,   -1,
  321,  322,   -1,  324,  325,  326,  327,  328,   -1,  330,
  331,  264,  333,  334,  335,   -1,  337,   -1,   -1,  340,
   -1,  274,  275,  276,  277,   -1,   -1,   -1,  281,  282,
  283,  284,  285,   -1,  287,  288,  289,   -1,  291,   -1,
   -1,  294,  295,  296,  297,  298,  299,  300,   -1,  302,
  303,  304,  305,  306,  307,  308,  309,  310,  311,  312,
  313,   -1,   -1,   -1,  317,  318,   -1,   -1,  321,  322,
   -1,  324,  325,  326,  327,  328,   -1,  330,  331,  264,
  333,  334,  335,   -1,  337,   -1,   -1,  340,   -1,  274,
  275,  276,  277,   -1,   -1,   -1,  281,  282,  283,  284,
  285,   -1,  287,  288,  289,   -1,  291,   -1,   -1,  294,
  295,  296,  297,  298,  299,  300,   -1,  302,  303,  304,
  305,  306,  307,  308,  309,  310,  311,  312,  313,   -1,
   -1,   -1,  317,  318,   -1,   -1,  321,  322,   -1,  324,
  325,  326,  327,  328,   -1,  330,  331,  264,  333,  334,
  335,   -1,  337,   -1,   -1,  340,   -1,  274,  275,  276,
  277,   -1,   -1,   -1,  281,  282,  283,  284,  285,   -1,
  287,  288,  289,   -1,  291,   -1,   -1,  294,  295,  296,
  297,  298,  299,  300,   -1,  302,  303,  304,  305,  306,
  307,  308,  309,  310,  311,  312,  313,   -1,   -1,   -1,
  317,  318,   -1,   -1,  321,  322,   -1,  324,  325,  326,
  327,  328,   -1,  330,  331,  264,  333,  334,  335,   -1,
  337,   -1,   -1,  340,   -1,  274,  275,  276,  277,   -1,
   -1,   -1,  281,  282,  283,  284,  285,   -1,  287,  288,
  289,   -1,  291,   -1,   -1,  294,  295,  296,  297,  298,
  299,  300,   -1,  302,  303,  304,  305,  306,  307,  308,
  309,  310,  311,  312,  313,   -1,   -1,   -1,  317,  318,
   -1,   -1,  321,  322,   -1,  324,  325,  326,  327,  328,
   -1,  330,  331,  264,  333,  334,  335,   -1,  337,   -1,
   -1,  340,   -1,  274,  275,  276,  277,   -1,   -1,   -1,
  281,  282,  283,  284,  285,   -1,  287,  288,  289,   -1,
  291,   -1,   -1,  294,  295,  296,  297,  298,  299,  300,
   -1,  302,  303,  304,  305,  306,  307,  308,  309,  310,
  311,  312,  313,   -1,   -1,   -1,  317,  318,   -1,   -1,
  321,  322,   -1,  324,  325,  326,  327,  328,   -1,  330,
  331,  264,  333,  334,  335,   -1,  337,   -1,   -1,  340,
   -1,  274,  275,  276,  277,   -1,   -1,   -1,  281,  282,
  283,  284,  285,   -1,  287,  288,  289,   -1,  291,   -1,
   -1,  294,  295,  296,  297,  298,  299,  300,   -1,  302,
  303,  304,  305,  306,  307,  308,  309,  310,  311,  312,
  313,   -1,   -1,   -1,  317,  318,   -1,   -1,  321,  322,
   -1,  324,  325,  326,  327,  328,   -1,  330,  331,  264,
  333,  334,  335,   -1,  337,   -1,   -1,  340,   -1,  274,
  275,  276,  277,   -1,   -1,   -1,  281,  282,  283,  284,
  285,   -1,  287,  288,  289,   -1,  291,   -1,   -1,  294,
  295,  296,  297,  298,  299,  300,   -1,  302,  303,  304,
  305,  306,  307,  308,  309,  310,  311,  312,  313,   -1,
   -1,   -1,  317,  318,   -1,   -1,  321,  322,   -1,  324,
  325,  326,  327,  328,   -1,  330,  331,  264,  333,  334,
  335,   -1,  337,   -1,   -1,  340,   -1,  274,  275,  276,
  277,   -1,   -1,   -1,  281,  282,  283,  284,  285,   -1,
  287,  288,  289,   -1,  291,   -1,   -1,  294,  295,  296,
  297,  298,  299,  300,   -1,  302,  303,  304,  305,  306,
  307,  308,  309,  310,  311,  312,  313,   -1,   -1,   -1,
  317,  318,   -1,   -1,  321,  322,   -1,  324,  325,  326,
  327,  328,   -1,  330,  331,  264,  333,  334,  335,   -1,
  337,   -1,   -1,  340,   -1,  274,  275,  276,  277,   -1,
   -1,   -1,  281,  282,  283,  284,  285,   -1,  287,  288,
  289,   -1,  291,   -1,   -1,  294,  295,  296,  297,  298,
  299,  300,   -1,  302,  303,  304,  305,  306,  307,  308,
  309,  310,  311,  312,  313,   -1,   -1,   -1,  317,  318,
   -1,   -1,  321,  322,   -1,  324,  325,  326,  327,  328,
   -1,  330,  331,   -1,  333,  334,  335,   -1,  337,   -1,
   -1,  340,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 343
#define YYUNDFTOKEN 548
#define YYTRANSLATE(a) ((a) > YYMAXTOKEN ? YYUNDFTOKEN : (a))
#if YYDEBUG
static const char *const yyname[] = {

"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,"'%'","'&'",0,"'('","')'","'*'","'+'","','","'-'","'.'","'/'",0,0,0,0,0,0,
0,0,0,0,"':'","';'","'<'","'='","'>'","'?'","'@'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,"'['",0,"']'","'^'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,"'{'","'|'","'}'","'~'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"TOK_ARROW",
"TOK_CONSTANT","TOK_FLOAT","TOK_STRING","TOK_NUMBER","TOK_INC","TOK_DEC",
"TOK_RETURN","TOK_EQ","TOK_GE","TOK_LE","TOK_NE","TOK_NOT","TOK_LSH","TOK_RSH",
"TOK_LAND","TOK_LOR","TOK_SWITCH","TOK_SSCANF","TOK_CATCH","TOK_FOREACH",
"TOK_LEX_EOF","TOK_ADD_EQ","TOK_AND_EQ","TOK_ARRAY_ID","TOK_ATTRIBUTE_ID",
"TOK_BREAK","TOK_CASE","TOK_CLASS","TOK_COLON_COLON","TOK_CONTINUE",
"TOK_DEFAULT","TOK_DEPRECATED_ID","TOK_DIV_EQ","TOK_DO","TOK_DOT_DOT",
"TOK_DOT_DOT_DOT","TOK_ELSE","TOK_ENUM","TOK_EXTERN","TOK_FLOAT_ID","TOK_FOR",
"TOK_FUNCTION_ID","TOK_GAUGE","TOK_GLOBAL","TOK_IDENTIFIER","TOK_RESERVED",
"TOK_IF","TOK_IMPORT","TOK_INHERIT","TOK_INLINE","TOK_LOCAL_ID","TOK_FINAL_ID",
"TOK_FUNCTION_NAME","TOK_INT_ID","TOK_LAMBDA","TOK_MULTISET_ID",
"TOK_MULTISET_END","TOK_MULTISET_START","TOK_LSH_EQ","TOK_MAPPING_ID",
"TOK_MIXED_ID","TOK_MOD_EQ","TOK_MULT_EQ","TOK_NO_MASK","TOK_OBJECT_ID",
"TOK_OR_EQ","TOK_PRIVATE","TOK_PROGRAM_ID","TOK_PROTECTED","TOK_PREDEF",
"TOK_PUBLIC","TOK_RSH_EQ","TOK_STATIC","TOK_STRING_ID","TOK_SUB_EQ",
"TOK_TYPEDEF","TOK_TYPEOF","TOK_VARIANT","TOK_VERSION","TOK_VOID_ID",
"TOK_WHILE","TOK_XOR_EQ","TOK_OPTIONAL","TOK_SAFE_INDEX","TOK_SAFE_START_INDEX",
"TOK_BITS",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,"illegal-symbol",
};
static const char *const yyrule[] = {
"$accept : all",
"all : program",
"all : program TOK_LEX_EOF",
"program : program def",
"program : program ';'",
"program :",
"real_string_or_identifier : TOK_IDENTIFIER",
"real_string_or_identifier : real_string_constant",
"optional_rename_inherit : ':' real_string_or_identifier",
"optional_rename_inherit : ':' bad_identifier",
"optional_rename_inherit : ':' error",
"optional_rename_inherit :",
"low_program_ref : string_constant",
"low_program_ref : idents",
"program_ref : low_program_ref",
"$$1 :",
"inherit_ref : $$1 low_program_ref",
"inheritance : modifiers TOK_INHERIT inherit_ref optional_rename_inherit ';'",
"inheritance : modifiers TOK_INHERIT inherit_ref error ';'",
"inheritance : modifiers TOK_INHERIT inherit_ref error TOK_LEX_EOF",
"inheritance : modifiers TOK_INHERIT inherit_ref error '}'",
"inheritance : modifiers TOK_INHERIT error ';'",
"inheritance : modifiers TOK_INHERIT error TOK_LEX_EOF",
"inheritance : modifiers TOK_INHERIT error '}'",
"import : TOK_IMPORT idents ';'",
"import : TOK_IMPORT string ';'",
"import : TOK_IMPORT error ';'",
"import : TOK_IMPORT error TOK_LEX_EOF",
"import : TOK_IMPORT error '}'",
"constant_name : TOK_IDENTIFIER '=' safe_expr0",
"constant_name : bad_identifier '=' safe_expr0",
"constant_name : error '=' safe_expr0",
"constant_list : constant_name",
"constant_list : constant_list ',' constant_name",
"constant : modifiers TOK_CONSTANT constant_list ';'",
"constant : modifiers TOK_CONSTANT error ';'",
"constant : modifiers TOK_CONSTANT error TOK_LEX_EOF",
"constant : modifiers TOK_CONSTANT error '}'",
"block_or_semi : block",
"block_or_semi : ';'",
"block_or_semi : TOK_LEX_EOF",
"block_or_semi : error",
"type_or_error : simple_type",
"open_paren_with_line_info : '('",
"close_paren_or_missing : ')'",
"close_paren_or_missing :",
"close_brace_or_missing : '}'",
"close_brace_or_missing :",
"close_brace_or_eof : '}'",
"close_brace_or_eof : TOK_LEX_EOF",
"open_bracket_with_line_info : '['",
"close_bracket_or_missing : ']'",
"close_bracket_or_missing :",
"push_compiler_frame0 :",
"optional_constant :",
"optional_constant : TOK_CONSTANT",
"$$2 :",
"$$3 :",
"def : modifiers optional_attributes type_or_error optional_constant optional_stars TOK_IDENTIFIER push_compiler_frame0 '(' $$2 arguments close_paren_or_missing $$3 block_or_semi",
"def : modifiers optional_attributes type_or_error optional_constant optional_stars TOK_IDENTIFIER push_compiler_frame0 error",
"$$4 :",
"def : modifiers optional_attributes type_or_error optional_constant optional_stars bad_identifier $$4 '(' arguments ')' block_or_semi",
"def : modifiers optional_attributes type_or_error optional_constant name_list ';'",
"def : inheritance",
"def : import",
"def : constant",
"def : modifiers class",
"def : modifiers enum",
"def : typedef",
"def : error TOK_LEX_EOF",
"def : error ';'",
"def : error '}'",
"$$5 :",
"def : modifiers '{' $$5 program close_brace_or_eof",
"optional_dot_dot_dot : TOK_DOT_DOT_DOT",
"optional_dot_dot_dot : TOK_DOT_DOT",
"optional_dot_dot_dot :",
"optional_identifier : TOK_IDENTIFIER",
"optional_identifier : bad_identifier",
"optional_identifier :",
"new_arg_name : full_type optional_dot_dot_dot optional_identifier",
"func_args : '(' arguments close_paren_or_missing",
"arguments : optional_comma",
"arguments : arguments2 optional_comma",
"arguments2 : new_arg_name",
"arguments2 : arguments2 ',' new_arg_name",
"arguments2 : arguments2 ':' new_arg_name",
"modifier : TOK_NO_MASK",
"modifier : TOK_FINAL_ID",
"modifier : TOK_STATIC",
"modifier : TOK_EXTERN",
"modifier : TOK_OPTIONAL",
"modifier : TOK_PRIVATE",
"modifier : TOK_LOCAL_ID",
"modifier : TOK_PUBLIC",
"modifier : TOK_PROTECTED",
"modifier : TOK_INLINE",
"modifier : TOK_VARIANT",
"magic_identifiers1 : TOK_NO_MASK",
"magic_identifiers1 : TOK_FINAL_ID",
"magic_identifiers1 : TOK_STATIC",
"magic_identifiers1 : TOK_EXTERN",
"magic_identifiers1 : TOK_PRIVATE",
"magic_identifiers1 : TOK_LOCAL_ID",
"magic_identifiers1 : TOK_PUBLIC",
"magic_identifiers1 : TOK_PROTECTED",
"magic_identifiers1 : TOK_INLINE",
"magic_identifiers1 : TOK_OPTIONAL",
"magic_identifiers1 : TOK_VARIANT",
"magic_identifiers2 : TOK_VOID_ID",
"magic_identifiers2 : TOK_MIXED_ID",
"magic_identifiers2 : TOK_ARRAY_ID",
"magic_identifiers2 : TOK_ATTRIBUTE_ID",
"magic_identifiers2 : TOK_DEPRECATED_ID",
"magic_identifiers2 : TOK_MAPPING_ID",
"magic_identifiers2 : TOK_MULTISET_ID",
"magic_identifiers2 : TOK_OBJECT_ID",
"magic_identifiers2 : TOK_FUNCTION_ID",
"magic_identifiers2 : TOK_FUNCTION_NAME",
"magic_identifiers2 : TOK_PROGRAM_ID",
"magic_identifiers2 : TOK_STRING_ID",
"magic_identifiers2 : TOK_FLOAT_ID",
"magic_identifiers2 : TOK_INT_ID",
"magic_identifiers2 : TOK_ENUM",
"magic_identifiers2 : TOK_TYPEDEF",
"magic_identifiers3 : TOK_IF",
"magic_identifiers3 : TOK_DO",
"magic_identifiers3 : TOK_FOR",
"magic_identifiers3 : TOK_WHILE",
"magic_identifiers3 : TOK_ELSE",
"magic_identifiers3 : TOK_FOREACH",
"magic_identifiers3 : TOK_CATCH",
"magic_identifiers3 : TOK_GAUGE",
"magic_identifiers3 : TOK_CLASS",
"magic_identifiers3 : TOK_BREAK",
"magic_identifiers3 : TOK_CASE",
"magic_identifiers3 : TOK_CONSTANT",
"magic_identifiers3 : TOK_CONTINUE",
"magic_identifiers3 : TOK_DEFAULT",
"magic_identifiers3 : TOK_IMPORT",
"magic_identifiers3 : TOK_INHERIT",
"magic_identifiers3 : TOK_LAMBDA",
"magic_identifiers3 : TOK_PREDEF",
"magic_identifiers3 : TOK_RETURN",
"magic_identifiers3 : TOK_SSCANF",
"magic_identifiers3 : TOK_SWITCH",
"magic_identifiers3 : TOK_TYPEOF",
"magic_identifiers3 : TOK_GLOBAL",
"magic_identifiers : magic_identifiers1",
"magic_identifiers : magic_identifiers2",
"magic_identifiers : magic_identifiers3",
"magic_identifier : TOK_IDENTIFIER",
"magic_identifier : TOK_RESERVED",
"magic_identifier : magic_identifiers",
"modifiers : modifier_list",
"modifier_list :",
"modifier_list : modifier_list modifier",
"attribute : TOK_ATTRIBUTE_ID '(' string_constant optional_comma ')'",
"attribute : TOK_DEPRECATED_ID '(' ')'",
"attribute : TOK_DEPRECATED_ID",
"optional_attributes :",
"optional_attributes : optional_attributes attribute",
"optional_stars :",
"cast : open_paren_with_line_info type ')'",
"soft_cast : open_bracket_with_line_info type ']'",
"type2 : type",
"type2 : identifier_type",
"simple_type : full_type",
"simple_type2 : type",
"simple_identifier_type : identifier_type",
"full_type : full_type '|' type3",
"full_type : type3",
"type : type '|' type3",
"type : basic_type",
"type3 : basic_type",
"type3 : identifier_type",
"basic_type : TOK_FLOAT_ID",
"basic_type : TOK_VOID_ID",
"basic_type : TOK_MIXED_ID",
"basic_type : TOK_STRING_ID opt_string_width",
"basic_type : TOK_INT_ID opt_int_range",
"basic_type : TOK_MAPPING_ID opt_mapping_type",
"basic_type : TOK_FUNCTION_ID opt_function_type",
"basic_type : TOK_OBJECT_ID opt_object_type",
"basic_type : TOK_PROGRAM_ID opt_program_type",
"basic_type : TOK_ARRAY_ID opt_array_type",
"basic_type : TOK_MULTISET_ID opt_array_type",
"basic_type : TOK_ATTRIBUTE_ID '(' string_constant ',' full_type ')'",
"basic_type : TOK_ATTRIBUTE_ID '(' string_constant error ')'",
"basic_type : TOK_ATTRIBUTE_ID error",
"basic_type : TOK_DEPRECATED_ID '(' full_type ')'",
"basic_type : TOK_DEPRECATED_ID '(' error ')'",
"identifier_type : idents",
"number_or_maxint :",
"number_or_maxint : TOK_NUMBER",
"number_or_maxint : '-' TOK_NUMBER",
"number_or_minint :",
"number_or_minint : TOK_NUMBER",
"number_or_minint : '-' TOK_NUMBER",
"expected_dot_dot : TOK_DOT_DOT",
"expected_dot_dot : TOK_DOT_DOT_DOT",
"opt_int_range :",
"opt_int_range : '(' TOK_BITS ')'",
"opt_int_range : '(' number_or_minint expected_dot_dot number_or_maxint ')'",
"opt_int_range : '(' error ')'",
"opt_string_width : opt_int_range",
"opt_object_type :",
"$$6 :",
"opt_object_type : $$6 '(' program_ref ')'",
"opt_program_type :",
"opt_program_type : '(' full_type ')'",
"opt_program_type : '(' error ')'",
"$$7 :",
"$$8 :",
"opt_function_type : '(' $$7 function_type_list optional_dot_dot_dot ':' $$8 full_type ')'",
"opt_function_type :",
"function_type_list : optional_comma",
"function_type_list : function_type_list2 optional_comma",
"function_type_list2 : full_type",
"$$9 :",
"function_type_list2 : function_type_list2 ',' $$9 full_type",
"opt_array_type : '(' full_type ')'",
"opt_array_type :",
"$$10 :",
"$$11 :",
"$$12 :",
"opt_mapping_type : '(' $$10 full_type ':' $$11 full_type $$12 ')'",
"opt_mapping_type :",
"name_list : new_name",
"name_list : name_list ',' new_name",
"new_name : optional_stars TOK_IDENTIFIER",
"new_name : optional_stars bad_identifier",
"$$13 :",
"new_name : optional_stars TOK_IDENTIFIER '=' $$13 expr0",
"new_name : optional_stars TOK_IDENTIFIER '=' error",
"new_name : optional_stars TOK_IDENTIFIER '=' TOK_LEX_EOF",
"new_name : optional_stars bad_identifier '=' expr0",
"new_local_name : optional_stars TOK_IDENTIFIER",
"new_local_name : optional_stars bad_identifier",
"new_local_name : optional_stars TOK_IDENTIFIER '=' expr0",
"new_local_name : optional_stars bad_identifier '=' expr0",
"new_local_name : optional_stars TOK_IDENTIFIER '=' error",
"new_local_name : optional_stars TOK_IDENTIFIER '=' TOK_LEX_EOF",
"new_local_name2 : TOK_IDENTIFIER",
"new_local_name2 : bad_identifier",
"new_local_name2 : TOK_IDENTIFIER '=' safe_expr0",
"new_local_name2 : bad_identifier '=' safe_expr0",
"line_number_info :",
"$$14 :",
"$$15 :",
"$$16 :",
"block : '{' $$14 line_number_info $$15 $$16 statements end_block",
"end_block : '}'",
"end_block : TOK_LEX_EOF",
"failsafe_block : block",
"failsafe_block : error",
"failsafe_block : TOK_LEX_EOF",
"propagated_type :",
"local_name_list : new_local_name",
"local_name_list : local_name_list ',' propagated_type new_local_name",
"local_name_list2 : new_local_name2",
"local_name_list2 : local_name_list2 ',' propagated_type new_local_name",
"local_constant_name : TOK_IDENTIFIER '=' safe_expr0",
"local_constant_name : bad_identifier '=' safe_expr0",
"local_constant_name : error '=' safe_expr0",
"local_constant_list : local_constant_name",
"local_constant_list : local_constant_list ',' local_constant_name",
"local_constant : TOK_CONSTANT local_constant_list ';'",
"local_constant : TOK_CONSTANT error ';'",
"local_constant : TOK_CONSTANT error TOK_LEX_EOF",
"local_constant : TOK_CONSTANT error '}'",
"statements :",
"statements : statements statement",
"statement_with_semicolon : unused2 expected_semicolon",
"normal_label_statement : statement_with_semicolon",
"normal_label_statement : import",
"normal_label_statement : cond",
"normal_label_statement : return",
"normal_label_statement : local_constant",
"normal_label_statement : block",
"normal_label_statement : break expected_semicolon",
"normal_label_statement : continue expected_semicolon",
"normal_label_statement : error ';'",
"normal_label_statement : error TOK_LEX_EOF",
"normal_label_statement : error '}'",
"normal_label_statement : ';'",
"statement : normal_label_statement",
"statement : while",
"statement : do",
"statement : for",
"statement : foreach",
"statement : switch",
"statement : case",
"statement : default",
"statement : labeled_statement",
"$$17 :",
"labeled_statement : TOK_IDENTIFIER $$17 ':' statement",
"optional_label : TOK_IDENTIFIER",
"optional_label :",
"break : TOK_BREAK optional_label",
"default : TOK_DEFAULT ':'",
"default : TOK_DEFAULT",
"continue : TOK_CONTINUE optional_label",
"push_compiler_frame1 :",
"implicit_identifier :",
"$$18 :",
"$$19 :",
"lambda : TOK_LAMBDA line_number_info implicit_identifier push_compiler_frame1 $$18 func_args $$19 failsafe_block",
"lambda : TOK_LAMBDA line_number_info implicit_identifier push_compiler_frame1 error",
"$$20 :",
"local_function : TOK_IDENTIFIER push_compiler_frame1 func_args $$20 failsafe_block",
"local_function : TOK_IDENTIFIER push_compiler_frame1 error",
"$$21 :",
"local_function2 : optional_stars TOK_IDENTIFIER push_compiler_frame1 func_args $$21 failsafe_block",
"local_function2 : optional_stars TOK_IDENTIFIER push_compiler_frame1 error",
"create_arg : modifiers type_or_error optional_stars optional_dot_dot_dot TOK_IDENTIFIER",
"create_arg : modifiers type_or_error optional_stars optional_dot_dot_dot bad_identifier",
"create_arg : modifiers type_or_error optional_stars optional_dot_dot_dot",
"create_arguments2 : create_arg",
"create_arguments2 : create_arguments2 ',' create_arg",
"create_arguments2 : create_arguments2 ':' create_arg",
"create_arguments : optional_comma",
"create_arguments : create_arguments2 optional_comma",
"optional_create_arguments :",
"optional_create_arguments : '(' create_arguments close_paren_or_missing",
"$$22 :",
"failsafe_program : '{' program $$22 end_block",
"failsafe_program : error",
"failsafe_program : TOK_LEX_EOF",
"$$23 :",
"$$24 :",
"class : TOK_CLASS line_number_info optional_identifier $$23 $$24 optional_create_arguments failsafe_program",
"simple_identifier : TOK_IDENTIFIER",
"simple_identifier : bad_identifier",
"enum_value :",
"enum_value : '=' safe_expr0",
"enum_def :",
"enum_def : simple_identifier enum_value",
"propagated_enum_value :",
"enum_list : enum_def",
"enum_list : enum_list ',' propagated_enum_value enum_def",
"enum_list : error",
"$$25 :",
"$$26 :",
"$$27 :",
"enum : TOK_ENUM $$25 optional_identifier '{' $$26 enum_list $$27 end_block",
"typedef : modifiers TOK_TYPEDEF full_type simple_identifier ';'",
"$$28 :",
"$$29 :",
"cond : TOK_IF $$28 line_number_info $$29 '(' safe_comma_expr end_cond statement optional_else_part",
"end_cond : ')'",
"end_cond : '}'",
"end_cond : TOK_LEX_EOF",
"optional_else_part :",
"optional_else_part : TOK_ELSE statement",
"safe_lvalue : lvalue",
"safe_lvalue : error",
"safe_expr0 : expr0",
"safe_expr0 : TOK_LEX_EOF",
"safe_expr0 : error",
"foreach_optional_lvalue :",
"foreach_optional_lvalue : safe_lvalue",
"foreach_lvalues : ',' safe_lvalue",
"foreach_lvalues : ';' foreach_optional_lvalue ';' foreach_optional_lvalue",
"$$30 :",
"$$31 :",
"foreach : TOK_FOREACH $$30 line_number_info $$31 '(' expr0 foreach_lvalues end_cond statement",
"do : TOK_DO line_number_info statement TOK_WHILE '(' safe_comma_expr end_cond expected_semicolon",
"do : TOK_DO line_number_info statement TOK_WHILE TOK_LEX_EOF",
"do : TOK_DO line_number_info statement TOK_LEX_EOF",
"expected_semicolon : ';'",
"expected_semicolon : TOK_LEX_EOF",
"$$32 :",
"$$33 :",
"for : TOK_FOR $$32 line_number_info $$33 '(' unused expected_semicolon for_expr expected_semicolon unused end_cond statement",
"$$34 :",
"$$35 :",
"while : TOK_WHILE $$34 line_number_info $$35 '(' safe_comma_expr end_cond statement",
"for_expr :",
"for_expr : safe_comma_expr",
"$$36 :",
"$$37 :",
"switch : TOK_SWITCH $$36 line_number_info $$37 '(' safe_comma_expr end_cond statement",
"case : TOK_CASE safe_comma_expr expected_colon",
"case : TOK_CASE safe_comma_expr expected_dot_dot optional_comma_expr expected_colon",
"case : TOK_CASE expected_dot_dot safe_comma_expr expected_colon",
"expected_colon : ':'",
"expected_colon : ';'",
"expected_colon : '}'",
"expected_colon : TOK_LEX_EOF",
"return : TOK_RETURN expected_semicolon",
"return : TOK_RETURN safe_comma_expr expected_semicolon",
"unused :",
"unused : safe_comma_expr",
"unused2 : comma_expr",
"optional_comma_expr :",
"optional_comma_expr : safe_comma_expr",
"safe_comma_expr : comma_expr",
"safe_comma_expr : error",
"comma_expr : comma_expr2",
"comma_expr : simple_type2 local_name_list",
"comma_expr : simple_identifier_type local_name_list2",
"comma_expr : simple_identifier_type local_function",
"comma_expr : simple_type2 local_function2",
"comma_expr2 : expr0",
"comma_expr2 : comma_expr2 ',' expr0",
"expr00 : expr0",
"expr00 : '@' expr0",
"expr0 : expr01",
"expr0 : expr4 '=' expr0",
"expr0 : expr4 '=' error",
"expr0 : bad_expr_ident '=' expr0",
"expr0 : open_bracket_with_line_info low_lvalue_list ']' '=' expr0",
"expr0 : expr4 assign expr0",
"expr0 : expr4 assign error",
"expr0 : bad_expr_ident assign expr0",
"expr0 : open_bracket_with_line_info low_lvalue_list ']' assign expr0",
"expr0 : open_bracket_with_line_info low_lvalue_list ']' error",
"expr01 : expr1",
"expr01 : expr1 '?' expr01 ':' expr01",
"assign : TOK_AND_EQ",
"assign : TOK_OR_EQ",
"assign : TOK_XOR_EQ",
"assign : TOK_LSH_EQ",
"assign : TOK_RSH_EQ",
"assign : TOK_ADD_EQ",
"assign : TOK_SUB_EQ",
"assign : TOK_MULT_EQ",
"assign : TOK_MOD_EQ",
"assign : TOK_DIV_EQ",
"optional_comma :",
"optional_comma : ','",
"expr_list :",
"expr_list : expr_list2 optional_comma",
"expr_list2 : expr00",
"expr_list2 : expr_list2 ',' expr00",
"m_expr_list :",
"m_expr_list : m_expr_list2 optional_comma",
"m_expr_list2 : assoc_pair",
"m_expr_list2 : m_expr_list2 ',' assoc_pair",
"m_expr_list2 : m_expr_list2 ',' error",
"assoc_pair : expr0 expected_colon expr0",
"assoc_pair : expr0 expected_colon error",
"expr1 : expr2",
"expr1 : expr1 TOK_LOR expr1",
"expr1 : expr1 TOK_LAND expr1",
"expr1 : expr1 '|' expr1",
"expr1 : expr1 '^' expr1",
"expr1 : expr1 '&' expr1",
"expr1 : expr1 TOK_EQ expr1",
"expr1 : expr1 TOK_NE expr1",
"expr1 : expr1 '>' expr1",
"expr1 : expr1 TOK_GE expr1",
"expr1 : expr1 '<' expr1",
"expr1 : expr1 TOK_LE expr1",
"expr1 : expr1 TOK_LSH expr1",
"expr1 : expr1 TOK_RSH expr1",
"expr1 : expr1 '+' expr1",
"expr1 : expr1 '-' expr1",
"expr1 : expr1 '*' expr1",
"expr1 : expr1 '%' expr1",
"expr1 : expr1 '/' expr1",
"expr1 : expr1 TOK_LOR error",
"expr1 : expr1 TOK_LAND error",
"expr1 : expr1 '|' error",
"expr1 : expr1 '^' error",
"expr1 : expr1 '&' error",
"expr1 : expr1 TOK_EQ error",
"expr1 : expr1 TOK_NE error",
"expr1 : expr1 '>' error",
"expr1 : expr1 TOK_GE error",
"expr1 : expr1 '<' error",
"expr1 : expr1 TOK_LE error",
"expr1 : expr1 TOK_LSH error",
"expr1 : expr1 TOK_RSH error",
"expr1 : expr1 '+' error",
"expr1 : expr1 '-' error",
"expr1 : expr1 '*' error",
"expr1 : expr1 '%' error",
"expr1 : expr1 '/' error",
"expr2 : expr3",
"expr2 : cast expr2",
"expr2 : soft_cast expr2",
"expr2 : TOK_INC expr4",
"expr2 : TOK_DEC expr4",
"expr2 : TOK_NOT expr2",
"expr2 : '~' expr2",
"expr2 : '-' expr2",
"expr3 : expr4",
"expr3 : expr4 TOK_INC",
"expr3 : expr4 TOK_DEC",
"optional_block :",
"$$38 :",
"optional_block : '{' line_number_info push_compiler_frame1 $$38 statements end_block",
"apply : expr4 open_paren_with_line_info expr_list ')' optional_block",
"apply : expr4 open_paren_with_line_info error ')' optional_block",
"apply : expr4 open_paren_with_line_info error TOK_LEX_EOF",
"apply : expr4 open_paren_with_line_info error ';'",
"apply : expr4 open_paren_with_line_info error '}'",
"implicit_modifiers :",
"expr4 : string",
"expr4 : TOK_NUMBER",
"expr4 : TOK_FLOAT",
"expr4 : catch",
"expr4 : gauge",
"expr4 : typeof",
"expr4 : sscanf",
"expr4 : lambda",
"expr4 : implicit_modifiers class",
"expr4 : implicit_modifiers enum",
"expr4 : idents2",
"expr4 : apply",
"expr4 : expr4 open_bracket_with_line_info '*' ']'",
"expr4 : expr4 open_bracket_with_line_info expr0 ']'",
"expr4 : expr4 open_bracket_with_line_info range_bound expected_dot_dot range_bound ']'",
"expr4 : expr4 TOK_SAFE_START_INDEX line_number_info expr0 ']'",
"expr4 : expr4 TOK_SAFE_START_INDEX line_number_info range_bound expected_dot_dot range_bound ']'",
"expr4 : expr4 open_bracket_with_line_info error ']'",
"expr4 : expr4 open_bracket_with_line_info error TOK_LEX_EOF",
"expr4 : expr4 open_bracket_with_line_info error ';'",
"expr4 : expr4 open_bracket_with_line_info error '}'",
"expr4 : expr4 open_bracket_with_line_info error ')'",
"expr4 : open_paren_with_line_info comma_expr2 ')'",
"expr4 : open_paren_with_line_info '{' expr_list close_brace_or_missing ')'",
"expr4 : open_paren_with_line_info open_bracket_with_line_info m_expr_list close_bracket_or_missing ')'",
"expr4 : TOK_MULTISET_START line_number_info expr_list TOK_MULTISET_END",
"expr4 : TOK_MULTISET_START line_number_info expr_list ')'",
"expr4 : open_paren_with_line_info error ')'",
"expr4 : open_paren_with_line_info error TOK_LEX_EOF",
"expr4 : open_paren_with_line_info error ';'",
"expr4 : open_paren_with_line_info error '}'",
"expr4 : TOK_MULTISET_START line_number_info error TOK_MULTISET_END",
"expr4 : TOK_MULTISET_START line_number_info error ')'",
"expr4 : TOK_MULTISET_START line_number_info error TOK_LEX_EOF",
"expr4 : TOK_MULTISET_START line_number_info error ';'",
"expr4 : TOK_MULTISET_START line_number_info error '}'",
"expr4 : expr4 TOK_ARROW line_number_info magic_identifier",
"expr4 : expr4 TOK_SAFE_INDEX line_number_info TOK_IDENTIFIER",
"expr4 : expr4 '.' line_number_info TOK_IDENTIFIER",
"expr4 : expr4 TOK_ARROW line_number_info error",
"idents2 : idents",
"idents2 : TOK_LOCAL_ID TOK_COLON_COLON TOK_IDENTIFIER",
"idents2 : TOK_LOCAL_ID TOK_COLON_COLON bad_identifier",
"idents : low_idents",
"idents : idents '.' TOK_IDENTIFIER",
"idents : idents '.' bad_identifier",
"idents : idents '.' error",
"string_or_identifier : TOK_IDENTIFIER",
"string_or_identifier : string",
"inherit_specifier : string_or_identifier TOK_COLON_COLON",
"inherit_specifier : TOK_GLOBAL TOK_COLON_COLON",
"inherit_specifier : inherit_specifier TOK_IDENTIFIER TOK_COLON_COLON",
"inherit_specifier : inherit_specifier bad_identifier TOK_COLON_COLON",
"low_idents : TOK_IDENTIFIER",
"low_idents : '.' TOK_IDENTIFIER",
"low_idents : TOK_GLOBAL '.' TOK_IDENTIFIER",
"low_idents : TOK_RESERVED",
"low_idents : TOK_PREDEF TOK_COLON_COLON TOK_IDENTIFIER",
"low_idents : TOK_PREDEF TOK_COLON_COLON bad_identifier",
"low_idents : TOK_VERSION TOK_COLON_COLON TOK_IDENTIFIER",
"low_idents : TOK_VERSION TOK_COLON_COLON bad_identifier",
"low_idents : inherit_specifier TOK_IDENTIFIER",
"low_idents : inherit_specifier bad_identifier",
"low_idents : inherit_specifier error",
"low_idents : TOK_COLON_COLON TOK_IDENTIFIER",
"low_idents : TOK_COLON_COLON bad_identifier",
"range_bound :",
"range_bound : comma_expr",
"range_bound : '<' comma_expr",
"range_bound : TOK_LEX_EOF",
"range_bound : '<' TOK_LEX_EOF",
"gauge : TOK_GAUGE catch_arg",
"typeof : TOK_TYPEOF '(' expr0 ')'",
"typeof : TOK_TYPEOF '(' error ')'",
"typeof : TOK_TYPEOF '(' error '}'",
"typeof : TOK_TYPEOF '(' error TOK_LEX_EOF",
"typeof : TOK_TYPEOF '(' error ';'",
"catch_arg : '(' comma_expr ')'",
"catch_arg : '(' error ')'",
"catch_arg : '(' error TOK_LEX_EOF",
"catch_arg : '(' error '}'",
"catch_arg : '(' error ';'",
"catch_arg : block",
"catch_arg : error",
"$$39 :",
"catch : TOK_CATCH $$39 catch_arg",
"sscanf : TOK_SSCANF '(' expr0 ',' expr0 lvalue_list ')'",
"sscanf : TOK_SSCANF '(' expr0 ',' expr0 error ')'",
"sscanf : TOK_SSCANF '(' expr0 ',' expr0 error TOK_LEX_EOF",
"sscanf : TOK_SSCANF '(' expr0 ',' expr0 error '}'",
"sscanf : TOK_SSCANF '(' expr0 ',' expr0 error ';'",
"sscanf : TOK_SSCANF '(' expr0 error ')'",
"sscanf : TOK_SSCANF '(' expr0 error TOK_LEX_EOF",
"sscanf : TOK_SSCANF '(' expr0 error '}'",
"sscanf : TOK_SSCANF '(' expr0 error ';'",
"sscanf : TOK_SSCANF '(' error ')'",
"sscanf : TOK_SSCANF '(' error TOK_LEX_EOF",
"sscanf : TOK_SSCANF '(' error '}'",
"sscanf : TOK_SSCANF '(' error ';'",
"lvalue : expr4",
"lvalue : open_bracket_with_line_info low_lvalue_list ']'",
"lvalue : type2 TOK_IDENTIFIER",
"lvalue : bad_expr_ident",
"low_lvalue_list : lvalue lvalue_list",
"lvalue_list :",
"lvalue_list : ',' lvalue lvalue_list",
"string_segment : TOK_STRING",
"string_segment : TOK_FUNCTION_NAME",
"string : string_segment",
"string : string string_segment",
"string_constant : string",
"string_constant : string_constant '+' string",
"real_string_constant : TOK_STRING",
"real_string_constant : real_string_constant TOK_STRING",
"real_string_constant : real_string_constant '+' TOK_STRING",
"bad_identifier : bad_expr_ident",
"bad_identifier : TOK_ARRAY_ID",
"bad_identifier : TOK_ATTRIBUTE_ID",
"bad_identifier : TOK_CLASS",
"bad_identifier : TOK_DEPRECATED_ID",
"bad_identifier : TOK_ENUM",
"bad_identifier : TOK_FLOAT_ID",
"bad_identifier : TOK_FUNCTION_ID",
"bad_identifier : TOK_FUNCTION_NAME",
"bad_identifier : TOK_INT_ID",
"bad_identifier : TOK_MAPPING_ID",
"bad_identifier : TOK_MIXED_ID",
"bad_identifier : TOK_MULTISET_ID",
"bad_identifier : TOK_OBJECT_ID",
"bad_identifier : TOK_PROGRAM_ID",
"bad_identifier : TOK_STRING_ID",
"bad_identifier : TOK_TYPEDEF",
"bad_identifier : TOK_VOID_ID",
"bad_identifier : TOK_RESERVED",
"bad_expr_ident : TOK_INLINE",
"bad_expr_ident : TOK_LOCAL_ID",
"bad_expr_ident : TOK_NO_MASK",
"bad_expr_ident : TOK_PREDEF",
"bad_expr_ident : TOK_PRIVATE",
"bad_expr_ident : TOK_PROTECTED",
"bad_expr_ident : TOK_PUBLIC",
"bad_expr_ident : TOK_OPTIONAL",
"bad_expr_ident : TOK_VARIANT",
"bad_expr_ident : TOK_STATIC",
"bad_expr_ident : TOK_EXTERN",
"bad_expr_ident : TOK_FINAL_ID",
"bad_expr_ident : TOK_DO",
"bad_expr_ident : TOK_ELSE",
"bad_expr_ident : TOK_RETURN",
"bad_expr_ident : TOK_IMPORT",
"bad_expr_ident : TOK_INHERIT",
"bad_expr_ident : TOK_CATCH",
"bad_expr_ident : TOK_GAUGE",
"bad_expr_ident : TOK_LAMBDA",
"bad_expr_ident : TOK_SSCANF",
"bad_expr_ident : TOK_SWITCH",
"bad_expr_ident : TOK_TYPEOF",
"bad_expr_ident : TOK_BREAK",
"bad_expr_ident : TOK_CASE",
"bad_expr_ident : TOK_CONTINUE",
"bad_expr_ident : TOK_DEFAULT",
"bad_expr_ident : TOK_FOR",
"bad_expr_ident : TOK_FOREACH",
"bad_expr_ident : TOK_IF",

};
#endif

#if YYDEBUG
int      yydebug;
#endif

/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH  10000
#endif
#endif

#define YYINITSTACKSIZE 200

typedef struct {
    unsigned stacksize;
    YYINT    *s_base;
    YYINT    *s_mark;
    YYINT    *s_last;
    YYSTYPE  *l_base;
    YYSTYPE  *l_mark;
} YYSTACKDATA;
#line 4596 "language.yacc"

static void yyerror_reserved(const char *keyword)
{
  my_yyerror("%s is a reserved word.", keyword);
}

static struct pike_string *get_new_name(struct pike_string *prefix)
{
  char buf[40];
  /* Generate a name for a global symbol... */
  sprintf(buf,"__lambda_%ld_%ld_line_%d",
	  (long)Pike_compiler->new_program->id,
	  (long)(Pike_compiler->local_class_counter++ & 0xffffffff), /* OSF/1 cc bug. */
	  (int) THIS_COMPILATION->lex.current_line);
  if (prefix) {
    struct string_builder sb;
    init_string_builder_alloc(&sb, prefix->len + strlen(buf) + 1,
			      prefix->size_shift);
    string_builder_shared_strcat(&sb, prefix);
    string_builder_putchar(&sb, 0);
    string_builder_strcat(&sb, buf);
    return finish_string_builder(&sb);
  }
  return make_shared_string(buf);
}


static int low_islocal(struct compiler_frame *f,
		       struct pike_string *str)
{
  int e;
  for(e=f->current_number_of_locals-1;e>=0;e--)
    if(f->variable[e].name==str) {
      f->variable[e].flags |= LOCAL_VAR_IS_USED;
      return e;
    }
  return -1;
}


/* Add a local variable to the current function in frame.
 * NOTE: Steals the references to type and def, but not to str.
 */
int low_add_local_name(struct compiler_frame *frame,
		       struct pike_string *str,
		       struct pike_type *type,
		       node *def)
{

  if (str->len) {
    int tmp=low_islocal(frame,str);
    if(tmp>=0 && tmp >= frame->last_block_level)
    {
      my_yyerror("Duplicate local variable %S, "
		 "previous declaration on line %d\n",
		 str, frame->variable[tmp].line);
    }

    if(type == void_type_string)
    {
      my_yyerror("Local variable %S is void.\n", str);
    }
  }

  debug_malloc_touch(def);
  debug_malloc_touch(type);
  debug_malloc_touch(str);
  /* NOTE: The number of locals can be 0..255 (not 256), due to
   *       the use of READ_INCR_BYTE() in apply_low.h.
   */
  if (frame->current_number_of_locals == MAX_LOCAL-1)
  {
    my_yyerror("Too many local variables: no space for local variable %S.",
	       str);
    free_type(type);
    if (def) free_node(def);
    return -1;
  } else {
    int var = frame->current_number_of_locals;

#ifdef PIKE_DEBUG
    check_type_string(type);
#endif /* PIKE_DEBUG */
    if (pike_types_le(type, void_type_string)) {
      if (Pike_compiler->compiler_pass != 1) {
	yywarning("Declaring local variable %S with type void "
		  "(converted to type zero).", str);
      }
      free_type(type);
      copy_pike_type(type, zero_type_string);
    }
    frame->variable[var].type = type;
    frame->variable[var].name = str;
    reference_shared_string(str);
    frame->variable[var].def = def;

    frame->variable[var].line = THIS_COMPILATION->lex.current_line;
    copy_shared_string(frame->variable[var].file,
		       THIS_COMPILATION->lex.current_file);

    if (pike_types_le(void_type_string, type)) {
      /* Don't warn about unused voidable variables. */
      frame->variable[var].flags = LOCAL_VAR_IS_USED;
    } else {
      frame->variable[var].flags = 0;
    }

    frame->current_number_of_locals++;
    if(frame->current_number_of_locals > frame->max_number_of_locals)
    {
      frame->max_number_of_locals = frame->current_number_of_locals;
    }

    return var;
  }
}


/* argument must be a shared string */
/* Note that this function eats a reference to 'type' */
/* If def is nonzero, it also eats a ref to def */
int add_local_name(struct pike_string *str,
		   struct pike_type *type,
		   node *def)
{
  return low_add_local_name(Pike_compiler->compiler_frame,
			    str,
			    type,
			    def);
}

/* Mark local variables declared in a multi-assign or sscanf expression
 * as used. */
static void mark_lvalues_as_used(node *n)
{
  while (n && n->token == F_LVALUE_LIST) {
    if (!CAR(n)) {
      /* Can happen if a variable hasn't been declared. */
    } else if (CAR(n)->token == F_ARRAY_LVALUE) {
      mark_lvalues_as_used(CAAR(n));
    } else if ((CAR(n)->token == F_LOCAL) && !(CAR(n)->u.integer.b)) {
      Pike_compiler->compiler_frame->variable[CAR(n)->u.integer.a].flags |=
	LOCAL_VAR_IS_USED;
    }
    n = CDR(n);
  }
}

#if 0
/* Note that this function eats a reference to each of
 * 'type' and 'initializer', but not to 'name'.
 * Note also that 'initializer' may be NULL.
 */
static node *add_protected_variable(struct pike_string *name,
				    struct pike_type *type,
				    int depth,
				    node *initializer)
{
  struct compiler_frame *f = Pike_compiler->compiler_frame;
  int i;
  int id;
  node *n = NULL;

  if (initializer) {
    /* FIXME: We need to pop levels off local and external variables here. */
  }

  for(i = depth; f && i; i--) {
    f->lexical_scope |= SCOPE_SCOPED;
    f = f->previous;
  }
  if (!f) {
    int parent_depth = i;
    struct program_state *p = Pike_compiler;
    struct pike_string *tmp_name;
    while (i--) {
      if (!p->previous) {
	my_yyerror("Too many levels of protected (%d, max:%d).",
		   depth, depth - (i+1));
	parent_depth -= i+1;
	break;
      }
      p->new_program->flags |= PROGRAM_USES_PARENT;
      p = p->previous;
    }
    
    tmp_name = get_new_name(name);
    id = define_parent_variable(p, tmp_name, type,
				ID_PROTECTED|ID_PRIVATE|ID_INLINE);
    free_string(tmp_name);
    if (id >= 0) {
      if (def) {
	p->init_node =
	  mknode(F_COMMA_EXPR, Pike_compiler->init_node,
		 mkcastnode(void_type_string,
			    mknode(F_ASSIGN, initializer,
				   mkidentifiernode(id))));
	initializer = NULL;
      }
      n = mkexternalnode(id, parent_depth);
    }
  } else if (depth) {
    f->lexical_scope|=SCOPE_SCOPE_USED;
    tmp_name = get_new_name(name);
    id = low_add_local_name(f, tmp_name, type, NULL);
    free_string(tmp_name);
    if(f->min_number_of_locals < id+1)
      f->min_number_of_locals = id+1;
    if (initializer) {
      /* FIXME! */
      yyerror("Initializers not yet supported for protected variables with function scope.");
    }
    n = mklocalnode(id, depth);
  }
  id = add_local_name(name, type, n);
  if (id >= 0) {
    if (initializer) {
      return mknode(F_ASSIGN, initializer, mklocalnode(id,0));
    }
    return mklocalnode(id, 0);
  }
  if (initializer) {
    free_node(initializer);
  }
  return NULL;
}
#endif /* 0 */

int islocal(struct pike_string *str)
{
  return low_islocal(Pike_compiler->compiler_frame, str);
}

/* argument must be a shared string */
static node *lexical_islocal(struct pike_string *str)
{
  int e,depth=0;
  struct compiler_frame *f=Pike_compiler->compiler_frame;
  
  while(1)
  {
    for(e=f->current_number_of_locals-1;e>=0;e--)
    {
      if(f->variable[e].name==str)
      {
	struct compiler_frame *q=Pike_compiler->compiler_frame;

	f->variable[e].flags |= LOCAL_VAR_IS_USED;

	while(q!=f) 
	{
	  q->lexical_scope|=SCOPE_SCOPED;
	  q=q->previous;
	}

	if(depth) {
	  q->lexical_scope|=SCOPE_SCOPE_USED;

	  if(q->min_number_of_locals < e+1)
	    q->min_number_of_locals = e+1;
	}

	if(f->variable[e].def) {
	  /*fprintf(stderr, "Found prior definition of \"%s\"\n", str->str); */
	  return copy_node(f->variable[e].def);
	}

	return mklocalnode(e,depth);
      }
    }
    if(!(f->lexical_scope & SCOPE_LOCAL)) return 0;
    depth++;
    f=f->previous;
  }
}

static node *safe_inc_enum(node *n)
{
  JMP_BUF recovery;
  STACK_LEVEL_START(0);

  if (SETJMP(recovery)) {
    handle_compile_exception ("Bad implicit enum value (failed to add 1).");
    push_int(0);
  } else {
    if (n->token != F_CONSTANT) Pike_fatal("Bad node to safe_inc_enum().\n");
    push_svalue(&n->u.sval);
    push_int(1);
    f_add(2);
  }
  UNSETJMP(recovery);
  STACK_LEVEL_DONE(1);
  free_node(n);
  n = mkconstantsvaluenode(Pike_sp-1);
  pop_stack();
  return n;
}

static node *find_versioned_identifier(struct pike_string *identifier,
				       int major, int minor)
{
  struct compilation *c = THIS_COMPILATION;
  int old_major = Pike_compiler->compat_major;
  int old_minor = Pike_compiler->compat_minor;
  struct svalue *efun = NULL;
  node *res = NULL;

  change_compiler_compatibility(major, minor);

  if(Pike_compiler->last_identifier)
    free_string(Pike_compiler->last_identifier);
  copy_shared_string(Pike_compiler->last_identifier, identifier);

  /* Check predef:: first, and then the modules. */

  if (TYPEOF(c->default_module) == T_MAPPING) {
    if ((efun = low_mapping_string_lookup(c->default_module.u.mapping,
					  identifier)))
      res = mkconstantsvaluenode(efun);
  }
  else if (TYPEOF(c->default_module) != T_INT) {
    JMP_BUF tmp;
    if (SETJMP (tmp)) {
      handle_compile_exception ("Couldn't index %d.%d "
				"default module with \"%S\".",
				major, minor, identifier);
    } else {
      push_svalue(&c->default_module);
      ref_push_string(identifier);
      f_index (2);
      if (!IS_UNDEFINED(Pike_sp - 1))
	res = mkconstantsvaluenode(Pike_sp - 1);
      pop_stack();
    }
    UNSETJMP(tmp);
  }

  if (!res && !(res = resolve_identifier(identifier))) {
    if((Pike_compiler->flags & COMPILATION_FORCE_RESOLVE) ||
       (Pike_compiler->compiler_pass==2)) {
      my_yyerror("Undefined identifier %d.%d::%S.",
		 major, minor, identifier);
    }else{
      res = mknode(F_UNDEFINED, 0, 0);
    }
  }

  change_compiler_compatibility(old_major, old_minor);

  return res;
}

static int call_handle_import(struct pike_string *s)
{
  struct compilation *c = THIS_COMPILATION;
  int args;

  ref_push_string(s);
  ref_push_string(c->lex.current_file);
  if (c->handler && c->handler->prog) {
    ref_push_object(c->handler);
    args = 3;
  }
  else args = 2;

  if (safe_apply_handler("handle_import", c->handler, c->compat_handler,
			 args, BIT_MAPPING|BIT_OBJECT|BIT_PROGRAM|BIT_ZERO))
    if (TYPEOF(Pike_sp[-1]) != T_INT)
      return 1;
    else {
      pop_stack();
      my_yyerror("Couldn't find module to import: %S", s);
    }
  else
    handle_compile_exception ("Error finding module to import");

  return 0;
}

void cleanup_compiler(void)
{
}
#line 4269 "y.tab.c"

#if YYDEBUG
#include <stdio.h>	/* needed for printf */
#endif

#include <stdlib.h>	/* needed for malloc, etc */
#include <string.h>	/* needed for memset */

/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(YYSTACKDATA *data)
{
    int i;
    unsigned newsize;
    YYINT *newss;
    YYSTYPE *newvs;

    if ((newsize = data->stacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return YYENOMEM;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = (int) (data->s_mark - data->s_base);
    newss = (YYINT *)realloc(data->s_base, newsize * sizeof(*newss));
    if (newss == 0)
        return YYENOMEM;

    data->s_base = newss;
    data->s_mark = newss + i;

    newvs = (YYSTYPE *)realloc(data->l_base, newsize * sizeof(*newvs));
    if (newvs == 0)
        return YYENOMEM;

    data->l_base = newvs;
    data->l_mark = newvs + i;

    data->stacksize = newsize;
    data->s_last = data->s_base + newsize - 1;
    return 0;
}

#if YYPURE || defined(YY_NO_LEAKS)
static void yyfreestack(YYSTACKDATA *data)
{
    free(data->s_base);
    free(data->l_base);
    memset(data, 0, sizeof(*data));
}
#else
#define yyfreestack(data) /* nothing */
#endif

#define YYABORT  goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR  goto yyerrlab

int
YYPARSE_DECL()
{
    int      yyerrflag;
    int      yychar;
    YYSTYPE  yyval;
    YYSTYPE  yylval;
    int      yynerrs;

    /* variables for the parser stack */
    YYSTACKDATA yystack;
    int yym, yyn, yystate;
#if YYDEBUG
    const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    memset(&yyval,  0, sizeof(yyval));
    memset(&yylval, 0, sizeof(yylval));

    yym = 0;
    yyn = 0;
    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;
    yystate = 0;

#if YYPURE
    memset(&yystack, 0, sizeof(yystack));
#endif

    if (yystack.s_base == NULL && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
    yystack.s_mark = yystack.s_base;
    yystack.l_mark = yystack.l_base;
    yystate = 0;
    *yystack.s_mark = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        yychar = YYLEX;
        if (yychar < 0) yychar = YYEOF;
#if YYDEBUG
        if (yydebug)
        {
            if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if (((yyn = yysindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
        yystate = yytable[yyn];
        *++yystack.s_mark = yytable[yyn];
        *++yystack.l_mark = yylval;
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if (((yyn = yyrindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag != 0) goto yyinrecovery;

    YYERROR_CALL("syntax error");

    goto yyerrlab; /* redundant goto avoids 'unused label' warning */
yyerrlab:
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if (((yyn = yysindex[*yystack.s_mark]) != 0) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yystack.s_mark, yytable[yyn]);
#endif
                if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
                yystate = yytable[yyn];
                *++yystack.s_mark = yytable[yyn];
                *++yystack.l_mark = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yystack.s_mark);
#endif
                if (yystack.s_mark <= yystack.s_base) goto yyabort;
                --yystack.s_mark;
                --yystack.l_mark;
            }
        }
    }
    else
    {
        if (yychar == YYEOF) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    if (yym > 0)
        yyval = yystack.l_mark[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);

    switch (yyn)
    {
case 1:
#line 385 "language.yacc"
	{ YYACCEPT; }
break;
case 2:
#line 386 "language.yacc"
	{ YYACCEPT; }
break;
case 8:
#line 399 "language.yacc"
	{ yyval.n=yystack.l_mark[0].n; }
break;
case 9:
#line 400 "language.yacc"
	{ yyval.n=0; }
break;
case 10:
#line 401 "language.yacc"
	{ yyval.n=0; }
break;
case 11:
#line 402 "language.yacc"
	{ yyval.n=0; }
break;
case 12:
#line 409 "language.yacc"
	{
    STACK_LEVEL_START(0);

    ref_push_string(yystack.l_mark[0].n->u.sval.u.string);
    if (call_handle_inherit(yystack.l_mark[0].n->u.sval.u.string)) {
      STACK_LEVEL_CHECK(2);
      yyval.n=mksvaluenode(Pike_sp-1);
      pop_stack();
    }
    else
      yyval.n=mknewintnode(0);
    STACK_LEVEL_CHECK(1);
    if(yyval.n->name) free_string(yyval.n->name);
#ifdef PIKE_DEBUG
    if (TYPEOF(Pike_sp[-1]) != T_STRING) {
      Pike_fatal("Compiler lost track of program name.\n");
    }
#endif /* PIKE_DEBUG */
    /* FIXME: Why not use $1->u.sval.u.string here? */
    add_ref( yyval.n->name=Pike_sp[-1].u.string );
    free_node(yystack.l_mark[0].n);

    STACK_LEVEL_DONE(1);
  }
break;
case 13:
#line 434 "language.yacc"
	{
    STACK_LEVEL_START(0);

    if(Pike_compiler->last_identifier)
    {
      ref_push_string(Pike_compiler->last_identifier);
    }else{
      push_empty_string();
    }
    yyval.n=yystack.l_mark[0].n;

    STACK_LEVEL_DONE(1);
  }
break;
case 14:
#line 451 "language.yacc"
	{
    STACK_LEVEL_START(0);

    resolv_program(yystack.l_mark[0].n);
    free_node(yystack.l_mark[0].n);

    STACK_LEVEL_DONE(1);
  }
break;
case 15:
#line 462 "language.yacc"
	{
    SET_FORCE_RESOLVE(yyval.number);
  }
break;
case 16:
#line 466 "language.yacc"
	{
    UNSET_FORCE_RESOLVE(yystack.l_mark[-1].number);
    yyval.n = yystack.l_mark[0].n;
  }
break;
case 17:
#line 473 "language.yacc"
	{
    if ((yystack.l_mark[-4].number & ID_EXTERN) && (Pike_compiler->compiler_pass == 1)) {
      yywarning("Extern declared inherit.");
    }
    if(yystack.l_mark[-2].n)
    {
      struct pike_string *s=Pike_sp[-1].u.string;
      if(yystack.l_mark[-1].n) s=yystack.l_mark[-1].n->u.sval.u.string;
      compiler_do_inherit(yystack.l_mark[-2].n,yystack.l_mark[-4].number,s);
    }
    if(yystack.l_mark[-1].n) free_node(yystack.l_mark[-1].n);
    pop_stack();
    if (yystack.l_mark[-2].n) free_node(yystack.l_mark[-2].n);
  }
break;
case 18:
#line 488 "language.yacc"
	{
    if (yystack.l_mark[-2].n) free_node(yystack.l_mark[-2].n);
    pop_stack();
    yyerrok;
  }
break;
case 19:
#line 494 "language.yacc"
	{
    if (yystack.l_mark[-2].n) free_node(yystack.l_mark[-2].n);
    pop_stack();
    yyerror("Missing ';'.");
    yyerror("Unexpected end of file.");
  }
break;
case 20:
#line 501 "language.yacc"
	{
    if (yystack.l_mark[-2].n) free_node(yystack.l_mark[-2].n);
    pop_stack();
    yyerror("Missing ';'.");
  }
break;
case 21:
#line 506 "language.yacc"
	{ yyerrok; }
break;
case 22:
#line 508 "language.yacc"
	{
    yyerror("Missing ';'.");
    yyerror("Unexpected end of file.");
  }
break;
case 23:
#line 512 "language.yacc"
	{ yyerror("Missing ';'."); }
break;
case 24:
#line 516 "language.yacc"
	{
    resolv_constant(yystack.l_mark[-1].n);
    free_node(yystack.l_mark[-1].n);
    use_module(Pike_sp-1);
    pop_stack();
  }
break;
case 25:
#line 523 "language.yacc"
	{
    if (call_handle_import(yystack.l_mark[-1].n->u.sval.u.string)) {
      use_module(Pike_sp-1);
      pop_stack();
    }
    free_node(yystack.l_mark[-1].n);
  }
break;
case 26:
#line 530 "language.yacc"
	{ yyerrok; }
break;
case 27:
#line 532 "language.yacc"
	{
    yyerror("Missing ';'.");
    yyerror("Unexpected end of file.");
  }
break;
case 28:
#line 536 "language.yacc"
	{ yyerror("Missing ';'."); }
break;
case 29:
#line 540 "language.yacc"
	{
    /* This can be made more lenient in the future */

    /* Ugly hack to make sure that $3 is optimized */
    {
      int tmp=Pike_compiler->compiler_pass;
      yystack.l_mark[0].n=mknode(F_COMMA_EXPR,yystack.l_mark[0].n,0);
      Pike_compiler->compiler_pass=tmp;
    }

    if (!TEST_COMPAT(7, 6) && (Pike_compiler->current_modifiers & ID_EXTERN)) {
      int depth = 0;
      struct program_state *state = Pike_compiler;
      node *n = yystack.l_mark[0].n;
      while (((n->token == F_COMMA_EXPR) || (n->token == F_ARG_LIST)) &&
	     ((!CAR(n)) ^ (!CDR(n)))) {
	if (CAR(n)) n = CAR(n);
	else n = CDR(n);
      }
      if (n->token == F_EXTERNAL) {
	while (state && (state->new_program->id != n->u.integer.a)) {
	  depth++;
	  state = state->previous;
	}
      }
      if (depth && state) {
	/* Alias for a symbol in a surrounding scope. */
	int id = really_low_reference_inherited_identifier(state, 0,
							   n->u.integer.b);
	define_alias(yystack.l_mark[-2].n->u.sval.u.string, n->type,
		     Pike_compiler->current_modifiers & ~ID_EXTERN,
		     depth, id);
      } else if (Pike_compiler->compiler_pass == 1) {
	yyerror("Invalid extern declared constant.");
	add_constant(yystack.l_mark[-2].n->u.sval.u.string, &svalue_undefined,
		     Pike_compiler->current_modifiers & ~ID_EXTERN);
      }
    } else {
      if (TEST_COMPAT(7, 6) &&
	  (Pike_compiler->current_modifiers & ID_EXTERN) &&
	  (Pike_compiler->compiler_pass == 1)) {
	yywarning("Extern declared constant.");
      }
      if(!is_const(yystack.l_mark[0].n)) {
	if (Pike_compiler->compiler_pass == 2) {
	  yyerror("Constant definition is not constant.");
	}
	add_constant(yystack.l_mark[-2].n->u.sval.u.string, 0,
		     Pike_compiler->current_modifiers & ~ID_EXTERN);
      } else {
	if(!Pike_compiler->num_parse_error)
	{
	  ptrdiff_t tmp=eval_low(yystack.l_mark[0].n,1);
	  if(tmp < 1)
	  {
	    yyerror("Error in constant definition.");
	    push_undefined();
	  }else{
	    pop_n_elems(DO_NOT_WARN((INT32)(tmp - 1)));
	  }
	} else {
	  push_undefined();
	}
	add_constant(yystack.l_mark[-2].n->u.sval.u.string, Pike_sp-1,
		     Pike_compiler->current_modifiers & ~ID_EXTERN);
	pop_stack();
      }
    }
  const_def_ok:
    if(yystack.l_mark[0].n) free_node(yystack.l_mark[0].n);
    free_node(yystack.l_mark[-2].n);
  }
break;
case 30:
#line 612 "language.yacc"
	{ if (yystack.l_mark[0].n) free_node(yystack.l_mark[0].n); }
break;
case 31:
#line 613 "language.yacc"
	{ if (yystack.l_mark[0].n) free_node(yystack.l_mark[0].n); }
break;
case 34:
#line 620 "language.yacc"
	{}
break;
case 35:
#line 621 "language.yacc"
	{ yyerrok; }
break;
case 36:
#line 623 "language.yacc"
	{
    yyerror("Missing ';'.");
    yyerror("Unexpected end of file.");
  }
break;
case 37:
#line 627 "language.yacc"
	{ yyerror("Missing ';'."); }
break;
case 38:
#line 631 "language.yacc"
	{
    yyval.n = mknode(F_COMMA_EXPR,yystack.l_mark[0].n,mknode(F_RETURN,mkintnode(0),0));
    COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[0].n);
  }
break;
case 39:
#line 635 "language.yacc"
	{ yyval.n = NULL; }
break;
case 40:
#line 636 "language.yacc"
	{ yyerror("Expected ';'."); yyval.n = NULL; }
break;
case 41:
#line 637 "language.yacc"
	{ yyval.n = NULL; }
break;
case 42:
#line 642 "language.yacc"
	{
#ifdef PIKE_DEBUG
    check_type_string(yystack.l_mark[0].n->u.sval.u.type);
#endif /* PIKE_DEBUG */
    if(Pike_compiler->compiler_frame->current_type)
      free_type(Pike_compiler->compiler_frame->current_type);
    copy_pike_type(Pike_compiler->compiler_frame->current_type,
		   yystack.l_mark[0].n->u.sval.u.type);
    free_node(yystack.l_mark[0].n);
  }
break;
case 43:
#line 655 "language.yacc"
	{
    /* Used to hold line-number info */
    yyval.n = mkintnode(0);
  }
break;
case 44:
#line 662 "language.yacc"
	{
    /* Used to hold line-number info */
    yyval.n = mkintnode(0);
  }
break;
case 45:
#line 667 "language.yacc"
	{
    yyerror("Missing ')'.");
    /* Used to hold line-number info */
    yyval.n = mkintnode(0);
  }
break;
case 47:
#line 676 "language.yacc"
	{
    yyerror("Missing '}'.");
  }
break;
case 49:
#line 683 "language.yacc"
	{
    yyerror("Missing '}'.");
  }
break;
case 50:
#line 689 "language.yacc"
	{
    /* Used to hold line-number info */
    yyval.n = mkintnode(0);
  }
break;
case 52:
#line 697 "language.yacc"
	{
    yyerror("Missing ']'.");
  }
break;
case 53:
#line 703 "language.yacc"
	{
    push_compiler_frame(SCOPE_LOCAL);

    if(!Pike_compiler->compiler_frame->previous ||
       !Pike_compiler->compiler_frame->previous->current_type)
    {
      yyerror("Internal compiler error (push_compiler_frame0).");
      copy_pike_type(Pike_compiler->compiler_frame->current_type,
		mixed_type_string);
    }else{
      copy_pike_type(Pike_compiler->compiler_frame->current_type,
		Pike_compiler->compiler_frame->previous->current_type);
    }

    yyval.ptr = Pike_compiler->compiler_frame;
  }
break;
case 54:
#line 722 "language.yacc"
	{
    yyval.number = OPT_EXTERNAL_DEPEND|OPT_SIDE_EFFECT;
  }
break;
case 55:
#line 726 "language.yacc"
	{
    yyval.number = 0;
  }
break;
case 56:
#line 734 "language.yacc"
	{
    yyval.number = 0;
    /* Check for the (very special) case of create and create_args. */
    if (Pike_compiler->num_create_args) {
      struct pike_string *create_string = NULL;
      int e;
      MAKE_CONST_STRING(create_string, "create");
      if (yystack.l_mark[-2].n->u.sval.u.string == create_string) {
	if (TEST_COMPAT(7, 6)) {
	  yywarning("Having both an implicit and an explicit create() "
		    "was not supported in Pike 7.6 and before.");
	}
	/* Prepend the create arguments. */
	if (Pike_compiler->num_create_args < 0) {
	  Pike_compiler->varargs = 1;
	  for (e = 0; e < -Pike_compiler->num_create_args; e++) {
	    struct identifier *id =
	      Pike_compiler->new_program->identifiers + e;
	    add_ref(id->type);
	    add_local_name(empty_pike_string, id->type, 0);
	    /* Note: add_local_name() above will return e. */
	    Pike_compiler->compiler_frame->variable[e].flags |=
	      LOCAL_VAR_IS_USED;
	  }
	} else {
	  for (e = 0; e < Pike_compiler->num_create_args; e++) {
	    struct identifier *id =
	      Pike_compiler->new_program->identifiers + e;
	    add_ref(id->type);
	    add_local_name(empty_pike_string, id->type, 0);
	    /* Note: add_local_name() above will return e. */
	    Pike_compiler->compiler_frame->variable[e].flags |=
	      LOCAL_VAR_IS_USED;
	  }
	}
	yyval.number = e;
      }
    }
  }
break;
case 57:
#line 774 "language.yacc"
	{
    int e;

    /* Adjust opt_flags in case we've got an optional_constant. */
    Pike_compiler->compiler_frame->opt_flags = yystack.l_mark[-7].number;

    /* construct the function type */
    push_finished_type(Pike_compiler->compiler_frame->current_type);

    if(Pike_compiler->compiler_frame->current_return_type)
      free_type(Pike_compiler->compiler_frame->current_return_type);
    Pike_compiler->compiler_frame->current_return_type = compiler_pop_type();

    push_finished_type(Pike_compiler->compiler_frame->current_return_type);

    e = yystack.l_mark[-2].number + yystack.l_mark[-1].number - 1;
    if(Pike_compiler->varargs &&
       (!yystack.l_mark[-2].number || (Pike_compiler->num_create_args >= 0)))
    {
      push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
      e--;
      pop_type_stack(T_ARRAY);
    }else{
      push_type(T_VOID);
    }
    push_type(T_MANY);
    for(; e>=0; e--)
    {
      push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
      push_type(T_FUNCTION);
    }

    if (Pike_compiler->current_attributes) {
      node *n = Pike_compiler->current_attributes;
      while (n) {
	push_type_attribute(CDR(n)->u.sval.u.string);
	n = CAR(n);
      }
    }

    {
      struct pike_type *s=compiler_pop_type();
      int i = isidentifier(yystack.l_mark[-5].n->u.sval.u.string);

      if (Pike_compiler->compiler_pass != 1) {
	if (i < 0) {
	  my_yyerror("Identifier %S lost after first pass.",
		     yystack.l_mark[-5].n->u.sval.u.string);
	}
      }

      yyval.n = mktypenode(s);
      free_type(s);
    }


/*    if(Pike_compiler->compiler_pass==1) */
    {
      /* FIXME:
       * set current_function_number for local functions as well
       */
      Pike_compiler->compiler_frame->current_function_number=
	define_function(yystack.l_mark[-5].n->u.sval.u.string,
			yyval.n->u.sval.u.type,
			yystack.l_mark[-10].number & (~ID_EXTERN),
			IDENTIFIER_PIKE_FUNCTION |
			(Pike_compiler->varargs?IDENTIFIER_VARARGS:0),
			0,
			yystack.l_mark[-7].number);

      Pike_compiler->varargs=0;
    }
  }
break;
case 58:
#line 848 "language.yacc"
	{
    int e;
    if(yystack.l_mark[0].n)
    {
      int f;
      node *check_args = NULL;
      struct compilation *c = THIS_COMPILATION;
      struct pike_string *save_file = c->lex.current_file;
      int save_line  = c->lex.current_line;
      int num_required_args = 0;
      struct identifier *i;
      c->lex.current_file = yystack.l_mark[-7].n->current_file;
      c->lex.current_line = yystack.l_mark[-7].n->line_number;

      if ((yystack.l_mark[-12].number & ID_EXTERN) && (Pike_compiler->compiler_pass == 1)) {
	yywarning("Extern declared function definition.");
      }

      for(e=0; e<yystack.l_mark[-4].number+yystack.l_mark[-3].number; e++)
      {
	if((e >= yystack.l_mark[-4].number) &&
	   (!Pike_compiler->compiler_frame->variable[e].name ||
	    !Pike_compiler->compiler_frame->variable[e].name->len))
	{
	  my_yyerror("Missing name for argument %d.", e - yystack.l_mark[-4].number);
	} else {
	  if (Pike_compiler->compiler_pass == 2) {
	      /* FIXME: Should probably use some other flag. */
	      if ((runtime_options & RUNTIME_CHECK_TYPES) &&
		  (Pike_compiler->compiler_frame->variable[e].type !=
		   mixed_type_string)) {
		node *local_node;

		/* fprintf(stderr, "Creating soft cast node for local #%d\n", e);*/

		local_node = mkcastnode(mixed_type_string, mklocalnode(e, 0));

		/* NOTE: The cast to mixed above is needed to avoid generating
		 *       compilation errors, as well as avoiding optimizations
		 *       in mksoftcastnode().
		 */
		check_args =
		  mknode(F_COMMA_EXPR, check_args,
			 mksoftcastnode(Pike_compiler->compiler_frame->variable[e].type,
					local_node));
	      }
	  }
	}
      }

      if (yystack.l_mark[-4].number) {
	/* Hook in the initializers for the create arguments. */
	for (e = yystack.l_mark[-4].number; e--;) {
	  yystack.l_mark[0].n = mknode(F_COMMA_EXPR,
		       mknode(F_POP_VALUE,
			      mknode(F_ASSIGN, mklocalnode(e, 0),
				     mkidentifiernode(e)), NULL),
		       yystack.l_mark[0].n);
	}
      }

      {
	int l = yystack.l_mark[0].n->line_number;
	struct pike_string *f = yystack.l_mark[0].n->current_file;
	if (check_args) {
	  /* Prepend the arg checking code. */
	  yystack.l_mark[0].n = mknode(F_COMMA_EXPR, mknode(F_POP_VALUE, check_args, NULL), yystack.l_mark[0].n);
	}
	c->lex.current_line = l;
	c->lex.current_file = f;
      }

      f=dooptcode(yystack.l_mark[-7].n->u.sval.u.string, yystack.l_mark[0].n, yystack.l_mark[-1].n->u.sval.u.type, yystack.l_mark[-12].number);

      i = ID_FROM_INT(Pike_compiler->new_program, f);
      i->opt_flags = Pike_compiler->compiler_frame->opt_flags;

#ifdef PIKE_DEBUG
      if(Pike_interpreter.recoveries &&
	 ((Pike_sp - Pike_interpreter.evaluator_stack) <
	  Pike_interpreter.recoveries->stack_pointer))
	Pike_fatal("Stack error (underflow)\n");

      if((Pike_compiler->compiler_pass == 1) &&
	 (f != Pike_compiler->compiler_frame->current_function_number)) {
	fprintf(stderr, "define_function()/do_opt_code() failed for symbol %s\n",
		yystack.l_mark[-7].n->u.sval.u.string->str);
	dump_program_desc(Pike_compiler->new_program);
	Pike_fatal("define_function screwed up! %d != %d\n",
	      f, Pike_compiler->compiler_frame->current_function_number);
      }
#endif

      c->lex.current_line = save_line;
      c->lex.current_file = save_file;
    } else {
      /* Prototype; don't warn about unused arguments. */
      for (e = Pike_compiler->compiler_frame->current_number_of_locals; e--;) {
	Pike_compiler->compiler_frame->variable[e].flags |= LOCAL_VAR_IS_USED;
      }
    }
#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != yystack.l_mark[-6].ptr) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
		 Pike_compiler->compiler_frame, yystack.l_mark[-6].ptr,
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();
    free_node(yystack.l_mark[-7].n);
    free_node(yystack.l_mark[-2].n);
    free_node(yystack.l_mark[-1].n);
  }
break;
case 59:
#line 965 "language.yacc"
	{
#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != yystack.l_mark[-1].ptr) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
		 Pike_compiler->compiler_frame, yystack.l_mark[-1].ptr,
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();
    free_node(yystack.l_mark[-2].n);
  }
break;
case 60:
#line 978 "language.yacc"
	{
    compiler_discard_type();
  }
break;
case 61:
#line 982 "language.yacc"
	{
    if (yystack.l_mark[0].n) free_node(yystack.l_mark[0].n);
  }
break;
case 63:
#line 986 "language.yacc"
	{}
break;
case 64:
#line 987 "language.yacc"
	{}
break;
case 65:
#line 988 "language.yacc"
	{}
break;
case 66:
#line 989 "language.yacc"
	{ free_node(yystack.l_mark[0].n); }
break;
case 67:
#line 990 "language.yacc"
	{ free_node(yystack.l_mark[0].n); }
break;
case 68:
#line 991 "language.yacc"
	{}
break;
case 69:
#line 993 "language.yacc"
	{
    reset_type_stack();
    yyerror("Missing ';'.");
    yyerror("Unexpected end of file");
  }
break;
case 70:
#line 999 "language.yacc"
	{
    reset_type_stack();
    yyerrok;
/*     if(Pike_compiler->num_parse_error>5) YYACCEPT; */
  }
break;
case 71:
#line 1005 "language.yacc"
	{
    reset_type_stack();
    yyerror("Missing ';'.");
   /* yychar = '}';	*/ /* Put the '}' back on the input stream */
  }
break;
case 72:
#line 1012 "language.yacc"
	{
      yyval.number=THIS_COMPILATION->lex.pragmas;
      THIS_COMPILATION->lex.pragmas|=yystack.l_mark[-1].number;
    }
break;
case 73:
#line 1018 "language.yacc"
	{
      THIS_COMPILATION->lex.pragmas=yystack.l_mark[-2].number;
    }
break;
case 74:
#line 1023 "language.yacc"
	{ yyval.number=1; }
break;
case 75:
#line 1025 "language.yacc"
	{
    yyerror("Range indicator ('..') where elipsis ('...') expected.");
    yyval.number=1;
  }
break;
case 76:
#line 1029 "language.yacc"
	{ yyval.number=0; }
break;
case 78:
#line 1033 "language.yacc"
	{ yyval.n=0; }
break;
case 79:
#line 1034 "language.yacc"
	{ yyval.n=0; }
break;
case 80:
#line 1038 "language.yacc"
	{
    int i;
    if(Pike_compiler->varargs) yyerror("Can't define more arguments after ...");

    if(yystack.l_mark[-1].number)
    {
      push_type(T_ARRAY);
      Pike_compiler->varargs=1;
    }

    if(!yystack.l_mark[0].n)
    {
      yystack.l_mark[0].n=mkstrnode(empty_pike_string);
    }

    if(yystack.l_mark[0].n->u.sval.u.string->len &&
       islocal(yystack.l_mark[0].n->u.sval.u.string) >= 0)
      my_yyerror("Variable %S appears twice in argument list.",
		 yystack.l_mark[0].n->u.sval.u.string);

    i = add_local_name(yystack.l_mark[0].n->u.sval.u.string, compiler_pop_type(),0);
    if (i >= 0) {
      /* Don't warn about unused arguments. */
      Pike_compiler->compiler_frame->variable[i].flags |= LOCAL_VAR_IS_USED;
    }
    free_node(yystack.l_mark[0].n);
  }
break;
case 81:
#line 1068 "language.yacc"
	{
    free_node(yystack.l_mark[0].n);
    yyval.number=yystack.l_mark[-1].number;
  }
break;
case 82:
#line 1074 "language.yacc"
	{ yyval.number=0; }
break;
case 84:
#line 1078 "language.yacc"
	{ yyval.number = 1; }
break;
case 85:
#line 1079 "language.yacc"
	{ yyval.number = yystack.l_mark[-2].number + 1; }
break;
case 86:
#line 1081 "language.yacc"
	{
    yyerror("Unexpected ':' in argument list.");
    yyval.number = yystack.l_mark[-2].number + 1;
  }
break;
case 87:
#line 1089 "language.yacc"
	{
      yyval.number = ID_FINAL | ID_INLINE;
      if( !(THIS_COMPILATION->lex.pragmas & ID_NO_DEPRECATION_WARNINGS) &&
          !TEST_COMPAT(7, 6) && Pike_compiler->compiler_pass==1 )
        yywarning("Keyword nomask is deprecated in favour of 'final'.");
    }
break;
case 88:
#line 1095 "language.yacc"
	{ yyval.number = ID_FINAL | ID_INLINE; }
break;
case 89:
#line 1096 "language.yacc"
	{
    yyval.number = ID_PROTECTED;
    if( !(THIS_COMPILATION->lex.pragmas & ID_NO_DEPRECATION_WARNINGS) &&
        !TEST_COMPAT(7, 8) && Pike_compiler->compiler_pass==1 )
      yywarning("Keyword static is deprecated in favour of 'protected'.");
    }
break;
case 90:
#line 1102 "language.yacc"
	{ yyval.number = ID_EXTERN | ID_OPTIONAL; }
break;
case 91:
#line 1103 "language.yacc"
	{ yyval.number = ID_OPTIONAL; }
break;
case 92:
#line 1104 "language.yacc"
	{ yyval.number = ID_PRIVATE | ID_PROTECTED | ID_INLINE; }
break;
case 93:
#line 1105 "language.yacc"
	{ yyval.number = ID_INLINE; }
break;
case 94:
#line 1106 "language.yacc"
	{ yyval.number = ID_PUBLIC; }
break;
case 95:
#line 1107 "language.yacc"
	{ yyval.number = ID_PROTECTED; }
break;
case 96:
#line 1108 "language.yacc"
	{ yyval.number = ID_INLINE; }
break;
case 97:
#line 1109 "language.yacc"
	{ yyval.number = ID_VARIANT; }
break;
case 98:
#line 1113 "language.yacc"
	{ yyval.str = "nomask"; }
break;
case 99:
#line 1114 "language.yacc"
	{ yyval.str = "final"; }
break;
case 100:
#line 1115 "language.yacc"
	{ yyval.str = "static"; }
break;
case 101:
#line 1116 "language.yacc"
	{ yyval.str = "extern"; }
break;
case 102:
#line 1117 "language.yacc"
	{ yyval.str = "private"; }
break;
case 103:
#line 1118 "language.yacc"
	{ yyval.str = "local"; }
break;
case 104:
#line 1119 "language.yacc"
	{ yyval.str = "public"; }
break;
case 105:
#line 1120 "language.yacc"
	{ yyval.str = "protected"; }
break;
case 106:
#line 1121 "language.yacc"
	{ yyval.str = "inline"; }
break;
case 107:
#line 1122 "language.yacc"
	{ yyval.str = "optional"; }
break;
case 108:
#line 1123 "language.yacc"
	{ yyval.str = "variant"; }
break;
case 109:
#line 1127 "language.yacc"
	{ yyval.str = "void"; }
break;
case 110:
#line 1128 "language.yacc"
	{ yyval.str = "mixed"; }
break;
case 111:
#line 1129 "language.yacc"
	{ yyval.str = "array"; }
break;
case 112:
#line 1130 "language.yacc"
	{ yyval.str = "__attribute__"; }
break;
case 113:
#line 1131 "language.yacc"
	{ yyval.str = "__deprecated__"; }
break;
case 114:
#line 1132 "language.yacc"
	{ yyval.str = "mapping"; }
break;
case 115:
#line 1133 "language.yacc"
	{ yyval.str = "multiset"; }
break;
case 116:
#line 1134 "language.yacc"
	{ yyval.str = "object"; }
break;
case 117:
#line 1135 "language.yacc"
	{ yyval.str = "function"; }
break;
case 118:
#line 1136 "language.yacc"
	{ yyval.str = "__func__"; }
break;
case 119:
#line 1137 "language.yacc"
	{ yyval.str = "program"; }
break;
case 120:
#line 1138 "language.yacc"
	{ yyval.str = "string"; }
break;
case 121:
#line 1139 "language.yacc"
	{ yyval.str = "float"; }
break;
case 122:
#line 1140 "language.yacc"
	{ yyval.str = "int"; }
break;
case 123:
#line 1141 "language.yacc"
	{ yyval.str = "enum"; }
break;
case 124:
#line 1142 "language.yacc"
	{ yyval.str = "typedef"; }
break;
case 125:
#line 1146 "language.yacc"
	{ yyval.str = "if"; }
break;
case 126:
#line 1147 "language.yacc"
	{ yyval.str = "do"; }
break;
case 127:
#line 1148 "language.yacc"
	{ yyval.str = "for"; }
break;
case 128:
#line 1149 "language.yacc"
	{ yyval.str = "while"; }
break;
case 129:
#line 1150 "language.yacc"
	{ yyval.str = "else"; }
break;
case 130:
#line 1151 "language.yacc"
	{ yyval.str = "foreach"; }
break;
case 131:
#line 1152 "language.yacc"
	{ yyval.str = "catch"; }
break;
case 132:
#line 1153 "language.yacc"
	{ yyval.str = "gauge"; }
break;
case 133:
#line 1154 "language.yacc"
	{ yyval.str = "class"; }
break;
case 134:
#line 1155 "language.yacc"
	{ yyval.str = "break"; }
break;
case 135:
#line 1156 "language.yacc"
	{ yyval.str = "case"; }
break;
case 136:
#line 1157 "language.yacc"
	{ yyval.str = "constant"; }
break;
case 137:
#line 1158 "language.yacc"
	{ yyval.str = "continue"; }
break;
case 138:
#line 1159 "language.yacc"
	{ yyval.str = "default"; }
break;
case 139:
#line 1160 "language.yacc"
	{ yyval.str = "import"; }
break;
case 140:
#line 1161 "language.yacc"
	{ yyval.str = "inherit"; }
break;
case 141:
#line 1162 "language.yacc"
	{ yyval.str = "lambda"; }
break;
case 142:
#line 1163 "language.yacc"
	{ yyval.str = "predef"; }
break;
case 143:
#line 1164 "language.yacc"
	{ yyval.str = "return"; }
break;
case 144:
#line 1165 "language.yacc"
	{ yyval.str = "sscanf"; }
break;
case 145:
#line 1166 "language.yacc"
	{ yyval.str = "switch"; }
break;
case 146:
#line 1167 "language.yacc"
	{ yyval.str = "typeof"; }
break;
case 147:
#line 1168 "language.yacc"
	{ yyval.str = "global"; }
break;
case 153:
#line 1175 "language.yacc"
	{
    struct pike_string *tmp=make_shared_string(yystack.l_mark[0].str);
    yyval.n=mkstrnode(tmp);
    free_string(tmp);
  }
break;
case 154:
#line 1183 "language.yacc"
	{
   yyval.number=Pike_compiler->current_modifiers=yystack.l_mark[0].number |
     (THIS_COMPILATION->lex.pragmas & ID_MODIFIER_MASK);
 }
break;
case 155:
#line 1189 "language.yacc"
	{ yyval.number = 0; }
break;
case 156:
#line 1190 "language.yacc"
	{ yyval.number = yystack.l_mark[-1].number | yystack.l_mark[0].number; }
break;
case 157:
#line 1194 "language.yacc"
	{
    yyval.n = yystack.l_mark[-2].n;
  }
break;
case 158:
#line 1198 "language.yacc"
	{
    struct pike_string *deprecated_string;
    MAKE_CONST_STRING(deprecated_string, "deprecated");
    yyval.n = mkstrnode(deprecated_string);
  }
break;
case 159:
#line 1204 "language.yacc"
	{
    struct pike_string *deprecated_string;
    MAKE_CONST_STRING(deprecated_string, "deprecated");
    yyval.n = mkstrnode(deprecated_string);
  }
break;
case 160:
#line 1212 "language.yacc"
	{
    if (Pike_compiler->current_attributes) {
      free_node(Pike_compiler->current_attributes);
    }
    if ((Pike_compiler->current_attributes =
	 THIS_COMPILATION->lex.attributes)) {
      add_ref(Pike_compiler->current_attributes);
    }
  }
break;
case 161:
#line 1222 "language.yacc"
	{
    if (yystack.l_mark[0].n) {
      Pike_compiler->current_attributes =
	mknode(F_ARG_LIST, Pike_compiler->current_attributes, yystack.l_mark[0].n);
    }
  }
break;
case 162:
#line 1230 "language.yacc"
	{ yyval.number=0; }
break;
case 163:
#line 1234 "language.yacc"
	{
      struct pike_type *s = compiler_pop_type();
      yyval.n = mktypenode(s);
      free_type(s);
      COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-2].n);
      free_node (yystack.l_mark[-2].n);
    }
break;
case 164:
#line 1244 "language.yacc"
	{
      struct pike_type *s = compiler_pop_type();
      yyval.n = mktypenode(s);
      free_type(s);
      COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-2].n);
      free_node (yystack.l_mark[-2].n);
    }
break;
case 167:
#line 1256 "language.yacc"
	{
    struct pike_type *s = compiler_pop_type();
    yyval.n = mktypenode(s);
#ifdef PIKE_DEBUG
    if (yyval.n->u.sval.u.type != s) {
      Pike_fatal("mktypenode(%p) created node with %p\n", s, yyval.n->u.sval.u.type);
    }
#endif /* PIKE_DEBUG */
    free_type(s);
  }
break;
case 168:
#line 1269 "language.yacc"
	{
    struct pike_type *s = compiler_pop_type();
    yyval.n = mktypenode(s);
#ifdef PIKE_DEBUG
    if (yyval.n->u.sval.u.type != s) {
      Pike_fatal("mktypenode(%p) created node with %p\n", s, yyval.n->u.sval.u.type);
    }
#endif /* PIKE_DEBUG */
    free_type(s);
  }
break;
case 169:
#line 1282 "language.yacc"
	{
    struct pike_type *s = compiler_pop_type();
    yyval.n = mktypenode(s);
#ifdef PIKE_DEBUG
    if (yyval.n->u.sval.u.type != s) {
      Pike_fatal("mktypenode(%p) created node with %p\n", s, yyval.n->u.sval.u.type);
    }
#endif /* PIKE_DEBUG */
    free_type(s);
  }
break;
case 170:
#line 1294 "language.yacc"
	{ push_type(T_OR); }
break;
case 172:
#line 1298 "language.yacc"
	{ push_type(T_OR); }
break;
case 176:
#line 1305 "language.yacc"
	{ push_type(T_FLOAT); }
break;
case 177:
#line 1306 "language.yacc"
	{ push_type(T_VOID); }
break;
case 178:
#line 1307 "language.yacc"
	{ push_type(T_MIXED); }
break;
case 179:
#line 1308 "language.yacc"
	{}
break;
case 180:
#line 1309 "language.yacc"
	{}
break;
case 181:
#line 1310 "language.yacc"
	{}
break;
case 182:
#line 1311 "language.yacc"
	{}
break;
case 183:
#line 1312 "language.yacc"
	{}
break;
case 184:
#line 1313 "language.yacc"
	{ push_type(T_PROGRAM); }
break;
case 185:
#line 1314 "language.yacc"
	{ push_type(T_ARRAY); }
break;
case 186:
#line 1315 "language.yacc"
	{ push_type(T_MULTISET); }
break;
case 187:
#line 1317 "language.yacc"
	{
    push_type_attribute(yystack.l_mark[-3].n->u.sval.u.string);
    free_node(yystack.l_mark[-3].n);
  }
break;
case 188:
#line 1322 "language.yacc"
	{
    push_type(T_MIXED);
    push_type_attribute(yystack.l_mark[-2].n->u.sval.u.string);
    free_node(yystack.l_mark[-2].n);
  }
break;
case 189:
#line 1328 "language.yacc"
	{
    push_type(T_MIXED);
  }
break;
case 190:
#line 1332 "language.yacc"
	{
    struct pike_string *deprecated_string;
    MAKE_CONST_STRING(deprecated_string, "deprecated");
    push_type_attribute(deprecated_string);
  }
break;
case 191:
#line 1338 "language.yacc"
	{
    struct pike_string *deprecated_string;
    MAKE_CONST_STRING(deprecated_string, "deprecated");
    push_type(T_MIXED);
    push_type_attribute(deprecated_string);
  }
break;
case 192:
#line 1347 "language.yacc"
	{
    if (yystack.l_mark[0].n) {
      fix_type_field(yystack.l_mark[0].n);

      if (!pike_types_le(yystack.l_mark[0].n->type, typeable_type_string) &&
	  (THIS_COMPILATION->lex.pragmas & ID_STRICT_TYPES)) {
	yytype_report(REPORT_WARNING,
		      yystack.l_mark[0].n->current_file, yystack.l_mark[0].n->line_number, typeable_type_string,
		      yystack.l_mark[0].n->current_file, yystack.l_mark[0].n->line_number, yystack.l_mark[0].n->type,
		      0, "Invalid type.");
      }
    }

    resolv_constant(yystack.l_mark[0].n);

    if (TYPEOF(Pike_sp[-1]) == T_TYPE) {
      /* "typedef" */
      push_finished_type(Pike_sp[-1].u.type);
    } else {
      /* object type */
      struct program *p = NULL;

      if (TYPEOF(Pike_sp[-1]) == T_OBJECT) {
	if(!(p = Pike_sp[-1].u.object->prog))
	{
	  pop_stack();
	  push_int(0);
	  yyerror("Destructed object used as program identifier.");
	}else{
	  int f = FIND_LFUN(p->inherits[SUBTYPEOF(Pike_sp[-1])].prog,
			    LFUN_CALL);
	  if(f!=-1)
	  {
	    SET_SVAL_SUBTYPE(Pike_sp[-1],
			     f + p->inherits[SUBTYPEOF(Pike_sp[-1])].
			     identifier_level);
	    SET_SVAL_TYPE(Pike_sp[-1], T_FUNCTION);
	  }else{
	    extern void f_object_program(INT32);
	    if (Pike_compiler->compiler_pass == 2)
	      yywarning("Using object as program identifier.");
	    f_object_program(1);
	  }
	}
      }

      switch(TYPEOF(Pike_sp[-1])) {
	case T_FUNCTION:
	if((p = program_from_function(Pike_sp-1))) {
	  push_object_type(0, p?(p->id):0);
	  break;
	} else {
	  /* Attempt to get the return type for the function. */
	  struct pike_type *a, *b;
	  a = get_type_of_svalue(Pike_sp-1);
	  /* Note: check_splice_call() below eats a reference from a.
	   * Note: CALL_INHIBIT_WARNINGS is needed since we don't
	   *       provide a function name (and we don't want
	   *       warnings here anyway).
	   */
	  a = check_splice_call(NULL, a, 0, mixed_type_string, NULL,
				CALL_INHIBIT_WARNINGS);
	  if (a) {
	    b = new_get_return_type(a, 0);
	    free_type(a);
	    if (b) {
	      push_finished_type(b);
	      free_type(b);
	      break;
	    }
	  }
	}
	/* FALL_THROUGH */

      default:
	if (Pike_compiler->compiler_pass!=1)
	  my_yyerror("Illegal program identifier: %O.", Pike_sp-1);
	pop_stack();
	push_int(0);
	push_object_type(0, 0);
	break;

      case T_PROGRAM:
	p = Pike_sp[-1].u.program;
	push_object_type(0, p?(p->id):0);
	break;
      }
    }
    /* Attempt to name the type. */
    if (Pike_compiler->last_identifier) {
      push_type_name(Pike_compiler->last_identifier);
    }
    pop_stack();
    free_node(yystack.l_mark[0].n);
  }
break;
case 193:
#line 1445 "language.yacc"
	{
    yyval.n = mkintnode(MAX_INT_TYPE);
  }
break;
case 195:
#line 1450 "language.yacc"
	{
#ifdef PIKE_DEBUG
    if ((yystack.l_mark[0].n->token != F_CONSTANT) || (TYPEOF(yystack.l_mark[0].n->u.sval) != T_INT)) {
      Pike_fatal("Unexpected number in negative int-range.\n");
    }
#endif /* PIKE_DEBUG */
    yyval.n = mkintnode(-(yystack.l_mark[0].n->u.sval.u.integer));
    free_node(yystack.l_mark[0].n);
  }
break;
case 196:
#line 1462 "language.yacc"
	{
    yyval.n = mkintnode(MIN_INT_TYPE);
  }
break;
case 198:
#line 1467 "language.yacc"
	{
#ifdef PIKE_DEBUG
    if ((yystack.l_mark[0].n->token != F_CONSTANT) || (TYPEOF(yystack.l_mark[0].n->u.sval) != T_INT)) {
      Pike_fatal("Unexpected number in negative int-range.\n");
    }
#endif /* PIKE_DEBUG */
    yyval.n = mkintnode(-(yystack.l_mark[0].n->u.sval.u.integer));
    free_node(yystack.l_mark[0].n);
  }
break;
case 200:
#line 1480 "language.yacc"
	{
    yyerror("Elipsis ('...') where range indicator ('..') expected.");
  }
break;
case 201:
#line 1486 "language.yacc"
	{
    push_int_type(MIN_INT_TYPE, MAX_INT_TYPE);
  }
break;
case 202:
#line 1490 "language.yacc"
	{
      push_int_type( 0, (1<<yystack.l_mark[-1].n->u.sval.u.integer)-1 );
      free_node( yystack.l_mark[-1].n );
  }
break;
case 203:
#line 1495 "language.yacc"
	{
    INT_TYPE min = MIN_INT_TYPE;
    INT_TYPE max = MAX_INT_TYPE;

    /* FIXME: Check that $4 is >= $2. */
    if(yystack.l_mark[-1].n->token == F_CONSTANT) {
      if (TYPEOF(yystack.l_mark[-1].n->u.sval) == T_INT) {
	max = yystack.l_mark[-1].n->u.sval.u.integer;
      } else if (is_bignum_object_in_svalue(&yystack.l_mark[-1].n->u.sval)) {
	push_int(0);
	if (is_lt(&yystack.l_mark[-1].n->u.sval, Pike_sp-1)) {
	  max = MIN_INT_TYPE;
	}
	pop_stack();
      }
    }

    if(yystack.l_mark[-3].n->token == F_CONSTANT) {
      if (TYPEOF(yystack.l_mark[-3].n->u.sval) == T_INT) {
	min = yystack.l_mark[-3].n->u.sval.u.integer;
      } else if (is_bignum_object_in_svalue(&yystack.l_mark[-3].n->u.sval)) {
	push_int(0);
	if (is_lt(Pike_sp-1, &yystack.l_mark[-3].n->u.sval)) {
	  min = MAX_INT_TYPE;
	}
	pop_stack();
      }
    }

    push_int_type(min, max);

    free_node(yystack.l_mark[-3].n);
    free_node(yystack.l_mark[-1].n);
  }
break;
case 204:
#line 1530 "language.yacc"
	{
    push_int_type(MIN_INT32, MAX_INT32);
    yyerror("Expected integer range.");
  }
break;
case 205:
#line 1537 "language.yacc"
	{
    push_type(T_STRING);
  }
break;
case 206:
#line 1542 "language.yacc"
	{ push_object_type(0, 0); }
break;
case 207:
#line 1543 "language.yacc"
	{
#ifdef PIKE_DEBUG
      yyval.ptr = Pike_sp;
#endif /* PIKE_DEBUG */
    }
break;
case 208:
#line 1549 "language.yacc"
	{
    /* NOTE: On entry, there are two items on the stack:
     *   Pike_sp-2:	Name of the program reference (string).
     *   Pike_sp-1:	The resolved program (program|function|zero).
     */
    struct program *p=program_from_svalue(Pike_sp-1);

#ifdef PIKE_DEBUG
    if (yystack.l_mark[-3].ptr != (Pike_sp - 2)) {
      Pike_fatal("Unexpected stack depth: %p != %p\n",
		 yystack.l_mark[-3].n, Pike_sp-2);
    }
#endif /* PIKE_DEBUG */

    if(!p) {
      if (Pike_compiler->compiler_pass!=1) {
	my_yyerror("Not a valid program specifier: %S", Pike_sp[-2].u.string);
      }
    }
    push_object_type(0, p?(p->id):0);
    /* Attempt to name the type. */
    if (TYPEOF(Pike_sp[-2]) == T_STRING) {
      push_type_name(Pike_sp[-2].u.string);
    }
    pop_n_elems(2);
  }
break;
case 209:
#line 1577 "language.yacc"
	{ push_object_type(0, 0); }
break;
case 211:
#line 1580 "language.yacc"
	{
    push_object_type(0, 0);
    yyerror("Invalid program subtype.");
  }
break;
case 212:
#line 1587 "language.yacc"
	{
    type_stack_mark();
  }
break;
case 213:
#line 1591 "language.yacc"
	{
    /* Add the many type if there is none. */
    if (yystack.l_mark[-1].number)
    {
      if (!yystack.l_mark[-2].number) {
	/* function_type_list ends with a comma, or is empty.
	 * FIXME: Should this be a syntax error or not?
	 */
	if (Pike_compiler->compiler_pass == 1) {
	  yyerror("Missing type before ... .");
	}
	push_type(T_MIXED);
      }
    }else{
      push_type(T_VOID);
    }
  }
break;
case 214:
#line 1609 "language.yacc"
	{
    push_reverse_type(T_MANY);
    Pike_compiler->pike_type_mark_stackp--;
    while (*Pike_compiler->pike_type_mark_stackp+1 <
	   Pike_compiler->type_stackp) {
      push_reverse_type(T_FUNCTION);
    }
  }
break;
case 215:
#line 1618 "language.yacc"
	{
   push_type(T_MIXED);
   push_type(T_VOID);
   push_type(T_OR);

   push_type(T_ZERO);
   push_type(T_VOID);
   push_type(T_OR);

   push_type(T_MANY);
  }
break;
case 216:
#line 1631 "language.yacc"
	{ yyval.number=0; }
break;
case 217:
#line 1632 "language.yacc"
	{ yyval.number=!yystack.l_mark[0].number; }
break;
case 218:
#line 1635 "language.yacc"
	{ yyval.number=1; }
break;
case 219:
#line 1637 "language.yacc"
	{
  }
break;
case 222:
#line 1643 "language.yacc"
	{ push_type(T_MIXED); }
break;
case 223:
#line 1647 "language.yacc"
	{
  }
break;
case 224:
#line 1650 "language.yacc"
	{
  }
break;
case 225:
#line 1653 "language.yacc"
	{
    push_reverse_type(T_MAPPING);
  }
break;
case 227:
#line 1658 "language.yacc"
	{
    push_type(T_MIXED);
    push_type(T_MIXED);
    push_type(T_MAPPING);
  }
break;
case 230:
#line 1671 "language.yacc"
	{
    struct pike_type *type;
    node *n;
    push_finished_type(Pike_compiler->compiler_frame->current_type);
    n = Pike_compiler->current_attributes;
    while(n) {
      push_type_attribute(CDR(n)->u.sval.u.string);
      n = CAR(n);
    }
    type=compiler_pop_type();
    define_variable(yystack.l_mark[0].n->u.sval.u.string, type,
		    Pike_compiler->current_modifiers);
    free_type(type);
    free_node(yystack.l_mark[0].n);
  }
break;
case 231:
#line 1686 "language.yacc"
	{}
break;
case 232:
#line 1688 "language.yacc"
	{
    struct pike_type *type;
    node *n;
    push_finished_type(Pike_compiler->compiler_frame->current_type);
    n = Pike_compiler->current_attributes;
    while(n) {
      push_type_attribute(CDR(n)->u.sval.u.string);
      n = CAR(n);
    }
    type=compiler_pop_type();
    if ((Pike_compiler->current_modifiers & ID_EXTERN) &&
	(Pike_compiler->compiler_pass == 1)) {
      yywarning("Extern declared variable has initializer.");
    }
    yyval.number=define_variable(yystack.l_mark[-1].n->u.sval.u.string, type,
			       Pike_compiler->current_modifiers & (~ID_EXTERN));
    free_type(type);
  }
break;
case 233:
#line 1707 "language.yacc"
	{
    if ((Pike_compiler->compiler_pass == 2) &&
	!TEST_COMPAT(7, 8) && (yystack.l_mark[0].n) && (yystack.l_mark[0].n->token == F_CONSTANT) &&
	!Pike_compiler->num_parse_error) {
      /* Check if it is zero, in which case we can throw it away.
       *
       * NB: The compat test is due to that this changes the semantics
       *     of calling __INIT() by hand.
       */
      if ((TYPEOF(yystack.l_mark[0].n->u.sval) == PIKE_T_INT) && !SUBTYPEOF(yystack.l_mark[0].n->u.sval) &&
	  !yystack.l_mark[0].n->u.sval.u.integer &&
	  !IDENTIFIER_IS_ALIAS(ID_FROM_INT(Pike_compiler->new_program,
					   yystack.l_mark[-1].number)->identifier_flags)) {
	/* NB: Inherited variables get converted into aliases by
	 *     define_variable, and we need to support clearing
	 *     of inherited variables.
	 */
#ifdef PIKE_DEBUG
	if (l_flag > 5) {
	  fprintf(stderr,
		  "Ignoring initialization to zero for variable %s.\n",
		  yystack.l_mark[-3].n->u.sval.u.string->str);
	}
#endif /* PIKE_DEBUG */
	free_node(yystack.l_mark[0].n);
	yystack.l_mark[0].n = NULL;
      }
    }
    if (yystack.l_mark[0].n) {
      Pike_compiler->init_node=mknode(F_COMMA_EXPR,Pike_compiler->init_node,
		       mkcastnode(void_type_string,
				  mknode(F_ASSIGN,yystack.l_mark[0].n,
					 mkidentifiernode(yystack.l_mark[-1].number))));
    }
    free_node(yystack.l_mark[-3].n);
  }
break;
case 234:
#line 1744 "language.yacc"
	{
    free_node(yystack.l_mark[-2].n);
  }
break;
case 235:
#line 1748 "language.yacc"
	{
    yyerror("Unexpected end of file in variable definition.");
    free_node(yystack.l_mark[-2].n);
  }
break;
case 236:
#line 1753 "language.yacc"
	{
    free_node(yystack.l_mark[0].n);
  }
break;
case 237:
#line 1760 "language.yacc"
	{
    int id;
    push_finished_type(yystack.l_mark[-2].n->u.sval.u.type);
    id = add_local_name(yystack.l_mark[0].n->u.sval.u.string, compiler_pop_type(),0);
    if (id >= 0) {
      /* FIXME: Consider using mklocalnode(id, -1). */
      yyval.n=mknode(F_ASSIGN,mkintnode(0),mklocalnode(id,0));
    } else
      yyval.n = 0;
    free_node(yystack.l_mark[0].n);
  }
break;
case 238:
#line 1771 "language.yacc"
	{ yyval.n=0; }
break;
case 239:
#line 1773 "language.yacc"
	{
    int id;
    push_finished_type(yystack.l_mark[-4].n->u.sval.u.type);
    id = add_local_name(yystack.l_mark[-2].n->u.sval.u.string, compiler_pop_type(),0);
    if (id >= 0) {
      if (!(THIS_COMPILATION->lex.pragmas & ID_STRICT_TYPES)) {
	/* Only warn about unused initialized variables in strict types mode. */
	Pike_compiler->compiler_frame->variable[id].flags |= LOCAL_VAR_IS_USED;
      }
      yyval.n=mknode(F_ASSIGN,yystack.l_mark[0].n,mklocalnode(id,0));
    } else
      yyval.n = 0;
    free_node(yystack.l_mark[-2].n);
  }
break;
case 240:
#line 1788 "language.yacc"
	{
    free_node(yystack.l_mark[0].n);
    yyval.n=0;
  }
break;
case 241:
#line 1793 "language.yacc"
	{
    free_node(yystack.l_mark[-2].n);
    /* No yyerok here since we aren't done yet. */
    yyval.n=0;
  }
break;
case 242:
#line 1799 "language.yacc"
	{
    yyerror("Unexpected end of file in local variable definition.");
    free_node(yystack.l_mark[-2].n);
    /* No yyerok here since we aren't done yet. */
    yyval.n=0;
  }
break;
case 243:
#line 1808 "language.yacc"
	{
    int id;
    add_ref(yystack.l_mark[-1].n->u.sval.u.type);
    id = add_local_name(yystack.l_mark[0].n->u.sval.u.string, yystack.l_mark[-1].n->u.sval.u.type, 0);
    if (id >= 0) {
      /* FIXME: Consider using mklocalnode(id, -1). */
      yyval.n=mknode(F_ASSIGN,mkintnode(0),mklocalnode(id,0));
    } else
      yyval.n = 0;
    free_node(yystack.l_mark[0].n);
  }
break;
case 244:
#line 1819 "language.yacc"
	{ yyval.n=0; }
break;
case 245:
#line 1821 "language.yacc"
	{
    int id;
    add_ref(yystack.l_mark[-3].n->u.sval.u.type);
    id = add_local_name(yystack.l_mark[-2].n->u.sval.u.string, yystack.l_mark[-3].n->u.sval.u.type, 0);
    if (id >= 0) {
      if (!(THIS_COMPILATION->lex.pragmas & ID_STRICT_TYPES)) {
	/* Only warn about unused initialized variables in strict types mode. */
	Pike_compiler->compiler_frame->variable[id].flags |= LOCAL_VAR_IS_USED;
      }
      yyval.n=mknode(F_ASSIGN,yystack.l_mark[0].n, mklocalnode(id,0));
    } else
      yyval.n = 0;
    free_node(yystack.l_mark[-2].n);
  }
break;
case 246:
#line 1835 "language.yacc"
	{ yyval.n=yystack.l_mark[0].n; }
break;
case 247:
#line 1839 "language.yacc"
	{
    /* Used to hold line-number info */
    yyval.n = mkintnode(0);
  }
break;
case 248:
#line 1846 "language.yacc"
	{
    yystack.l_mark[0].number=Pike_compiler->num_used_modules;
    yyval.number=Pike_compiler->compiler_frame->current_number_of_locals;
  }
break;
case 249:
#line 1851 "language.yacc"
	{
    /* Trick to store more than one number on compiler stack - Hubbe */
    yyval.number=Pike_compiler->compiler_frame->last_block_level;

    if(yyval.number == -1) /* if 'first block' */
      Pike_compiler->compiler_frame->last_block_level=0; /* all variables */
    else
      Pike_compiler->compiler_frame->last_block_level=yystack.l_mark[-1].number;
  }
break;
case 250:
#line 1860 "language.yacc"
	{
    yyval.ptr = Pike_compiler;
  }
break;
case 251:
#line 1864 "language.yacc"
	{
    /* Recover compilation context on syntax errors. */
    while (Pike_compiler != yystack.l_mark[-2].ptr) {
      struct program *p;
      /* fprintf(stderr, "Compiler context out of sync. Attempting to recover...\n"); */
      if(Pike_compiler->compiler_pass == 1)
	p = end_first_pass(0);
      else
	p=end_first_pass(1);

      if (p) free_program(p);
    }

    unuse_modules(Pike_compiler->num_used_modules - yystack.l_mark[-6].number);
    yystack.l_mark[-1].n = pop_local_variables(yystack.l_mark[-5].number, yystack.l_mark[-1].n);
    Pike_compiler->compiler_frame->last_block_level=yystack.l_mark[-3].number;
    if (yystack.l_mark[-1].n) COPY_LINE_NUMBER_INFO(yystack.l_mark[-1].n, yystack.l_mark[-4].n);
    free_node (yystack.l_mark[-4].n);
    yyval.n=yystack.l_mark[-1].n;
  }
break;
case 253:
#line 1889 "language.yacc"
	{
    yyerror("Missing '}'.");
    if (yystack.l_mark[-1].n) {
      low_yyreport(REPORT_ERROR, yystack.l_mark[-1].n->current_file, yystack.l_mark[-1].n->line_number,
		   parser_system_string, 0, "Opening '{' was here.");
    }
    yyerror("Unexpected end of file.");
  }
break;
case 255:
#line 1900 "language.yacc"
	{ yyval.n=0; }
break;
case 256:
#line 1901 "language.yacc"
	{ yyerror("Unexpected end of file."); yyval.n=0; }
break;
case 257:
#line 1906 "language.yacc"
	{
    yyval.n = yystack.l_mark[-2].n;
  }
break;
case 259:
#line 1914 "language.yacc"
	{ yyval.n = mknode(F_COMMA_EXPR, mkcastnode(void_type_string, yystack.l_mark[-3].n), yystack.l_mark[0].n); }
break;
case 261:
#line 1920 "language.yacc"
	{ yyval.n = mknode(F_COMMA_EXPR, mkcastnode(void_type_string, yystack.l_mark[-3].n), yystack.l_mark[0].n); }
break;
case 262:
#line 1925 "language.yacc"
	{
    struct pike_type *type;

    /* Ugly hack to make sure that $3 is optimized */
    {
      int tmp=Pike_compiler->compiler_pass;
      yystack.l_mark[0].n=mknode(F_COMMA_EXPR,yystack.l_mark[0].n,0);
      optimize_node(yystack.l_mark[0].n);
      Pike_compiler->compiler_pass=tmp;
      type=yystack.l_mark[0].n->u.node.a->type;
    }

    if(!is_const(yystack.l_mark[0].n))
    {
      if(Pike_compiler->compiler_pass==2)
	yyerror("Constant definition is not constant.");
    }else{
      ptrdiff_t tmp=eval_low(yystack.l_mark[0].n,1);
      if(tmp < 1)
      {
	yyerror("Error in constant definition.");
      }else{
	pop_n_elems(DO_NOT_WARN((INT32)(tmp - 1)));
	if(yystack.l_mark[0].n) free_node(yystack.l_mark[0].n);
	yystack.l_mark[0].n=mksvaluenode(Pike_sp-1);
	type=yystack.l_mark[0].n->type;
	pop_stack();
      }
    }
    if(!type) type = mixed_type_string;
    add_ref(type);
    low_add_local_name(Pike_compiler->compiler_frame, /*->previous,*/
		       yystack.l_mark[-2].n->u.sval.u.string,
		       type, yystack.l_mark[0].n);
    /* Note: Intentionally not marked as used. */
    free_node(yystack.l_mark[-2].n);
  }
break;
case 263:
#line 1962 "language.yacc"
	{ if (yystack.l_mark[0].n) free_node(yystack.l_mark[0].n); }
break;
case 264:
#line 1963 "language.yacc"
	{ if (yystack.l_mark[0].n) free_node(yystack.l_mark[0].n); }
break;
case 268:
#line 1971 "language.yacc"
	{ yyerrok; }
break;
case 269:
#line 1973 "language.yacc"
	{
    yyerror("Missing ';'.");
    yyerror("Unexpected end of file.");
  }
break;
case 270:
#line 1977 "language.yacc"
	{ yyerror("Missing ';'."); }
break;
case 271:
#line 1981 "language.yacc"
	{ yyval.n=0; }
break;
case 272:
#line 1983 "language.yacc"
	{
    yyval.n = mknode(F_COMMA_EXPR, yystack.l_mark[-1].n, mkcastnode(void_type_string, yystack.l_mark[0].n));
  }
break;
case 275:
#line 1991 "language.yacc"
	{ yyval.n=0; }
break;
case 278:
#line 1994 "language.yacc"
	{ yyval.n=0; }
break;
case 282:
#line 1998 "language.yacc"
	{ reset_type_stack(); yyval.n=0; yyerrok; }
break;
case 283:
#line 2000 "language.yacc"
	{
    reset_type_stack();
    yyerror("Missing ';'.");
    yyerror("Unexpected end of file.");
    yyval.n=0;
  }
break;
case 284:
#line 2007 "language.yacc"
	{
    reset_type_stack();
    yyerror("Missing ';'.");
/*    yychar = '}'; */	/* Put the '}' back on the input stream. */
    yyval.n=0;
  }
break;
case 285:
#line 2013 "language.yacc"
	{ yyval.n=0; }
break;
case 286:
#line 2017 "language.yacc"
	{
    Pike_compiler->compiler_frame->opt_flags &= ~OPT_CUSTOM_LABELS;
  }
break;
case 295:
#line 2031 "language.yacc"
	{
    Pike_compiler->compiler_frame->opt_flags &= ~OPT_CUSTOM_LABELS;
  }
break;
case 296:
#line 2035 "language.yacc"
	{
    yyval.n = mknode(Pike_compiler->compiler_frame->opt_flags & OPT_CUSTOM_LABELS ?
		F_CUSTOM_STMT_LABEL : F_NORMAL_STMT_LABEL,
		yystack.l_mark[-3].n, yystack.l_mark[0].n);

    /* FIXME: This won't be correct if the node happens to be shared.
     * That's an issue to be solved with shared nodes in general,
     * though. */
    COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-3].n);
  }
break;
case 298:
#line 2048 "language.yacc"
	{yyval.n = 0;}
break;
case 299:
#line 2051 "language.yacc"
	{ yyval.n=mknode(F_BREAK,yystack.l_mark[0].n,0); }
break;
case 300:
#line 2052 "language.yacc"
	{ yyval.n=mknode(F_DEFAULT,0,0); }
break;
case 301:
#line 2054 "language.yacc"
	{
    yyval.n=mknode(F_DEFAULT,0,0); yyerror("Expected ':' after default.");
  }
break;
case 302:
#line 2059 "language.yacc"
	{ yyval.n=mknode(F_CONTINUE,yystack.l_mark[0].n,0); }
break;
case 303:
#line 2062 "language.yacc"
	{
    push_compiler_frame(SCOPE_LOCAL);

    yyval.ptr = Pike_compiler->compiler_frame;
  }
break;
case 304:
#line 2070 "language.yacc"
	{
    struct pike_string *name;
    yyval.n=mkstrnode(name = get_new_name(NULL));
    free_string(name);
  }
break;
case 305:
#line 2078 "language.yacc"
	{
    debug_malloc_touch(Pike_compiler->compiler_frame->current_return_type);
    if(Pike_compiler->compiler_frame->current_return_type)
      free_type(Pike_compiler->compiler_frame->current_return_type);
    copy_pike_type(Pike_compiler->compiler_frame->current_return_type,
		   any_type_string);
  }
break;
case 306:
#line 2086 "language.yacc"
	{
    struct pike_string *name = yystack.l_mark[-3].n->u.sval.u.string;
    struct pike_type *type;
    int e;

    yyval.number = Pike_compiler->varargs;
    Pike_compiler->varargs = 0;

    if (Pike_compiler->compiler_pass == 1) {
      /* Define a tentative prototype for the lambda. */
      push_finished_type(mixed_type_string);
      e=yystack.l_mark[0].number-1;
      if(yyval.number)
      {
	push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
	e--;
	pop_type_stack(T_ARRAY);
      }else{
	push_type(T_VOID);
      }
      Pike_compiler->varargs=0;
      push_type(T_MANY);
      for(; e>=0; e--) {
	push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
	push_type(T_FUNCTION);
      }
      type=compiler_pop_type();
      Pike_compiler->compiler_frame->current_function_number =
	define_function(name, type,
			ID_PROTECTED | ID_PRIVATE | ID_INLINE | ID_USED,
			IDENTIFIER_PIKE_FUNCTION, NULL,
			(unsigned INT16)
			(Pike_compiler->compiler_frame->opt_flags));
      free_type(type);
    } else {
      /* In pass 2 we just reuse the type from pass 1. */
      Pike_compiler->compiler_frame->current_function_number =
	isidentifier(name);
    }
  }
break;
case 307:
#line 2127 "language.yacc"
	{
    struct pike_type *type;
    int f,e;
    struct pike_string *name;
    struct compilation *c = THIS_COMPILATION;
    struct pike_string *save_file = c->lex.current_file;
    int save_line = c->lex.current_line;
    c->lex.current_file = yystack.l_mark[-6].n->current_file;
    c->lex.current_line = yystack.l_mark[-6].n->line_number;

    debug_malloc_touch(yystack.l_mark[0].n);
    yystack.l_mark[0].n=mknode(F_COMMA_EXPR,yystack.l_mark[0].n,mknode(F_RETURN,mkintnode(0),0));
    if (Pike_compiler->compiler_pass == 2) {
      /* Doing this in pass 1 might induce too strict checks on types
       * in cases where we got placeholders. */
      type=find_return_type(yystack.l_mark[0].n);
      if (type) {
	push_finished_type(type);
	free_type(type);
      } else {
	yywarning("Failed to determine return type for lambda.");
	push_type(T_ZERO);
      }
    } else {
      /* Tentative return type. */
      push_type(T_MIXED);
    }

    e=yystack.l_mark[-2].number-1;
    if(yystack.l_mark[-1].number)
    {
      push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
      e--;
      pop_type_stack(T_ARRAY);
    }else{
      push_type(T_VOID);
    }
    Pike_compiler->varargs=0;
    push_type(T_MANY);
    for(; e>=0; e--) {
      push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
      push_type(T_FUNCTION);
    }

    type=compiler_pop_type();

    name = yystack.l_mark[-5].n->u.sval.u.string;

#ifdef LAMBDA_DEBUG
    fprintf(stderr, "%d: LAMBDA: %s 0x%08lx 0x%08lx\n%d:   type: ",
	    Pike_compiler->compiler_pass, name->str,
	    (long)Pike_compiler->new_program->id,
	    Pike_compiler->local_class_counter-1,
	    Pike_compiler->compiler_pass);
    simple_describe_type(type);
    fprintf(stderr, "\n");
#endif /* LAMBDA_DEBUG */

    f=dooptcode(name,
		yystack.l_mark[0].n,
		type,
		ID_PROTECTED | ID_PRIVATE | ID_INLINE | ID_USED);

#ifdef PIKE_DEBUG
    if (f != Pike_compiler->compiler_frame->current_function_number) {
      Pike_fatal("Lost track of lambda %s.\n", name->str);
    }
#endif /* PIKE_DEBUG */

#ifdef LAMBDA_DEBUG
    fprintf(stderr, "%d:   lexical_scope: 0x%08x\n",
	    Pike_compiler->compiler_pass,
	    Pike_compiler->compiler_frame->lexical_scope);
#endif /* LAMBDA_DEBUG */

    if(Pike_compiler->compiler_frame->lexical_scope & SCOPE_SCOPED) {
      yyval.n = mktrampolinenode(f, Pike_compiler->compiler_frame->previous);
    } else {
      yyval.n = mkidentifiernode(f);
    }
    free_type(type);
    c->lex.current_line = save_line;
    c->lex.current_file = save_file;
    free_node(yystack.l_mark[-5].n);
    free_node (yystack.l_mark[-6].n);
#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != yystack.l_mark[-4].ptr) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
		 Pike_compiler->compiler_frame, yystack.l_mark[-4].ptr,
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();
  }
break;
case 308:
#line 2223 "language.yacc"
	{
#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != yystack.l_mark[-1].ptr) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
		 Pike_compiler->compiler_frame, yystack.l_mark[-1].ptr,
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();
    yyval.n = mkintnode(0);
    COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-3].n);
    free_node(yystack.l_mark[-2].n);
    free_node(yystack.l_mark[-3].n);
  }
break;
case 309:
#line 2241 "language.yacc"
	{
    struct pike_string *name;
    struct pike_type *type;
    int id,e;
    node *n;
    struct identifier *i=0;

    debug_malloc_touch(Pike_compiler->compiler_frame->current_return_type);
    if(Pike_compiler->compiler_frame->current_return_type)
      free_type(Pike_compiler->compiler_frame->current_return_type);
    copy_pike_type(Pike_compiler->compiler_frame->current_return_type,
		   yystack.l_mark[-3].n->u.sval.u.type);


    /***/
    push_finished_type(Pike_compiler->compiler_frame->current_return_type);

    e=yystack.l_mark[0].number-1;
    if(Pike_compiler->varargs)
    {
      push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
      e--;
      pop_type_stack(T_ARRAY);
    }else{
      push_type(T_VOID);
    }
    push_type(T_MANY);
    for(; e>=0; e--) {
      push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
    push_type(T_FUNCTION);
    }

    type=compiler_pop_type();
    /***/

    name = get_new_name(yystack.l_mark[-2].n->u.sval.u.string);

#ifdef LAMBDA_DEBUG
    fprintf(stderr, "%d: LAMBDA: %s 0x%08lx 0x%08lx\n",
	    Pike_compiler->compiler_pass, name->str,
	    (long)Pike_compiler->new_program->id,
	    Pike_compiler->local_class_counter-1);
#endif /* LAMBDA_DEBUG */

    if(Pike_compiler->compiler_pass > 1)
    {
      id=isidentifier(name);
    }else{
      id=define_function(name,
			 type,
			 ID_PROTECTED | ID_PRIVATE | ID_INLINE | ID_USED,
			 IDENTIFIER_PIKE_FUNCTION |
			 (Pike_compiler->varargs?IDENTIFIER_VARARGS:0),
			 0,
			 OPT_SIDE_EFFECT|OPT_EXTERNAL_DEPEND);
    }
    Pike_compiler->varargs=0;
    Pike_compiler->compiler_frame->current_function_number=id;

    n=0;
    if(Pike_compiler->compiler_pass > 1 &&
       (i=ID_FROM_INT(Pike_compiler->new_program, id)))
    {
      if(i->identifier_flags & IDENTIFIER_SCOPED)
	n = mktrampolinenode(id, Pike_compiler->compiler_frame->previous);
      else
	n = mkidentifiernode(id);
    }

    low_add_local_name(Pike_compiler->compiler_frame->previous,
		       yystack.l_mark[-2].n->u.sval.u.string, type, n);

    yyval.number=id;
    free_string(name);
  }
break;
case 310:
#line 2317 "language.yacc"
	{
    int localid;
    struct identifier *i=ID_FROM_INT(Pike_compiler->new_program, yystack.l_mark[-1].number);
    struct compilation *c = THIS_COMPILATION;
    struct pike_string *save_file = c->lex.current_file;
    int save_line = c->lex.current_line;
    c->lex.current_file = yystack.l_mark[-4].n->current_file;
    c->lex.current_line = yystack.l_mark[-4].n->line_number;

    yystack.l_mark[0].n=mknode(F_COMMA_EXPR,yystack.l_mark[0].n,mknode(F_RETURN,mkintnode(0),0));

    debug_malloc_touch(yystack.l_mark[0].n);
    dooptcode(i->name,
	      yystack.l_mark[0].n,
	      i->type,
	      ID_PROTECTED | ID_PRIVATE | ID_INLINE);

    i->opt_flags = Pike_compiler->compiler_frame->opt_flags;

    c->lex.current_line = save_line;
    c->lex.current_file = save_file;
#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != yystack.l_mark[-3].ptr) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
		 Pike_compiler->compiler_frame, yystack.l_mark[-3].ptr,
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();
    free_node(yystack.l_mark[-4].n);

    /* WARNING: If the local function adds more variables we are screwed */
    /* WARNING2: if add_local_name stops adding local variables at the end,
     *           this has to be fixed.
     */

    localid=Pike_compiler->compiler_frame->current_number_of_locals-1;
    if(Pike_compiler->compiler_frame->variable[localid].def)
    {
      yyval.n=copy_node(Pike_compiler->compiler_frame->variable[localid].def);
    }else{
      if(Pike_compiler->compiler_frame->lexical_scope &
	 (SCOPE_SCOPE_USED | SCOPE_SCOPED))
      {
	yyval.n = mktrampolinenode(yystack.l_mark[-1].number,Pike_compiler->compiler_frame);
      }else{
	yyval.n = mkidentifiernode(yystack.l_mark[-1].number);
      }
    }
  }
break;
case 311:
#line 2369 "language.yacc"
	{
#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != yystack.l_mark[-1].ptr) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
		 Pike_compiler->compiler_frame, yystack.l_mark[-1].ptr,
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();
    yyval.n=mkintnode(0);
  }
break;
case 312:
#line 2384 "language.yacc"
	{
    struct pike_string *name;
    struct pike_type *type;
    int id,e;
    node *n;
    struct identifier *i=0;

    /***/
    debug_malloc_touch(Pike_compiler->compiler_frame->current_return_type);

    push_finished_type(yystack.l_mark[-4].n->u.sval.u.type);

    if(Pike_compiler->compiler_frame->current_return_type)
      free_type(Pike_compiler->compiler_frame->current_return_type);
    Pike_compiler->compiler_frame->current_return_type=compiler_pop_type();

    /***/
    push_finished_type(Pike_compiler->compiler_frame->current_return_type);

    e=yystack.l_mark[0].number-1;
    if(Pike_compiler->varargs)
    {
      push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
      e--;
      pop_type_stack(T_ARRAY);
    }else{
      push_type(T_VOID);
    }
    push_type(T_MANY);
    for(; e>=0; e--) {
      push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
      push_type(T_FUNCTION);
    }

    type=compiler_pop_type();
    /***/

    name = get_new_name(yystack.l_mark[-2].n->u.sval.u.string);

#ifdef LAMBDA_DEBUG
    fprintf(stderr, "%d: LAMBDA: %s 0x%08lx 0x%08lx\n",
	    Pike_compiler->compiler_pass, name->str,
	    (long)Pike_compiler->new_program->id,
	    Pike_compiler->local_class_counter-1);
#endif /* LAMBDA_DEBUG */

    if(Pike_compiler->compiler_pass > 1)
    {
      id=isidentifier(name);
    }else{
      id=define_function(name,
			 type,
			 ID_PROTECTED | ID_PRIVATE | ID_INLINE | ID_USED,
			 IDENTIFIER_PIKE_FUNCTION|
			 (Pike_compiler->varargs?IDENTIFIER_VARARGS:0),
			 0,
			 OPT_SIDE_EFFECT|OPT_EXTERNAL_DEPEND);
    }
    Pike_compiler->varargs=0;
    Pike_compiler->compiler_frame->current_function_number=id;

    n=0;
    if(Pike_compiler->compiler_pass > 1 &&
       (i=ID_FROM_INT(Pike_compiler->new_program, id)))
    {
      if(i->identifier_flags & IDENTIFIER_SCOPED)
	n = mktrampolinenode(id, Pike_compiler->compiler_frame->previous);
      else
	n = mkidentifiernode(id);
    }

    low_add_local_name(Pike_compiler->compiler_frame->previous,
		       yystack.l_mark[-2].n->u.sval.u.string, type, n);
    yyval.number=id;
    free_string(name);
  }
break;
case 313:
#line 2461 "language.yacc"
	{
    int localid;
    struct identifier *i=ID_FROM_INT(Pike_compiler->new_program, yystack.l_mark[-1].number);
    struct compilation *c = THIS_COMPILATION;
    struct pike_string *save_file = c->lex.current_file;
    int save_line = c->lex.current_line;
    c->lex.current_file = yystack.l_mark[-4].n->current_file;
    c->lex.current_line = yystack.l_mark[-4].n->line_number;

    debug_malloc_touch(yystack.l_mark[0].n);
    yystack.l_mark[0].n=mknode(F_COMMA_EXPR,yystack.l_mark[0].n,mknode(F_RETURN,mkintnode(0),0));


    debug_malloc_touch(yystack.l_mark[0].n);
    dooptcode(i->name,
	      yystack.l_mark[0].n,
	      i->type,
	      ID_PROTECTED | ID_PRIVATE | ID_INLINE);

    i->opt_flags = Pike_compiler->compiler_frame->opt_flags;

    c->lex.current_line = save_line;
    c->lex.current_file = save_file;
#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != yystack.l_mark[-3].ptr) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
		 Pike_compiler->compiler_frame, yystack.l_mark[-3].ptr,
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();
    free_node(yystack.l_mark[-4].n);

    /* WARNING: If the local function adds more variables we are screwed */
    /* WARNING2: if add_local_name stops adding local variables at the end,
     *           this has to be fixed.
     */

    localid=Pike_compiler->compiler_frame->current_number_of_locals-1;
    if(Pike_compiler->compiler_frame->variable[localid].def)
    {
      yyval.n=copy_node(Pike_compiler->compiler_frame->variable[localid].def);
    }else{
      if(Pike_compiler->compiler_frame->lexical_scope &
	 (SCOPE_SCOPE_USED | SCOPE_SCOPED))
      {
        yyval.n = mktrampolinenode(yystack.l_mark[-1].number,Pike_compiler->compiler_frame);
      }else{
        yyval.n = mkidentifiernode(yystack.l_mark[-1].number);
      }
    }
  }
break;
case 314:
#line 2515 "language.yacc"
	{
#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != yystack.l_mark[-1].ptr) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
		 Pike_compiler->compiler_frame, yystack.l_mark[-1].ptr,
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();
    free_node(yystack.l_mark[-2].n);
    yyval.n=mkintnode(0);
  }
break;
case 315:
#line 2531 "language.yacc"
	{
    struct pike_type *type;
    int ref_no;

    if (Pike_compiler->num_create_args < 0) {
      yyerror("Can't define more variables after ...");
    }

    push_finished_type(Pike_compiler->compiler_frame->current_type);
    if (yystack.l_mark[-1].number) {
      push_type(T_ARRAY);
    }
    type=compiler_pop_type();

    /* Add the identifier globally.
     * Note: Since these are the first identifiers (and references)
     *       to be added to the program, they will be numbered in
     *       sequence starting at 0 (zero). This means that the
     *       counter num_create_args is sufficient extra information
     *       to be able to keep track of them.
     */
    ref_no = define_variable(yystack.l_mark[0].n->u.sval.u.string, type,
			     Pike_compiler->current_modifiers);
    free_type(type);

    if (Pike_compiler->num_create_args != ref_no) {
      my_yyerror("Multiple definitions of create variable %S (%d != %d).",
		 yystack.l_mark[0].n->u.sval.u.string,
		 Pike_compiler->num_create_args, ref_no);
    }
    if (yystack.l_mark[-1].number) {
      /* Encode varargs marker as negative number of args. */
      Pike_compiler->num_create_args = -(ref_no + 1);
    } else {
      Pike_compiler->num_create_args = ref_no + 1;
    }

    /* free_type(type); */
    free_node(yystack.l_mark[0].n);
    yyval.number=0;
  }
break;
case 316:
#line 2572 "language.yacc"
	{ yyval.number=0; }
break;
case 317:
#line 2573 "language.yacc"
	{
    yyerror("Missing identifier.");
    yyval.number=0;
  }
break;
case 318:
#line 2579 "language.yacc"
	{ yyval.number = 1; }
break;
case 319:
#line 2580 "language.yacc"
	{ yyval.number = yystack.l_mark[-2].number + 1; }
break;
case 320:
#line 2582 "language.yacc"
	{
    yyerror("Unexpected ':' in create argument list.");
    yyval.number = yystack.l_mark[-2].number + 1;
  }
break;
case 321:
#line 2588 "language.yacc"
	{ yyval.number=0; }
break;
case 323:
#line 2592 "language.yacc"
	{ yyval.number = 0; }
break;
case 324:
#line 2594 "language.yacc"
	{
    /* NOTE: One more than the number of arguments, so that we
     *       can detect the case of no parenthesis below. */
    yyval.number = (Pike_compiler->num_create_args < 0) ?
      (1 - Pike_compiler->num_create_args):(1 + Pike_compiler->num_create_args);
    free_node(yystack.l_mark[0].n);
  }
break;
case 325:
#line 2603 "language.yacc"
	{ yyval.n = NULL; }
break;
case 327:
#line 2604 "language.yacc"
	{ yyerrok; }
break;
case 328:
#line 2606 "language.yacc"
	{
		  yyerror("End of file where program definition expected.");
		}
break;
case 329:
#line 2613 "language.yacc"
	{
    if(!yystack.l_mark[0].n)
    {
      struct pike_string *s;
      char buffer[42];
      sprintf(buffer,"__class_%ld_%ld_line_%d",
	      (long)Pike_compiler->new_program->id,
	      (long)Pike_compiler->local_class_counter++,
	      (int) yystack.l_mark[-1].n->line_number);
      s=make_shared_string(buffer);
      yystack.l_mark[0].n=mkstrnode(s);
      free_string(s);
      yystack.l_mark[-3].number|=ID_PROTECTED | ID_PRIVATE | ID_INLINE;
    }
    /* fprintf(stderr, "LANGUAGE.YACC: CLASS start\n"); */
    if(Pike_compiler->compiler_pass==1)
    {
      if (yystack.l_mark[-3].number & ID_EXTERN) {
	yywarning("Extern declared class definition.");
      }
      low_start_new_program(0, 1, yystack.l_mark[0].n->u.sval.u.string,
			    yystack.l_mark[-3].number,
			    &yyval.number);

      /* fprintf(stderr, "Pass 1: Program %s has id %d\n",
	 $4->u.sval.u.string->str, Pike_compiler->new_program->id); */

      store_linenumber(yystack.l_mark[-1].n->line_number, yystack.l_mark[-1].n->current_file);
      debug_malloc_name(Pike_compiler->new_program,
			yystack.l_mark[-1].n->current_file->str,
			yystack.l_mark[-1].n->line_number);
    }else{
      int i;
      struct identifier *id;
      int tmp=Pike_compiler->compiler_pass;
      i=isidentifier(yystack.l_mark[0].n->u.sval.u.string);
      if(i<0)
      {
	/* Seriously broken... */
	yyerror("Pass 2: program not defined!");
	low_start_new_program(0, 2, 0,
			      yystack.l_mark[-3].number,
			      &yyval.number);
      }else{
	id=ID_FROM_INT(Pike_compiler->new_program, i);
	if(IDENTIFIER_IS_CONSTANT(id->identifier_flags))
	{
	  struct svalue *s;
	  if ((id->func.const_info.offset >= 0) &&
	      (TYPEOF(*(s = &PROG_FROM_INT(Pike_compiler->new_program,i)->
			constants[id->func.const_info.offset].sval)) ==
	       T_PROGRAM))
	  {
	    low_start_new_program(s->u.program, 2,
				  yystack.l_mark[0].n->u.sval.u.string,
				  yystack.l_mark[-3].number,
				  &yyval.number);

	    /* fprintf(stderr, "Pass 2: Program %s has id %d\n",
	       $4->u.sval.u.string->str, Pike_compiler->new_program->id); */

	  }else{
	    yyerror("Pass 2: constant redefined!");
	    low_start_new_program(0, 2, 0,
				  yystack.l_mark[-3].number,
				  &yyval.number);
	  }
	}else{
	  yyerror("Pass 2: class constant no longer constant!");
	  low_start_new_program(0, 2, 0,
				yystack.l_mark[-3].number,
				&yyval.number);
	}
      }
      Pike_compiler->compiler_pass=tmp;
    }
  }
break;
case 330:
#line 2690 "language.yacc"
	{
    /* Clear scoped modifiers. */
    yyval.number = THIS_COMPILATION->lex.pragmas;
    THIS_COMPILATION->lex.pragmas &= ~ID_MODIFIER_MASK;
  }
break;
case 331:
#line 2696 "language.yacc"
	{
    struct program *p;

    /* Check if we have create arguments but no locally defined create(). */
    if (yystack.l_mark[-1].number) {
      struct pike_string *create_string = NULL;
      struct reference *ref = NULL;
      struct identifier *id = NULL;
      int ref_id;
      MAKE_CONST_STRING(create_string, "create");
      if (((ref_id = isidentifier(create_string)) < 0) ||
	  (ref = PTR_FROM_INT(Pike_compiler->new_program, ref_id))->inherit_offset ||
	  ((id = ID_FROM_PTR(Pike_compiler->new_program, ref))->func.offset == -1)) {
	int e;
	struct pike_type *type = NULL;
	int nargs = Pike_compiler->num_create_args;

	push_compiler_frame(SCOPE_LOCAL);

	/* Init: Prepend the create arguments. */
	if (Pike_compiler->num_create_args < 0) {
	  for (e = 0; e < -Pike_compiler->num_create_args; e++) {
	    id = Pike_compiler->new_program->identifiers + e;
	    add_ref(id->type);
	    add_local_name(id->name, id->type, 0);
	    /* Note: add_local_name() above will return e. */
	    Pike_compiler->compiler_frame->variable[e].flags |=
	      LOCAL_VAR_IS_USED;
	  }
	} else {
	  for (e = 0; e < Pike_compiler->num_create_args; e++) {
	    id = Pike_compiler->new_program->identifiers + e;
	    add_ref(id->type);
	    add_local_name(id->name, id->type, 0);
	    /* Note: add_local_name() above will return e. */
	    Pike_compiler->compiler_frame->variable[e].flags |=
	      LOCAL_VAR_IS_USED;
	  }
	}

	/* First: Deduce the type for the create() function. */
	push_type(T_VOID); /* Return type. */

	if ((e = nargs) < 0) {
	  /* Varargs */
	  e = nargs = -nargs;
	  push_finished_type(Pike_compiler->compiler_frame->variable[--e].type);
	  pop_type_stack(T_ARRAY); /* Pop one level of array. */
	} else {
	  /* Not varargs. */
	  push_type(T_VOID);
	}
	push_type(T_MANY);
	while(e--) {
	  push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
	  push_type(T_FUNCTION);
	}

	type = compiler_pop_type();

	/* Second: Declare the function. */

	Pike_compiler->compiler_frame->current_function_number=
	  define_function(create_string, type,
			  ID_INLINE | ID_PROTECTED,
			  IDENTIFIER_PIKE_FUNCTION |
			  (Pike_compiler->num_create_args < 0?IDENTIFIER_VARARGS:0),
			  0,
			  OPT_SIDE_EFFECT);

	if (Pike_compiler->compiler_pass == 2) {
	  node *create_code = NULL;
	  int f;

	  /* Third: Generate the initialization code.
	   *
	   * global_arg = [type]local_arg;
	   * [,..]
	   */

	  for(e=0; e<nargs; e++)
	  {
	    if(!Pike_compiler->compiler_frame->variable[e].name ||
	       !Pike_compiler->compiler_frame->variable[e].name->len)
	    {
	      my_yyerror("Missing name for argument %d.",e);
	    } else {
	      node *local_node = mklocalnode(e, 0);

	      /* FIXME: Should probably use some other flag. */
	      if ((runtime_options & RUNTIME_CHECK_TYPES) &&
		  (Pike_compiler->compiler_pass == 2) &&
		  (Pike_compiler->compiler_frame->variable[e].type !=
		   mixed_type_string)) {
		/* fprintf(stderr, "Creating soft cast node for local #%d\n", e);*/

		local_node = mkcastnode(mixed_type_string, local_node);

		/* NOTE: The cast to mixed above is needed to avoid generating
		 *       compilation errors, as well as avoiding optimizations
		 *       in mksoftcastnode().
		 */
		local_node = mksoftcastnode(Pike_compiler->compiler_frame->
					    variable[e].type, local_node);
	      }
	      create_code =
		mknode(F_COMMA_EXPR, create_code,
		       mknode(F_ASSIGN, local_node,
			      mkidentifiernode(e)));
	    }
	  }

	  /* Fourth: Add a return 0; at the end. */

	  create_code = mknode(F_COMMA_EXPR,
			       mknode(F_POP_VALUE, create_code, NULL),
			       mknode(F_RETURN, mkintnode(0), NULL));

	  /* Fifth: Define the function. */

	  f=dooptcode(create_string, create_code, type, ID_PROTECTED);

#ifdef PIKE_DEBUG
	  if(Pike_interpreter.recoveries &&
	     Pike_sp-Pike_interpreter.evaluator_stack < Pike_interpreter.recoveries->stack_pointer)
	    Pike_fatal("Stack error (underflow)\n");

	  if(Pike_compiler->compiler_pass == 1 &&
	     f!=Pike_compiler->compiler_frame->current_function_number)
	    Pike_fatal("define_function screwed up! %d != %d\n",
		       f, Pike_compiler->compiler_frame->current_function_number);
#endif
	}

	/* Done. */

	free_type(type);
	pop_compiler_frame();
      }
    }

    if(Pike_compiler->compiler_pass == 1)
      p=end_first_pass(0);
    else
      p=end_first_pass(1);

    /* fprintf(stderr, "LANGUAGE.YACC: CLASS end\n"); */

    if(p) {
      /* Update the type for the program constant,
       * since we might have a lfun::create(). */
      struct identifier *i;
      struct svalue sv;
      SET_SVAL(sv, T_PROGRAM, 0, program, p);
      i = ID_FROM_INT(Pike_compiler->new_program, yystack.l_mark[-3].number);
      free_type(i->type);
      i->type = get_type_of_svalue(&sv);
      free_program(p);
    } else if (!Pike_compiler->num_parse_error) {
      /* Make sure code in this class is aware that something went wrong. */
      Pike_compiler->num_parse_error = 1;
    }

    yyval.n=mkidentifiernode(yystack.l_mark[-3].number);

    free_node(yystack.l_mark[-5].n);
    free_node(yystack.l_mark[-4].n);
    check_tree(yyval.n,0);
    THIS_COMPILATION->lex.pragmas = yystack.l_mark[-2].number;
  }
break;
case 333:
#line 2869 "language.yacc"
	{ yyval.n = 0; }
break;
case 334:
#line 2872 "language.yacc"
	{ yyval.n = 0; }
break;
case 335:
#line 2873 "language.yacc"
	{ yyval.n = yystack.l_mark[0].n; }
break;
case 337:
#line 2879 "language.yacc"
	{
    if (yystack.l_mark[-1].n) {
      if (yystack.l_mark[0].n) {
	/* Explicit enum value. */

	/* This can be made more lenient in the future */

	/* Ugly hack to make sure that $2 is optimized */
	{
	  int tmp=Pike_compiler->compiler_pass;
	  yystack.l_mark[0].n=mknode(F_COMMA_EXPR,yystack.l_mark[0].n,0);
	  Pike_compiler->compiler_pass=tmp;
	}

	if(!is_const(yystack.l_mark[0].n))
	{
	  if(Pike_compiler->compiler_pass==2)
	    yyerror("Enum definition is not constant.");
	  push_int(0);
	} else {
	  if(!Pike_compiler->num_parse_error)
	  {
	    ptrdiff_t tmp=eval_low(yystack.l_mark[0].n,1);
	    if(tmp < 1)
	    {
	      yyerror("Error in enum definition.");
	      push_int(0);
	    }else{
	      pop_n_elems(DO_NOT_WARN((INT32)(tmp - 1)));
	    }
	  } else {
	    push_int(0);
	  }
	}
	free_node(yystack.l_mark[0].n);
	free_node(yystack.l_mark[-2].n);
	yystack.l_mark[-2].n = mkconstantsvaluenode(Pike_sp-1);
      } else {
	/* Implicit enum value. */
	yystack.l_mark[-2].n = safe_inc_enum(yystack.l_mark[-2].n);
	push_svalue(&yystack.l_mark[-2].n->u.sval);
      }
      add_constant(yystack.l_mark[-1].n->u.sval.u.string, Pike_sp-1,
		   (Pike_compiler->current_modifiers & ~ID_EXTERN) | ID_INLINE);
      /* Update the type. */
      {
	struct pike_type *current = pop_unfinished_type();
	struct pike_type *new = get_type_of_svalue(Pike_sp-1);
	struct pike_type *res = or_pike_types(new, current, 3);
	free_type(current);
	free_type(new);
	type_stack_mark();
	push_finished_type(res);
	free_type(res);
      }
      pop_stack();
      free_node(yystack.l_mark[-1].n);
    } else if (yystack.l_mark[0].n) {
      free_node(yystack.l_mark[0].n);
    }
  }
break;
case 338:
#line 2944 "language.yacc"
	{
    yyval.n = yystack.l_mark[-2].n;
  }
break;
case 340:
#line 2951 "language.yacc"
	{ yystack.l_mark[-4].n = yystack.l_mark[-1].n; }
break;
case 342:
#line 2957 "language.yacc"
	{
    if ((Pike_compiler->current_modifiers & ID_EXTERN) &&
	(Pike_compiler->compiler_pass == 1)) {
      yywarning("Extern declared enum.");
    }

    type_stack_mark();
    push_type(T_ZERO);	/* Joined type so far. */
  }
break;
case 343:
#line 2967 "language.yacc"
	{
    push_int(-1);	/* Previous value. */
    yyval.n = mkconstantsvaluenode(Pike_sp-1);
    pop_stack();
  }
break;
case 344:
#line 2972 "language.yacc"
	{ yyval.n = NULL; }
break;
case 345:
#line 2973 "language.yacc"
	{
    struct pike_type *t = pop_unfinished_type();
    free_node(yystack.l_mark[-3].n);
    if (yystack.l_mark[-5].n) {
      ref_push_type_value(t);
      add_constant(yystack.l_mark[-5].n->u.sval.u.string, Pike_sp-1,
		   (Pike_compiler->current_modifiers & ~ID_EXTERN) | ID_INLINE);
      pop_stack();
      free_node(yystack.l_mark[-5].n);
    }
    yyval.n = mktypenode(t);
    free_type(t);
  }
break;
case 346:
#line 2989 "language.yacc"
	{
    struct pike_type *t = compiler_pop_type();

    if ((Pike_compiler->current_modifiers & ID_EXTERN) &&
	(Pike_compiler->compiler_pass == 1)) {
      yywarning("Extern declared typedef.");
    }

    if (yystack.l_mark[-1].n) {
      ref_push_type_value(t);
      add_constant(yystack.l_mark[-1].n->u.sval.u.string, Pike_sp-1,
		   (Pike_compiler->current_modifiers & ~ID_EXTERN) | ID_INLINE);
      pop_stack();
      free_node(yystack.l_mark[-1].n);
    }
    free_type(t);
  }
break;
case 347:
#line 3009 "language.yacc"
	{
    yyval.number=Pike_compiler->compiler_frame->current_number_of_locals;
  }
break;
case 348:
#line 3013 "language.yacc"
	{
    /* Trick to store more than one number on compiler stack - Hubbe */
    yyval.number=Pike_compiler->compiler_frame->last_block_level;
    Pike_compiler->compiler_frame->last_block_level=yystack.l_mark[-1].number;
  }
break;
case 349:
#line 3019 "language.yacc"
	{
    yyval.n = mknode('?', yystack.l_mark[-3].n,
		mknode(':',
		       mkcastnode(void_type_string, yystack.l_mark[-1].n),
		       mkcastnode(void_type_string, yystack.l_mark[0].n)));
    COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-6].n);
    yyval.n = mkcastnode(void_type_string, yyval.n);
    COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-6].n);
    free_node (yystack.l_mark[-6].n);
    yyval.n = pop_local_variables(yystack.l_mark[-7].number, yyval.n);
    Pike_compiler->compiler_frame->last_block_level=yystack.l_mark[-5].number;
  }
break;
case 351:
#line 3034 "language.yacc"
	{ yyerror("Missing ')'."); }
break;
case 352:
#line 3036 "language.yacc"
	{
    yyerror("Missing ')'.");
    yyerror("Unexpected end of file.");
  }
break;
case 353:
#line 3042 "language.yacc"
	{ yyval.n=0; }
break;
case 354:
#line 3043 "language.yacc"
	{ yyval.n=yystack.l_mark[0].n; }
break;
case 355:
#line 3047 "language.yacc"
	{
    if (!(THIS_COMPILATION->lex.pragmas & ID_STRICT_TYPES) && yystack.l_mark[0].n) {
      if (yystack.l_mark[0].n->token == F_ARRAY_LVALUE) {
	mark_lvalues_as_used(CAR(yystack.l_mark[0].n));
      } else if ((yystack.l_mark[0].n->token == F_LOCAL) && !(yystack.l_mark[0].n->u.integer.b)) {
	Pike_compiler->compiler_frame->variable[yystack.l_mark[0].n->u.integer.a].flags |=
	  LOCAL_VAR_IS_USED;
      }
    }
  }
break;
case 356:
#line 3057 "language.yacc"
	{ yyval.n=0; }
break;
case 358:
#line 3061 "language.yacc"
	{ yyerror("Unexpected end of file."); yyval.n=0; }
break;
case 359:
#line 3062 "language.yacc"
	{ yyval.n=0; }
break;
case 360:
#line 3066 "language.yacc"
	{ yyval.n=0; }
break;
case 362:
#line 3070 "language.yacc"
	{ yyval.n=yystack.l_mark[0].n; }
break;
case 363:
#line 3072 "language.yacc"
	{ yyval.n=mknode(':',yystack.l_mark[-2].n,yystack.l_mark[0].n); }
break;
case 364:
#line 3076 "language.yacc"
	{
    yyval.number=Pike_compiler->compiler_frame->current_number_of_locals;
  }
break;
case 365:
#line 3080 "language.yacc"
	{
    /* Trick to store more than one number on compiler stack - Hubbe */
    yyval.number=Pike_compiler->compiler_frame->last_block_level;
    Pike_compiler->compiler_frame->last_block_level=yystack.l_mark[-1].number;
  }
break;
case 366:
#line 3086 "language.yacc"
	{
    if (yystack.l_mark[-2].n) {
      yyval.n=mknode(F_FOREACH,
		mknode(F_VAL_LVAL,yystack.l_mark[-3].n,yystack.l_mark[-2].n),
		yystack.l_mark[0].n);
    } else {
      /* Error in lvalue */
      yyval.n=mknode(F_COMMA_EXPR, mkcastnode(void_type_string, yystack.l_mark[-3].n), yystack.l_mark[0].n);
    }
    COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-6].n);
    free_node (yystack.l_mark[-6].n);
    yyval.n = pop_local_variables(yystack.l_mark[-7].number, yyval.n);
    Pike_compiler->compiler_frame->last_block_level=yystack.l_mark[-5].number;
    Pike_compiler->compiler_frame->opt_flags |= OPT_CUSTOM_LABELS;
  }
break;
case 367:
#line 3105 "language.yacc"
	{
    yyval.n=mknode(F_DO,yystack.l_mark[-5].n,yystack.l_mark[-2].n);
    COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-6].n);
    free_node (yystack.l_mark[-6].n);
    Pike_compiler->compiler_frame->opt_flags |= OPT_CUSTOM_LABELS;
  }
break;
case 368:
#line 3112 "language.yacc"
	{
    free_node (yystack.l_mark[-3].n);
    yyval.n=0;
    yyerror("Missing '(' in do-while loop.");
    yyerror("Unexpected end of file.");
  }
break;
case 369:
#line 3119 "language.yacc"
	{
    free_node (yystack.l_mark[-2].n);
    yyval.n=0;
    yyerror("Missing 'while' in do-while loop.");
    yyerror("Unexpected end of file.");
  }
break;
case 371:
#line 3129 "language.yacc"
	{
    yyerror("Missing ';'.");
    yyerror("Unexpected end of file.");
  }
break;
case 372:
#line 3136 "language.yacc"
	{
    yyval.number=Pike_compiler->compiler_frame->current_number_of_locals;
  }
break;
case 373:
#line 3140 "language.yacc"
	{
    /* Trick to store more than one number on compiler stack - Hubbe */
    yyval.number=Pike_compiler->compiler_frame->last_block_level;
    Pike_compiler->compiler_frame->last_block_level=yystack.l_mark[-1].number;
  }
break;
case 374:
#line 3147 "language.yacc"
	{
    yyval.n=mknode(F_COMMA_EXPR, mkcastnode(void_type_string, yystack.l_mark[-6].n),
	      mknode(F_FOR,yystack.l_mark[-4].n,mknode(':',yystack.l_mark[0].n,yystack.l_mark[-2].n)));
    COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-9].n);
    free_node (yystack.l_mark[-9].n);
    yyval.n = pop_local_variables(yystack.l_mark[-10].number, yyval.n);
    Pike_compiler->compiler_frame->last_block_level=yystack.l_mark[-8].number;
    Pike_compiler->compiler_frame->opt_flags |= OPT_CUSTOM_LABELS;
  }
break;
case 375:
#line 3160 "language.yacc"
	{
    yyval.number=Pike_compiler->compiler_frame->current_number_of_locals;
  }
break;
case 376:
#line 3164 "language.yacc"
	{
    /* Trick to store more than one number on compiler stack - Hubbe */
    yyval.number=Pike_compiler->compiler_frame->last_block_level;
    Pike_compiler->compiler_frame->last_block_level=yystack.l_mark[-1].number;
  }
break;
case 377:
#line 3170 "language.yacc"
	{
    yyval.n=mknode(F_FOR,yystack.l_mark[-2].n,mknode(':',yystack.l_mark[0].n,NULL));
    COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-5].n);
    free_node (yystack.l_mark[-5].n);
    yyval.n = pop_local_variables(yystack.l_mark[-6].number, yyval.n);
    Pike_compiler->compiler_frame->last_block_level=yystack.l_mark[-4].number;
    Pike_compiler->compiler_frame->opt_flags |= OPT_CUSTOM_LABELS;
  }
break;
case 378:
#line 3180 "language.yacc"
	{ yyval.n=mkintnode(1); }
break;
case 380:
#line 3185 "language.yacc"
	{
    yyval.number=Pike_compiler->compiler_frame->current_number_of_locals;
  }
break;
case 381:
#line 3189 "language.yacc"
	{
    /* Trick to store more than one number on compiler stack - Hubbe */
    yyval.number=Pike_compiler->compiler_frame->last_block_level;
    Pike_compiler->compiler_frame->last_block_level=yystack.l_mark[-1].number;
  }
break;
case 382:
#line 3195 "language.yacc"
	{
    yyval.n=mknode(F_SWITCH,yystack.l_mark[-2].n,yystack.l_mark[0].n);
    COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-5].n);
    free_node (yystack.l_mark[-5].n);
    yyval.n = pop_local_variables(yystack.l_mark[-6].number, yyval.n);
    Pike_compiler->compiler_frame->last_block_level=yystack.l_mark[-4].number;
  }
break;
case 383:
#line 3205 "language.yacc"
	{
    yyval.n=mknode(F_CASE,yystack.l_mark[-1].n,0);
  }
break;
case 384:
#line 3209 "language.yacc"
	{
     yyval.n=mknode(F_CASE_RANGE,yystack.l_mark[-3].n,yystack.l_mark[-1].n);
  }
break;
case 385:
#line 3213 "language.yacc"
	{
     yyval.n=mknode(F_CASE_RANGE,0,yystack.l_mark[-1].n);
  }
break;
case 387:
#line 3220 "language.yacc"
	{
    yyerror("Missing ':'.");
  }
break;
case 388:
#line 3224 "language.yacc"
	{
    yyerror("Missing ':'.");
  }
break;
case 389:
#line 3228 "language.yacc"
	{
    yyerror("Missing ':'.");
    yyerror("Unexpected end of file.");
  }
break;
case 390:
#line 3235 "language.yacc"
	{
    if(!match_types(Pike_compiler->compiler_frame->current_return_type,
		    void_type_string))
    {
      yytype_error("Must return a value for a non-void function.",
		   Pike_compiler->compiler_frame->current_return_type,
		   void_type_string, 0);
    }
    yyval.n=mknode(F_RETURN,mkintnode(0),0);
  }
break;
case 391:
#line 3246 "language.yacc"
	{
    yyval.n=mknode(F_RETURN,yystack.l_mark[-1].n,0);
  }
break;
case 392:
#line 3251 "language.yacc"
	{ yyval.n=0; }
break;
case 393:
#line 3252 "language.yacc"
	{ yyval.n=mkcastnode(void_type_string, yystack.l_mark[0].n);  }
break;
case 394:
#line 3255 "language.yacc"
	{ yyval.n=mkcastnode(void_type_string, yystack.l_mark[0].n);  }
break;
case 395:
#line 3257 "language.yacc"
	{ yyval.n=0; }
break;
case 398:
#line 3262 "language.yacc"
	{ yyval.n=0; }
break;
case 400:
#line 3266 "language.yacc"
	{ yyval.n=yystack.l_mark[0].n; free_node(yystack.l_mark[-1].n); }
break;
case 401:
#line 3267 "language.yacc"
	{ yyval.n=yystack.l_mark[0].n; free_node(yystack.l_mark[-1].n); }
break;
case 402:
#line 3268 "language.yacc"
	{ yyval.n=yystack.l_mark[0].n; free_node(yystack.l_mark[-1].n); }
break;
case 403:
#line 3269 "language.yacc"
	{ yyval.n=yystack.l_mark[0].n; free_node(yystack.l_mark[-1].n); }
break;
case 405:
#line 3275 "language.yacc"
	{
    yyval.n = mknode(F_COMMA_EXPR, mkcastnode(void_type_string, yystack.l_mark[-2].n), yystack.l_mark[0].n);
  }
break;
case 407:
#line 3281 "language.yacc"
	{ yyval.n=mknode(F_PUSH_ARRAY,yystack.l_mark[0].n,0); }
break;
case 409:
#line 3284 "language.yacc"
	{ yyval.n=mknode(F_ASSIGN,yystack.l_mark[0].n,yystack.l_mark[-2].n); }
break;
case 410:
#line 3285 "language.yacc"
	{ yyval.n=yystack.l_mark[-2].n; reset_type_stack(); yyerrok; }
break;
case 411:
#line 3286 "language.yacc"
	{ yyval.n=yystack.l_mark[0].n; }
break;
case 412:
#line 3288 "language.yacc"
	{
    if (!(THIS_COMPILATION->lex.pragmas & ID_STRICT_TYPES)) {
      mark_lvalues_as_used(yystack.l_mark[-3].n);
    }
    yyval.n=mknode(F_ASSIGN,yystack.l_mark[0].n,mknode(F_ARRAY_LVALUE,yystack.l_mark[-3].n,0));
    COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-4].n);
    free_node (yystack.l_mark[-4].n);
  }
break;
case 413:
#line 3296 "language.yacc"
	{ yyval.n=mknode(yystack.l_mark[-1].number,yystack.l_mark[-2].n,yystack.l_mark[0].n); }
break;
case 414:
#line 3297 "language.yacc"
	{ yyval.n=yystack.l_mark[-2].n; reset_type_stack(); yyerrok; }
break;
case 415:
#line 3298 "language.yacc"
	{ yyval.n=yystack.l_mark[0].n; }
break;
case 416:
#line 3300 "language.yacc"
	{
    yyval.n=mknode(yystack.l_mark[-1].number,mknode(F_ARRAY_LVALUE,yystack.l_mark[-3].n,0),yystack.l_mark[0].n);
    COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-4].n);
    free_node (yystack.l_mark[-4].n);
  }
break;
case 417:
#line 3306 "language.yacc"
	{
      yyval.n=yystack.l_mark[-2].n; free_node (yystack.l_mark[-3].n); reset_type_stack(); yyerrok;
    }
break;
case 419:
#line 3313 "language.yacc"
	{ yyval.n=mknode('?',yystack.l_mark[-4].n,mknode(':',yystack.l_mark[-2].n,yystack.l_mark[0].n)); }
break;
case 420:
#line 3316 "language.yacc"
	{ yyval.number=F_AND_EQ; }
break;
case 421:
#line 3317 "language.yacc"
	{ yyval.number=F_OR_EQ; }
break;
case 422:
#line 3318 "language.yacc"
	{ yyval.number=F_XOR_EQ; }
break;
case 423:
#line 3319 "language.yacc"
	{ yyval.number=F_LSH_EQ; }
break;
case 424:
#line 3320 "language.yacc"
	{ yyval.number=F_RSH_EQ; }
break;
case 425:
#line 3321 "language.yacc"
	{ yyval.number=F_ADD_EQ; }
break;
case 426:
#line 3322 "language.yacc"
	{ yyval.number=F_SUB_EQ; }
break;
case 427:
#line 3323 "language.yacc"
	{ yyval.number=F_MULT_EQ; }
break;
case 428:
#line 3324 "language.yacc"
	{ yyval.number=F_MOD_EQ; }
break;
case 429:
#line 3325 "language.yacc"
	{ yyval.number=F_DIV_EQ; }
break;
case 430:
#line 3328 "language.yacc"
	{ yyval.number=0; }
break;
case 431:
#line 3328 "language.yacc"
	{ yyval.number=1; }
break;
case 432:
#line 3330 "language.yacc"
	{ yyval.n=0; }
break;
case 435:
#line 3336 "language.yacc"
	{ yyval.n=mknode(F_ARG_LIST,yystack.l_mark[-2].n,yystack.l_mark[0].n); }
break;
case 436:
#line 3339 "language.yacc"
	{ yyval.n=0; }
break;
case 439:
#line 3345 "language.yacc"
	{
    if (yystack.l_mark[0].n) {
      yyval.n=mknode(F_ARG_LIST,yystack.l_mark[-2].n,yystack.l_mark[0].n);
    } else {
      /* Error in assoc_pair */
      yyval.n=yystack.l_mark[-2].n;
    }
  }
break;
case 441:
#line 3357 "language.yacc"
	{
    yyval.n=mknode(F_ARG_LIST,yystack.l_mark[-2].n,yystack.l_mark[0].n);
  }
break;
case 442:
#line 3360 "language.yacc"
	{ free_node(yystack.l_mark[-2].n); yyval.n=0; }
break;
case 444:
#line 3364 "language.yacc"
	{ yyval.n=mknode(F_LOR,yystack.l_mark[-2].n,yystack.l_mark[0].n); }
break;
case 445:
#line 3365 "language.yacc"
	{ yyval.n=mknode(F_LAND,yystack.l_mark[-2].n,yystack.l_mark[0].n); }
break;
case 446:
#line 3366 "language.yacc"
	{ yyval.n=mkopernode("`|",yystack.l_mark[-2].n,yystack.l_mark[0].n); }
break;
case 447:
#line 3367 "language.yacc"
	{ yyval.n=mkopernode("`^",yystack.l_mark[-2].n,yystack.l_mark[0].n); }
break;
case 448:
#line 3368 "language.yacc"
	{ yyval.n=mkopernode("`&",yystack.l_mark[-2].n,yystack.l_mark[0].n); }
break;
case 449:
#line 3369 "language.yacc"
	{ yyval.n=mkopernode("`==",yystack.l_mark[-2].n,yystack.l_mark[0].n); }
break;
case 450:
#line 3370 "language.yacc"
	{ yyval.n=mkopernode("`!=",yystack.l_mark[-2].n,yystack.l_mark[0].n); }
break;
case 451:
#line 3371 "language.yacc"
	{ yyval.n=mkopernode("`>",yystack.l_mark[-2].n,yystack.l_mark[0].n); }
break;
case 452:
#line 3372 "language.yacc"
	{ yyval.n=mkopernode("`>=",yystack.l_mark[-2].n,yystack.l_mark[0].n); }
break;
case 453:
#line 3373 "language.yacc"
	{ yyval.n=mkopernode("`<",yystack.l_mark[-2].n,yystack.l_mark[0].n); }
break;
case 454:
#line 3374 "language.yacc"
	{ yyval.n=mkopernode("`<=",yystack.l_mark[-2].n,yystack.l_mark[0].n); }
break;
case 455:
#line 3375 "language.yacc"
	{ yyval.n=mkopernode("`<<",yystack.l_mark[-2].n,yystack.l_mark[0].n); }
break;
case 456:
#line 3376 "language.yacc"
	{ yyval.n=mkopernode("`>>",yystack.l_mark[-2].n,yystack.l_mark[0].n); }
break;
case 457:
#line 3377 "language.yacc"
	{ yyval.n=mkopernode("`+",yystack.l_mark[-2].n,yystack.l_mark[0].n); }
break;
case 458:
#line 3378 "language.yacc"
	{ yyval.n=mkopernode("`-",yystack.l_mark[-2].n,yystack.l_mark[0].n); }
break;
case 459:
#line 3379 "language.yacc"
	{ yyval.n=mkopernode("`*",yystack.l_mark[-2].n,yystack.l_mark[0].n); }
break;
case 460:
#line 3380 "language.yacc"
	{ yyval.n=mkopernode("`%",yystack.l_mark[-2].n,yystack.l_mark[0].n); }
break;
case 461:
#line 3381 "language.yacc"
	{ yyval.n=mkopernode("`/",yystack.l_mark[-2].n,yystack.l_mark[0].n); }
break;
case 481:
#line 3404 "language.yacc"
	{
    yyval.n = mkcastnode(yystack.l_mark[-1].n->u.sval.u.type, yystack.l_mark[0].n);
    free_node(yystack.l_mark[-1].n);
  }
break;
case 482:
#line 3409 "language.yacc"
	{
    yyval.n = mksoftcastnode(yystack.l_mark[-1].n->u.sval.u.type, yystack.l_mark[0].n);
    free_node(yystack.l_mark[-1].n);
  }
break;
case 483:
#line 3413 "language.yacc"
	{ yyval.n=mknode(F_INC,yystack.l_mark[0].n,0); }
break;
case 484:
#line 3414 "language.yacc"
	{ yyval.n=mknode(F_DEC,yystack.l_mark[0].n,0); }
break;
case 485:
#line 3415 "language.yacc"
	{ yyval.n=mkopernode("`!",yystack.l_mark[0].n,0); }
break;
case 486:
#line 3416 "language.yacc"
	{ yyval.n=mkopernode("`~",yystack.l_mark[0].n,0); }
break;
case 487:
#line 3417 "language.yacc"
	{ yyval.n=mkopernode("`-",yystack.l_mark[0].n,0); }
break;
case 489:
#line 3421 "language.yacc"
	{ yyval.n=mknode(F_POST_INC,yystack.l_mark[-1].n,0); }
break;
case 490:
#line 3422 "language.yacc"
	{ yyval.n=mknode(F_POST_DEC,yystack.l_mark[-1].n,0); }
break;
case 491:
#line 3444 "language.yacc"
	{ yyval.n=0; }
break;
case 492:
#line 3448 "language.yacc"
	{
    debug_malloc_touch(Pike_compiler->compiler_frame->current_return_type);
    if(Pike_compiler->compiler_frame->current_return_type)
      free_type(Pike_compiler->compiler_frame->current_return_type);
    copy_pike_type(Pike_compiler->compiler_frame->current_return_type,
		   any_type_string);

    /* block code */
    yystack.l_mark[-2].number=Pike_compiler->num_used_modules;
    yyval.number=Pike_compiler->compiler_frame->current_number_of_locals;
  }
break;
case 493:
#line 3460 "language.yacc"
	{
    struct pike_type *type;
    int f/*, e */;
    struct pike_string *name;
    struct compilation *c = THIS_COMPILATION;
    struct pike_string *save_file = c->lex.current_file;
    int save_line = c->lex.current_line;
    c->lex.current_file = yystack.l_mark[-4].n->current_file;
    c->lex.current_line = yystack.l_mark[-4].n->line_number;

    /* block code */
    unuse_modules(Pike_compiler->num_used_modules - yystack.l_mark[-5].number);
    yystack.l_mark[-1].n = pop_local_variables(yystack.l_mark[-2].number, yystack.l_mark[-1].n);

    debug_malloc_touch(yystack.l_mark[-1].n);
    yystack.l_mark[-1].n=mknode(F_COMMA_EXPR,yystack.l_mark[-1].n,mknode(F_RETURN,mkintnode(0),0));
    if (Pike_compiler->compiler_pass == 2) {
      /* Doing this in pass 1 might induce too strict checks on types
       * in cases where we got placeholders. */
      type=find_return_type(yystack.l_mark[-1].n);
      if (type) {
	push_finished_type(type);
	free_type(type);
      } else {
	yywarning("Failed to determine return type for implicit lambda.");
	push_type(T_ZERO);
      }
    } else {
      /* Tentative return type. */
      push_type(T_MIXED);
    }

    push_type(T_VOID);
    push_type(T_MANY);
/*
    e=$5-1;
    for(; e>=0; e--)
      push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
*/

    type=compiler_pop_type();

    name = get_new_name(NULL);

#ifdef LAMBDA_DEBUG
    fprintf(stderr, "%d: IMPLICIT LAMBDA: %s 0x%08lx 0x%08lx\n",
	    Pike_compiler->compiler_pass, name->str,
	    (long)Pike_compiler->new_program->id,
	    Pike_compiler->local_class_counter-1);
#endif /* LAMBDA_DEBUG */

    f=dooptcode(name,
		yystack.l_mark[-1].n,
		type,
		ID_PROTECTED | ID_PRIVATE | ID_INLINE | ID_USED);

    if(Pike_compiler->compiler_frame->lexical_scope & SCOPE_SCOPED) {
      yyval.n = mktrampolinenode(f,Pike_compiler->compiler_frame->previous);
    } else {
      yyval.n = mkidentifiernode(f);
    }

    c->lex.current_line = save_line;
    c->lex.current_file = save_file;
    free_node (yystack.l_mark[-4].n);
    free_string(name);
    free_type(type);
#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != yystack.l_mark[-3].ptr) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
		 Pike_compiler->compiler_frame, yystack.l_mark[-3].ptr,
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();
  }
break;
case 494:
#line 3541 "language.yacc"
	{
    yyval.n = mkapplynode(yystack.l_mark[-4].n, mknode(F_ARG_LIST, yystack.l_mark[-2].n, yystack.l_mark[0].n));
    COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-3].n);
    free_node (yystack.l_mark[-3].n);
  }
break;
case 495:
#line 3547 "language.yacc"
	{
    yyval.n=mkapplynode(yystack.l_mark[-4].n, yystack.l_mark[0].n);
    free_node (yystack.l_mark[-3].n);
    yyerrok;
  }
break;
case 496:
#line 3553 "language.yacc"
	{
    yyerror("Missing ')'.");
    yyerror("Unexpected end of file.");
    yyval.n=mkapplynode(yystack.l_mark[-3].n, NULL);
    free_node (yystack.l_mark[-2].n);
  }
break;
case 497:
#line 3560 "language.yacc"
	{
    yyerror("Missing ')'.");
    yyval.n=mkapplynode(yystack.l_mark[-3].n, NULL);
    free_node (yystack.l_mark[-2].n);
  }
break;
case 498:
#line 3566 "language.yacc"
	{
    yyerror("Missing ')'.");
    yyval.n=mkapplynode(yystack.l_mark[-3].n, NULL);
    free_node (yystack.l_mark[-2].n);
  }
break;
case 499:
#line 3574 "language.yacc"
	{
    if (TEST_COMPAT(7, 6)) {
      yyval.number = Pike_compiler->current_modifiers =
	(THIS_COMPILATION->lex.pragmas & ID_MODIFIER_MASK);
    } else {
      yyval.number = Pike_compiler->current_modifiers = ID_PROTECTED|ID_INLINE|ID_PRIVATE |
	(THIS_COMPILATION->lex.pragmas & ID_MODIFIER_MASK);
    }
  }
break;
case 502:
#line 3587 "language.yacc"
	{ yyval.n=mkfloatnode((FLOAT_TYPE)yystack.l_mark[0].fnum); }
break;
case 508:
#line 3593 "language.yacc"
	{ yyval.n = yystack.l_mark[0].n; }
break;
case 509:
#line 3594 "language.yacc"
	{ yyval.n = yystack.l_mark[0].n; }
break;
case 512:
#line 3598 "language.yacc"
	{
    yyval.n=mknode(F_AUTO_MAP_MARKER, yystack.l_mark[-3].n, 0);
    COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-2].n);
    free_node (yystack.l_mark[-2].n);
  }
break;
case 513:
#line 3604 "language.yacc"
	{
    yyval.n=mknode(F_INDEX,yystack.l_mark[-3].n,yystack.l_mark[-1].n);
    COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-2].n);
    free_node (yystack.l_mark[-2].n);
  }
break;
case 514:
#line 3611 "language.yacc"
	{
    yyval.n=mknode(F_RANGE,yystack.l_mark[-5].n,mknode(':',yystack.l_mark[-3].n,yystack.l_mark[-1].n));
    COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-4].n);
    free_node (yystack.l_mark[-4].n);
  }
break;
case 515:
#line 3617 "language.yacc"
	{
    /* A[?X] to ((tmp=A) && tmp[X]) */
    if( yystack.l_mark[-4].n && (yystack.l_mark[-4].n->token == F_LOCAL) )
    {
      yyval.n=mknode(F_LAND, copy_node(yystack.l_mark[-4].n), mknode(F_INDEX,  yystack.l_mark[-4].n, yystack.l_mark[-1].n));
    }
    else
    {
      fix_type_field( yystack.l_mark[-4].n );
      if( yystack.l_mark[-4].n && yystack.l_mark[-4].n->type )
      {
        int temporary;
        yystack.l_mark[-4].n->type->refs++;

        temporary = add_local_name(empty_pike_string, yystack.l_mark[-4].n->type, 0);
        Pike_compiler->compiler_frame->variable[temporary].flags |= LOCAL_VAR_IS_USED;
        yyval.n=mknode(F_LAND,
                  mknode(F_ASSIGN, yystack.l_mark[-4].n, mklocalnode(temporary,0)),
                  mknode(F_INDEX,  mklocalnode(temporary,0), yystack.l_mark[-1].n));
      }
      else
      {
        yyval.n=mknode(F_INDEX, yystack.l_mark[-4].n,yystack.l_mark[-1].n);
        yyerror("Indexing unexpected value.");
      }
    }
    COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-2].n);
    free_node (yystack.l_mark[-2].n);
  }
break;
case 516:
#line 3648 "language.yacc"
	{
    /* A[?X..Y] to ((tmp=A) && tmp[X..Y]) */
    node *range = mknode(':',yystack.l_mark[-3].n,yystack.l_mark[-1].n);
    if( yystack.l_mark[-6].n && (yystack.l_mark[-6].n->token == F_LOCAL ) )
    {
      yyval.n = mknode( F_LAND, copy_node(yystack.l_mark[-6].n), mknode(F_RANGE, yystack.l_mark[-6].n, range) );
    }
    else
    {
      fix_type_field( yystack.l_mark[-6].n );
      if( yystack.l_mark[-6].n && yystack.l_mark[-6].n->type )
      {
        int temporary;
        yystack.l_mark[-6].n->type->refs++;

        temporary = add_local_name(empty_pike_string, yystack.l_mark[-6].n->type, 0);
        Pike_compiler->compiler_frame->variable[temporary].flags |= LOCAL_VAR_IS_USED;
        yyval.n=mknode(F_LAND,
                  mknode(F_ASSIGN, yystack.l_mark[-6].n, mklocalnode(temporary,0) ),
                  mknode(F_RANGE,  mklocalnode(temporary,0), range) );
      }
      else
      {
        yyval.n = mknode( F_LAND, yystack.l_mark[-6].n, mknode(F_RANGE,yystack.l_mark[-6].n,range) );
        yyerror("Indexing unexpected value.");
      }
    }
    COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-4].n);
    free_node (yystack.l_mark[-4].n);
  }
break;
case 517:
#line 3679 "language.yacc"
	{
    yyval.n=yystack.l_mark[-3].n;
    free_node (yystack.l_mark[-2].n);
    yyerrok;
  }
break;
case 518:
#line 3685 "language.yacc"
	{
    yyval.n=yystack.l_mark[-3].n; yyerror("Missing ']'.");
    yyerror("Unexpected end of file.");
    free_node (yystack.l_mark[-2].n);
  }
break;
case 519:
#line 3691 "language.yacc"
	{yyval.n=yystack.l_mark[-3].n; yyerror("Missing ']'."); free_node (yystack.l_mark[-2].n);}
break;
case 520:
#line 3693 "language.yacc"
	{yyval.n=yystack.l_mark[-3].n; yyerror("Missing ']'."); free_node (yystack.l_mark[-2].n);}
break;
case 521:
#line 3695 "language.yacc"
	{yyval.n=yystack.l_mark[-3].n; yyerror("Missing ']'."); free_node (yystack.l_mark[-2].n);}
break;
case 522:
#line 3697 "language.yacc"
	{
      yyval.n=yystack.l_mark[-1].n;
      if (yyval.n) {
	COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-2].n);
      }
      free_node (yystack.l_mark[-2].n);
    }
break;
case 523:
#line 3705 "language.yacc"
	{
      /* FIXME: May eat lots of stack; cf Standards.FIPS10_4.divisions */
      yyval.n=mkefuncallnode("aggregate",yystack.l_mark[-2].n);
      COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-4].n);
      free_node (yystack.l_mark[-4].n);
    }
break;
case 524:
#line 3714 "language.yacc"
	{
      /* FIXME: May eat lots of stack; cf Standards.FIPS10_4.divisions */
      yyval.n=mkefuncallnode("aggregate_mapping",yystack.l_mark[-2].n);
      COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-4].n);
      free_node (yystack.l_mark[-4].n);
      free_node (yystack.l_mark[-3].n);
    }
break;
case 525:
#line 3722 "language.yacc"
	{
      /* FIXME: May eat lots of stack; cf Standards.FIPS10_4.divisions */
      yyval.n=mkefuncallnode("aggregate_multiset",yystack.l_mark[-1].n);
      COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-2].n);
      free_node (yystack.l_mark[-2].n);
    }
break;
case 526:
#line 3729 "language.yacc"
	{
      yyerror("Missing '>'.");
      yyval.n=mkefuncallnode("aggregate_multiset",yystack.l_mark[-1].n);
      COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-2].n);
      free_node (yystack.l_mark[-2].n);
    }
break;
case 527:
#line 3735 "language.yacc"
	{ yyval.n=yystack.l_mark[-2].n; yyerrok; }
break;
case 528:
#line 3737 "language.yacc"
	{
    yyval.n=yystack.l_mark[-2].n; yyerror("Missing ')'.");
    yyerror("Unexpected end of file.");
  }
break;
case 529:
#line 3741 "language.yacc"
	{ yyval.n=yystack.l_mark[-2].n; yyerror("Missing ')'."); }
break;
case 530:
#line 3742 "language.yacc"
	{ yyval.n=yystack.l_mark[-2].n; yyerror("Missing ')'."); }
break;
case 531:
#line 3743 "language.yacc"
	{ yyval.n=yystack.l_mark[-2].n; yyerrok; }
break;
case 532:
#line 3744 "language.yacc"
	{
    yyerror("Missing '>'.");
    yyval.n=yystack.l_mark[-2].n; yyerrok;
  }
break;
case 533:
#line 3749 "language.yacc"
	{
    yyval.n=yystack.l_mark[-2].n; yyerror("Missing '>)'.");
    yyerror("Unexpected end of file.");
  }
break;
case 534:
#line 3753 "language.yacc"
	{ yyval.n=yystack.l_mark[-2].n; yyerror("Missing '>)'."); }
break;
case 535:
#line 3754 "language.yacc"
	{ yyval.n=yystack.l_mark[-2].n; yyerror("Missing '>)'."); }
break;
case 536:
#line 3756 "language.yacc"
	{
    yyval.n=mknode(F_ARROW,yystack.l_mark[-3].n,yystack.l_mark[0].n);
    COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-1].n);
    free_node (yystack.l_mark[-1].n);
  }
break;
case 537:
#line 3762 "language.yacc"
	{
    /* A->?B to ((tmp=A) && tmp->B) */
    int temporary;
    if( yystack.l_mark[-3].n && (yystack.l_mark[-3].n->token == F_LOCAL) )
    {
      yyval.n=mknode(F_LAND, copy_node(yystack.l_mark[-3].n), mknode(F_ARROW, yystack.l_mark[-3].n, yystack.l_mark[0].n));
    }
    else
    {
      fix_type_field( yystack.l_mark[-3].n );
      if( yystack.l_mark[-3].n && yystack.l_mark[-3].n->type )
      {
        yystack.l_mark[-3].n->type->refs++;

        temporary = add_local_name(empty_pike_string, yystack.l_mark[-3].n->type, 0);
        Pike_compiler->compiler_frame->variable[temporary].flags |= LOCAL_VAR_IS_USED;
        yyval.n=mknode(F_LAND,
                  mknode(F_ASSIGN, yystack.l_mark[-3].n, mklocalnode(temporary,0)),
                  mknode(F_ARROW,  mklocalnode(temporary,0), yystack.l_mark[0].n));
      }
      else
      {
        yyval.n=mknode(F_ARROW, yystack.l_mark[-3].n,yystack.l_mark[0].n);
        yyerror("Indexing unexpected value.");
      }
    }
    COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-1].n);
    free_node (yystack.l_mark[-1].n);
  }
break;
case 538:
#line 3792 "language.yacc"
	{
    yyval.n=index_node(yystack.l_mark[-3].n,".",yystack.l_mark[0].n->u.sval.u.string);
    COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-1].n);
    free_node (yystack.l_mark[-3].n);
    free_node (yystack.l_mark[-1].n);
    free_node (yystack.l_mark[0].n);
  }
break;
case 539:
#line 3799 "language.yacc"
	{yyval.n=yystack.l_mark[-3].n; free_node (yystack.l_mark[-1].n);}
break;
case 541:
#line 3804 "language.yacc"
	{
    int i;

    if(Pike_compiler->last_identifier) free_string(Pike_compiler->last_identifier);
    copy_shared_string(Pike_compiler->last_identifier, yystack.l_mark[0].n->u.sval.u.string);

    if (((i = find_shared_string_identifier(Pike_compiler->last_identifier,
					    Pike_compiler->new_program)) >= 0) ||
	((i = really_low_find_shared_string_identifier(Pike_compiler->last_identifier,
						       Pike_compiler->new_program,
						       SEE_PROTECTED|
						       SEE_PRIVATE)) >= 0)) {
      struct reference *ref = Pike_compiler->new_program->identifier_references + i;
      if (IDENTIFIER_IS_VARIABLE (
	    ID_FROM_PTR (Pike_compiler->new_program, ref)->identifier_flags)) {
	/* Allowing local:: on variables would lead to pathological
	 * behavior: If a non-local variable in a class is referenced
	 * both with and without local::, both references would
	 * address the same variable in all cases except where an
	 * inheriting program overrides it (c.f. [bug 1252]).
	 *
	 * Furthermore, that's not how it works currently; if this
	 * error is removed then local:: will do nothing on variables
	 * except forcing a lookup in the closest surrounding class
	 * scope. */
	yyerror ("Cannot make local references to variables.");
	yyval.n = 0;
      }
      else {
	if (!(ref->id_flags & ID_LOCAL)) {
	  /* We need to generate a new reference. */
	  int d;
	  struct reference funp = *ref;
	  funp.id_flags = (funp.id_flags & ~ID_INHERITED) | ID_INLINE|ID_HIDDEN;
	  i = -1;
	  for(d = 0; d < (int)Pike_compiler->new_program->num_identifier_references; d++) {
	    struct reference *refp;
	    refp = Pike_compiler->new_program->identifier_references + d;

	    if (!(refp->id_flags & ID_LOCAL)) continue;

	    if((refp->inherit_offset == funp.inherit_offset) &&
	       (refp->identifier_offset == funp.identifier_offset)) {
	      i = d;
	      break;
	    }
	  }
	  if (i < 0) {
	    add_to_identifier_references(funp);
	    i = Pike_compiler->new_program->num_identifier_references - 1;
	  }
	}
	yyval.n = mkidentifiernode(i);
      }
    } else {
      if (Pike_compiler->compiler_pass == 2) {
	my_yyerror("%S not defined in local scope.",
		   Pike_compiler->last_identifier);
	yyval.n = 0;
      } else {
	yyval.n = mknode(F_UNDEFINED, 0, 0);
      }
    }

    free_node(yystack.l_mark[0].n);
  }
break;
case 542:
#line 3871 "language.yacc"
	{
    yyval.n=0;
  }
break;
case 544:
#line 3878 "language.yacc"
	{
    yyval.n=index_node(yystack.l_mark[-2].n, Pike_compiler->last_identifier?Pike_compiler->last_identifier->str:NULL,
		  yystack.l_mark[0].n->u.sval.u.string);
    free_node(yystack.l_mark[-2].n);
    if(Pike_compiler->last_identifier) free_string(Pike_compiler->last_identifier);
    copy_shared_string(Pike_compiler->last_identifier, yystack.l_mark[0].n->u.sval.u.string);
    free_node(yystack.l_mark[0].n);
  }
break;
case 545:
#line 3886 "language.yacc"
	{}
break;
case 546:
#line 3887 "language.yacc"
	{}
break;
case 549:
#line 3901 "language.yacc"
	{
    struct compilation *c = THIS_COMPILATION;
    struct program_state *state = Pike_compiler;
    int depth;
    int e = -1;

    inherit_state = NULL;
    inherit_depth = 0;

    /* NB: The heuristics here are a bit strange
     *     (all to make it as backward compatible as possible).
     *
     *     The priority order is as follows:
     *
     *     1: Direct inherits in the current class.
     *
     *     2: The name of the current class.
     *
     *     3: 1 & 2 recursively for surrounding parent classes.
     *
     *     4: Indirect inherits in the current class.
     *
     *     5: 4 recursively for surrounding parent classes.
     *
     *     6: this_program.
     *
     * Note that a deep inherit in the current class trumphs
     * a not so deep inherit in a parent class (but not a
     * direct inherit in a parent class). To select the deep
     * inherit in the parent class in this case, prefix it
     * with the name of the parent class.
     */
    for (depth = 0;; depth++, state = state->previous) {
      int inh = find_inherit(state->new_program, yystack.l_mark[-1].n->u.sval.u.string);
      if (inh &&
	  (!inherit_state ||
	   (state->new_program->inherits[inh].inherit_level == 1))) {
	/* Found, and we've either not found anything earlier,
	 * or this is a direct inherit (and the previous
	 * wasn't since we didn't break out of the loop).
	 */
	e = inh;
	inherit_state = state;
	inherit_depth = depth;
	if (state->new_program->inherits[inh].inherit_level == 1) {
	  /* Name of direct inherit ==> Done. */
	  break;
	}
      }
      /* The top-level class does not have a name, so break here. */
      if (depth == c->compilation_depth) break;
      if (ID_FROM_INT (state->previous->new_program,
		       state->parent_identifier)->name ==
	  yystack.l_mark[-1].n->u.sval.u.string) {
	/* Name of surrounding class ==> Done. */
	e = 0;
	inherit_state = state;
	inherit_depth = depth;
	break;
      }
    }
    if (e == -1) {
      inherit_state = state;
      inherit_depth = depth;
      if (yystack.l_mark[-1].n->u.sval.u.string == this_program_string || yystack.l_mark[-1].n->u.sval.u.string == this_string) {
        inherit_state = Pike_compiler;
        inherit_depth = 0;
        e = 0;
      }
      else
        my_yyerror("No inherit or surrounding class %S.",
                   yystack.l_mark[-1].n->u.sval.u.string);
    }
    free_node(yystack.l_mark[-1].n);
    yyval.number = e;
  }
break;
case 550:
#line 3978 "language.yacc"
	{
    struct compilation *c = THIS_COMPILATION;
    inherit_state = Pike_compiler;
    for (inherit_depth = 0; inherit_depth < c->compilation_depth;
	 inherit_depth++, inherit_state = inherit_state->previous) {}
    yyval.number = -1;
  }
break;
case 551:
#line 3986 "language.yacc"
	{
    int e = 0;
    if (yystack.l_mark[-2].number < 0) {
      yystack.l_mark[-2].number = 0;
    }
#if 0
    /* FIXME: The inherit modifiers aren't kept. */
    if (!(inherit_state->new_program->inherits[yystack.l_mark[-2].number].flags & ID_PRIVATE)) {
#endif /* 0 */
      e = find_inherit(inherit_state->new_program->inherits[yystack.l_mark[-2].number].prog,
		       yystack.l_mark[-1].n->u.sval.u.string);
#if 0
    }
#endif /* 0 */
    if (!e) {
      if (inherit_state->new_program->inherits[yystack.l_mark[-2].number].name) {
	my_yyerror("No such inherit %S::%S.",
		   inherit_state->new_program->inherits[yystack.l_mark[-2].number].name,
		   yystack.l_mark[-1].n->u.sval.u.string);
      } else {
	my_yyerror("No such inherit %S.", yystack.l_mark[-1].n->u.sval.u.string);
      }
      yyval.number = -1;
    } else {
      /* We know stuff about the inherit structure... */
      yyval.number = e + yystack.l_mark[-2].number;
    }
    free_node(yystack.l_mark[-1].n);
  }
break;
case 552:
#line 4015 "language.yacc"
	{ yyval.number = -1; }
break;
case 553:
#line 4019 "language.yacc"
	{
    if(Pike_compiler->last_identifier) free_string(Pike_compiler->last_identifier);
    copy_shared_string(Pike_compiler->last_identifier, yystack.l_mark[0].n->u.sval.u.string);

    if((yyval.n=lexical_islocal(Pike_compiler->last_identifier)))
    {
      /* done, nothing to do here */
    }else if(!(yyval.n=find_module_identifier(Pike_compiler->last_identifier,1)) &&
	     !(yyval.n = program_magic_identifier (Pike_compiler, 0, -1,
					      Pike_compiler->last_identifier, 0))) {
      if((Pike_compiler->flags & COMPILATION_FORCE_RESOLVE) ||
	 (Pike_compiler->compiler_pass==2)) {
	my_yyerror("Undefined identifier %S.",
		   Pike_compiler->last_identifier);
	/* FIXME: Add this identifier as a constant in the current program to
	 *        avoid multiple reporting of the same identifier.
	 * NOTE: This should then only be done in the second pass.
	 */	
	yyval.n=0;
      }else{
	yyval.n=mknode(F_UNDEFINED,0,0);
      }
    }
    free_node(yystack.l_mark[0].n);
  }
break;
case 554:
#line 4045 "language.yacc"
	{
    struct pike_string *dot;
    MAKE_CONST_STRING(dot, ".");
    if (call_handle_import(dot)) {
      node *tmp=mkconstantsvaluenode(Pike_sp-1);
      pop_stack();
      yyval.n=index_node(tmp, ".", yystack.l_mark[0].n->u.sval.u.string);
      free_node(tmp);
    }
    else
      yyval.n=mknewintnode(0);
    if(Pike_compiler->last_identifier) free_string(Pike_compiler->last_identifier);
    copy_shared_string(Pike_compiler->last_identifier, yystack.l_mark[0].n->u.sval.u.string);
    free_node(yystack.l_mark[0].n);
  }
break;
case 555:
#line 4061 "language.yacc"
	{
    yyval.n = resolve_identifier (yystack.l_mark[0].n->u.sval.u.string);
    if(Pike_compiler->last_identifier) free_string(Pike_compiler->last_identifier);
    copy_shared_string(Pike_compiler->last_identifier, yystack.l_mark[0].n->u.sval.u.string);
    free_node (yystack.l_mark[0].n);
  }
break;
case 556:
#line 4068 "language.yacc"
	{
    ref_push_string(yystack.l_mark[0].n->u.sval.u.string);
    low_yyreport(REPORT_ERROR, NULL, 0, parser_system_string,
		 1, "Unknown reserved symbol %s.");
    free_node(yystack.l_mark[0].n);
    yyval.n = 0;
  }
break;
case 557:
#line 4076 "language.yacc"
	{
    struct compilation *c = THIS_COMPILATION;
    node *tmp2;

    if(Pike_compiler->last_identifier)
      free_string(Pike_compiler->last_identifier);
    copy_shared_string(Pike_compiler->last_identifier, yystack.l_mark[0].n->u.sval.u.string);

    tmp2 = mkconstantsvaluenode(&c->default_module);
    yyval.n = index_node(tmp2, "predef", yystack.l_mark[0].n->u.sval.u.string);
    if(!yyval.n->name)
      add_ref( yyval.n->name=yystack.l_mark[0].n->u.sval.u.string );
    free_node(tmp2);
    free_node(yystack.l_mark[0].n);
  }
break;
case 558:
#line 4092 "language.yacc"
	{
    yyval.n=0;
  }
break;
case 559:
#line 4096 "language.yacc"
	{
    yyval.n = find_versioned_identifier(yystack.l_mark[0].n->u.sval.u.string,
				   yystack.l_mark[-2].n->u.integer.a, yystack.l_mark[-2].n->u.integer.b);
    free_node(yystack.l_mark[-2].n);
    free_node(yystack.l_mark[0].n);
  }
break;
case 560:
#line 4103 "language.yacc"
	{
    free_node(yystack.l_mark[-2].n);
    yyval.n=0;
  }
break;
case 561:
#line 4108 "language.yacc"
	{
    int id;

    if(Pike_compiler->last_identifier) free_string(Pike_compiler->last_identifier);
    copy_shared_string(Pike_compiler->last_identifier, yystack.l_mark[0].n->u.sval.u.string);

    if (yystack.l_mark[-1].number > 0)
      id = low_reference_inherited_identifier(inherit_state,
					      yystack.l_mark[-1].number,
					      Pike_compiler->last_identifier,
					      SEE_PROTECTED);
    else
      id = really_low_find_shared_string_identifier(Pike_compiler->last_identifier,
						    inherit_state->new_program,
						    SEE_PROTECTED|SEE_PRIVATE);

    if (id != -1) {
      if (inherit_depth > 0) {
	yyval.n = mkexternalnode(inherit_state->new_program, id);
      } else {
	yyval.n = mkidentifiernode(id);
      }
    } else if ((yyval.n = program_magic_identifier (inherit_state, inherit_depth, yystack.l_mark[-1].number,
					       Pike_compiler->last_identifier, 1))) {
      /* All done. */
    }
    else {
      if ((Pike_compiler->flags & COMPILATION_FORCE_RESOLVE) ||
	  (Pike_compiler->compiler_pass == 2)) {
	if ((yystack.l_mark[-1].number >= 0) && inherit_state->new_program->inherits[yystack.l_mark[-1].number].name) {
	  my_yyerror("Undefined identifier %S::%S.",
		     inherit_state->new_program->inherits[yystack.l_mark[-1].number].name,
		     Pike_compiler->last_identifier);
	} else {
	  my_yyerror("Undefined identifier %S.",
		     Pike_compiler->last_identifier);
	}
	yyval.n=0;
      }
      else
	yyval.n=mknode(F_UNDEFINED,0,0);
    }

    free_node(yystack.l_mark[0].n);
  }
break;
case 562:
#line 4153 "language.yacc"
	{ yyval.n=0; }
break;
case 563:
#line 4154 "language.yacc"
	{ yyval.n=0; }
break;
case 564:
#line 4156 "language.yacc"
	{
    int e,i;

    if(Pike_compiler->last_identifier) free_string(Pike_compiler->last_identifier);
    copy_shared_string(Pike_compiler->last_identifier, yystack.l_mark[0].n->u.sval.u.string);

    yyval.n=0;
    for(e=1;e<(int)Pike_compiler->new_program->num_inherits;e++)
    {
      if(Pike_compiler->new_program->inherits[e].inherit_level!=1) continue;
      i=low_reference_inherited_identifier(0,e,yystack.l_mark[0].n->u.sval.u.string,SEE_PROTECTED);
      if(i==-1) continue;
      if(yyval.n)
      {
	yyval.n=mknode(F_ARG_LIST,yyval.n,mkidentifiernode(i));
      }else{
	yyval.n=mkidentifiernode(i);
      }
    }
    if(!yyval.n)
    {
      if (!(yyval.n = program_magic_identifier (Pike_compiler, 0, -1,
					   yystack.l_mark[0].n->u.sval.u.string, 1)))
      {
	if (Pike_compiler->compiler_pass == 2) {
          my_yyerror("Undefined identifier ::%S.", yystack.l_mark[0].n->u.sval.u.string);
	}
	yyval.n=mkintnode(0);
      }
    }else{
      if(yyval.n->token==F_ARG_LIST) yyval.n=mkefuncallnode("aggregate",yyval.n);
    }
    free_node(yystack.l_mark[0].n);
  }
break;
case 565:
#line 4191 "language.yacc"
	{
    yyval.n=0;
  }
break;
case 566:
#line 4198 "language.yacc"
	{yyval.n = mknode (F_RANGE_OPEN, NULL, NULL);}
break;
case 567:
#line 4200 "language.yacc"
	{yyval.n = mknode (F_RANGE_FROM_BEG, yystack.l_mark[0].n, NULL);}
break;
case 568:
#line 4202 "language.yacc"
	{yyval.n = mknode (F_RANGE_FROM_END, yystack.l_mark[0].n, NULL);}
break;
case 569:
#line 4204 "language.yacc"
	{
    yyerror("Unexpected end of file.");
    yyval.n = mknode (F_RANGE_OPEN, NULL, NULL);
  }
break;
case 570:
#line 4209 "language.yacc"
	{
    yyerror("Unexpected end of file.");
    yyval.n = mknode (F_RANGE_OPEN, NULL, NULL);
  }
break;
case 571:
#line 4216 "language.yacc"
	{
    yyval.n=mkopernode("`/",
		  mkopernode("`-",
			     mkopernode("`-",
					mkefuncallnode("gethrvtime",
						       mkintnode(1)),
					mknode(F_COMMA_EXPR,
					       mknode(F_POP_VALUE, yystack.l_mark[0].n, NULL),
					       mkefuncallnode("gethrvtime",
							      mkintnode(1)))),
			     NULL),
		  mkfloatnode((FLOAT_TYPE)1e9));
  }
break;
case 572:
#line 4231 "language.yacc"
	{
    struct pike_type *t;
    node *tmp;

    /* FIXME: Why build the node at all? */
    /* Because the optimizer cannot optimize the root node of the
     * tree properly -Hubbe
     */
    tmp=mknode(F_COMMA_EXPR, yystack.l_mark[-1].n, 0);
    optimize_node(tmp);

    t=(tmp && CAR(tmp) && CAR(tmp)->type ? CAR(tmp)->type : mixed_type_string);
    yyval.n = mktypenode(t);
    free_node(tmp);
  }
break;
case 573:
#line 4246 "language.yacc"
	{ yyval.n=0; yyerrok; }
break;
case 574:
#line 4247 "language.yacc"
	{ yyval.n=0; yyerror("Missing ')'."); }
break;
case 575:
#line 4249 "language.yacc"
	{
    yyval.n=0; yyerror("Missing ')'.");
    yyerror("Unexpected end of file.");
  }
break;
case 576:
#line 4253 "language.yacc"
	{ yyval.n=0; yyerror("Missing ')'."); }
break;
case 577:
#line 4256 "language.yacc"
	{ yyval.n=yystack.l_mark[-1].n; }
break;
case 578:
#line 4257 "language.yacc"
	{ yyval.n=0; yyerrok; }
break;
case 579:
#line 4259 "language.yacc"
	{
    yyval.n=0; yyerror("Missing ')'.");
    yyerror("Unexpected end of file.");
  }
break;
case 580:
#line 4263 "language.yacc"
	{ yyval.n=0; yyerror("Missing ')'."); }
break;
case 581:
#line 4264 "language.yacc"
	{ yyval.n=0; yyerror("Missing ')'."); }
break;
case 583:
#line 4266 "language.yacc"
	{ yyval.n=0; yyerror("Bad expression for catch."); }
break;
case 584:
#line 4270 "language.yacc"
	{
       Pike_compiler->catch_level++;
     }
break;
case 585:
#line 4274 "language.yacc"
	{
       yyval.n=mknode(F_CATCH,yystack.l_mark[0].n,NULL);
       Pike_compiler->catch_level--;
     }
break;
case 586:
#line 4281 "language.yacc"
	{
    if (yystack.l_mark[-1].n && !(THIS_COMPILATION->lex.pragmas & ID_STRICT_TYPES)) {
      mark_lvalues_as_used(yystack.l_mark[-1].n);
    }
    yyval.n=mknode(F_SSCANF,mknode(':', mkintnode(TEST_COMPAT(7, 6)? SSCANF_FLAG_76_COMPAT : 0), mknode(F_ARG_LIST,yystack.l_mark[-4].n,yystack.l_mark[-2].n)),yystack.l_mark[-1].n);
  }
break;
case 587:
#line 4288 "language.yacc"
	{
    yyval.n=0;
    free_node(yystack.l_mark[-4].n);
    free_node(yystack.l_mark[-2].n);
    yyerrok;
  }
break;
case 588:
#line 4295 "language.yacc"
	{
    yyval.n=0;
    free_node(yystack.l_mark[-4].n);
    free_node(yystack.l_mark[-2].n);
    yyerror("Missing ')'.");
    yyerror("Unexpected end of file.");
  }
break;
case 589:
#line 4303 "language.yacc"
	{
    yyval.n=0;
    free_node(yystack.l_mark[-4].n);
    free_node(yystack.l_mark[-2].n);
    yyerror("Missing ')'.");
  }
break;
case 590:
#line 4310 "language.yacc"
	{
    yyval.n=0;
    free_node(yystack.l_mark[-4].n);
    free_node(yystack.l_mark[-2].n);
    yyerror("Missing ')'.");
  }
break;
case 591:
#line 4317 "language.yacc"
	{
    yyval.n=0;
    free_node(yystack.l_mark[-2].n);
    yyerrok;
  }
break;
case 592:
#line 4323 "language.yacc"
	{
    yyval.n=0;
    free_node(yystack.l_mark[-2].n);
    yyerror("Missing ')'.");
    yyerror("Unexpected end of file.");
  }
break;
case 593:
#line 4330 "language.yacc"
	{
    yyval.n=0;
    free_node(yystack.l_mark[-2].n);
    yyerror("Missing ')'.");
  }
break;
case 594:
#line 4336 "language.yacc"
	{
    yyval.n=0;
    free_node(yystack.l_mark[-2].n);
    yyerror("Missing ')'.");
  }
break;
case 595:
#line 4341 "language.yacc"
	{ yyval.n=0; yyerrok; }
break;
case 596:
#line 4343 "language.yacc"
	{
    yyval.n=0; yyerror("Missing ')'.");
    yyerror("Unexpected end of file.");
  }
break;
case 597:
#line 4347 "language.yacc"
	{ yyval.n=0; yyerror("Missing ')'."); }
break;
case 598:
#line 4348 "language.yacc"
	{ yyval.n=0; yyerror("Missing ')'."); }
break;
case 600:
#line 4353 "language.yacc"
	{
    yyval.n=mknode(F_ARRAY_LVALUE, yystack.l_mark[-1].n,0);
    COPY_LINE_NUMBER_INFO(yyval.n, yystack.l_mark[-2].n);
    free_node(yystack.l_mark[-2].n);
  }
break;
case 601:
#line 4359 "language.yacc"
	{
    int id = add_local_name(yystack.l_mark[0].n->u.sval.u.string,compiler_pop_type(),0);
    /* Note: Variable intentionally not marked as used. */
    if (id >= 0)
      yyval.n=mklocalnode(id,-1);
    else
      yyval.n = 0;
    free_node(yystack.l_mark[0].n);
  }
break;
case 602:
#line 4370 "language.yacc"
	{ yyval.n=mknewintnode(0); }
break;
case 603:
#line 4374 "language.yacc"
	{
    yyval.n=mknode(F_LVALUE_LIST,yystack.l_mark[-1].n,yystack.l_mark[0].n);
  }
break;
case 604:
#line 4379 "language.yacc"
	{ yyval.n = 0; }
break;
case 605:
#line 4381 "language.yacc"
	{
    yyval.n = mknode(F_LVALUE_LIST,yystack.l_mark[-1].n,yystack.l_mark[0].n);
  }
break;
case 607:
#line 4388 "language.yacc"
	{
    struct compiler_frame *f = Pike_compiler->compiler_frame;
    if (!f || (f->current_function_number < 0)) {
      yyval.n = mkstrnode(lfun_strings[LFUN___INIT]);
    } else {
      struct identifier *id =
	ID_FROM_INT(Pike_compiler->new_program, f->current_function_number);
      if (!id->name->size_shift) {
	int len;
	if ((len = strlen(id->name->str)) == id->name->len) {
	  /* Most common case. */
	  yyval.n = mkstrnode(id->name);
	} else {
	  struct pike_string *str =
	    make_shared_binary_string(id->name->str, len);
	  yyval.n = mkstrnode(str);
	  free_string(str);
	}
      } else {
	struct pike_string *str;
	struct array *split;
	MAKE_CONST_STRING(str, "\0");
	split = explode(id->name, str);
	yyval.n = mkstrnode(split->item->u.string);
	free_array(split);
      }
    }
  }
break;
case 609:
#line 4420 "language.yacc"
	{
    struct pike_string *a,*b;
    copy_shared_string(a,yystack.l_mark[-1].n->u.sval.u.string);
    copy_shared_string(b,yystack.l_mark[0].n->u.sval.u.string);
    free_node(yystack.l_mark[-1].n);
    free_node(yystack.l_mark[0].n);
    a=add_and_free_shared_strings(a,b);
    yyval.n=mkstrnode(a);
    free_string(a);
  }
break;
case 611:
#line 4434 "language.yacc"
	{
    struct pike_string *a,*b;
    copy_shared_string(a,yystack.l_mark[-2].n->u.sval.u.string);
    copy_shared_string(b,yystack.l_mark[0].n->u.sval.u.string);
    free_node(yystack.l_mark[-2].n);
    free_node(yystack.l_mark[0].n);
    a=add_and_free_shared_strings(a,b);
    yyval.n=mkstrnode(a);
    free_string(a);
  }
break;
case 613:
#line 4449 "language.yacc"
	{
    struct pike_string *a,*b;
    copy_shared_string(a,yystack.l_mark[-1].n->u.sval.u.string);
    copy_shared_string(b,yystack.l_mark[0].n->u.sval.u.string);
    free_node(yystack.l_mark[-1].n);
    free_node(yystack.l_mark[0].n);
    a=add_and_free_shared_strings(a,b);
    yyval.n=mkstrnode(a);
    free_string(a);
  }
break;
case 614:
#line 4460 "language.yacc"
	{
    struct pike_string *a,*b;
    copy_shared_string(a,yystack.l_mark[-2].n->u.sval.u.string);
    copy_shared_string(b,yystack.l_mark[0].n->u.sval.u.string);
    free_node(yystack.l_mark[-2].n);
    free_node(yystack.l_mark[0].n);
    a=add_and_free_shared_strings(a,b);
    yyval.n=mkstrnode(a);
    free_string(a);
  }
break;
case 616:
#line 4480 "language.yacc"
	{ yyerror_reserved("array"); }
break;
case 617:
#line 4482 "language.yacc"
	{ yyerror_reserved("__attribute__"); }
break;
case 618:
#line 4484 "language.yacc"
	{ yyerror_reserved("class"); }
break;
case 619:
#line 4486 "language.yacc"
	{ yyerror_reserved("__deprecated__"); }
break;
case 620:
#line 4488 "language.yacc"
	{ yyerror_reserved("enum"); }
break;
case 621:
#line 4490 "language.yacc"
	{ yyerror_reserved("float");}
break;
case 622:
#line 4492 "language.yacc"
	{ yyerror_reserved("function");}
break;
case 623:
#line 4494 "language.yacc"
	{ yyerror_reserved("__FUNCTION__");}
break;
case 624:
#line 4496 "language.yacc"
	{ yyerror_reserved("int"); }
break;
case 625:
#line 4498 "language.yacc"
	{ yyerror_reserved("mapping"); }
break;
case 626:
#line 4500 "language.yacc"
	{ yyerror_reserved("mixed"); }
break;
case 627:
#line 4502 "language.yacc"
	{ yyerror_reserved("multiset"); }
break;
case 628:
#line 4504 "language.yacc"
	{ yyerror_reserved("object"); }
break;
case 629:
#line 4506 "language.yacc"
	{ yyerror_reserved("program"); }
break;
case 630:
#line 4508 "language.yacc"
	{ yyerror_reserved("string"); }
break;
case 631:
#line 4510 "language.yacc"
	{ yyerror_reserved("typedef"); }
break;
case 632:
#line 4512 "language.yacc"
	{ yyerror_reserved("void"); }
break;
case 633:
#line 4514 "language.yacc"
	{
    ref_push_string(yystack.l_mark[0].n->u.sval.u.string);
    low_yyreport(REPORT_ERROR, NULL, 0, parser_system_string,
		 1, "Unknown reserved symbol %s.");
    free_node(yystack.l_mark[0].n);
  }
break;
case 634:
#line 4524 "language.yacc"
	{ yyerror_reserved("inline"); }
break;
case 635:
#line 4526 "language.yacc"
	{ yyerror_reserved("local"); }
break;
case 636:
#line 4528 "language.yacc"
	{ yyerror_reserved("nomask"); }
break;
case 637:
#line 4530 "language.yacc"
	{ yyerror_reserved("predef"); }
break;
case 638:
#line 4532 "language.yacc"
	{ yyerror_reserved("private"); }
break;
case 639:
#line 4534 "language.yacc"
	{ yyerror_reserved("protected"); }
break;
case 640:
#line 4536 "language.yacc"
	{ yyerror_reserved("public"); }
break;
case 641:
#line 4538 "language.yacc"
	{ yyerror_reserved("optional"); }
break;
case 642:
#line 4540 "language.yacc"
	{ yyerror_reserved("variant"); }
break;
case 643:
#line 4542 "language.yacc"
	{ yyerror_reserved("static"); }
break;
case 644:
#line 4544 "language.yacc"
	{ yyerror_reserved("extern"); }
break;
case 645:
#line 4546 "language.yacc"
	{ yyerror_reserved("final");}
break;
case 646:
#line 4548 "language.yacc"
	{ yyerror_reserved("do"); }
break;
case 647:
#line 4550 "language.yacc"
	{ yyerror("else without if."); }
break;
case 648:
#line 4552 "language.yacc"
	{ yyerror_reserved("return"); }
break;
case 649:
#line 4554 "language.yacc"
	{ yyerror_reserved("import"); }
break;
case 650:
#line 4556 "language.yacc"
	{ yyerror_reserved("inherit"); }
break;
case 651:
#line 4558 "language.yacc"
	{ yyerror_reserved("catch"); }
break;
case 652:
#line 4560 "language.yacc"
	{ yyerror_reserved("gauge"); }
break;
case 653:
#line 4562 "language.yacc"
	{ yyerror_reserved("lambda"); }
break;
case 654:
#line 4564 "language.yacc"
	{ yyerror_reserved("sscanf"); }
break;
case 655:
#line 4566 "language.yacc"
	{ yyerror_reserved("switch"); }
break;
case 656:
#line 4568 "language.yacc"
	{ yyerror_reserved("typeof"); }
break;
case 657:
#line 4570 "language.yacc"
	{ yyerror_reserved("break"); }
break;
case 658:
#line 4572 "language.yacc"
	{ yyerror_reserved("case"); }
break;
case 659:
#line 4574 "language.yacc"
	{ yyerror_reserved("continue"); }
break;
case 660:
#line 4576 "language.yacc"
	{ yyerror_reserved("default"); }
break;
case 661:
#line 4578 "language.yacc"
	{ yyerror_reserved("for"); }
break;
case 662:
#line 4580 "language.yacc"
	{ yyerror_reserved("foreach"); }
break;
case 663:
#line 4582 "language.yacc"
	{ yyerror_reserved("if"); }
break;
#line 9498 "y.tab.c"
    }
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yystack.s_mark = YYFINAL;
        *++yystack.l_mark = yyval;
        if (yychar < 0)
        {
            yychar = YYLEX;
            if (yychar < 0) yychar = YYEOF;
#if YYDEBUG
            if (yydebug)
            {
                if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == YYEOF) goto yyaccept;
        goto yyloop;
    }
    if (((yyn = yygindex[yym]) != 0) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yystack.s_mark, yystate);
#endif
    if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
    *++yystack.s_mark = (YYINT) yystate;
    *++yystack.l_mark = yyval;
    goto yyloop;

yyoverflow:
    YYERROR_CALL("yacc stack overflow");

yyabort:
    yyfreestack(&yystack);
    return (1);

yyaccept:
    yyfreestack(&yystack);
    return (0);
}
